/* composer-link-popover.c generated by valac 0.39.7, the Vala compiler
 * generated from composer-link-popover.vala, do not modify */

/*
 * Copyright 2017 Michael Gratton <mike@vee.net>
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later). See the COPYING file in this distribution.
 */

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <geary-engine.h>
#include <stdlib.h>
#include <string.h>
#include <libsoup/soup.h>
#include <glib/gi18n-lib.h>


#define TYPE_COMPOSER_LINK_POPOVER (composer_link_popover_get_type ())
#define COMPOSER_LINK_POPOVER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_COMPOSER_LINK_POPOVER, ComposerLinkPopover))
#define COMPOSER_LINK_POPOVER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_COMPOSER_LINK_POPOVER, ComposerLinkPopoverClass))
#define IS_COMPOSER_LINK_POPOVER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_COMPOSER_LINK_POPOVER))
#define IS_COMPOSER_LINK_POPOVER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_COMPOSER_LINK_POPOVER))
#define COMPOSER_LINK_POPOVER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_COMPOSER_LINK_POPOVER, ComposerLinkPopoverClass))

typedef struct _ComposerLinkPopover ComposerLinkPopover;
typedef struct _ComposerLinkPopoverClass ComposerLinkPopoverClass;
typedef struct _ComposerLinkPopoverPrivate ComposerLinkPopoverPrivate;
enum  {
	COMPOSER_LINK_POPOVER_0_PROPERTY,
	COMPOSER_LINK_POPOVER_LINK_URI_PROPERTY,
	COMPOSER_LINK_POPOVER_NUM_PROPERTIES
};
static GParamSpec* composer_link_popover_properties[COMPOSER_LINK_POPOVER_NUM_PROPERTIES];

#define COMPOSER_LINK_POPOVER_TYPE_TYPE (composer_link_popover_type_get_type ())
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define __vala_SoupURI_free0(var) ((var == NULL) ? NULL : (var = (_vala_SoupURI_free (var), NULL)))
enum  {
	COMPOSER_LINK_POPOVER_LINK_CHANGED_SIGNAL,
	COMPOSER_LINK_POPOVER_LINK_ACTIVATE_SIGNAL,
	COMPOSER_LINK_POPOVER_LINK_OPEN_SIGNAL,
	COMPOSER_LINK_POPOVER_LINK_DELETE_SIGNAL,
	COMPOSER_LINK_POPOVER_NUM_SIGNALS
};
static guint composer_link_popover_signals[COMPOSER_LINK_POPOVER_NUM_SIGNALS] = {0};

struct _ComposerLinkPopover {
	GtkPopover parent_instance;
	ComposerLinkPopoverPrivate * priv;
};

struct _ComposerLinkPopoverClass {
	GtkPopoverClass parent_class;
};

struct _ComposerLinkPopoverPrivate {
	GtkEntry* url;
	GtkButton* insert;
	GtkButton* update;
	GtkButton* delete;
	GtkButton* open;
	GearyTimeoutManager* validation_timeout;
};

typedef enum  {
	COMPOSER_LINK_POPOVER_TYPE_NEW_LINK,
	COMPOSER_LINK_POPOVER_TYPE_EXISTING_LINK
} ComposerLinkPopoverType;


static gpointer composer_link_popover_parent_class = NULL;

GType composer_link_popover_get_type (void) G_GNUC_CONST;
#define COMPOSER_LINK_POPOVER_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_COMPOSER_LINK_POPOVER, ComposerLinkPopoverPrivate))
GType composer_link_popover_type_get_type (void) G_GNUC_CONST;
ComposerLinkPopover* composer_link_popover_new (ComposerLinkPopoverType type);
ComposerLinkPopover* composer_link_popover_construct (GType object_type,
                                                      ComposerLinkPopoverType type);
static void __lambda17_ (ComposerLinkPopover* self);
static void composer_link_popover_validate (ComposerLinkPopover* self);
static void ___lambda17__geary_timeout_manager_timeout_func (GearyTimeoutManager* manager,
                                                      gpointer self);
static void composer_link_popover_real_show (GtkWidget* base);
static void composer_link_popover_real_destroy (GtkWidget* base);
void composer_link_popover_set_link_url (ComposerLinkPopover* self,
                                         const gchar* url);
static void _vala_SoupURI_free (SoupURI* self);
static gboolean _vala_string_array_contains (const gchar* * stack,
                                      int stack_length,
                                      const gchar* needle);
static void composer_link_popover_on_url_changed (ComposerLinkPopover* self);
static void _composer_link_popover_on_url_changed_gtk_editable_changed (GtkEditable* _sender,
                                                                 gpointer self);
static void composer_link_popover_on_activate_popover (ComposerLinkPopover* self);
static void _composer_link_popover_on_activate_popover_gtk_button_clicked (GtkButton* _sender,
                                                                    gpointer self);
static void composer_link_popover_on_delete_clicked (ComposerLinkPopover* self);
static void _composer_link_popover_on_delete_clicked_gtk_button_clicked (GtkButton* _sender,
                                                                  gpointer self);
static void composer_link_popover_on_open_clicked (ComposerLinkPopover* self);
static void _composer_link_popover_on_open_clicked_gtk_button_clicked (GtkButton* _sender,
                                                                gpointer self);
const gchar* composer_link_popover_get_link_uri (ComposerLinkPopover* self);
static void g_cclosure_user_marshal_VOID__BOXED_BOOLEAN (GClosure * closure,
                                                  GValue * return_value,
                                                  guint n_param_values,
                                                  const GValue * param_values,
                                                  gpointer invocation_hint,
                                                  gpointer marshal_data);
static void composer_link_popover_finalize (GObject * obj);
static void _vala_composer_link_popover_get_property (GObject * object,
                                               guint property_id,
                                               GValue * value,
                                               GParamSpec * pspec);

static const gchar* COMPOSER_LINK_POPOVER_HTTP_SCHEMES[2] = {"http", "https"};
static const gchar* COMPOSER_LINK_POPOVER_OTHER_SCHEMES[30] = {"aim", "apt", "bitcoin", "cvs", "ed2k", "ftp", "file", "finger", "git", "gtalk", "irc", "ircs", "irc6", "lastfm", "ldap", "ldaps", "magnet", "news", "nntp", "rsync", "sftp", "skype", "smb", "sms", "svn", "telnet", "tftp", "ssh", "webcal", "xmpp"};

/** Determines which version of the UI is presented to the user. */
GType
composer_link_popover_type_get_type (void)
{
	static volatile gsize composer_link_popover_type_type_id__volatile = 0;
	if (g_once_init_enter (&composer_link_popover_type_type_id__volatile)) {
		static const GEnumValue values[] = {{COMPOSER_LINK_POPOVER_TYPE_NEW_LINK, "COMPOSER_LINK_POPOVER_TYPE_NEW_LINK", "new-link"}, {COMPOSER_LINK_POPOVER_TYPE_EXISTING_LINK, "COMPOSER_LINK_POPOVER_TYPE_EXISTING_LINK", "existing-link"}, {0, NULL, NULL}};
		GType composer_link_popover_type_type_id;
		composer_link_popover_type_type_id = g_enum_register_static ("ComposerLinkPopoverType", values);
		g_once_init_leave (&composer_link_popover_type_type_id__volatile, composer_link_popover_type_type_id);
	}
	return composer_link_popover_type_type_id__volatile;
}


static void
__lambda17_ (ComposerLinkPopover* self)
{
#line 88 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
	composer_link_popover_validate (self);
#line 144 "composer-link-popover.c"
}


static void
___lambda17__geary_timeout_manager_timeout_func (GearyTimeoutManager* manager,
                                                 gpointer self)
{
#line 87 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
	__lambda17_ ((ComposerLinkPopover*) self);
#line 154 "composer-link-popover.c"
}


ComposerLinkPopover*
composer_link_popover_construct (GType object_type,
                                 ComposerLinkPopoverType type)
{
	ComposerLinkPopover * self = NULL;
	GtkEntry* _tmp0_;
	GearyTimeoutManager* _tmp4_;
#line 74 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
	self = (ComposerLinkPopover*) g_object_new (object_type, NULL);
#line 77 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
	_tmp0_ = self->priv->url;
#line 77 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
	gtk_container_set_focus_child (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_container_get_type (), GtkContainer), G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, gtk_widget_get_type (), GtkWidget));
#line 78 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
	switch (type) {
#line 78 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
		case COMPOSER_LINK_POPOVER_TYPE_NEW_LINK:
#line 175 "composer-link-popover.c"
		{
			GtkButton* _tmp1_;
			GtkButton* _tmp2_;
#line 80 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
			_tmp1_ = self->priv->update;
#line 80 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
			gtk_widget_hide (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, gtk_widget_get_type (), GtkWidget));
#line 81 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
			_tmp2_ = self->priv->delete;
#line 81 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
			gtk_widget_hide (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, gtk_widget_get_type (), GtkWidget));
#line 82 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
			break;
#line 189 "composer-link-popover.c"
		}
#line 78 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
		case COMPOSER_LINK_POPOVER_TYPE_EXISTING_LINK:
#line 193 "composer-link-popover.c"
		{
			GtkButton* _tmp3_;
#line 84 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
			_tmp3_ = self->priv->insert;
#line 84 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
			gtk_widget_hide (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, gtk_widget_get_type (), GtkWidget));
#line 85 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
			break;
#line 202 "composer-link-popover.c"
		}
		default:
#line 78 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
		break;
#line 207 "composer-link-popover.c"
	}
#line 87 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
	_tmp4_ = geary_timeout_manager_new_milliseconds ((guint) 150, ___lambda17__geary_timeout_manager_timeout_func, self);
#line 87 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
	_g_object_unref0 (self->priv->validation_timeout);
#line 87 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
	self->priv->validation_timeout = _tmp4_;
#line 74 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
	return self;
#line 217 "composer-link-popover.c"
}


ComposerLinkPopover*
composer_link_popover_new (ComposerLinkPopoverType type)
{
#line 74 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
	return composer_link_popover_construct (TYPE_COMPOSER_LINK_POPOVER, type);
#line 226 "composer-link-popover.c"
}


static void
composer_link_popover_real_show (GtkWidget* base)
{
	ComposerLinkPopover * self;
	GtkEntry* _tmp0_;
#line 92 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_COMPOSER_LINK_POPOVER, ComposerLinkPopover);
#line 93 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
	GTK_WIDGET_CLASS (composer_link_popover_parent_class)->show (G_TYPE_CHECK_INSTANCE_CAST (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_popover_get_type (), GtkPopover), gtk_widget_get_type (), GtkWidget));
#line 94 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
	_tmp0_ = self->priv->url;
#line 94 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
	gtk_widget_grab_focus (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, gtk_widget_get_type (), GtkWidget));
#line 243 "composer-link-popover.c"
}


static void
composer_link_popover_real_destroy (GtkWidget* base)
{
	ComposerLinkPopover * self;
	GearyTimeoutManager* _tmp0_;
#line 97 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_COMPOSER_LINK_POPOVER, ComposerLinkPopover);
#line 98 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
	_tmp0_ = self->priv->validation_timeout;
#line 98 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
	geary_timeout_manager_reset (_tmp0_);
#line 99 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
	GTK_WIDGET_CLASS (composer_link_popover_parent_class)->destroy (G_TYPE_CHECK_INSTANCE_CAST (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_popover_get_type (), GtkPopover), gtk_widget_get_type (), GtkWidget));
#line 260 "composer-link-popover.c"
}


void
composer_link_popover_set_link_url (ComposerLinkPopover* self,
                                    const gchar* url)
{
	GtkEntry* _tmp0_;
	GearyTimeoutManager* _tmp1_;
#line 102 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
	g_return_if_fail (IS_COMPOSER_LINK_POPOVER (self));
#line 102 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
	g_return_if_fail (url != NULL);
#line 103 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
	_tmp0_ = self->priv->url;
#line 103 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
	gtk_entry_set_text (_tmp0_, url);
#line 104 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
	_tmp1_ = self->priv->validation_timeout;
#line 104 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
	geary_timeout_manager_reset (_tmp1_);
#line 282 "composer-link-popover.c"
}


static gchar*
string_strip (const gchar* self)
{
	gchar* result = NULL;
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
#line 1248 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1249 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_tmp0_ = g_strdup (self);
#line 1249 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1250 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_tmp1_ = _result_;
#line 1250 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	g_strstrip (_tmp1_);
#line 1251 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	result = _result_;
#line 1251 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	return result;
#line 307 "composer-link-popover.c"
}


static void
_vala_SoupURI_free (SoupURI* self)
{
#line 115 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
	g_boxed_free (soup_uri_get_type (), self);
#line 316 "composer-link-popover.c"
}


static gboolean
_vala_string_array_contains (const gchar* * stack,
                             int stack_length,
                             const gchar* needle)
{
	int i;
#line 121 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
	for (i = 0; i < stack_length; i++) {
#line 121 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
		if (g_strcmp0 (stack[i], needle) == 0) {
#line 121 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
			return TRUE;
#line 332 "composer-link-popover.c"
		}
	}
#line 121 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
	return FALSE;
#line 337 "composer-link-popover.c"
}


static gpointer
_g_object_ref0 (gpointer self)
{
#line 143 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
	return self ? g_object_ref (self) : NULL;
#line 346 "composer-link-popover.c"
}


static void
composer_link_popover_validate (ComposerLinkPopover* self)
{
	gchar* text = NULL;
	GtkEntry* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gboolean is_empty = FALSE;
	const gchar* _tmp3_;
	gboolean is_valid = FALSE;
	gboolean is_nominal = FALSE;
	gboolean is_mailto = FALSE;
	SoupURI* url = NULL;
	gboolean _tmp4_;
	gboolean _tmp27_ = FALSE;
	gboolean _tmp28_;
	GtkButton* _tmp30_;
	GtkStyleContext* style = NULL;
	GtkEntry* _tmp31_;
	GtkStyleContext* _tmp32_;
	GtkStyleContext* _tmp33_;
	GtkEntryIconPosition pos = 0;
	gboolean _tmp34_;
	gboolean _tmp53_ = FALSE;
	gboolean _tmp54_;
	SoupURI* _tmp56_;
#line 107 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
	g_return_if_fail (IS_COMPOSER_LINK_POPOVER (self));
#line 108 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
	_tmp0_ = self->priv->url;
#line 108 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
	_tmp1_ = gtk_entry_get_text (_tmp0_);
#line 108 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
	_tmp2_ = string_strip (_tmp1_);
#line 108 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
	text = _tmp2_;
#line 109 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
	_tmp3_ = text;
#line 109 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
	is_empty = geary_string_is_empty (_tmp3_);
#line 110 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
	is_valid = FALSE;
#line 111 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
	is_nominal = FALSE;
#line 112 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
	is_mailto = FALSE;
#line 113 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
	url = NULL;
#line 114 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
	_tmp4_ = is_empty;
#line 114 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
	if (!_tmp4_) {
#line 402 "composer-link-popover.c"
		const gchar* _tmp5_;
		SoupURI* _tmp6_;
		SoupURI* _tmp7_;
#line 115 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
		_tmp5_ = text;
#line 115 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
		_tmp6_ = soup_uri_new (_tmp5_);
#line 115 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
		__vala_SoupURI_free0 (url);
#line 115 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
		url = _tmp6_;
#line 116 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
		_tmp7_ = url;
#line 116 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
		if (_tmp7_ != NULL) {
#line 418 "composer-link-popover.c"
			gchar* scheme = NULL;
			SoupURI* _tmp8_;
			const gchar* _tmp9_;
			gchar* _tmp10_;
			gchar* path = NULL;
			SoupURI* _tmp11_;
			const gchar* _tmp12_;
			gchar* _tmp13_;
			const gchar* _tmp14_;
#line 117 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
			is_valid = TRUE;
#line 119 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
			_tmp8_ = url;
#line 119 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
			_tmp9_ = soup_uri_get_scheme (_tmp8_);
#line 119 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
			_tmp10_ = g_strdup (_tmp9_);
#line 119 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
			scheme = _tmp10_;
#line 120 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
			_tmp11_ = url;
#line 120 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
			_tmp12_ = soup_uri_get_path (_tmp11_);
#line 120 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
			_tmp13_ = g_strdup (_tmp12_);
#line 120 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
			path = _tmp13_;
#line 121 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
			_tmp14_ = scheme;
#line 121 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
			if (_vala_string_array_contains (COMPOSER_LINK_POPOVER_HTTP_SCHEMES, G_N_ELEMENTS (COMPOSER_LINK_POPOVER_HTTP_SCHEMES), _tmp14_)) {
#line 450 "composer-link-popover.c"
				SoupURI* _tmp15_;
				const gchar* _tmp16_;
				gchar* _tmp17_;
#line 122 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
				_tmp15_ = url;
#line 122 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
				_tmp16_ = soup_uri_get_host (_tmp15_);
#line 122 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
				_tmp17_ = g_strdup (_tmp16_);
#line 122 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
				is_nominal = geary_inet_is_valid_display_host (_tmp17_);
#line 462 "composer-link-popover.c"
			} else {
				const gchar* _tmp18_;
#line 123 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
				_tmp18_ = scheme;
#line 123 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
				if (g_strcmp0 (_tmp18_, "mailto") == 0) {
#line 469 "composer-link-popover.c"
					gboolean _tmp19_ = FALSE;
					const gchar* _tmp20_;
#line 124 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
					is_mailto = TRUE;
#line 126 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
					_tmp20_ = path;
#line 126 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
					if (!geary_string_is_empty (_tmp20_)) {
#line 478 "composer-link-popover.c"
						const gchar* _tmp21_;
#line 127 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
						_tmp21_ = path;
#line 127 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
						_tmp19_ = geary_rf_c822_mailbox_address_is_valid_address (_tmp21_);
#line 484 "composer-link-popover.c"
					} else {
#line 126 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
						_tmp19_ = FALSE;
#line 488 "composer-link-popover.c"
					}
#line 125 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
					is_nominal = _tmp19_;
#line 492 "composer-link-popover.c"
				} else {
					const gchar* _tmp22_;
#line 129 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
					_tmp22_ = scheme;
#line 129 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
					if (_vala_string_array_contains (COMPOSER_LINK_POPOVER_OTHER_SCHEMES, G_N_ELEMENTS (COMPOSER_LINK_POPOVER_OTHER_SCHEMES), _tmp22_)) {
#line 499 "composer-link-popover.c"
						const gchar* _tmp23_;
#line 130 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
						_tmp23_ = path;
#line 130 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
						is_nominal = !geary_string_is_empty (_tmp23_);
#line 505 "composer-link-popover.c"
					}
				}
			}
#line 116 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
			_g_free0 (path);
#line 116 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
			_g_free0 (scheme);
#line 513 "composer-link-popover.c"
		} else {
			gboolean _tmp24_ = FALSE;
			const gchar* _tmp25_;
#line 132 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
			_tmp25_ = text;
#line 132 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
			if (g_strcmp0 (_tmp25_, "http:/") == 0) {
#line 132 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
				_tmp24_ = TRUE;
#line 523 "composer-link-popover.c"
			} else {
				const gchar* _tmp26_;
#line 132 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
				_tmp26_ = text;
#line 132 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
				_tmp24_ = g_strcmp0 (_tmp26_, "https:/") == 0;
#line 530 "composer-link-popover.c"
			}
#line 132 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
			if (_tmp24_) {
#line 135 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
				is_valid = TRUE;
#line 536 "composer-link-popover.c"
			}
		}
	}
#line 141 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
	_tmp28_ = is_nominal;
#line 141 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
	if (_tmp28_) {
#line 544 "composer-link-popover.c"
		gboolean _tmp29_;
#line 141 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
		_tmp29_ = is_mailto;
#line 141 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
		_tmp27_ = !_tmp29_;
#line 550 "composer-link-popover.c"
	} else {
#line 141 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
		_tmp27_ = FALSE;
#line 554 "composer-link-popover.c"
	}
#line 141 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
	_tmp30_ = self->priv->open;
#line 141 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
	gtk_widget_set_sensitive (G_TYPE_CHECK_INSTANCE_CAST (_tmp30_, gtk_widget_get_type (), GtkWidget), _tmp27_);
#line 143 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
	_tmp31_ = self->priv->url;
#line 143 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
	_tmp32_ = gtk_widget_get_style_context (G_TYPE_CHECK_INSTANCE_CAST (_tmp31_, gtk_widget_get_type (), GtkWidget));
#line 143 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
	_tmp33_ = _g_object_ref0 (_tmp32_);
#line 143 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
	style = _tmp33_;
#line 144 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
	pos = GTK_ENTRY_ICON_SECONDARY;
#line 145 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
	_tmp34_ = is_valid;
#line 145 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
	if (!_tmp34_) {
#line 574 "composer-link-popover.c"
		GtkStyleContext* _tmp35_;
		GtkStyleContext* _tmp36_;
		GtkEntry* _tmp37_;
		GtkEntryIconPosition _tmp38_;
		GtkEntry* _tmp39_;
#line 146 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
		_tmp35_ = style;
#line 146 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
		gtk_style_context_add_class (_tmp35_, GTK_STYLE_CLASS_ERROR);
#line 147 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
		_tmp36_ = style;
#line 147 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
		gtk_style_context_remove_class (_tmp36_, GTK_STYLE_CLASS_WARNING);
#line 148 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
		_tmp37_ = self->priv->url;
#line 148 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
		_tmp38_ = pos;
#line 148 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
		gtk_entry_set_icon_from_icon_name (_tmp37_, _tmp38_, "dialog-error-symbolic");
#line 149 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
		_tmp39_ = self->priv->url;
#line 149 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
		gtk_widget_set_tooltip_text (G_TYPE_CHECK_INSTANCE_CAST (_tmp39_, gtk_widget_get_type (), GtkWidget), _ ("Link URL is not correctly formatted, e.g. http://example.com"));
#line 598 "composer-link-popover.c"
	} else {
		gboolean _tmp40_;
#line 152 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
		_tmp40_ = is_nominal;
#line 152 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
		if (!_tmp40_) {
#line 605 "composer-link-popover.c"
			GtkStyleContext* _tmp41_;
			GtkStyleContext* _tmp42_;
			GtkEntry* _tmp43_;
			GtkEntryIconPosition _tmp44_;
			const gchar* _tmp45_ = NULL;
			gboolean _tmp46_;
			GtkEntry* _tmp47_;
#line 153 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
			_tmp41_ = style;
#line 153 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
			gtk_style_context_remove_class (_tmp41_, GTK_STYLE_CLASS_ERROR);
#line 154 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
			_tmp42_ = style;
#line 154 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
			gtk_style_context_add_class (_tmp42_, GTK_STYLE_CLASS_WARNING);
#line 155 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
			_tmp43_ = self->priv->url;
#line 155 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
			_tmp44_ = pos;
#line 155 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
			gtk_entry_set_icon_from_icon_name (_tmp43_, _tmp44_, "dialog-warning-symbolic");
#line 157 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
			_tmp46_ = is_mailto;
#line 157 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
			if (!_tmp46_) {
#line 157 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
				_tmp45_ = _ ("Invalid link URL");
#line 633 "composer-link-popover.c"
			} else {
#line 157 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
				_tmp45_ = _ ("Invalid email address");
#line 637 "composer-link-popover.c"
			}
#line 156 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
			_tmp47_ = self->priv->url;
#line 156 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
			gtk_widget_set_tooltip_text (G_TYPE_CHECK_INSTANCE_CAST (_tmp47_, gtk_widget_get_type (), GtkWidget), _tmp45_);
#line 643 "composer-link-popover.c"
		} else {
			GtkStyleContext* _tmp48_;
			GtkStyleContext* _tmp49_;
			GtkEntry* _tmp50_;
			GtkEntryIconPosition _tmp51_;
			GtkEntry* _tmp52_;
#line 160 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
			_tmp48_ = style;
#line 160 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
			gtk_style_context_remove_class (_tmp48_, GTK_STYLE_CLASS_ERROR);
#line 161 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
			_tmp49_ = style;
#line 161 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
			gtk_style_context_remove_class (_tmp49_, GTK_STYLE_CLASS_WARNING);
#line 162 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
			_tmp50_ = self->priv->url;
#line 162 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
			_tmp51_ = pos;
#line 162 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
			gtk_entry_set_icon_from_icon_name (_tmp50_, _tmp51_, NULL);
#line 163 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
			_tmp52_ = self->priv->url;
#line 163 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
			gtk_widget_set_tooltip_text (G_TYPE_CHECK_INSTANCE_CAST (_tmp52_, gtk_widget_get_type (), GtkWidget), "");
#line 668 "composer-link-popover.c"
		}
	}
#line 166 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
	_tmp54_ = is_valid;
#line 166 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
	if (_tmp54_) {
#line 675 "composer-link-popover.c"
		gboolean _tmp55_;
#line 166 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
		_tmp55_ = is_nominal;
#line 166 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
		_tmp53_ = _tmp55_;
#line 681 "composer-link-popover.c"
	} else {
#line 166 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
		_tmp53_ = FALSE;
#line 685 "composer-link-popover.c"
	}
#line 166 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
	_tmp56_ = url;
#line 166 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
	g_signal_emit (self, composer_link_popover_signals[COMPOSER_LINK_POPOVER_LINK_CHANGED_SIGNAL], 0, _tmp56_, _tmp53_);
#line 107 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
	_g_object_unref0 (style);
#line 107 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
	__vala_SoupURI_free0 (url);
#line 107 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
	_g_free0 (text);
#line 697 "composer-link-popover.c"
}


static void
composer_link_popover_on_url_changed (ComposerLinkPopover* self)
{
	GearyTimeoutManager* _tmp0_;
#line 170 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
	g_return_if_fail (IS_COMPOSER_LINK_POPOVER (self));
#line 171 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
	_tmp0_ = self->priv->validation_timeout;
#line 171 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
	geary_timeout_manager_start (_tmp0_);
#line 711 "composer-link-popover.c"
}


static void
_composer_link_popover_on_url_changed_gtk_editable_changed (GtkEditable* _sender,
                                                            gpointer self)
{
#line 21 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
	composer_link_popover_on_url_changed ((ComposerLinkPopover*) self);
#line 721 "composer-link-popover.c"
}


static void
composer_link_popover_on_activate_popover (ComposerLinkPopover* self)
{
#line 175 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
	g_return_if_fail (IS_COMPOSER_LINK_POPOVER (self));
#line 176 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
	g_signal_emit (self, composer_link_popover_signals[COMPOSER_LINK_POPOVER_LINK_ACTIVATE_SIGNAL], 0);
#line 178 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
	gtk_widget_hide (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget));
#line 734 "composer-link-popover.c"
}


static void
_composer_link_popover_on_activate_popover_gtk_button_clicked (GtkButton* _sender,
                                                               gpointer self)
{
#line 21 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
	composer_link_popover_on_activate_popover ((ComposerLinkPopover*) self);
#line 744 "composer-link-popover.c"
}


static void
composer_link_popover_on_delete_clicked (ComposerLinkPopover* self)
{
#line 182 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
	g_return_if_fail (IS_COMPOSER_LINK_POPOVER (self));
#line 183 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
	g_signal_emit (self, composer_link_popover_signals[COMPOSER_LINK_POPOVER_LINK_DELETE_SIGNAL], 0);
#line 185 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
	gtk_widget_hide (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget));
#line 757 "composer-link-popover.c"
}


static void
_composer_link_popover_on_delete_clicked_gtk_button_clicked (GtkButton* _sender,
                                                             gpointer self)
{
#line 21 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
	composer_link_popover_on_delete_clicked ((ComposerLinkPopover*) self);
#line 767 "composer-link-popover.c"
}


static void
composer_link_popover_on_open_clicked (ComposerLinkPopover* self)
{
#line 189 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
	g_return_if_fail (IS_COMPOSER_LINK_POPOVER (self));
#line 190 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
	g_signal_emit (self, composer_link_popover_signals[COMPOSER_LINK_POPOVER_LINK_OPEN_SIGNAL], 0);
#line 778 "composer-link-popover.c"
}


static void
_composer_link_popover_on_open_clicked_gtk_button_clicked (GtkButton* _sender,
                                                           gpointer self)
{
#line 21 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
	composer_link_popover_on_open_clicked ((ComposerLinkPopover*) self);
#line 788 "composer-link-popover.c"
}


const gchar*
composer_link_popover_get_link_uri (ComposerLinkPopover* self)
{
	const gchar* result;
	GtkEntry* _tmp0_;
	const gchar* _tmp1_;
#line 41 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
	g_return_val_if_fail (IS_COMPOSER_LINK_POPOVER (self), NULL);
#line 41 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
	_tmp0_ = self->priv->url;
#line 41 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
	_tmp1_ = gtk_entry_get_text (_tmp0_);
#line 41 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
	result = _tmp1_;
#line 41 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
	return result;
#line 808 "composer-link-popover.c"
}


static void
g_cclosure_user_marshal_VOID__BOXED_BOOLEAN (GClosure * closure,
                                             GValue * return_value,
                                             guint n_param_values,
                                             const GValue * param_values,
                                             gpointer invocation_hint,
                                             gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__BOXED_BOOLEAN) (gpointer data1, gpointer arg_1, gboolean arg_2, gpointer data2);
	register GMarshalFunc_VOID__BOXED_BOOLEAN callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 21 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
	g_return_if_fail (n_param_values == 3);
#line 21 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 21 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
		data1 = closure->data;
#line 21 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
		data2 = param_values->data[0].v_pointer;
#line 834 "composer-link-popover.c"
	} else {
#line 21 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
		data1 = param_values->data[0].v_pointer;
#line 21 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
		data2 = closure->data;
#line 840 "composer-link-popover.c"
	}
#line 21 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
	callback = (GMarshalFunc_VOID__BOXED_BOOLEAN) (marshal_data ? marshal_data : cc->callback);
#line 21 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
	callback (data1, g_value_get_boxed (param_values + 1), g_value_get_boolean (param_values + 2), data2);
#line 846 "composer-link-popover.c"
}


static void
composer_link_popover_class_init (ComposerLinkPopoverClass * klass)
{
	gint ComposerLinkPopover_private_offset;
#line 21 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
	composer_link_popover_parent_class = g_type_class_peek_parent (klass);
#line 21 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
	g_type_class_add_private (klass, sizeof (ComposerLinkPopoverPrivate));
#line 21 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
	((GtkWidgetClass *) klass)->show = (void (*) (GtkWidget *)) composer_link_popover_real_show;
#line 21 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
	((GtkWidgetClass *) klass)->destroy = (void (*) (GtkWidget *)) composer_link_popover_real_destroy;
#line 21 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_composer_link_popover_get_property;
#line 21 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
	G_OBJECT_CLASS (klass)->finalize = composer_link_popover_finalize;
#line 866 "composer-link-popover.c"
	/** The URL displayed in the popover */
#line 21 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), COMPOSER_LINK_POPOVER_LINK_URI_PROPERTY, composer_link_popover_properties[COMPOSER_LINK_POPOVER_LINK_URI_PROPERTY] = g_param_spec_string ("link-uri", "link-uri", "link-uri", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 21 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
	ComposerLinkPopover_private_offset = g_type_class_get_instance_private_offset (klass);
#line 21 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
	gtk_widget_class_set_template_from_resource (GTK_WIDGET_CLASS (klass), "/org/gnome/Geary/composer-link-popover.ui");
#line 874 "composer-link-popover.c"
	/** Emitted when the link URL has changed. */
#line 21 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
	composer_link_popover_signals[COMPOSER_LINK_POPOVER_LINK_CHANGED_SIGNAL] = g_signal_new ("link-changed", TYPE_COMPOSER_LINK_POPOVER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__BOXED_BOOLEAN, G_TYPE_NONE, 2, soup_uri_get_type (), G_TYPE_BOOLEAN);
#line 878 "composer-link-popover.c"
	/** Emitted when the link URL was activated. */
#line 21 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
	composer_link_popover_signals[COMPOSER_LINK_POPOVER_LINK_ACTIVATE_SIGNAL] = g_signal_new ("link-activate", TYPE_COMPOSER_LINK_POPOVER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 882 "composer-link-popover.c"
	/** Emitted when the open button was activated. */
#line 21 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
	composer_link_popover_signals[COMPOSER_LINK_POPOVER_LINK_OPEN_SIGNAL] = g_signal_new ("link-open", TYPE_COMPOSER_LINK_POPOVER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 886 "composer-link-popover.c"
	/** Emitted when the delete button was activated. */
#line 21 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
	composer_link_popover_signals[COMPOSER_LINK_POPOVER_LINK_DELETE_SIGNAL] = g_signal_new ("link-delete", TYPE_COMPOSER_LINK_POPOVER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 21 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "url", FALSE, ComposerLinkPopover_private_offset + G_STRUCT_OFFSET (ComposerLinkPopoverPrivate, url));
#line 21 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "insert", FALSE, ComposerLinkPopover_private_offset + G_STRUCT_OFFSET (ComposerLinkPopoverPrivate, insert));
#line 21 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "update", FALSE, ComposerLinkPopover_private_offset + G_STRUCT_OFFSET (ComposerLinkPopoverPrivate, update));
#line 21 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "delete", FALSE, ComposerLinkPopover_private_offset + G_STRUCT_OFFSET (ComposerLinkPopoverPrivate, delete));
#line 21 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "open", FALSE, ComposerLinkPopover_private_offset + G_STRUCT_OFFSET (ComposerLinkPopoverPrivate, open));
#line 21 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "on_url_changed", G_CALLBACK(_composer_link_popover_on_url_changed_gtk_editable_changed));
#line 21 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "on_activate_popover", G_CALLBACK(_composer_link_popover_on_activate_popover_gtk_button_clicked));
#line 21 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "on_delete_clicked", G_CALLBACK(_composer_link_popover_on_delete_clicked_gtk_button_clicked));
#line 21 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "on_open_clicked", G_CALLBACK(_composer_link_popover_on_open_clicked_gtk_button_clicked));
#line 908 "composer-link-popover.c"
}


static void
composer_link_popover_instance_init (ComposerLinkPopover * self)
{
#line 21 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
	self->priv = COMPOSER_LINK_POPOVER_GET_PRIVATE (self);
#line 21 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
	gtk_widget_init_template (GTK_WIDGET (self));
#line 919 "composer-link-popover.c"
}


static void
composer_link_popover_finalize (GObject * obj)
{
	ComposerLinkPopover * self;
#line 21 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_COMPOSER_LINK_POPOVER, ComposerLinkPopover);
#line 44 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
	_g_object_unref0 (self->priv->url);
#line 47 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
	_g_object_unref0 (self->priv->insert);
#line 50 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
	_g_object_unref0 (self->priv->update);
#line 53 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
	_g_object_unref0 (self->priv->delete);
#line 56 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
	_g_object_unref0 (self->priv->open);
#line 58 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
	_g_object_unref0 (self->priv->validation_timeout);
#line 21 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
	G_OBJECT_CLASS (composer_link_popover_parent_class)->finalize (obj);
#line 943 "composer-link-popover.c"
}


/**
 * A popover for editing a link in the composer.
 *
 * The exact appearance of the popover will depend on the {@link
 * Type} passed to the constructor:
 *
 * - For {@link Type.NEW_LINK}, the user will be presented with an
 *   insert button and an open button.
 * - For {@link Type.EXISTING_LINK}, the user will be presented with
 *   an update, delete and open buttons.
 */
GType
composer_link_popover_get_type (void)
{
	static volatile gsize composer_link_popover_type_id__volatile = 0;
	if (g_once_init_enter (&composer_link_popover_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (ComposerLinkPopoverClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) composer_link_popover_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ComposerLinkPopover), 0, (GInstanceInitFunc) composer_link_popover_instance_init, NULL };
		GType composer_link_popover_type_id;
		composer_link_popover_type_id = g_type_register_static (gtk_popover_get_type (), "ComposerLinkPopover", &g_define_type_info, 0);
		g_once_init_leave (&composer_link_popover_type_id__volatile, composer_link_popover_type_id);
	}
	return composer_link_popover_type_id__volatile;
}


static void
_vala_composer_link_popover_get_property (GObject * object,
                                          guint property_id,
                                          GValue * value,
                                          GParamSpec * pspec)
{
	ComposerLinkPopover * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_COMPOSER_LINK_POPOVER, ComposerLinkPopover);
#line 21 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
	switch (property_id) {
#line 21 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
		case COMPOSER_LINK_POPOVER_LINK_URI_PROPERTY:
#line 21 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
		g_value_set_string (value, composer_link_popover_get_link_uri (self));
#line 21 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
		break;
#line 988 "composer-link-popover.c"
		default:
#line 21 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 21 "/builddir/build/BUILD/geary-0.12.1/src/client/composer/composer-link-popover.vala"
		break;
#line 994 "composer-link-popover.c"
	}
}



