/* libnotify.c generated by valac 0.39.7, the Vala compiler
 * generated from libnotify.vala, do not modify */

/* Copyright 2016 Software Freedom Conservancy Inc.
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution.
 */
/* Displays a notification via libnotify*/

#include <glib.h>
#include <glib-object.h>
#include <geary-engine.h>
#include <libnotify/notify.h>
#include <stdlib.h>
#include <string.h>
#include <canberra.h>
#include <gio/gio.h>
#include <gtk/gtk.h>
#include <glib/gi18n-lib.h>
#include <gdk-pixbuf/gdk-pixbuf.h>


#define TYPE_LIBNOTIFY (libnotify_get_type ())
#define LIBNOTIFY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_LIBNOTIFY, Libnotify))
#define LIBNOTIFY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_LIBNOTIFY, LibnotifyClass))
#define IS_LIBNOTIFY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_LIBNOTIFY))
#define IS_LIBNOTIFY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_LIBNOTIFY))
#define LIBNOTIFY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_LIBNOTIFY, LibnotifyClass))

typedef struct _Libnotify Libnotify;
typedef struct _LibnotifyClass LibnotifyClass;
typedef struct _LibnotifyPrivate LibnotifyPrivate;

#define TYPE_NEW_MESSAGES_MONITOR (new_messages_monitor_get_type ())
#define NEW_MESSAGES_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_NEW_MESSAGES_MONITOR, NewMessagesMonitor))
#define NEW_MESSAGES_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_NEW_MESSAGES_MONITOR, NewMessagesMonitorClass))
#define IS_NEW_MESSAGES_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_NEW_MESSAGES_MONITOR))
#define IS_NEW_MESSAGES_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_NEW_MESSAGES_MONITOR))
#define NEW_MESSAGES_MONITOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_NEW_MESSAGES_MONITOR, NewMessagesMonitorClass))

typedef struct _NewMessagesMonitor NewMessagesMonitor;
typedef struct _NewMessagesMonitorClass NewMessagesMonitorClass;
enum  {
	LIBNOTIFY_0_PROPERTY,
	LIBNOTIFY_NUM_PROPERTIES
};
static GParamSpec* libnotify_properties[LIBNOTIFY_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define __g_list_free__g_free0_0(var) ((var == NULL) ? NULL : (var = (_g_list_free__g_free0_ (var), NULL)))
#define _ca_context_destroy0(var) ((var == NULL) ? NULL : (var = (ca_context_destroy (var), NULL)))

#define TYPE_GEARY_APPLICATION (geary_application_get_type ())
#define GEARY_APPLICATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_GEARY_APPLICATION, GearyApplication))
#define GEARY_APPLICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_GEARY_APPLICATION, GearyApplicationClass))
#define IS_GEARY_APPLICATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_GEARY_APPLICATION))
#define IS_GEARY_APPLICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_GEARY_APPLICATION))
#define GEARY_APPLICATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_GEARY_APPLICATION, GearyApplicationClass))

typedef struct _GearyApplication GearyApplication;
typedef struct _GearyApplicationClass GearyApplicationClass;

#define TYPE_CONFIGURATION (configuration_get_type ())
#define CONFIGURATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CONFIGURATION, Configuration))
#define CONFIGURATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CONFIGURATION, ConfigurationClass))
#define IS_CONFIGURATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CONFIGURATION))
#define IS_CONFIGURATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CONFIGURATION))
#define CONFIGURATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CONFIGURATION, ConfigurationClass))

typedef struct _Configuration Configuration;
typedef struct _ConfigurationClass ConfigurationClass;
#define _g_free0(var) (var = (g_free (var), NULL))

#define GRAVATAR_TYPE_DEFAULT (gravatar_default_get_type ())
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _LibnotifyNotifyOneMessageAsyncData LibnotifyNotifyOneMessageAsyncData;
enum  {
	LIBNOTIFY_INVOKED_SIGNAL,
	LIBNOTIFY_NUM_SIGNALS
};
static guint libnotify_signals[LIBNOTIFY_NUM_SIGNALS] = {0};
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _Libnotify {
	GearyBaseObject parent_instance;
	LibnotifyPrivate * priv;
};

struct _LibnotifyClass {
	GearyBaseObjectClass parent_class;
};

struct _LibnotifyPrivate {
	NewMessagesMonitor* monitor;
	NotifyNotification* current_notification;
	NotifyNotification* error_notification;
	GearyFolder* folder;
	GearyEmail* email;
	GList* caps;
};

typedef enum  {
	GRAVATAR_DEFAULT_NOT_FOUND,
	GRAVATAR_DEFAULT_MYSTERY_MAN,
	GRAVATAR_DEFAULT_IDENTICON,
	GRAVATAR_DEFAULT_MONSTER_ID,
	GRAVATAR_DEFAULT_WAVATAR,
	GRAVATAR_DEFAULT_RETRO
} GravatarDefault;

struct _LibnotifyNotifyOneMessageAsyncData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GAsyncReadyCallback _callback_;
	gboolean _task_complete_;
	Libnotify* self;
	GearyFolder* folder;
	GearyEmail* email;
	GCancellable* cancellable;
	GearyEmailField _tmp0_;
	GearyEmailField _tmp1_;
	GearyFolder* _tmp2_;
	GearyEmail* _tmp3_;
	gboolean _tmp4_;
	GearyApplication* _tmp5_;
	GearyApplication* _tmp6_;
	Configuration* _tmp7_;
	Configuration* _tmp8_;
	gboolean _tmp9_;
	gboolean _tmp10_;
	NewMessagesMonitor* _tmp11_;
	GearyRFC822MailboxAddress* primary;
	GearyRFC822MailboxAddress* _tmp12_;
	GearyRFC822MailboxAddress* _tmp13_;
	gchar* body;
	gint count;
	NewMessagesMonitor* _tmp14_;
	gint _tmp15_;
	gchar* _tmp16_;
	gint _tmp17_;
	gchar* _tmp18_;
	gchar* _tmp19_;
	gint _tmp20_;
	GearyAccount* _tmp21_;
	GearyAccount* _tmp22_;
	GearyAccountInformation* _tmp23_;
	GearyAccountInformation* _tmp24_;
	const gchar* _tmp25_;
	const gchar* _tmp26_;
	gchar* _tmp27_;
	GdkPixbuf* avatar;
	GInputStream* ins;
	GFile* file;
	GearyRFC822MailboxAddress* _tmp28_;
	gchar* _tmp29_;
	gchar* _tmp30_;
	GFile* _tmp31_;
	GFile* _tmp32_;
	GFileInputStream* _tmp33_;
	GFile* _tmp34_;
	GFileInputStream* _tmp35_;
	GFileInputStream* _tmp36_;
	GdkPixbuf* _tmp37_;
	GInputStream* _tmp38_;
	GdkPixbuf* _tmp39_;
	GdkPixbuf* _tmp40_;
	GError* err;
	GError* _tmp41_;
	const gchar* _tmp42_;
	GInputStream* _tmp43_;
	GInputStream* _tmp44_;
	GError* close_err;
	GearyRFC822MailboxAddress* _tmp45_;
	gchar* _tmp46_;
	gchar* _tmp47_;
	const gchar* _tmp48_;
	GdkPixbuf* _tmp49_;
	GError * _inner_error_;
};


static gpointer libnotify_parent_class = NULL;
static ca_context* libnotify_sound_context;
static ca_context* libnotify_sound_context = NULL;

GType libnotify_get_type (void) G_GNUC_CONST;
GType new_messages_monitor_get_type (void) G_GNUC_CONST;
#define LIBNOTIFY_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_LIBNOTIFY, LibnotifyPrivate))
static void libnotify_on_new_messages_arrived (Libnotify* self,
                                        GearyFolder* folder,
                                        gint total,
                                        gint added);
static void _libnotify_on_new_messages_arrived_new_messages_monitor_new_messages_arrived (NewMessagesMonitor* _sender,
                                                                                   GearyFolder* folder,
                                                                                   gint total,
                                                                                   gint added,
                                                                                   gpointer self);
static void _g_free0_ (gpointer var);
static inline void _g_list_free__g_free0_ (GList* self);
#define LIBNOTIFY_REQUIRED_FIELDS (GEARY_EMAIL_FIELD_ORIGINATORS | GEARY_EMAIL_FIELD_SUBJECT)
Libnotify* libnotify_new (NewMessagesMonitor* monitor);
Libnotify* libnotify_construct (GType object_type,
                                NewMessagesMonitor* monitor);
void new_messages_monitor_add_required_fields (NewMessagesMonitor* self,
                                               GearyEmailField fields);
#define GEARY_APPLICATION_PRGNAME "geary"
static void libnotify_init_sound (void);
GearyFolder* new_messages_monitor_get_last_new_message_folder (NewMessagesMonitor* self);
GearyEmail* new_messages_monitor_get_last_new_message (NewMessagesMonitor* self);
static void libnotify_notify_one_message_async (Libnotify* self,
                                         GearyFolder* folder,
                                         GearyEmail* email,
                                         GCancellable* cancellable,
                                         GAsyncReadyCallback _callback_,
                                         gpointer _user_data_);
static void libnotify_notify_one_message_finish (Libnotify* self,
                                          GAsyncResult* _res_,
                                          GError** error);
static void libnotify_notify_new_mail (Libnotify* self,
                                GearyFolder* folder,
                                gint added);
static void libnotify_on_default_action (Libnotify* self,
                                  NotifyNotification* notification,
                                  const gchar* action);
GType geary_application_get_type (void) G_GNUC_CONST;
GearyApplication* geary_application_get_instance (void) G_GNUC_DEPRECATED;
gpointer configuration_ref (gpointer instance);
void configuration_unref (gpointer instance);
GParamSpec* param_spec_configuration (const gchar* name,
                                      const gchar* nick,
                                      const gchar* blurb,
                                      GType object_type,
                                      GParamFlags flags);
void value_set_configuration (GValue* value,
                              gpointer v_object);
void value_take_configuration (GValue* value,
                               gpointer v_object);
gpointer value_get_configuration (const GValue* value);
GType configuration_get_type (void) G_GNUC_CONST;
Configuration* geary_application_get_config (GearyApplication* self);
gboolean configuration_get_show_notifications (Configuration* self);
gboolean new_messages_monitor_should_notify_new_messages (NewMessagesMonitor* self,
                                                          GearyFolder* folder);
gint new_messages_monitor_get_new_message_count (NewMessagesMonitor* self,
                                                 GearyFolder* folder);
static void libnotify_issue_current_notification (Libnotify* self,
                                           const gchar* summary,
                                           const gchar* body,
                                           GdkPixbuf* icon);
static void libnotify_notify_one_message_async_data_free (gpointer _data);
static void libnotify_notify_one_message_async_async_ready_wrapper (GObject *source_object,
                                                             GAsyncResult *res,
                                                             void *user_data);
static gboolean libnotify_notify_one_message_async_co (LibnotifyNotifyOneMessageAsyncData* _data_);
gchar* email_util_strip_subject_prefixes (GearyEmail* email);
GType gravatar_default_get_type (void) G_GNUC_CONST;
gchar* gravatar_get_image_uri (GearyRFC822MailboxAddress* addr,
                               GravatarDefault def,
                               gint size);
#define GRAVATAR_DEFAULT_SIZE 80
static void libnotify_notify_one_message_async_ready (GObject* source_object,
                                               GAsyncResult* _res_,
                                               gpointer _user_data_);
static NotifyNotification* libnotify_issue_notification (Libnotify* self,
                                                  const gchar* category,
                                                  const gchar* summary,
                                                  const gchar* body,
                                                  GdkPixbuf* icon,
                                                  const gchar* sound);
static void _libnotify_on_default_action_notify_action_callback (NotifyNotification* notification,
                                                          const gchar* action,
                                                          gpointer self);
void libnotify_play_sound (const gchar* sound);
gboolean configuration_get_play_sounds (Configuration* self);
void libnotify_set_error_notification (Libnotify* self,
                                       const gchar* summary,
                                       const gchar* body);
void libnotify_clear_error_notification (Libnotify* self);
static void g_cclosure_user_marshal_VOID__OBJECT_OBJECT (GClosure * closure,
                                                  GValue * return_value,
                                                  guint n_param_values,
                                                  const GValue * param_values,
                                                  gpointer invocation_hint,
                                                  gpointer marshal_data);
static void libnotify_finalize (GObject * obj);


static void
_libnotify_on_new_messages_arrived_new_messages_monitor_new_messages_arrived (NewMessagesMonitor* _sender,
                                                                              GearyFolder* folder,
                                                                              gint total,
                                                                              gint added,
                                                                              gpointer self)
{
#line 42 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	libnotify_on_new_messages_arrived ((Libnotify*) self, folder, total, added);
#line 303 "libnotify.c"
}


static void
_g_free0_ (gpointer var)
{
#line 19 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	var = (g_free (var), NULL);
#line 312 "libnotify.c"
}


static inline void
_g_list_free__g_free0_ (GList* self)
{
#line 19 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	g_list_free_full (self, (GDestroyNotify) _g_free0_);
#line 321 "libnotify.c"
}


static gpointer
_g_object_ref0 (gpointer self)
{
#line 24 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	return self ? g_object_ref (self) : NULL;
#line 330 "libnotify.c"
}


Libnotify*
libnotify_construct (GType object_type,
                     NewMessagesMonitor* monitor)
{
	Libnotify * self = NULL;
	NewMessagesMonitor* _tmp0_;
	GList* _tmp1_;
#line 23 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	g_return_val_if_fail (IS_NEW_MESSAGES_MONITOR (monitor), NULL);
#line 23 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	self = (Libnotify*) geary_base_object_construct (object_type);
#line 24 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	_tmp0_ = _g_object_ref0 (monitor);
#line 24 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	_g_object_unref0 (self->priv->monitor);
#line 24 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	self->priv->monitor = _tmp0_;
#line 26 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	new_messages_monitor_add_required_fields (monitor, LIBNOTIFY_REQUIRED_FIELDS);
#line 28 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	if (!notify_is_initted ()) {
#line 29 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
		if (!notify_init (GEARY_APPLICATION_PRGNAME)) {
#line 30 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
			g_message ("libnotify.vala:30: Failed to initialize libnotify.");
#line 359 "libnotify.c"
		}
	}
#line 33 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	libnotify_init_sound ();
#line 36 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	_tmp1_ = notify_get_server_caps ();
#line 36 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	__g_list_free__g_free0_0 (self->priv->caps);
#line 36 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	self->priv->caps = _tmp1_;
#line 38 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	g_signal_connect_object (monitor, "new-messages-arrived", (GCallback) _libnotify_on_new_messages_arrived_new_messages_monitor_new_messages_arrived, self, 0);
#line 23 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	return self;
#line 374 "libnotify.c"
}


Libnotify*
libnotify_new (NewMessagesMonitor* monitor)
{
#line 23 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	return libnotify_construct (TYPE_LIBNOTIFY, monitor);
#line 383 "libnotify.c"
}


static void
libnotify_init_sound (void)
{
	ca_context* _tmp0_;
#line 46 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	_tmp0_ = libnotify_sound_context;
#line 46 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	if (_tmp0_ == NULL) {
#line 395 "libnotify.c"
		ca_context* _tmp1_ = NULL;
#line 47 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
		ca_context_create (&_tmp1_);
#line 47 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
		_ca_context_destroy0 (libnotify_sound_context);
#line 47 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
		libnotify_sound_context = _tmp1_;
#line 403 "libnotify.c"
	}
}


static void
libnotify_on_new_messages_arrived (Libnotify* self,
                                   GearyFolder* folder,
                                   gint total,
                                   gint added)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
#line 50 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	g_return_if_fail (IS_LIBNOTIFY (self));
#line 50 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	g_return_if_fail (GEARY_IS_FOLDER (folder));
#line 51 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	if (added == 1) {
#line 422 "libnotify.c"
		NewMessagesMonitor* _tmp2_;
		GearyFolder* _tmp3_;
		GearyFolder* _tmp4_;
#line 51 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
		_tmp2_ = self->priv->monitor;
#line 51 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
		_tmp3_ = new_messages_monitor_get_last_new_message_folder (_tmp2_);
#line 51 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
		_tmp4_ = _tmp3_;
#line 51 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
		_tmp1_ = _tmp4_ != NULL;
#line 434 "libnotify.c"
	} else {
#line 51 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
		_tmp1_ = FALSE;
#line 438 "libnotify.c"
	}
#line 51 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	if (_tmp1_) {
#line 442 "libnotify.c"
		NewMessagesMonitor* _tmp5_;
		GearyEmail* _tmp6_;
		GearyEmail* _tmp7_;
#line 52 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
		_tmp5_ = self->priv->monitor;
#line 52 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
		_tmp6_ = new_messages_monitor_get_last_new_message (_tmp5_);
#line 52 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
		_tmp7_ = _tmp6_;
#line 52 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
		_tmp0_ = _tmp7_ != NULL;
#line 454 "libnotify.c"
	} else {
#line 51 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
		_tmp0_ = FALSE;
#line 458 "libnotify.c"
	}
#line 51 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	if (_tmp0_) {
#line 462 "libnotify.c"
		NewMessagesMonitor* _tmp8_;
		GearyFolder* _tmp9_;
		GearyFolder* _tmp10_;
		NewMessagesMonitor* _tmp11_;
		GearyEmail* _tmp12_;
		GearyEmail* _tmp13_;
#line 53 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
		_tmp8_ = self->priv->monitor;
#line 53 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
		_tmp9_ = new_messages_monitor_get_last_new_message_folder (_tmp8_);
#line 53 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
		_tmp10_ = _tmp9_;
#line 53 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
		_tmp11_ = self->priv->monitor;
#line 53 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
		_tmp12_ = new_messages_monitor_get_last_new_message (_tmp11_);
#line 53 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
		_tmp13_ = _tmp12_;
#line 53 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
		libnotify_notify_one_message_async (self, _tmp10_, _tmp13_, NULL, NULL, NULL);
#line 483 "libnotify.c"
	} else {
#line 55 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
		if (added > 0) {
#line 56 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
			libnotify_notify_new_mail (self, folder, added);
#line 489 "libnotify.c"
		}
	}
}


static void
libnotify_on_default_action (Libnotify* self,
                             NotifyNotification* notification,
                             const gchar* action)
{
	GearyFolder* _tmp0_;
	GearyEmail* _tmp1_;
	GearyApplication* _tmp2_;
	GearyApplication* _tmp3_;
#line 60 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	g_return_if_fail (IS_LIBNOTIFY (self));
#line 60 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	g_return_if_fail (NOTIFY_IS_NOTIFICATION (notification));
#line 60 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	g_return_if_fail (action != NULL);
#line 61 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	_tmp0_ = self->priv->folder;
#line 61 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	_tmp1_ = self->priv->email;
#line 61 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	g_signal_emit (self, libnotify_signals[LIBNOTIFY_INVOKED_SIGNAL], 0, _tmp0_, _tmp1_);
#line 62 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	_tmp2_ = geary_application_get_instance ();
#line 62 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	_tmp3_ = _tmp2_;
#line 62 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	g_application_activate (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, g_application_get_type (), GApplication));
#line 522 "libnotify.c"
}


static void
libnotify_notify_new_mail (Libnotify* self,
                           GearyFolder* folder,
                           gint added)
{
	gboolean _tmp0_ = FALSE;
	GearyApplication* _tmp1_;
	GearyApplication* _tmp2_;
	Configuration* _tmp3_;
	Configuration* _tmp4_;
	gboolean _tmp5_;
	gboolean _tmp6_;
	gchar* body = NULL;
	gchar* _tmp8_;
	gint total = 0;
	NewMessagesMonitor* _tmp9_;
	gint _tmp10_;
	GearyAccount* _tmp15_;
	GearyAccount* _tmp16_;
	GearyAccountInformation* _tmp17_;
	GearyAccountInformation* _tmp18_;
	const gchar* _tmp19_;
	const gchar* _tmp20_;
	const gchar* _tmp21_;
#line 65 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	g_return_if_fail (IS_LIBNOTIFY (self));
#line 65 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	g_return_if_fail (GEARY_IS_FOLDER (folder));
#line 67 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	_g_object_unref0 (self->priv->folder);
#line 67 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	self->priv->folder = NULL;
#line 68 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	_g_object_unref0 (self->priv->email);
#line 68 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	self->priv->email = NULL;
#line 70 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	_tmp1_ = geary_application_get_instance ();
#line 70 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	_tmp2_ = _tmp1_;
#line 70 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	_tmp3_ = geary_application_get_config (_tmp2_);
#line 70 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	_tmp4_ = _tmp3_;
#line 70 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	_tmp5_ = configuration_get_show_notifications (_tmp4_);
#line 70 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	_tmp6_ = _tmp5_;
#line 70 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	if (!_tmp6_) {
#line 70 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
		_tmp0_ = TRUE;
#line 578 "libnotify.c"
	} else {
		NewMessagesMonitor* _tmp7_;
#line 71 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
		_tmp7_ = self->priv->monitor;
#line 71 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
		_tmp0_ = !new_messages_monitor_should_notify_new_messages (_tmp7_, folder);
#line 585 "libnotify.c"
	}
#line 70 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	if (_tmp0_) {
#line 72 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
		return;
#line 591 "libnotify.c"
	}
#line 74 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	_tmp8_ = g_strdup_printf (ngettext ("%d new message", "%d new messages", (gulong) added), added);
#line 74 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	body = _tmp8_;
#line 75 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	_tmp9_ = self->priv->monitor;
#line 75 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	total = new_messages_monitor_get_new_message_count (_tmp9_, folder);
#line 76 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	_tmp10_ = total;
#line 76 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	if (_tmp10_ > added) {
#line 605 "libnotify.c"
		gint _tmp11_;
		const gchar* _tmp12_;
		gint _tmp13_;
		gchar* _tmp14_;
#line 77 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
		_tmp11_ = total;
#line 77 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
		_tmp12_ = body;
#line 77 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
		_tmp13_ = total;
#line 77 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
		_tmp14_ = g_strdup_printf (ngettext ("%s, %d new message total", "%s, %d new messages total", (gulong) _tmp11_), _tmp12_, _tmp13_);
#line 77 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
		_g_free0 (body);
#line 77 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
		body = _tmp14_;
#line 622 "libnotify.c"
	}
#line 81 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	_tmp15_ = geary_folder_get_account (folder);
#line 81 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	_tmp16_ = _tmp15_;
#line 81 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	_tmp17_ = geary_account_get_information (_tmp16_);
#line 81 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	_tmp18_ = _tmp17_;
#line 81 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	_tmp19_ = geary_account_information_get_display_name (_tmp18_);
#line 81 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	_tmp20_ = _tmp19_;
#line 81 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	_tmp21_ = body;
#line 81 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	libnotify_issue_current_notification (self, _tmp20_, _tmp21_, NULL);
#line 65 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	_g_free0 (body);
#line 642 "libnotify.c"
}


static void
libnotify_notify_one_message_async_data_free (gpointer _data)
{
	LibnotifyNotifyOneMessageAsyncData* _data_;
	_data_ = _data;
#line 8 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	_g_object_unref0 (_data_->folder);
#line 8 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	_g_object_unref0 (_data_->email);
#line 8 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	_g_object_unref0 (_data_->cancellable);
#line 8 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	_g_object_unref0 (_data_->self);
#line 8 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	g_slice_free (LibnotifyNotifyOneMessageAsyncData, _data_);
#line 661 "libnotify.c"
}


static void
libnotify_notify_one_message_async_async_ready_wrapper (GObject *source_object,
                                                        GAsyncResult *res,
                                                        void *user_data)
{
	LibnotifyNotifyOneMessageAsyncData* _task_data_;
#line 8 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	_task_data_ = g_task_get_task_data (G_TASK (res));
#line 8 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	if (_task_data_->_callback_ != NULL) {
#line 8 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
		_task_data_->_callback_ (source_object, res, user_data);
#line 677 "libnotify.c"
	}
#line 8 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	_task_data_->_task_complete_ = TRUE;
#line 681 "libnotify.c"
}


static void
libnotify_notify_one_message_async (Libnotify* self,
                                    GearyFolder* folder,
                                    GearyEmail* email,
                                    GCancellable* cancellable,
                                    GAsyncReadyCallback _callback_,
                                    gpointer _user_data_)
{
	LibnotifyNotifyOneMessageAsyncData* _data_;
	Libnotify* _tmp0_;
	GearyFolder* _tmp1_;
	GearyEmail* _tmp2_;
	GCancellable* _tmp3_;
#line 8 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	_data_ = g_slice_new0 (LibnotifyNotifyOneMessageAsyncData);
#line 8 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	_data_->_callback_ = _callback_;
#line 8 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), cancellable, libnotify_notify_one_message_async_async_ready_wrapper, _user_data_);
#line 8 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	if (_callback_ == NULL) {
#line 8 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
		_data_->_task_complete_ = TRUE;
#line 708 "libnotify.c"
	}
#line 8 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	g_task_set_task_data (_data_->_async_result, _data_, libnotify_notify_one_message_async_data_free);
#line 8 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 8 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	_data_->self = _tmp0_;
#line 8 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	_tmp1_ = _g_object_ref0 (folder);
#line 8 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	_g_object_unref0 (_data_->folder);
#line 8 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	_data_->folder = _tmp1_;
#line 8 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	_tmp2_ = _g_object_ref0 (email);
#line 8 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	_g_object_unref0 (_data_->email);
#line 8 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	_data_->email = _tmp2_;
#line 8 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	_tmp3_ = _g_object_ref0 (cancellable);
#line 8 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	_g_object_unref0 (_data_->cancellable);
#line 8 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	_data_->cancellable = _tmp3_;
#line 8 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	libnotify_notify_one_message_async_co (_data_);
#line 736 "libnotify.c"
}


static void
libnotify_notify_one_message_finish (Libnotify* self,
                                     GAsyncResult* _res_,
                                     GError** error)
{
	LibnotifyNotifyOneMessageAsyncData* _data_;
#line 8 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 8 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	if (NULL == _data_) {
#line 8 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
		return;
#line 752 "libnotify.c"
	}
}


static void
libnotify_notify_one_message_async_ready (GObject* source_object,
                                          GAsyncResult* _res_,
                                          gpointer _user_data_)
{
	LibnotifyNotifyOneMessageAsyncData* _data_;
#line 118 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	_data_ = _user_data_;
#line 118 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	_data_->_source_object_ = source_object;
#line 118 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	_data_->_res_ = _res_;
#line 118 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	_data_->_task_complete_ = TRUE;
#line 118 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	libnotify_notify_one_message_async_co (_data_);
#line 773 "libnotify.c"
}


static gboolean
libnotify_notify_one_message_async_co (LibnotifyNotifyOneMessageAsyncData* _data_)
{
#line 84 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	switch (_data_->_state_) {
#line 84 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
		case 0:
#line 784 "libnotify.c"
		goto _state_0;
#line 84 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
		case 1:
#line 788 "libnotify.c"
		goto _state_1;
#line 84 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
		case 2:
#line 792 "libnotify.c"
		goto _state_2;
#line 84 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
		case 3:
#line 796 "libnotify.c"
		goto _state_3;
		default:
#line 84 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
		g_assert_not_reached ();
#line 801 "libnotify.c"
	}
	_state_0:
#line 86 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	_data_->_tmp0_ = geary_email_get_fields (_data_->email);
#line 86 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	_data_->_tmp1_ = _data_->_tmp0_;
#line 86 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	_vala_assert (geary_email_field_fulfills (_data_->_tmp1_, LIBNOTIFY_REQUIRED_FIELDS), "email.fields.fulfills(REQUIRED_FIELDS)");
#line 89 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	_data_->_tmp2_ = _g_object_ref0 (_data_->folder);
#line 89 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	_g_object_unref0 (_data_->self->priv->folder);
#line 89 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	_data_->self->priv->folder = _data_->_tmp2_;
#line 90 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	_data_->_tmp3_ = _g_object_ref0 (_data_->email);
#line 90 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	_g_object_unref0 (_data_->self->priv->email);
#line 90 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	_data_->self->priv->email = _data_->_tmp3_;
#line 92 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	_data_->_tmp5_ = geary_application_get_instance ();
#line 92 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	_data_->_tmp6_ = _data_->_tmp5_;
#line 92 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	_data_->_tmp7_ = geary_application_get_config (_data_->_tmp6_);
#line 92 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	_data_->_tmp8_ = _data_->_tmp7_;
#line 92 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	_data_->_tmp9_ = configuration_get_show_notifications (_data_->_tmp8_);
#line 92 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	_data_->_tmp10_ = _data_->_tmp9_;
#line 92 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	if (!_data_->_tmp10_) {
#line 92 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
		_data_->_tmp4_ = TRUE;
#line 838 "libnotify.c"
	} else {
#line 93 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
		_data_->_tmp11_ = _data_->self->priv->monitor;
#line 93 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
		_data_->_tmp4_ = !new_messages_monitor_should_notify_new_messages (_data_->_tmp11_, _data_->folder);
#line 844 "libnotify.c"
	}
#line 92 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	if (_data_->_tmp4_) {
#line 94 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 94 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
		if (_data_->_state_ != 0) {
#line 94 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
			while (_data_->_task_complete_ != TRUE) {
#line 94 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 856 "libnotify.c"
			}
		}
#line 94 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
		g_object_unref (_data_->_async_result);
#line 94 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
		return FALSE;
#line 863 "libnotify.c"
	}
#line 97 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	_data_->_tmp12_ = geary_email_get_primary_originator (_data_->email);
#line 97 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	_data_->primary = _data_->_tmp12_;
#line 98 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	_data_->_tmp13_ = _data_->primary;
#line 98 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	if (_data_->_tmp13_ == NULL) {
#line 99 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
		libnotify_notify_new_mail (_data_->self, _data_->folder, 1);
#line 101 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
		_g_object_unref0 (_data_->primary);
#line 101 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 101 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
		if (_data_->_state_ != 0) {
#line 101 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
			while (_data_->_task_complete_ != TRUE) {
#line 101 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 885 "libnotify.c"
			}
		}
#line 101 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
		g_object_unref (_data_->_async_result);
#line 101 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
		return FALSE;
#line 892 "libnotify.c"
	}
#line 105 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	_data_->_tmp14_ = _data_->self->priv->monitor;
#line 105 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	_data_->count = new_messages_monitor_get_new_message_count (_data_->_tmp14_, _data_->folder);
#line 106 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	_data_->_tmp15_ = _data_->count;
#line 106 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	if (_data_->_tmp15_ <= 1) {
#line 107 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
		_data_->_tmp16_ = email_util_strip_subject_prefixes (_data_->email);
#line 107 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
		_g_free0 (_data_->body);
#line 107 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
		_data_->body = _data_->_tmp16_;
#line 908 "libnotify.c"
	} else {
#line 109 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
		_data_->_tmp17_ = _data_->count;
#line 109 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
		_data_->_tmp18_ = email_util_strip_subject_prefixes (_data_->email);
#line 109 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
		_data_->_tmp19_ = _data_->_tmp18_;
#line 109 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
		_data_->_tmp20_ = _data_->count;
#line 109 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
		_data_->_tmp21_ = geary_folder_get_account (_data_->folder);
#line 109 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
		_data_->_tmp22_ = _data_->_tmp21_;
#line 109 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
		_data_->_tmp23_ = geary_account_get_information (_data_->_tmp22_);
#line 109 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
		_data_->_tmp24_ = _data_->_tmp23_;
#line 109 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
		_data_->_tmp25_ = geary_account_information_get_display_name (_data_->_tmp24_);
#line 109 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
		_data_->_tmp26_ = _data_->_tmp25_;
#line 109 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
		_data_->_tmp27_ = g_strdup_printf (ngettext ("%s\n(%d other new message for %s)", "%s\n(%d other new messages for %s)", (gulong) (_data_->_tmp17_ - 1)), _data_->_tmp19_, _data_->_tmp20_ - 1, _data_->_tmp26_);
#line 109 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
		_g_free0 (_data_->body);
#line 109 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
		_data_->body = _data_->_tmp27_;
#line 109 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
		_g_free0 (_data_->_tmp19_);
#line 938 "libnotify.c"
	}
#line 114 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	_data_->avatar = NULL;
#line 115 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	_data_->ins = NULL;
#line 116 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	_data_->_tmp28_ = _data_->primary;
#line 116 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	_data_->_tmp29_ = gravatar_get_image_uri (_data_->_tmp28_, GRAVATAR_DEFAULT_MYSTERY_MAN, GRAVATAR_DEFAULT_SIZE);
#line 116 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	_data_->_tmp30_ = _data_->_tmp29_;
#line 116 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	_data_->_tmp31_ = g_file_new_for_uri (_data_->_tmp30_);
#line 116 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	_data_->_tmp32_ = _data_->_tmp31_;
#line 116 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	_g_free0 (_data_->_tmp30_);
#line 116 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	_data_->file = _data_->_tmp32_;
#line 958 "libnotify.c"
	{
#line 118 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
		_data_->_tmp34_ = _data_->file;
#line 118 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
		_data_->_state_ = 1;
#line 118 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
		g_file_read_async (_data_->_tmp34_, G_PRIORITY_DEFAULT, _data_->cancellable, libnotify_notify_one_message_async_ready, _data_);
#line 118 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
		return FALSE;
#line 968 "libnotify.c"
		_state_1:
#line 118 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
		_data_->_tmp35_ = g_file_read_finish (_data_->_tmp34_, _data_->_res_, &_data_->_inner_error_);
#line 118 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
		_data_->_tmp33_ = _data_->_tmp35_;
#line 118 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
		if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
#line 976 "libnotify.c"
			goto __catch119_g_error;
		}
#line 118 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
		_data_->_tmp36_ = _data_->_tmp33_;
#line 118 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
		_data_->_tmp33_ = NULL;
#line 118 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
		_g_object_unref0 (_data_->ins);
#line 118 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
		_data_->ins = G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp36_, g_input_stream_get_type (), GInputStream);
#line 119 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
		_data_->_tmp38_ = _data_->ins;
#line 119 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
		_data_->_state_ = 2;
#line 119 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
		gdk_pixbuf_new_from_stream_async (_data_->_tmp38_, _data_->cancellable, libnotify_notify_one_message_async_ready, _data_);
#line 119 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
		return FALSE;
#line 995 "libnotify.c"
		_state_2:
#line 119 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
		_data_->_tmp39_ = (GdkPixbuf*) gdk_pixbuf_new_from_stream_finish (_data_->_res_, &_data_->_inner_error_);
#line 119 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
		_data_->_tmp37_ = _data_->_tmp39_;
#line 119 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
		if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
#line 119 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
			_g_object_unref0 (_data_->_tmp33_);
#line 1005 "libnotify.c"
			goto __catch119_g_error;
		}
#line 119 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
		_data_->_tmp40_ = _data_->_tmp37_;
#line 119 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
		_data_->_tmp37_ = NULL;
#line 119 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
		_g_object_unref0 (_data_->avatar);
#line 119 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
		_data_->avatar = _data_->_tmp40_;
#line 117 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
		_g_object_unref0 (_data_->_tmp37_);
#line 117 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
		_g_object_unref0 (_data_->_tmp33_);
#line 1020 "libnotify.c"
	}
	goto __finally119;
	__catch119_g_error:
	{
#line 117 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
		_data_->err = _data_->_inner_error_;
#line 117 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
		_data_->_inner_error_ = NULL;
#line 121 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
		_data_->_tmp41_ = _data_->err;
#line 121 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
		_data_->_tmp42_ = _data_->_tmp41_->message;
#line 121 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
		g_debug ("libnotify.vala:121: Failed to get avatar for notification: %s", _data_->_tmp42_);
#line 117 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
		_g_error_free0 (_data_->err);
#line 1037 "libnotify.c"
	}
	__finally119:
#line 117 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
#line 117 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error_);
#line 117 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
		_g_object_unref0 (_data_->file);
#line 117 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
		_g_object_unref0 (_data_->ins);
#line 117 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
		_g_object_unref0 (_data_->avatar);
#line 117 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
		_g_free0 (_data_->body);
#line 117 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
		_g_object_unref0 (_data_->primary);
#line 117 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
		g_object_unref (_data_->_async_result);
#line 117 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
		return FALSE;
#line 1058 "libnotify.c"
	}
#line 124 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	_data_->_tmp43_ = _data_->ins;
#line 124 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	if (_data_->_tmp43_ != NULL) {
#line 1064 "libnotify.c"
		{
#line 126 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
			_data_->_tmp44_ = _data_->ins;
#line 126 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
			_data_->_state_ = 3;
#line 126 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
			g_input_stream_close_async (_data_->_tmp44_, G_PRIORITY_DEFAULT, _data_->cancellable, libnotify_notify_one_message_async_ready, _data_);
#line 126 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
			return FALSE;
#line 1074 "libnotify.c"
			_state_3:
#line 126 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
			g_input_stream_close_finish (_data_->_tmp44_, _data_->_res_, &_data_->_inner_error_);
#line 126 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
			if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
#line 1080 "libnotify.c"
				goto __catch120_g_error;
			}
		}
		goto __finally120;
		__catch120_g_error:
		{
#line 125 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
			_data_->close_err = _data_->_inner_error_;
#line 125 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
			_data_->_inner_error_ = NULL;
#line 125 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
			_g_error_free0 (_data_->close_err);
#line 1093 "libnotify.c"
		}
		__finally120:
#line 125 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
		if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
#line 125 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
			g_task_return_error (_data_->_async_result, _data_->_inner_error_);
#line 125 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
			_g_object_unref0 (_data_->file);
#line 125 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
			_g_object_unref0 (_data_->ins);
#line 125 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
			_g_object_unref0 (_data_->avatar);
#line 125 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
			_g_free0 (_data_->body);
#line 125 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
			_g_object_unref0 (_data_->primary);
#line 125 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
			g_object_unref (_data_->_async_result);
#line 125 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
			return FALSE;
#line 1114 "libnotify.c"
		}
#line 131 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
		_g_object_unref0 (_data_->ins);
#line 131 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
		_data_->ins = NULL;
#line 1120 "libnotify.c"
	}
#line 134 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	_data_->_tmp45_ = _data_->primary;
#line 134 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	_data_->_tmp46_ = geary_rf_c822_mailbox_address_get_short_address (_data_->_tmp45_);
#line 134 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	_data_->_tmp47_ = _data_->_tmp46_;
#line 134 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	_data_->_tmp48_ = _data_->body;
#line 134 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	_data_->_tmp49_ = _data_->avatar;
#line 134 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	libnotify_issue_current_notification (_data_->self, _data_->_tmp47_, _data_->_tmp48_, _data_->_tmp49_);
#line 134 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	_g_free0 (_data_->_tmp47_);
#line 84 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	_g_object_unref0 (_data_->file);
#line 84 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	_g_object_unref0 (_data_->ins);
#line 84 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	_g_object_unref0 (_data_->avatar);
#line 84 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	_g_free0 (_data_->body);
#line 84 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	_g_object_unref0 (_data_->primary);
#line 84 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 84 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	if (_data_->_state_ != 0) {
#line 84 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
		while (_data_->_task_complete_ != TRUE) {
#line 84 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1154 "libnotify.c"
		}
	}
#line 84 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	g_object_unref (_data_->_async_result);
#line 84 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	return FALSE;
#line 1161 "libnotify.c"
}


static void
libnotify_issue_current_notification (Libnotify* self,
                                      const gchar* summary,
                                      const gchar* body,
                                      GdkPixbuf* icon)
{
	NotifyNotification* _tmp0_;
	NotifyNotification* _tmp4_;
	GError * _inner_error_ = NULL;
#line 137 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	g_return_if_fail (IS_LIBNOTIFY (self));
#line 137 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	g_return_if_fail (summary != NULL);
#line 137 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	g_return_if_fail (body != NULL);
#line 137 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	g_return_if_fail ((icon == NULL) || GDK_IS_PIXBUF (icon));
#line 139 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	_tmp0_ = self->priv->current_notification;
#line 139 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	if (_tmp0_ != NULL) {
#line 1186 "libnotify.c"
		{
			NotifyNotification* _tmp1_;
#line 141 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
			_tmp1_ = self->priv->current_notification;
#line 141 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
			notify_notification_close (_tmp1_, &_inner_error_);
#line 141 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1195 "libnotify.c"
				goto __catch121_g_error;
			}
		}
		goto __finally121;
		__catch121_g_error:
		{
			GError* err = NULL;
			GError* _tmp2_;
			const gchar* _tmp3_;
#line 140 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
			err = _inner_error_;
#line 140 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
			_inner_error_ = NULL;
#line 143 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
			_tmp2_ = err;
#line 143 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
			_tmp3_ = _tmp2_->message;
#line 143 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
			g_debug ("libnotify.vala:143: Unable to close current libnotify notification: %s", _tmp3_);
#line 140 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
			_g_error_free0 (err);
#line 1217 "libnotify.c"
		}
		__finally121:
#line 140 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 140 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 140 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
			g_clear_error (&_inner_error_);
#line 140 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
			return;
#line 1228 "libnotify.c"
		}
#line 146 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
		_g_object_unref0 (self->priv->current_notification);
#line 146 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
		self->priv->current_notification = NULL;
#line 1234 "libnotify.c"
	}
#line 149 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	_tmp4_ = libnotify_issue_notification (self, "email.arrived", summary, body, icon, "message-new_email");
#line 149 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	_g_object_unref0 (self->priv->current_notification);
#line 149 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	self->priv->current_notification = _tmp4_;
#line 1242 "libnotify.c"
}


static void
_libnotify_on_default_action_notify_action_callback (NotifyNotification* notification,
                                                     const gchar* action,
                                                     gpointer self)
{
#line 165 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	libnotify_on_default_action ((Libnotify*) self, notification, action);
#line 1253 "libnotify.c"
}


static NotifyNotification*
libnotify_issue_notification (Libnotify* self,
                              const gchar* category,
                              const gchar* summary,
                              const gchar* body,
                              GdkPixbuf* icon,
                              const gchar* sound)
{
	NotifyNotification* result = NULL;
	GList* _tmp0_;
	NotifyNotification* notification = NULL;
	const gchar* _tmp1_;
	GObject* _tmp2_;
	GObject* _tmp3_;
	NotifyNotification* _tmp4_;
	GList* _tmp5_;
	GCompareFunc _tmp6_;
	GList* _tmp7_;
	NotifyNotification* _tmp9_;
	NotifyNotification* _tmp10_;
	NotifyNotification* _tmp11_;
	GError * _inner_error_ = NULL;
#line 153 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	g_return_val_if_fail (IS_LIBNOTIFY (self), NULL);
#line 153 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	g_return_val_if_fail (category != NULL, NULL);
#line 153 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	g_return_val_if_fail (summary != NULL, NULL);
#line 153 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	g_return_val_if_fail (body != NULL, NULL);
#line 153 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	g_return_val_if_fail ((icon == NULL) || GDK_IS_PIXBUF (icon), NULL);
#line 155 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	_tmp0_ = self->priv->caps;
#line 155 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	if (_tmp0_ == NULL) {
#line 156 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
		result = NULL;
#line 156 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
		return result;
#line 1297 "libnotify.c"
	}
#line 159 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	_tmp1_ = g_get_application_name ();
#line 159 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	_tmp2_ = g_object_new (NOTIFY_TYPE_NOTIFICATION, "icon-name", "geary", "summary", _tmp1_, NULL);
#line 159 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	_tmp3_ = G_IS_INITIALLY_UNOWNED (_tmp2_) ? g_object_ref_sink (_tmp2_) : _tmp2_;
#line 159 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	notification = G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, NOTIFY_TYPE_NOTIFICATION, NotifyNotification);
#line 163 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	_tmp4_ = notification;
#line 163 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	notify_notification_set_hint_string (_tmp4_, "desktop-entry", "org.gnome.Geary");
#line 164 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	_tmp5_ = self->priv->caps;
#line 164 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	_tmp6_ = g_strcmp0;
#line 164 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	_tmp7_ = g_list_find_custom (_tmp5_, "actions", _tmp6_);
#line 164 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	if (_tmp7_ != NULL) {
#line 1319 "libnotify.c"
		NotifyNotification* _tmp8_;
#line 165 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
		_tmp8_ = notification;
#line 165 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
		notify_notification_add_action (_tmp8_, "default", _ ("Open"), _libnotify_on_default_action_notify_action_callback, g_object_ref (self), g_object_unref);
#line 1325 "libnotify.c"
	}
#line 167 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	_tmp9_ = notification;
#line 167 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	notify_notification_set_category (_tmp9_, category);
#line 168 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	_tmp10_ = notification;
#line 168 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	g_object_set (G_TYPE_CHECK_INSTANCE_CAST (_tmp10_, G_TYPE_OBJECT, GObject), "summary", summary, NULL);
#line 169 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	_tmp11_ = notification;
#line 169 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	g_object_set (G_TYPE_CHECK_INSTANCE_CAST (_tmp11_, G_TYPE_OBJECT, GObject), "body", body, NULL);
#line 171 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	if (icon != NULL) {
#line 1341 "libnotify.c"
		NotifyNotification* _tmp12_;
#line 172 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
		_tmp12_ = notification;
#line 172 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
		notify_notification_set_image_from_pixbuf (_tmp12_, icon);
#line 1347 "libnotify.c"
	}
#line 174 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	if (sound != NULL) {
#line 1351 "libnotify.c"
		GList* _tmp13_;
		GList* _tmp14_;
#line 175 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
		_tmp13_ = self->priv->caps;
#line 175 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
		_tmp14_ = g_list_find (_tmp13_, "sound");
#line 175 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
		if (_tmp14_ != NULL) {
#line 1360 "libnotify.c"
			NotifyNotification* _tmp15_;
#line 176 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
			_tmp15_ = notification;
#line 176 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
			notify_notification_set_hint_string (_tmp15_, "sound-name", sound);
#line 1366 "libnotify.c"
		} else {
#line 178 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
			libnotify_play_sound (sound);
#line 1370 "libnotify.c"
		}
	}
	{
		NotifyNotification* _tmp16_;
#line 182 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
		_tmp16_ = notification;
#line 182 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
		notify_notification_show (_tmp16_, &_inner_error_);
#line 182 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1381 "libnotify.c"
			goto __catch122_g_error;
		}
	}
	goto __finally122;
	__catch122_g_error:
	{
		GError* err = NULL;
		GError* _tmp17_;
		const gchar* _tmp18_;
#line 181 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
		err = _inner_error_;
#line 181 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
		_inner_error_ = NULL;
#line 184 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
		_tmp17_ = err;
#line 184 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
		_tmp18_ = _tmp17_->message;
#line 184 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
		g_message ("libnotify.vala:184: Unable to show notification: %s", _tmp18_);
#line 181 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
		_g_error_free0 (err);
#line 1403 "libnotify.c"
	}
	__finally122:
#line 181 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 181 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
		_g_object_unref0 (notification);
#line 181 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 181 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
		g_clear_error (&_inner_error_);
#line 181 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
		return NULL;
#line 1416 "libnotify.c"
	}
#line 187 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	result = notification;
#line 187 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	return result;
#line 1422 "libnotify.c"
}


void
libnotify_play_sound (const gchar* sound)
{
	GearyApplication* _tmp0_;
	GearyApplication* _tmp1_;
	Configuration* _tmp2_;
	Configuration* _tmp3_;
	gboolean _tmp4_;
	gboolean _tmp5_;
	ca_context* _tmp6_;
#line 190 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	g_return_if_fail (sound != NULL);
#line 191 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	_tmp0_ = geary_application_get_instance ();
#line 191 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	_tmp1_ = _tmp0_;
#line 191 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	_tmp2_ = geary_application_get_config (_tmp1_);
#line 191 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	_tmp3_ = _tmp2_;
#line 191 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	_tmp4_ = configuration_get_play_sounds (_tmp3_);
#line 191 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	_tmp5_ = _tmp4_;
#line 191 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	if (!_tmp5_) {
#line 192 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
		return;
#line 1454 "libnotify.c"
	}
#line 194 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	libnotify_init_sound ();
#line 195 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	_tmp6_ = libnotify_sound_context;
#line 195 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	ca_context_play (_tmp6_, (guint32) 0, CA_PROP_EVENT_ID, sound, NULL);
#line 1462 "libnotify.c"
}


void
libnotify_set_error_notification (Libnotify* self,
                                  const gchar* summary,
                                  const gchar* body)
{
	NotifyNotification* _tmp0_;
	NotifyNotification* _tmp1_;
#line 198 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	g_return_if_fail (IS_LIBNOTIFY (self));
#line 198 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	g_return_if_fail (summary != NULL);
#line 198 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	g_return_if_fail (body != NULL);
#line 202 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	_tmp0_ = self->priv->error_notification;
#line 202 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	if (_tmp0_ != NULL) {
#line 203 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
		return;
#line 1485 "libnotify.c"
	}
#line 205 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	_tmp1_ = libnotify_issue_notification (self, "email", summary, body, NULL, NULL);
#line 205 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	_g_object_unref0 (self->priv->error_notification);
#line 205 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	self->priv->error_notification = _tmp1_;
#line 1493 "libnotify.c"
}


void
libnotify_clear_error_notification (Libnotify* self)
{
	NotifyNotification* _tmp0_;
	GError * _inner_error_ = NULL;
#line 208 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	g_return_if_fail (IS_LIBNOTIFY (self));
#line 209 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	_tmp0_ = self->priv->error_notification;
#line 209 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	if (_tmp0_ != NULL) {
#line 1508 "libnotify.c"
		{
			NotifyNotification* _tmp1_;
#line 211 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
			_tmp1_ = self->priv->error_notification;
#line 211 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
			notify_notification_close (_tmp1_, &_inner_error_);
#line 211 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1517 "libnotify.c"
				goto __catch123_g_error;
			}
		}
		goto __finally123;
		__catch123_g_error:
		{
			GError* err = NULL;
			GError* _tmp2_;
			const gchar* _tmp3_;
#line 210 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
			err = _inner_error_;
#line 210 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
			_inner_error_ = NULL;
#line 213 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
			_tmp2_ = err;
#line 213 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
			_tmp3_ = _tmp2_->message;
#line 213 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
			g_debug ("libnotify.vala:213: Unable to close libnotify error notification: %s", _tmp3_);
#line 210 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
			_g_error_free0 (err);
#line 1539 "libnotify.c"
		}
		__finally123:
#line 210 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 210 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 210 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
			g_clear_error (&_inner_error_);
#line 210 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
			return;
#line 1550 "libnotify.c"
		}
#line 216 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
		_g_object_unref0 (self->priv->error_notification);
#line 216 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
		self->priv->error_notification = NULL;
#line 1556 "libnotify.c"
	}
}


static void
g_cclosure_user_marshal_VOID__OBJECT_OBJECT (GClosure * closure,
                                             GValue * return_value,
                                             guint n_param_values,
                                             const GValue * param_values,
                                             gpointer invocation_hint,
                                             gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__OBJECT_OBJECT) (gpointer data1, gpointer arg_1, gpointer arg_2, gpointer data2);
	register GMarshalFunc_VOID__OBJECT_OBJECT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 153 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	g_return_if_fail (n_param_values == 3);
#line 153 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 153 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
		data1 = closure->data;
#line 153 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
		data2 = param_values->data[0].v_pointer;
#line 1583 "libnotify.c"
	} else {
#line 153 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
		data1 = param_values->data[0].v_pointer;
#line 153 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
		data2 = closure->data;
#line 1589 "libnotify.c"
	}
#line 153 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	callback = (GMarshalFunc_VOID__OBJECT_OBJECT) (marshal_data ? marshal_data : cc->callback);
#line 153 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	callback (data1, g_value_get_object (param_values + 1), g_value_get_object (param_values + 2), data2);
#line 1595 "libnotify.c"
}


static void
libnotify_class_init (LibnotifyClass * klass)
{
#line 8 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	libnotify_parent_class = g_type_class_peek_parent (klass);
#line 8 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	g_type_class_add_private (klass, sizeof (LibnotifyPrivate));
#line 8 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	G_OBJECT_CLASS (klass)->finalize = libnotify_finalize;
#line 8 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	libnotify_signals[LIBNOTIFY_INVOKED_SIGNAL] = g_signal_new ("invoked", TYPE_LIBNOTIFY, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_OBJECT, G_TYPE_NONE, 2, GEARY_TYPE_FOLDER, GEARY_TYPE_EMAIL);
#line 1610 "libnotify.c"
}


static void
libnotify_instance_init (Libnotify * self)
{
#line 8 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	self->priv = LIBNOTIFY_GET_PRIVATE (self);
#line 15 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	self->priv->current_notification = NULL;
#line 16 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	self->priv->error_notification = NULL;
#line 17 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	self->priv->folder = NULL;
#line 18 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	self->priv->email = NULL;
#line 19 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	self->priv->caps = NULL;
#line 1629 "libnotify.c"
}


static void
libnotify_finalize (GObject * obj)
{
	Libnotify * self;
	NewMessagesMonitor* _tmp0_;
	guint _tmp1_;
#line 8 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_LIBNOTIFY, Libnotify);
#line 42 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	_tmp0_ = self->priv->monitor;
#line 42 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	g_signal_parse_name ("new-messages-arrived", TYPE_NEW_MESSAGES_MONITOR, &_tmp1_, NULL, FALSE);
#line 42 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	g_signal_handlers_disconnect_matched (_tmp0_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp1_, 0, NULL, (GCallback) _libnotify_on_new_messages_arrived_new_messages_monitor_new_messages_arrived, self);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	_g_object_unref0 (self->priv->monitor);
#line 15 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	_g_object_unref0 (self->priv->current_notification);
#line 16 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	_g_object_unref0 (self->priv->error_notification);
#line 17 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	_g_object_unref0 (self->priv->folder);
#line 18 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	_g_object_unref0 (self->priv->email);
#line 19 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	__g_list_free__g_free0_0 (self->priv->caps);
#line 153 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/libnotify.vala"
	G_OBJECT_CLASS (libnotify_parent_class)->finalize (obj);
#line 1661 "libnotify.c"
}


GType
libnotify_get_type (void)
{
	static volatile gsize libnotify_type_id__volatile = 0;
	if (g_once_init_enter (&libnotify_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (LibnotifyClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) libnotify_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Libnotify), 0, (GInstanceInitFunc) libnotify_instance_init, NULL };
		GType libnotify_type_id;
		libnotify_type_id = g_type_register_static (GEARY_TYPE_BASE_OBJECT, "Libnotify", &g_define_type_info, 0);
		g_once_init_leave (&libnotify_type_id__volatile, libnotify_type_id);
	}
	return libnotify_type_id__volatile;
}



