/* new-messages-monitor.c generated by valac 0.39.7, the Vala compiler
 * generated from new-messages-monitor.vala, do not modify */

/* Copyright 2016 Software Freedom Conservancy Inc.
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution.
 */
/* NewMessagesMonitor is a central data store for new message information that the various*/
/* notification methods (libnotify, libunity, etc.) can monitor to do their thing.*/
/* Subclasses should trap the "notify::count" signal and use that to perform whatever magic*/
/* they need for their implementation, or trap "new-messages" to receive notifications of the emails*/
/* themselves as they're added.  In the latter case, subscribers should add required Email.Field*/
/* flags to the object with add_required_fields().*/

#include <glib.h>
#include <glib-object.h>
#include <geary-engine.h>
#include <gee.h>
#include <gio/gio.h>


#define TYPE_NEW_MESSAGES_MONITOR (new_messages_monitor_get_type ())
#define NEW_MESSAGES_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_NEW_MESSAGES_MONITOR, NewMessagesMonitor))
#define NEW_MESSAGES_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_NEW_MESSAGES_MONITOR, NewMessagesMonitorClass))
#define IS_NEW_MESSAGES_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_NEW_MESSAGES_MONITOR))
#define IS_NEW_MESSAGES_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_NEW_MESSAGES_MONITOR))
#define NEW_MESSAGES_MONITOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_NEW_MESSAGES_MONITOR, NewMessagesMonitorClass))

typedef struct _NewMessagesMonitor NewMessagesMonitor;
typedef struct _NewMessagesMonitorClass NewMessagesMonitorClass;
typedef struct _NewMessagesMonitorPrivate NewMessagesMonitorPrivate;

#define NEW_MESSAGES_MONITOR_TYPE_MONITOR_INFORMATION (new_messages_monitor_monitor_information_get_type ())
#define NEW_MESSAGES_MONITOR_MONITOR_INFORMATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NEW_MESSAGES_MONITOR_TYPE_MONITOR_INFORMATION, NewMessagesMonitorMonitorInformation))
#define NEW_MESSAGES_MONITOR_MONITOR_INFORMATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NEW_MESSAGES_MONITOR_TYPE_MONITOR_INFORMATION, NewMessagesMonitorMonitorInformationClass))
#define NEW_MESSAGES_MONITOR_IS_MONITOR_INFORMATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NEW_MESSAGES_MONITOR_TYPE_MONITOR_INFORMATION))
#define NEW_MESSAGES_MONITOR_IS_MONITOR_INFORMATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NEW_MESSAGES_MONITOR_TYPE_MONITOR_INFORMATION))
#define NEW_MESSAGES_MONITOR_MONITOR_INFORMATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NEW_MESSAGES_MONITOR_TYPE_MONITOR_INFORMATION, NewMessagesMonitorMonitorInformationClass))

typedef struct _NewMessagesMonitorMonitorInformation NewMessagesMonitorMonitorInformation;
typedef struct _NewMessagesMonitorMonitorInformationClass NewMessagesMonitorMonitorInformationClass;
enum  {
	NEW_MESSAGES_MONITOR_0_PROPERTY,
	NEW_MESSAGES_MONITOR_REQUIRED_FIELDS_PROPERTY,
	NEW_MESSAGES_MONITOR_TOTAL_NEW_MESSAGES_PROPERTY,
	NEW_MESSAGES_MONITOR_LAST_NEW_MESSAGE_FOLDER_PROPERTY,
	NEW_MESSAGES_MONITOR_LAST_NEW_MESSAGE_PROPERTY,
	NEW_MESSAGES_MONITOR_NUM_PROPERTIES
};
static GParamSpec* new_messages_monitor_properties[NEW_MESSAGES_MONITOR_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _NewMessagesMonitorMonitorInformationPrivate NewMessagesMonitorMonitorInformationPrivate;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _NewMessagesMonitorDoProcessNewEmailData NewMessagesMonitorDoProcessNewEmailData;
enum  {
	NEW_MESSAGES_MONITOR_MONITOR_INFORMATION_0_PROPERTY,
	NEW_MESSAGES_MONITOR_MONITOR_INFORMATION_NUM_PROPERTIES
};
static GParamSpec* new_messages_monitor_monitor_information_properties[NEW_MESSAGES_MONITOR_MONITOR_INFORMATION_NUM_PROPERTIES];
enum  {
	NEW_MESSAGES_MONITOR_FOLDER_ADDED_SIGNAL,
	NEW_MESSAGES_MONITOR_FOLDER_REMOVED_SIGNAL,
	NEW_MESSAGES_MONITOR_NEW_MESSAGES_ARRIVED_SIGNAL,
	NEW_MESSAGES_MONITOR_NEW_MESSAGES_RETIRED_SIGNAL,
	NEW_MESSAGES_MONITOR_NUM_SIGNALS
};
static guint new_messages_monitor_signals[NEW_MESSAGES_MONITOR_NUM_SIGNALS] = {0};
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _NewMessagesMonitor {
	GearyBaseObject parent_instance;
	NewMessagesMonitorPrivate * priv;
};

struct _NewMessagesMonitorClass {
	GearyBaseObjectClass parent_class;
};

typedef gboolean (*NewMessagesMonitorShouldNotifyNewMessages) (GearyFolder* folder, void* user_data);
struct _NewMessagesMonitorPrivate {
	GearyEmailField _required_fields;
	gint _total_new_messages;
	GearyFolder* _last_new_message_folder;
	GearyEmail* _last_new_message;
	GeeHashMap* folder_information;
	NewMessagesMonitorShouldNotifyNewMessages _should_notify_new_messages;
	gpointer _should_notify_new_messages_target;
};

struct _NewMessagesMonitorMonitorInformation {
	GearyBaseObject parent_instance;
	NewMessagesMonitorMonitorInformationPrivate * priv;
	GearyFolder* folder;
	GCancellable* cancellable;
	gint count;
	GeeHashSet* new_ids;
};

struct _NewMessagesMonitorMonitorInformationClass {
	GearyBaseObjectClass parent_class;
};

struct _NewMessagesMonitorDoProcessNewEmailData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GAsyncReadyCallback _callback_;
	gboolean _task_complete_;
	NewMessagesMonitor* self;
	GearyFolder* folder;
	GeeCollection* email_ids;
	NewMessagesMonitorMonitorInformation* info;
	GeeHashMap* _tmp0_;
	gpointer _tmp1_;
	GeeList* list;
	GearyEmailField _tmp2_;
	NewMessagesMonitorMonitorInformation* _tmp3_;
	GCancellable* _tmp4_;
	GeeList* _tmp5_;
	gboolean _tmp6_;
	GeeList* _tmp7_;
	GeeList* _tmp8_;
	gint _tmp9_;
	gint _tmp10_;
	gint _tmp11_;
	gint _tmp12_;
	NewMessagesMonitorMonitorInformation* _tmp13_;
	GeeList* _tmp14_;
	GeeList* _tmp15_;
	gint _tmp16_;
	gint _tmp17_;
	NewMessagesMonitorMonitorInformation* _tmp18_;
	gint _tmp19_;
	gchar* _tmp20_;
	gchar* _tmp21_;
	GError* err;
	GError* _tmp22_;
	const gchar* _tmp23_;
	GError * _inner_error_;
};


static gpointer new_messages_monitor_parent_class = NULL;
static gpointer new_messages_monitor_monitor_information_parent_class = NULL;

GType new_messages_monitor_get_type (void) G_GNUC_CONST;
static GType new_messages_monitor_monitor_information_get_type (void) G_GNUC_CONST G_GNUC_UNUSED;
#define NEW_MESSAGES_MONITOR_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_NEW_MESSAGES_MONITOR, NewMessagesMonitorPrivate))
NewMessagesMonitor* new_messages_monitor_new (NewMessagesMonitorShouldNotifyNewMessages should_notify_new_messages,
                                              void* should_notify_new_messages_target);
NewMessagesMonitor* new_messages_monitor_construct (GType object_type,
                                                    NewMessagesMonitorShouldNotifyNewMessages should_notify_new_messages,
                                                    void* should_notify_new_messages_target);
gboolean new_messages_monitor_should_notify_new_messages (NewMessagesMonitor* self,
                                                          GearyFolder* folder);
void new_messages_monitor_add_folder (NewMessagesMonitor* self,
                                      GearyFolder* folder,
                                      GCancellable* cancellable);
static void new_messages_monitor_on_email_locally_appended (NewMessagesMonitor* self,
                                                     GearyFolder* folder,
                                                     GeeCollection* email_ids);
static void _new_messages_monitor_on_email_locally_appended_geary_folder_email_locally_appended (GearyFolder* _sender,
                                                                                          GeeCollection* ids,
                                                                                          gpointer self);
static void new_messages_monitor_on_email_flags_changed (NewMessagesMonitor* self,
                                                  GearyFolder* folder,
                                                  GeeMap* ids);
static void _new_messages_monitor_on_email_flags_changed_geary_folder_email_flags_changed (GearyFolder* _sender,
                                                                                    GeeMap* map,
                                                                                    gpointer self);
static void new_messages_monitor_on_email_removed (NewMessagesMonitor* self,
                                            GearyFolder* folder,
                                            GeeCollection* ids);
static void _new_messages_monitor_on_email_removed_geary_folder_email_removed (GearyFolder* _sender,
                                                                        GeeCollection* ids,
                                                                        gpointer self);
static NewMessagesMonitorMonitorInformation* new_messages_monitor_monitor_information_new (GearyFolder* folder,
                                                                                    GCancellable* cancellable);
static NewMessagesMonitorMonitorInformation* new_messages_monitor_monitor_information_construct (GType object_type,
                                                                                          GearyFolder* folder,
                                                                                          GCancellable* cancellable);
void new_messages_monitor_remove_folder (NewMessagesMonitor* self,
                                         GearyFolder* folder);
gint new_messages_monitor_get_total_new_messages (NewMessagesMonitor* self);
static void new_messages_monitor_set_total_new_messages (NewMessagesMonitor* self,
                                                  gint value);
GeeCollection* new_messages_monitor_get_folders (NewMessagesMonitor* self);
gint new_messages_monitor_get_new_message_count (NewMessagesMonitor* self,
                                                 GearyFolder* folder);
void new_messages_monitor_add_required_fields (NewMessagesMonitor* self,
                                               GearyEmailField fields);
GearyEmailField new_messages_monitor_get_required_fields (NewMessagesMonitor* self);
static void new_messages_monitor_set_required_fields (NewMessagesMonitor* self,
                                               GearyEmailField value);
gboolean new_messages_monitor_are_any_new_messages (NewMessagesMonitor* self,
                                                    GearyFolder* folder,
                                                    GeeCollection* ids);
static void new_messages_monitor_do_process_new_email (NewMessagesMonitor* self,
                                                GearyFolder* folder,
                                                GeeCollection* email_ids,
                                                GAsyncReadyCallback _callback_,
                                                gpointer _user_data_);
static void new_messages_monitor_do_process_new_email_finish (NewMessagesMonitor* self,
                                                       GAsyncResult* _res_);
static void new_messages_monitor_retire_new_messages (NewMessagesMonitor* self,
                                               GearyFolder* folder,
                                               GeeCollection* email_ids);
static void new_messages_monitor_do_process_new_email_data_free (gpointer _data);
static void new_messages_monitor_do_process_new_email_async_ready_wrapper (GObject *source_object,
                                                                    GAsyncResult *res,
                                                                    void *user_data);
static gboolean new_messages_monitor_do_process_new_email_co (NewMessagesMonitorDoProcessNewEmailData* _data_);
static void new_messages_monitor_do_process_new_email_ready (GObject* source_object,
                                                      GAsyncResult* _res_,
                                                      gpointer _user_data_);
static void new_messages_monitor_new_messages (NewMessagesMonitor* self,
                                        NewMessagesMonitorMonitorInformation* info,
                                        GeeCollection* emails);
static void new_messages_monitor_set_last_new_message_folder (NewMessagesMonitor* self,
                                                       GearyFolder* value);
static void new_messages_monitor_set_last_new_message (NewMessagesMonitor* self,
                                                GearyEmail* value);
static void new_messages_monitor_update_count (NewMessagesMonitor* self,
                                        NewMessagesMonitorMonitorInformation* info,
                                        gboolean arrived,
                                        gint delta);
GearyEmail* new_messages_monitor_get_last_new_message (NewMessagesMonitor* self);
void new_messages_monitor_clear_new_messages (NewMessagesMonitor* self,
                                              GearyFolder* folder);
void new_messages_monitor_clear_all_new_messages (NewMessagesMonitor* self);
GearyFolder* new_messages_monitor_get_last_new_message_folder (NewMessagesMonitor* self);
static void g_cclosure_user_marshal_VOID__OBJECT_INT_INT (GClosure * closure,
                                                   GValue * return_value,
                                                   guint n_param_values,
                                                   const GValue * param_values,
                                                   gpointer invocation_hint,
                                                   gpointer marshal_data);
static void g_cclosure_user_marshal_VOID__OBJECT_INT (GClosure * closure,
                                               GValue * return_value,
                                               guint n_param_values,
                                               const GValue * param_values,
                                               gpointer invocation_hint,
                                               gpointer marshal_data);
static void new_messages_monitor_monitor_information_finalize (GObject * obj);
static void new_messages_monitor_finalize (GObject * obj);
static void _vala_new_messages_monitor_get_property (GObject * object,
                                              guint property_id,
                                              GValue * value,
                                              GParamSpec * pspec);
static void _vala_new_messages_monitor_set_property (GObject * object,
                                              guint property_id,
                                              const GValue * value,
                                              GParamSpec * pspec);


NewMessagesMonitor*
new_messages_monitor_construct (GType object_type,
                                NewMessagesMonitorShouldNotifyNewMessages should_notify_new_messages,
                                void* should_notify_new_messages_target)
{
	NewMessagesMonitor * self = NULL;
#line 54 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	self = (NewMessagesMonitor*) geary_base_object_construct (object_type);
#line 55 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	self->priv->_should_notify_new_messages = should_notify_new_messages;
#line 55 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	self->priv->_should_notify_new_messages_target = should_notify_new_messages_target;
#line 54 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	return self;
#line 277 "new-messages-monitor.c"
}


NewMessagesMonitor*
new_messages_monitor_new (NewMessagesMonitorShouldNotifyNewMessages should_notify_new_messages,
                          void* should_notify_new_messages_target)
{
#line 54 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	return new_messages_monitor_construct (TYPE_NEW_MESSAGES_MONITOR, should_notify_new_messages, should_notify_new_messages_target);
#line 287 "new-messages-monitor.c"
}


gboolean
new_messages_monitor_should_notify_new_messages (NewMessagesMonitor* self,
                                                 GearyFolder* folder)
{
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	NewMessagesMonitorShouldNotifyNewMessages _tmp1_;
	void* _tmp1__target;
#line 58 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	g_return_val_if_fail (IS_NEW_MESSAGES_MONITOR (self), FALSE);
#line 58 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	g_return_val_if_fail (GEARY_IS_FOLDER (folder), FALSE);
#line 59 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	_tmp1_ = self->priv->_should_notify_new_messages;
#line 59 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	_tmp1__target = self->priv->_should_notify_new_messages_target;
#line 59 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	if (_tmp1_ == NULL) {
#line 59 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
		_tmp0_ = TRUE;
#line 311 "new-messages-monitor.c"
	} else {
		NewMessagesMonitorShouldNotifyNewMessages _tmp2_;
		void* _tmp2__target;
#line 59 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
		_tmp2_ = self->priv->_should_notify_new_messages;
#line 59 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
		_tmp2__target = self->priv->_should_notify_new_messages_target;
#line 59 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
		_tmp0_ = _tmp2_ (folder, _tmp2__target);
#line 321 "new-messages-monitor.c"
	}
#line 59 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	result = _tmp0_;
#line 59 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	return result;
#line 327 "new-messages-monitor.c"
}


static void
_new_messages_monitor_on_email_locally_appended_geary_folder_email_locally_appended (GearyFolder* _sender,
                                                                                     GeeCollection* ids,
                                                                                     gpointer self)
{
#line 65 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	new_messages_monitor_on_email_locally_appended ((NewMessagesMonitor*) self, _sender, ids);
#line 338 "new-messages-monitor.c"
}


static void
_new_messages_monitor_on_email_flags_changed_geary_folder_email_flags_changed (GearyFolder* _sender,
                                                                               GeeMap* map,
                                                                               gpointer self)
{
#line 66 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	new_messages_monitor_on_email_flags_changed ((NewMessagesMonitor*) self, _sender, map);
#line 349 "new-messages-monitor.c"
}


static void
_new_messages_monitor_on_email_removed_geary_folder_email_removed (GearyFolder* _sender,
                                                                   GeeCollection* ids,
                                                                   gpointer self)
{
#line 67 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	new_messages_monitor_on_email_removed ((NewMessagesMonitor*) self, _sender, ids);
#line 360 "new-messages-monitor.c"
}


void
new_messages_monitor_add_folder (NewMessagesMonitor* self,
                                 GearyFolder* folder,
                                 GCancellable* cancellable)
{
	GeeHashMap* _tmp0_;
	GeeHashMap* _tmp1_;
	NewMessagesMonitorMonitorInformation* _tmp2_;
	NewMessagesMonitorMonitorInformation* _tmp3_;
#line 62 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	g_return_if_fail (IS_NEW_MESSAGES_MONITOR (self));
#line 62 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	g_return_if_fail (GEARY_IS_FOLDER (folder));
#line 62 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	g_return_if_fail ((cancellable == NULL) || G_IS_CANCELLABLE (cancellable));
#line 63 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	_tmp0_ = self->priv->folder_information;
#line 63 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	_vala_assert (!gee_abstract_map_has_key (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), folder), "!folder_information.has_key(folder)");
#line 65 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	g_signal_connect_object (folder, "email-locally-appended", (GCallback) _new_messages_monitor_on_email_locally_appended_geary_folder_email_locally_appended, self, 0);
#line 66 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	g_signal_connect_object (folder, "email-flags-changed", (GCallback) _new_messages_monitor_on_email_flags_changed_geary_folder_email_flags_changed, self, 0);
#line 67 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	g_signal_connect_object (folder, "email-removed", (GCallback) _new_messages_monitor_on_email_removed_geary_folder_email_removed, self, 0);
#line 69 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	_tmp1_ = self->priv->folder_information;
#line 69 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	_tmp2_ = new_messages_monitor_monitor_information_new (folder, cancellable);
#line 69 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	_tmp3_ = _tmp2_;
#line 69 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	gee_abstract_map_set (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), folder, _tmp3_);
#line 69 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	_g_object_unref0 (_tmp3_);
#line 71 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	g_signal_emit (self, new_messages_monitor_signals[NEW_MESSAGES_MONITOR_FOLDER_ADDED_SIGNAL], 0, folder);
#line 401 "new-messages-monitor.c"
}


void
new_messages_monitor_remove_folder (NewMessagesMonitor* self,
                                    GearyFolder* folder)
{
	GeeHashMap* _tmp0_;
	guint _tmp1_;
	guint _tmp2_;
	guint _tmp3_;
	gint _tmp4_;
	GeeHashMap* _tmp5_;
	gpointer _tmp6_;
	NewMessagesMonitorMonitorInformation* _tmp7_;
	gint _tmp8_;
	GeeHashMap* _tmp9_;
#line 74 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	g_return_if_fail (IS_NEW_MESSAGES_MONITOR (self));
#line 74 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	g_return_if_fail (GEARY_IS_FOLDER (folder));
#line 75 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	_tmp0_ = self->priv->folder_information;
#line 75 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	if (!gee_abstract_map_has_key (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), folder)) {
#line 76 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
		return;
#line 429 "new-messages-monitor.c"
	}
#line 78 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	g_signal_parse_name ("email-locally-appended", GEARY_TYPE_FOLDER, &_tmp1_, NULL, FALSE);
#line 78 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	g_signal_handlers_disconnect_matched (folder, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp1_, 0, NULL, (GCallback) _new_messages_monitor_on_email_locally_appended_geary_folder_email_locally_appended, self);
#line 79 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	g_signal_parse_name ("email-flags-changed", GEARY_TYPE_FOLDER, &_tmp2_, NULL, FALSE);
#line 79 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	g_signal_handlers_disconnect_matched (folder, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp2_, 0, NULL, (GCallback) _new_messages_monitor_on_email_flags_changed_geary_folder_email_flags_changed, self);
#line 80 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	g_signal_parse_name ("email-removed", GEARY_TYPE_FOLDER, &_tmp3_, NULL, FALSE);
#line 80 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	g_signal_handlers_disconnect_matched (folder, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp3_, 0, NULL, (GCallback) _new_messages_monitor_on_email_removed_geary_folder_email_removed, self);
#line 82 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	_tmp4_ = self->priv->_total_new_messages;
#line 82 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	_tmp5_ = self->priv->folder_information;
#line 82 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	_tmp6_ = gee_abstract_map_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), folder);
#line 82 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	_tmp7_ = (NewMessagesMonitorMonitorInformation*) _tmp6_;
#line 82 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	_tmp8_ = _tmp7_->count;
#line 82 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	new_messages_monitor_set_total_new_messages (self, _tmp4_ - _tmp8_);
#line 82 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	_g_object_unref0 (_tmp7_);
#line 84 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	_tmp9_ = self->priv->folder_information;
#line 84 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	gee_abstract_map_unset (G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), folder, NULL);
#line 86 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	g_signal_emit (self, new_messages_monitor_signals[NEW_MESSAGES_MONITOR_FOLDER_REMOVED_SIGNAL], 0, folder);
#line 463 "new-messages-monitor.c"
}


GeeCollection*
new_messages_monitor_get_folders (NewMessagesMonitor* self)
{
	GeeCollection* result = NULL;
	GeeHashMap* _tmp0_;
	GeeSet* _tmp1_;
	GeeSet* _tmp2_;
#line 89 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	g_return_val_if_fail (IS_NEW_MESSAGES_MONITOR (self), NULL);
#line 90 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	_tmp0_ = self->priv->folder_information;
#line 90 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	_tmp1_ = gee_abstract_map_get_keys (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap));
#line 90 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	_tmp2_ = _tmp1_;
#line 90 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	result = G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, GEE_TYPE_COLLECTION, GeeCollection);
#line 90 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	return result;
#line 486 "new-messages-monitor.c"
}


gint
new_messages_monitor_get_new_message_count (NewMessagesMonitor* self,
                                            GearyFolder* folder)
{
	gint result = 0;
	GeeHashMap* _tmp0_;
	GeeHashMap* _tmp1_;
	gpointer _tmp2_;
	NewMessagesMonitorMonitorInformation* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
#line 93 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	g_return_val_if_fail (IS_NEW_MESSAGES_MONITOR (self), 0);
#line 93 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	g_return_val_if_fail (GEARY_IS_FOLDER (folder), 0);
#line 94 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	_tmp0_ = self->priv->folder_information;
#line 94 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	_vala_assert (gee_abstract_map_has_key (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), folder), "folder_information.has_key(folder)");
#line 96 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	_tmp1_ = self->priv->folder_information;
#line 96 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	_tmp2_ = gee_abstract_map_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), folder);
#line 96 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	_tmp3_ = (NewMessagesMonitorMonitorInformation*) _tmp2_;
#line 96 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	_tmp4_ = _tmp3_->count;
#line 96 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	_tmp5_ = _tmp4_;
#line 96 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	_g_object_unref0 (_tmp3_);
#line 96 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	result = _tmp5_;
#line 96 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	return result;
#line 525 "new-messages-monitor.c"
}


void
new_messages_monitor_add_required_fields (NewMessagesMonitor* self,
                                          GearyEmailField fields)
{
	GearyEmailField _tmp0_;
#line 99 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	g_return_if_fail (IS_NEW_MESSAGES_MONITOR (self));
#line 100 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	_tmp0_ = self->priv->_required_fields;
#line 100 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	new_messages_monitor_set_required_fields (self, _tmp0_ | fields);
#line 540 "new-messages-monitor.c"
}


gboolean
new_messages_monitor_are_any_new_messages (NewMessagesMonitor* self,
                                           GearyFolder* folder,
                                           GeeCollection* ids)
{
	gboolean result = FALSE;
	GeeHashMap* _tmp0_;
	NewMessagesMonitorMonitorInformation* info = NULL;
	GeeHashMap* _tmp1_;
	gpointer _tmp2_;
#line 103 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	g_return_val_if_fail (IS_NEW_MESSAGES_MONITOR (self), FALSE);
#line 103 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	g_return_val_if_fail (GEARY_IS_FOLDER (folder), FALSE);
#line 103 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	g_return_val_if_fail (GEE_IS_COLLECTION (ids), FALSE);
#line 105 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	_tmp0_ = self->priv->folder_information;
#line 105 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	_vala_assert (gee_abstract_map_has_key (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), folder), "folder_information.has_key(folder)");
#line 106 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	_tmp1_ = self->priv->folder_information;
#line 106 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	_tmp2_ = gee_abstract_map_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), folder);
#line 106 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	info = (NewMessagesMonitorMonitorInformation*) _tmp2_;
#line 570 "new-messages-monitor.c"
	{
		GeeIterator* _id_it = NULL;
		GeeIterator* _tmp3_;
#line 108 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
		_tmp3_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (ids, GEE_TYPE_ITERABLE, GeeIterable));
#line 108 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
		_id_it = _tmp3_;
#line 108 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
		while (TRUE) {
#line 580 "new-messages-monitor.c"
			GeeIterator* _tmp4_;
			GearyEmailIdentifier* id = NULL;
			GeeIterator* _tmp5_;
			gpointer _tmp6_;
			NewMessagesMonitorMonitorInformation* _tmp7_;
			GeeHashSet* _tmp8_;
			GearyEmailIdentifier* _tmp9_;
#line 108 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
			_tmp4_ = _id_it;
#line 108 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
			if (!gee_iterator_next (_tmp4_)) {
#line 108 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
				break;
#line 594 "new-messages-monitor.c"
			}
#line 108 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
			_tmp5_ = _id_it;
#line 108 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
			_tmp6_ = gee_iterator_get (_tmp5_);
#line 108 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
			id = (GearyEmailIdentifier*) _tmp6_;
#line 109 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
			_tmp7_ = info;
#line 109 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
			_tmp8_ = _tmp7_->new_ids;
#line 109 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
			_tmp9_ = id;
#line 109 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
			if (gee_abstract_collection_contains (G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), _tmp9_)) {
#line 110 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
				result = TRUE;
#line 110 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
				_g_object_unref0 (id);
#line 110 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
				_g_object_unref0 (_id_it);
#line 110 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
				_g_object_unref0 (info);
#line 110 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
				return result;
#line 620 "new-messages-monitor.c"
			}
#line 108 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
			_g_object_unref0 (id);
#line 624 "new-messages-monitor.c"
		}
#line 108 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
		_g_object_unref0 (_id_it);
#line 628 "new-messages-monitor.c"
	}
#line 113 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	result = FALSE;
#line 113 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	_g_object_unref0 (info);
#line 113 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	return result;
#line 636 "new-messages-monitor.c"
}


static void
new_messages_monitor_on_email_locally_appended (NewMessagesMonitor* self,
                                                GearyFolder* folder,
                                                GeeCollection* email_ids)
{
#line 116 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	g_return_if_fail (IS_NEW_MESSAGES_MONITOR (self));
#line 116 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	g_return_if_fail (GEARY_IS_FOLDER (folder));
#line 116 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	g_return_if_fail (GEE_IS_COLLECTION (email_ids));
#line 118 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	new_messages_monitor_do_process_new_email (self, folder, email_ids, NULL, NULL);
#line 653 "new-messages-monitor.c"
}


static void
new_messages_monitor_on_email_flags_changed (NewMessagesMonitor* self,
                                             GearyFolder* folder,
                                             GeeMap* ids)
{
	GeeSet* _tmp0_;
	GeeSet* _tmp1_;
	GeeSet* _tmp2_;
#line 121 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	g_return_if_fail (IS_NEW_MESSAGES_MONITOR (self));
#line 121 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	g_return_if_fail (GEARY_IS_FOLDER (folder));
#line 121 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	g_return_if_fail (GEE_IS_MAP (ids));
#line 123 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	_tmp0_ = gee_map_get_keys (ids);
#line 123 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	_tmp1_ = _tmp0_;
#line 123 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	_tmp2_ = _tmp1_;
#line 123 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	new_messages_monitor_retire_new_messages (self, folder, G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, GEE_TYPE_COLLECTION, GeeCollection));
#line 123 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	_g_object_unref0 (_tmp2_);
#line 681 "new-messages-monitor.c"
}


static void
new_messages_monitor_on_email_removed (NewMessagesMonitor* self,
                                       GearyFolder* folder,
                                       GeeCollection* ids)
{
#line 126 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	g_return_if_fail (IS_NEW_MESSAGES_MONITOR (self));
#line 126 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	g_return_if_fail (GEARY_IS_FOLDER (folder));
#line 126 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	g_return_if_fail (GEE_IS_COLLECTION (ids));
#line 127 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	new_messages_monitor_retire_new_messages (self, folder, ids);
#line 698 "new-messages-monitor.c"
}


static void
new_messages_monitor_do_process_new_email_data_free (gpointer _data)
{
	NewMessagesMonitorDoProcessNewEmailData* _data_;
	_data_ = _data;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	_g_object_unref0 (_data_->folder);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	_g_object_unref0 (_data_->email_ids);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	_g_object_unref0 (_data_->self);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	g_slice_free (NewMessagesMonitorDoProcessNewEmailData, _data_);
#line 715 "new-messages-monitor.c"
}


static void
new_messages_monitor_do_process_new_email_async_ready_wrapper (GObject *source_object,
                                                               GAsyncResult *res,
                                                               void *user_data)
{
	NewMessagesMonitorDoProcessNewEmailData* _task_data_;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	_task_data_ = g_task_get_task_data (G_TASK (res));
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	if (_task_data_->_callback_ != NULL) {
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
		_task_data_->_callback_ (source_object, res, user_data);
#line 731 "new-messages-monitor.c"
	}
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	_task_data_->_task_complete_ = TRUE;
#line 735 "new-messages-monitor.c"
}


static gpointer
_g_object_ref0 (gpointer self)
{
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	return self ? g_object_ref (self) : NULL;
#line 744 "new-messages-monitor.c"
}


static void
new_messages_monitor_do_process_new_email (NewMessagesMonitor* self,
                                           GearyFolder* folder,
                                           GeeCollection* email_ids,
                                           GAsyncReadyCallback _callback_,
                                           gpointer _user_data_)
{
	NewMessagesMonitorDoProcessNewEmailData* _data_;
	NewMessagesMonitor* _tmp0_;
	GearyFolder* _tmp1_;
	GeeCollection* _tmp2_;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	_data_ = g_slice_new0 (NewMessagesMonitorDoProcessNewEmailData);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	_data_->_callback_ = _callback_;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, new_messages_monitor_do_process_new_email_async_ready_wrapper, _user_data_);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	if (_callback_ == NULL) {
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
		_data_->_task_complete_ = TRUE;
#line 769 "new-messages-monitor.c"
	}
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	g_task_set_task_data (_data_->_async_result, _data_, new_messages_monitor_do_process_new_email_data_free);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	_data_->self = _tmp0_;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	_tmp1_ = _g_object_ref0 (folder);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	_g_object_unref0 (_data_->folder);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	_data_->folder = _tmp1_;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	_tmp2_ = _g_object_ref0 (email_ids);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	_g_object_unref0 (_data_->email_ids);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	_data_->email_ids = _tmp2_;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	new_messages_monitor_do_process_new_email_co (_data_);
#line 791 "new-messages-monitor.c"
}


static void
new_messages_monitor_do_process_new_email_finish (NewMessagesMonitor* self,
                                                  GAsyncResult* _res_)
{
	NewMessagesMonitorDoProcessNewEmailData* _data_;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 802 "new-messages-monitor.c"
}


static void
new_messages_monitor_do_process_new_email_ready (GObject* source_object,
                                                 GAsyncResult* _res_,
                                                 gpointer _user_data_)
{
	NewMessagesMonitorDoProcessNewEmailData* _data_;
#line 135 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	_data_ = _user_data_;
#line 135 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	_data_->_source_object_ = source_object;
#line 135 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	_data_->_res_ = _res_;
#line 135 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	_data_->_task_complete_ = TRUE;
#line 135 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	new_messages_monitor_do_process_new_email_co (_data_);
#line 822 "new-messages-monitor.c"
}


static gboolean
new_messages_monitor_do_process_new_email_co (NewMessagesMonitorDoProcessNewEmailData* _data_)
{
#line 130 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	switch (_data_->_state_) {
#line 130 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
		case 0:
#line 833 "new-messages-monitor.c"
		goto _state_0;
#line 130 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
		case 1:
#line 837 "new-messages-monitor.c"
		goto _state_1;
		default:
#line 130 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
		g_assert_not_reached ();
#line 842 "new-messages-monitor.c"
	}
	_state_0:
#line 132 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	_data_->_tmp0_ = _data_->self->priv->folder_information;
#line 132 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	_data_->_tmp1_ = gee_abstract_map_get (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp0_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _data_->folder);
#line 132 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	_data_->info = (NewMessagesMonitorMonitorInformation*) _data_->_tmp1_;
#line 851 "new-messages-monitor.c"
	{
#line 135 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
		_data_->_tmp2_ = _data_->self->priv->_required_fields;
#line 135 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
		_data_->_tmp3_ = _data_->info;
#line 135 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
		_data_->_tmp4_ = _data_->_tmp3_->cancellable;
#line 135 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
		_data_->_state_ = 1;
#line 135 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
		geary_folder_list_email_by_sparse_id_async (_data_->folder, _data_->email_ids, _data_->_tmp2_, GEARY_FOLDER_LIST_FLAGS_NONE, _data_->_tmp4_, new_messages_monitor_do_process_new_email_ready, _data_);
#line 135 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
		return FALSE;
#line 865 "new-messages-monitor.c"
		_state_1:
#line 135 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
		_data_->_tmp5_ = geary_folder_list_email_by_sparse_id_finish (_data_->folder, _data_->_res_, &_data_->_inner_error_);
#line 135 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
		_data_->list = _data_->_tmp5_;
#line 135 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
		if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
#line 873 "new-messages-monitor.c"
			goto __catch124_g_error;
		}
#line 137 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
		_data_->_tmp7_ = _data_->list;
#line 137 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
		if (_data_->_tmp7_ == NULL) {
#line 137 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
			_data_->_tmp6_ = TRUE;
#line 882 "new-messages-monitor.c"
		} else {
#line 137 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
			_data_->_tmp8_ = _data_->list;
#line 137 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
			_data_->_tmp9_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp8_, GEE_TYPE_COLLECTION, GeeCollection));
#line 137 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
			_data_->_tmp10_ = _data_->_tmp9_;
#line 137 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
			_data_->_tmp6_ = _data_->_tmp10_ == 0;
#line 892 "new-messages-monitor.c"
		}
#line 137 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
		if (_data_->_tmp6_) {
#line 138 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
			_data_->_tmp11_ = gee_collection_get_size (_data_->email_ids);
#line 138 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
			_data_->_tmp12_ = _data_->_tmp11_;
#line 138 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
			g_debug ("new-messages-monitor.vala:138: Warning: %d new emails, but none could " \
"be listed", _data_->_tmp12_);
#line 140 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
			_g_object_unref0 (_data_->list);
#line 140 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
			_g_object_unref0 (_data_->info);
#line 140 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
			g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 140 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
			if (_data_->_state_ != 0) {
#line 140 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
				while (_data_->_task_complete_ != TRUE) {
#line 140 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
					g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 914 "new-messages-monitor.c"
				}
			}
#line 140 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
			g_object_unref (_data_->_async_result);
#line 140 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
			return FALSE;
#line 921 "new-messages-monitor.c"
		}
#line 143 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
		_data_->_tmp13_ = _data_->info;
#line 143 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
		_data_->_tmp14_ = _data_->list;
#line 143 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
		new_messages_monitor_new_messages (_data_->self, _data_->_tmp13_, G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp14_, GEE_TYPE_COLLECTION, GeeCollection));
#line 145 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
		_data_->_tmp15_ = _data_->list;
#line 145 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
		_data_->_tmp16_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp15_, GEE_TYPE_COLLECTION, GeeCollection));
#line 145 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
		_data_->_tmp17_ = _data_->_tmp16_;
#line 145 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
		_data_->_tmp18_ = _data_->info;
#line 145 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
		_data_->_tmp19_ = _data_->_tmp18_->count;
#line 145 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
		_data_->_tmp20_ = geary_folder_to_string (_data_->folder);
#line 145 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
		_data_->_tmp21_ = _data_->_tmp20_;
#line 145 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
		g_debug ("new-messages-monitor.vala:145: do_process_new_email: %d messages liste" \
"d, %d unread in folder %s", _data_->_tmp17_, _data_->_tmp19_, _data_->_tmp21_);
#line 145 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
		_g_free0 (_data_->_tmp21_);
#line 134 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
		_g_object_unref0 (_data_->list);
#line 949 "new-messages-monitor.c"
	}
	goto __finally124;
	__catch124_g_error:
	{
#line 134 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
		_data_->err = _data_->_inner_error_;
#line 134 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
		_data_->_inner_error_ = NULL;
#line 148 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
		_data_->_tmp22_ = _data_->err;
#line 148 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
		_data_->_tmp23_ = _data_->_tmp22_->message;
#line 148 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
		g_debug ("new-messages-monitor.vala:148: Unable to notify of new email: %s", _data_->_tmp23_);
#line 134 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
		_g_error_free0 (_data_->err);
#line 966 "new-messages-monitor.c"
	}
	__finally124:
#line 134 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
#line 134 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
		_g_object_unref0 (_data_->info);
#line 134 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error_->message, g_quark_to_string (_data_->_inner_error_->domain), _data_->_inner_error_->code);
#line 134 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
		g_clear_error (&_data_->_inner_error_);
#line 134 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
		g_object_unref (_data_->_async_result);
#line 134 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
		return FALSE;
#line 981 "new-messages-monitor.c"
	}
#line 130 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	_g_object_unref0 (_data_->info);
#line 130 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 130 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	if (_data_->_state_ != 0) {
#line 130 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
		while (_data_->_task_complete_ != TRUE) {
#line 130 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 993 "new-messages-monitor.c"
		}
	}
#line 130 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	g_object_unref (_data_->_async_result);
#line 130 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	return FALSE;
#line 1000 "new-messages-monitor.c"
}


static void
new_messages_monitor_new_messages (NewMessagesMonitor* self,
                                   NewMessagesMonitorMonitorInformation* info,
                                   GeeCollection* emails)
{
	gint appended_count = 0;
	gint _tmp31_;
#line 152 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	g_return_if_fail (IS_NEW_MESSAGES_MONITOR (self));
#line 152 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	g_return_if_fail (NEW_MESSAGES_MONITOR_IS_MONITOR_INFORMATION (info));
#line 152 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	g_return_if_fail (GEE_IS_COLLECTION (emails));
#line 153 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	appended_count = 0;
#line 1019 "new-messages-monitor.c"
	{
		GeeIterator* _email_it = NULL;
		GeeIterator* _tmp0_;
#line 154 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
		_tmp0_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (emails, GEE_TYPE_ITERABLE, GeeIterable));
#line 154 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
		_email_it = _tmp0_;
#line 154 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
		while (TRUE) {
#line 1029 "new-messages-monitor.c"
			GeeIterator* _tmp1_;
			GearyEmail* email = NULL;
			GeeIterator* _tmp2_;
			gpointer _tmp3_;
			GearyEmail* _tmp4_;
			GearyEmailField _tmp5_;
			GearyEmailField _tmp6_;
			GearyEmailField _tmp7_;
			GeeHashSet* _tmp17_;
			GearyEmail* _tmp18_;
			GearyEmailIdentifier* _tmp19_;
			GearyEmailIdentifier* _tmp20_;
			GearyEmail* _tmp21_;
			GearyEmailFlags* _tmp22_;
			GearyEmailFlags* _tmp23_;
			GearyFolder* _tmp24_;
			GearyEmail* _tmp25_;
			GeeHashSet* _tmp26_;
			GearyEmail* _tmp27_;
			GearyEmailIdentifier* _tmp28_;
			GearyEmailIdentifier* _tmp29_;
			gint _tmp30_;
#line 154 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
			_tmp1_ = _email_it;
#line 154 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
			if (!gee_iterator_next (_tmp1_)) {
#line 154 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
				break;
#line 1058 "new-messages-monitor.c"
			}
#line 154 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
			_tmp2_ = _email_it;
#line 154 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
			_tmp3_ = gee_iterator_get (_tmp2_);
#line 154 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
			email = (GearyEmail*) _tmp3_;
#line 155 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
			_tmp4_ = email;
#line 155 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
			_tmp5_ = geary_email_get_fields (_tmp4_);
#line 155 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
			_tmp6_ = _tmp5_;
#line 155 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
			_tmp7_ = self->priv->_required_fields;
#line 155 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
			if (!geary_email_field_fulfills (_tmp6_, _tmp7_)) {
#line 1076 "new-messages-monitor.c"
				GearyEmail* _tmp8_;
				GearyEmailIdentifier* _tmp9_;
				GearyEmailIdentifier* _tmp10_;
				gchar* _tmp11_;
				gchar* _tmp12_;
				GearyEmail* _tmp13_;
				GearyEmailField _tmp14_;
				GearyEmailField _tmp15_;
				GearyEmailField _tmp16_;
#line 156 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
				_tmp8_ = email;
#line 156 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
				_tmp9_ = geary_email_get_id (_tmp8_);
#line 156 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
				_tmp10_ = _tmp9_;
#line 156 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
				_tmp11_ = geary_email_identifier_to_string (_tmp10_);
#line 156 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
				_tmp12_ = _tmp11_;
#line 156 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
				_tmp13_ = email;
#line 156 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
				_tmp14_ = geary_email_get_fields (_tmp13_);
#line 156 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
				_tmp15_ = _tmp14_;
#line 156 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
				_tmp16_ = self->priv->_required_fields;
#line 156 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
				g_debug ("new-messages-monitor.vala:156: Warning: new message %s (%Xh) does not " \
"fulfill NewMessagesMonitor required fields of %Xh", _tmp12_, (guint) _tmp15_, (guint) _tmp16_);
#line 156 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
				_g_free0 (_tmp12_);
#line 1108 "new-messages-monitor.c"
			}
#line 160 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
			_tmp17_ = info->new_ids;
#line 160 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
			_tmp18_ = email;
#line 160 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
			_tmp19_ = geary_email_get_id (_tmp18_);
#line 160 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
			_tmp20_ = _tmp19_;
#line 160 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
			if (gee_abstract_collection_contains (G_TYPE_CHECK_INSTANCE_CAST (_tmp17_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), _tmp20_)) {
#line 161 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
				_g_object_unref0 (email);
#line 161 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
				continue;
#line 1124 "new-messages-monitor.c"
			}
#line 163 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
			_tmp21_ = email;
#line 163 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
			_tmp22_ = geary_email_get_email_flags (_tmp21_);
#line 163 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
			_tmp23_ = _tmp22_;
#line 163 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
			if (!geary_email_flags_is_unread (_tmp23_)) {
#line 164 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
				_g_object_unref0 (email);
#line 164 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
				continue;
#line 1138 "new-messages-monitor.c"
			}
#line 166 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
			_tmp24_ = info->folder;
#line 166 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
			new_messages_monitor_set_last_new_message_folder (self, _tmp24_);
#line 167 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
			_tmp25_ = email;
#line 167 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
			new_messages_monitor_set_last_new_message (self, _tmp25_);
#line 169 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
			_tmp26_ = info->new_ids;
#line 169 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
			_tmp27_ = email;
#line 169 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
			_tmp28_ = geary_email_get_id (_tmp27_);
#line 169 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
			_tmp29_ = _tmp28_;
#line 169 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
			gee_abstract_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp26_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), _tmp29_);
#line 170 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
			_tmp30_ = appended_count;
#line 170 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
			appended_count = _tmp30_ + 1;
#line 154 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
			_g_object_unref0 (email);
#line 1164 "new-messages-monitor.c"
		}
#line 154 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
		_g_object_unref0 (_email_it);
#line 1168 "new-messages-monitor.c"
	}
#line 173 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	_tmp31_ = appended_count;
#line 173 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	new_messages_monitor_update_count (self, info, TRUE, _tmp31_);
#line 1174 "new-messages-monitor.c"
}


static void
new_messages_monitor_retire_new_messages (NewMessagesMonitor* self,
                                          GearyFolder* folder,
                                          GeeCollection* email_ids)
{
	NewMessagesMonitorMonitorInformation* info = NULL;
	GeeHashMap* _tmp0_;
	gpointer _tmp1_;
	gint removed_count = 0;
	NewMessagesMonitorMonitorInformation* _tmp16_;
	gint _tmp17_;
#line 176 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	g_return_if_fail (IS_NEW_MESSAGES_MONITOR (self));
#line 176 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	g_return_if_fail (GEARY_IS_FOLDER (folder));
#line 176 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	g_return_if_fail (GEE_IS_COLLECTION (email_ids));
#line 178 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	_tmp0_ = self->priv->folder_information;
#line 178 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	_tmp1_ = gee_abstract_map_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), folder);
#line 178 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	info = (NewMessagesMonitorMonitorInformation*) _tmp1_;
#line 180 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	removed_count = 0;
#line 1203 "new-messages-monitor.c"
	{
		GeeIterator* _email_id_it = NULL;
		GeeIterator* _tmp2_;
#line 181 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
		_tmp2_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (email_ids, GEE_TYPE_ITERABLE, GeeIterable));
#line 181 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
		_email_id_it = _tmp2_;
#line 181 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
		while (TRUE) {
#line 1213 "new-messages-monitor.c"
			GeeIterator* _tmp3_;
			GearyEmailIdentifier* email_id = NULL;
			GeeIterator* _tmp4_;
			gpointer _tmp5_;
			gboolean _tmp6_ = FALSE;
			GearyEmail* _tmp7_;
			NewMessagesMonitorMonitorInformation* _tmp12_;
			GeeHashSet* _tmp13_;
			GearyEmailIdentifier* _tmp14_;
#line 181 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
			_tmp3_ = _email_id_it;
#line 181 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
			if (!gee_iterator_next (_tmp3_)) {
#line 181 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
				break;
#line 1229 "new-messages-monitor.c"
			}
#line 181 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
			_tmp4_ = _email_id_it;
#line 181 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
			_tmp5_ = gee_iterator_get (_tmp4_);
#line 181 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
			email_id = (GearyEmailIdentifier*) _tmp5_;
#line 182 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
			_tmp7_ = self->priv->_last_new_message;
#line 182 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
			if (_tmp7_ != NULL) {
#line 1241 "new-messages-monitor.c"
				GearyEmail* _tmp8_;
				GearyEmailIdentifier* _tmp9_;
				GearyEmailIdentifier* _tmp10_;
				GearyEmailIdentifier* _tmp11_;
#line 182 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
				_tmp8_ = self->priv->_last_new_message;
#line 182 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
				_tmp9_ = geary_email_get_id (_tmp8_);
#line 182 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
				_tmp10_ = _tmp9_;
#line 182 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
				_tmp11_ = email_id;
#line 182 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
				_tmp6_ = geary_email_identifier_equal_to (_tmp10_, _tmp11_);
#line 1256 "new-messages-monitor.c"
			} else {
#line 182 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
				_tmp6_ = FALSE;
#line 1260 "new-messages-monitor.c"
			}
#line 182 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
			if (_tmp6_) {
#line 183 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
				new_messages_monitor_set_last_new_message_folder (self, NULL);
#line 184 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
				new_messages_monitor_set_last_new_message (self, NULL);
#line 1268 "new-messages-monitor.c"
			}
#line 187 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
			_tmp12_ = info;
#line 187 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
			_tmp13_ = _tmp12_->new_ids;
#line 187 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
			_tmp14_ = email_id;
#line 187 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
			if (gee_abstract_collection_remove (G_TYPE_CHECK_INSTANCE_CAST (_tmp13_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), _tmp14_)) {
#line 1278 "new-messages-monitor.c"
				gint _tmp15_;
#line 188 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
				_tmp15_ = removed_count;
#line 188 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
				removed_count = _tmp15_ + 1;
#line 1284 "new-messages-monitor.c"
			}
#line 181 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
			_g_object_unref0 (email_id);
#line 1288 "new-messages-monitor.c"
		}
#line 181 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
		_g_object_unref0 (_email_id_it);
#line 1292 "new-messages-monitor.c"
	}
#line 191 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	_tmp16_ = info;
#line 191 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	_tmp17_ = removed_count;
#line 191 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	new_messages_monitor_update_count (self, _tmp16_, FALSE, _tmp17_);
#line 176 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	_g_object_unref0 (info);
#line 1302 "new-messages-monitor.c"
}


void
new_messages_monitor_clear_new_messages (NewMessagesMonitor* self,
                                         GearyFolder* folder)
{
	GeeHashMap* _tmp0_;
	NewMessagesMonitorMonitorInformation* info = NULL;
	GeeHashMap* _tmp1_;
	gpointer _tmp2_;
	GeeHashSet* _tmp3_;
#line 194 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	g_return_if_fail (IS_NEW_MESSAGES_MONITOR (self));
#line 194 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	g_return_if_fail (GEARY_IS_FOLDER (folder));
#line 195 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	_tmp0_ = self->priv->folder_information;
#line 195 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	_vala_assert (gee_abstract_map_has_key (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), folder), "folder_information.has_key(folder)");
#line 196 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	_tmp1_ = self->priv->folder_information;
#line 196 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	_tmp2_ = gee_abstract_map_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), folder);
#line 196 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	info = (NewMessagesMonitorMonitorInformation*) _tmp2_;
#line 198 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	_tmp3_ = info->new_ids;
#line 198 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	gee_abstract_collection_clear (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection));
#line 199 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	new_messages_monitor_set_last_new_message_folder (self, NULL);
#line 200 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	new_messages_monitor_set_last_new_message (self, NULL);
#line 202 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	new_messages_monitor_update_count (self, info, FALSE, 0);
#line 194 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	_g_object_unref0 (info);
#line 1341 "new-messages-monitor.c"
}


void
new_messages_monitor_clear_all_new_messages (NewMessagesMonitor* self)
{
#line 205 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	g_return_if_fail (IS_NEW_MESSAGES_MONITOR (self));
#line 1350 "new-messages-monitor.c"
	{
		GeeIterator* _folder_it = NULL;
		GeeHashMap* _tmp0_;
		GeeSet* _tmp1_;
		GeeSet* _tmp2_;
		GeeSet* _tmp3_;
		GeeIterator* _tmp4_;
		GeeIterator* _tmp5_;
#line 206 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
		_tmp0_ = self->priv->folder_information;
#line 206 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
		_tmp1_ = gee_abstract_map_get_keys (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap));
#line 206 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
		_tmp2_ = _tmp1_;
#line 206 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
		_tmp3_ = _tmp2_;
#line 206 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
		_tmp4_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, GEE_TYPE_ITERABLE, GeeIterable));
#line 206 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
		_tmp5_ = _tmp4_;
#line 206 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
		_g_object_unref0 (_tmp3_);
#line 206 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
		_folder_it = _tmp5_;
#line 206 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
		while (TRUE) {
#line 1377 "new-messages-monitor.c"
			GeeIterator* _tmp6_;
			GearyFolder* folder = NULL;
			GeeIterator* _tmp7_;
			gpointer _tmp8_;
			GearyFolder* _tmp9_;
#line 206 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
			_tmp6_ = _folder_it;
#line 206 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
			if (!gee_iterator_next (_tmp6_)) {
#line 206 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
				break;
#line 1389 "new-messages-monitor.c"
			}
#line 206 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
			_tmp7_ = _folder_it;
#line 206 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
			_tmp8_ = gee_iterator_get (_tmp7_);
#line 206 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
			folder = (GearyFolder*) _tmp8_;
#line 207 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
			_tmp9_ = folder;
#line 207 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
			new_messages_monitor_clear_new_messages (self, _tmp9_);
#line 206 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
			_g_object_unref0 (folder);
#line 1403 "new-messages-monitor.c"
		}
#line 206 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
		_g_object_unref0 (_folder_it);
#line 1407 "new-messages-monitor.c"
	}
}


static void
new_messages_monitor_update_count (NewMessagesMonitor* self,
                                   NewMessagesMonitorMonitorInformation* info,
                                   gboolean arrived,
                                   gint delta)
{
	gint new_size = 0;
	GeeHashSet* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
	gint _tmp7_;
	gint _tmp8_;
#line 210 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	g_return_if_fail (IS_NEW_MESSAGES_MONITOR (self));
#line 210 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	g_return_if_fail (NEW_MESSAGES_MONITOR_IS_MONITOR_INFORMATION (info));
#line 211 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	_tmp0_ = info->new_ids;
#line 211 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	_tmp1_ = gee_abstract_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection));
#line 211 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	_tmp2_ = _tmp1_;
#line 211 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	new_size = _tmp2_;
#line 216 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	_tmp3_ = info->count;
#line 216 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	_tmp4_ = new_size;
#line 216 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	if (_tmp3_ == _tmp4_) {
#line 217 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
		return;
#line 1448 "new-messages-monitor.c"
	}
#line 219 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	_tmp5_ = self->priv->_total_new_messages;
#line 219 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	_tmp6_ = new_size;
#line 219 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	_tmp7_ = info->count;
#line 219 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	new_messages_monitor_set_total_new_messages (self, _tmp5_ + (_tmp6_ - _tmp7_));
#line 220 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	_tmp8_ = new_size;
#line 220 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	info->count = _tmp8_;
#line 222 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	if (arrived) {
#line 1464 "new-messages-monitor.c"
		GearyFolder* _tmp9_;
		gint _tmp10_;
#line 223 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
		_tmp9_ = info->folder;
#line 223 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
		_tmp10_ = info->count;
#line 223 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
		g_signal_emit (self, new_messages_monitor_signals[NEW_MESSAGES_MONITOR_NEW_MESSAGES_ARRIVED_SIGNAL], 0, _tmp9_, _tmp10_, delta);
#line 1473 "new-messages-monitor.c"
	} else {
		GearyFolder* _tmp11_;
		gint _tmp12_;
#line 225 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
		_tmp11_ = info->folder;
#line 225 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
		_tmp12_ = info->count;
#line 225 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
		g_signal_emit (self, new_messages_monitor_signals[NEW_MESSAGES_MONITOR_NEW_MESSAGES_RETIRED_SIGNAL], 0, _tmp11_, _tmp12_);
#line 1483 "new-messages-monitor.c"
	}
}


GearyEmailField
new_messages_monitor_get_required_fields (NewMessagesMonitor* self)
{
	GearyEmailField result;
	GearyEmailField _tmp0_;
#line 30 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	g_return_val_if_fail (IS_NEW_MESSAGES_MONITOR (self), 0);
#line 30 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	_tmp0_ = self->priv->_required_fields;
#line 30 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	result = _tmp0_;
#line 30 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	return result;
#line 1501 "new-messages-monitor.c"
}


static void
new_messages_monitor_set_required_fields (NewMessagesMonitor* self,
                                          GearyEmailField value)
{
#line 30 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	g_return_if_fail (IS_NEW_MESSAGES_MONITOR (self));
#line 30 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	if (new_messages_monitor_get_required_fields (self) != value) {
#line 30 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
		self->priv->_required_fields = value;
#line 30 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
		g_object_notify_by_pspec ((GObject *) self, new_messages_monitor_properties[NEW_MESSAGES_MONITOR_REQUIRED_FIELDS_PROPERTY]);
#line 1517 "new-messages-monitor.c"
	}
}


gint
new_messages_monitor_get_total_new_messages (NewMessagesMonitor* self)
{
	gint result;
	gint _tmp0_;
#line 31 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	g_return_val_if_fail (IS_NEW_MESSAGES_MONITOR (self), 0);
#line 31 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	_tmp0_ = self->priv->_total_new_messages;
#line 31 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	result = _tmp0_;
#line 31 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	return result;
#line 1535 "new-messages-monitor.c"
}


static void
new_messages_monitor_set_total_new_messages (NewMessagesMonitor* self,
                                             gint value)
{
#line 31 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	g_return_if_fail (IS_NEW_MESSAGES_MONITOR (self));
#line 31 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	if (new_messages_monitor_get_total_new_messages (self) != value) {
#line 31 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
		self->priv->_total_new_messages = value;
#line 31 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
		g_object_notify_by_pspec ((GObject *) self, new_messages_monitor_properties[NEW_MESSAGES_MONITOR_TOTAL_NEW_MESSAGES_PROPERTY]);
#line 1551 "new-messages-monitor.c"
	}
}


GearyFolder*
new_messages_monitor_get_last_new_message_folder (NewMessagesMonitor* self)
{
	GearyFolder* result;
	GearyFolder* _tmp0_;
#line 32 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	g_return_val_if_fail (IS_NEW_MESSAGES_MONITOR (self), NULL);
#line 32 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	_tmp0_ = self->priv->_last_new_message_folder;
#line 32 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	result = _tmp0_;
#line 32 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	return result;
#line 1569 "new-messages-monitor.c"
}


static void
new_messages_monitor_set_last_new_message_folder (NewMessagesMonitor* self,
                                                  GearyFolder* value)
{
#line 32 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	g_return_if_fail (IS_NEW_MESSAGES_MONITOR (self));
#line 32 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	if (new_messages_monitor_get_last_new_message_folder (self) != value) {
#line 1581 "new-messages-monitor.c"
		GearyFolder* _tmp0_;
#line 32 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 32 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
		_g_object_unref0 (self->priv->_last_new_message_folder);
#line 32 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
		self->priv->_last_new_message_folder = _tmp0_;
#line 32 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
		g_object_notify_by_pspec ((GObject *) self, new_messages_monitor_properties[NEW_MESSAGES_MONITOR_LAST_NEW_MESSAGE_FOLDER_PROPERTY]);
#line 1591 "new-messages-monitor.c"
	}
}


GearyEmail*
new_messages_monitor_get_last_new_message (NewMessagesMonitor* self)
{
	GearyEmail* result;
	GearyEmail* _tmp0_;
#line 33 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	g_return_val_if_fail (IS_NEW_MESSAGES_MONITOR (self), NULL);
#line 33 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	_tmp0_ = self->priv->_last_new_message;
#line 33 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	result = _tmp0_;
#line 33 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	return result;
#line 1609 "new-messages-monitor.c"
}


static void
new_messages_monitor_set_last_new_message (NewMessagesMonitor* self,
                                           GearyEmail* value)
{
#line 33 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	g_return_if_fail (IS_NEW_MESSAGES_MONITOR (self));
#line 33 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	if (new_messages_monitor_get_last_new_message (self) != value) {
#line 1621 "new-messages-monitor.c"
		GearyEmail* _tmp0_;
#line 33 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 33 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
		_g_object_unref0 (self->priv->_last_new_message);
#line 33 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
		self->priv->_last_new_message = _tmp0_;
#line 33 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
		g_object_notify_by_pspec ((GObject *) self, new_messages_monitor_properties[NEW_MESSAGES_MONITOR_LAST_NEW_MESSAGE_PROPERTY]);
#line 1631 "new-messages-monitor.c"
	}
}


static void
g_cclosure_user_marshal_VOID__OBJECT_INT_INT (GClosure * closure,
                                              GValue * return_value,
                                              guint n_param_values,
                                              const GValue * param_values,
                                              gpointer invocation_hint,
                                              gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__OBJECT_INT_INT) (gpointer data1, gpointer arg_1, gint arg_2, gint arg_3, gpointer data2);
	register GMarshalFunc_VOID__OBJECT_INT_INT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	g_return_if_fail (n_param_values == 4);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
		data1 = closure->data;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
		data2 = param_values->data[0].v_pointer;
#line 1658 "new-messages-monitor.c"
	} else {
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
		data1 = param_values->data[0].v_pointer;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
		data2 = closure->data;
#line 1664 "new-messages-monitor.c"
	}
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	callback = (GMarshalFunc_VOID__OBJECT_INT_INT) (marshal_data ? marshal_data : cc->callback);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	callback (data1, g_value_get_object (param_values + 1), g_value_get_int (param_values + 2), g_value_get_int (param_values + 3), data2);
#line 1670 "new-messages-monitor.c"
}


static void
g_cclosure_user_marshal_VOID__OBJECT_INT (GClosure * closure,
                                          GValue * return_value,
                                          guint n_param_values,
                                          const GValue * param_values,
                                          gpointer invocation_hint,
                                          gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__OBJECT_INT) (gpointer data1, gpointer arg_1, gint arg_2, gpointer data2);
	register GMarshalFunc_VOID__OBJECT_INT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	g_return_if_fail (n_param_values == 3);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
		data1 = closure->data;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
		data2 = param_values->data[0].v_pointer;
#line 1696 "new-messages-monitor.c"
	} else {
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
		data1 = param_values->data[0].v_pointer;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
		data2 = closure->data;
#line 1702 "new-messages-monitor.c"
	}
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	callback = (GMarshalFunc_VOID__OBJECT_INT) (marshal_data ? marshal_data : cc->callback);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	callback (data1, g_value_get_object (param_values + 1), g_value_get_int (param_values + 2), data2);
#line 1708 "new-messages-monitor.c"
}


static NewMessagesMonitorMonitorInformation*
new_messages_monitor_monitor_information_construct (GType object_type,
                                                    GearyFolder* folder,
                                                    GCancellable* cancellable)
{
	NewMessagesMonitorMonitorInformation * self = NULL;
	GearyFolder* _tmp0_;
	GCancellable* _tmp1_;
#line 24 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	g_return_val_if_fail (GEARY_IS_FOLDER (folder), NULL);
#line 24 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	g_return_val_if_fail ((cancellable == NULL) || G_IS_CANCELLABLE (cancellable), NULL);
#line 24 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	self = (NewMessagesMonitorMonitorInformation*) geary_base_object_construct (object_type);
#line 25 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	_tmp0_ = _g_object_ref0 (folder);
#line 25 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	_g_object_unref0 (self->folder);
#line 25 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	self->folder = _tmp0_;
#line 26 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	_tmp1_ = _g_object_ref0 (cancellable);
#line 26 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	_g_object_unref0 (self->cancellable);
#line 26 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	self->cancellable = _tmp1_;
#line 24 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	return self;
#line 1740 "new-messages-monitor.c"
}


static NewMessagesMonitorMonitorInformation*
new_messages_monitor_monitor_information_new (GearyFolder* folder,
                                              GCancellable* cancellable)
{
#line 24 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	return new_messages_monitor_monitor_information_construct (NEW_MESSAGES_MONITOR_TYPE_MONITOR_INFORMATION, folder, cancellable);
#line 1750 "new-messages-monitor.c"
}


static void
new_messages_monitor_monitor_information_class_init (NewMessagesMonitorMonitorInformationClass * klass)
{
#line 17 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	new_messages_monitor_monitor_information_parent_class = g_type_class_peek_parent (klass);
#line 17 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	G_OBJECT_CLASS (klass)->finalize = new_messages_monitor_monitor_information_finalize;
#line 1761 "new-messages-monitor.c"
}


static void
new_messages_monitor_monitor_information_instance_init (NewMessagesMonitorMonitorInformation * self)
{
	GeeHashSet* _tmp0_;
#line 19 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	self->cancellable = NULL;
#line 20 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	self->count = 0;
#line 21 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	_tmp0_ = gee_hash_set_new (GEARY_TYPE_EMAIL_IDENTIFIER, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL);
#line 21 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	self->new_ids = _tmp0_;
#line 1777 "new-messages-monitor.c"
}


static void
new_messages_monitor_monitor_information_finalize (GObject * obj)
{
	NewMessagesMonitorMonitorInformation * self;
#line 17 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NEW_MESSAGES_MONITOR_TYPE_MONITOR_INFORMATION, NewMessagesMonitorMonitorInformation);
#line 18 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	_g_object_unref0 (self->folder);
#line 19 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	_g_object_unref0 (self->cancellable);
#line 21 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	_g_object_unref0 (self->new_ids);
#line 17 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	G_OBJECT_CLASS (new_messages_monitor_monitor_information_parent_class)->finalize (obj);
#line 1795 "new-messages-monitor.c"
}


static GType
new_messages_monitor_monitor_information_get_type (void)
{
	static volatile gsize new_messages_monitor_monitor_information_type_id__volatile = 0;
	if (g_once_init_enter (&new_messages_monitor_monitor_information_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (NewMessagesMonitorMonitorInformationClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) new_messages_monitor_monitor_information_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NewMessagesMonitorMonitorInformation), 0, (GInstanceInitFunc) new_messages_monitor_monitor_information_instance_init, NULL };
		GType new_messages_monitor_monitor_information_type_id;
		new_messages_monitor_monitor_information_type_id = g_type_register_static (GEARY_TYPE_BASE_OBJECT, "NewMessagesMonitorMonitorInformation", &g_define_type_info, 0);
		g_once_init_leave (&new_messages_monitor_monitor_information_type_id__volatile, new_messages_monitor_monitor_information_type_id);
	}
	return new_messages_monitor_monitor_information_type_id__volatile;
}


static void
new_messages_monitor_class_init (NewMessagesMonitorClass * klass)
{
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	new_messages_monitor_parent_class = g_type_class_peek_parent (klass);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	g_type_class_add_private (klass, sizeof (NewMessagesMonitorPrivate));
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_new_messages_monitor_get_property;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_new_messages_monitor_set_property;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	G_OBJECT_CLASS (klass)->finalize = new_messages_monitor_finalize;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NEW_MESSAGES_MONITOR_REQUIRED_FIELDS_PROPERTY, new_messages_monitor_properties[NEW_MESSAGES_MONITOR_REQUIRED_FIELDS_PROPERTY] = g_param_spec_enum ("required-fields", "required-fields", "required-fields", GEARY_EMAIL_TYPE_FIELD, GEARY_EMAIL_FIELD_FLAGS, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NEW_MESSAGES_MONITOR_TOTAL_NEW_MESSAGES_PROPERTY, new_messages_monitor_properties[NEW_MESSAGES_MONITOR_TOTAL_NEW_MESSAGES_PROPERTY] = g_param_spec_int ("total-new-messages", "total-new-messages", "total-new-messages", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NEW_MESSAGES_MONITOR_LAST_NEW_MESSAGE_FOLDER_PROPERTY, new_messages_monitor_properties[NEW_MESSAGES_MONITOR_LAST_NEW_MESSAGE_FOLDER_PROPERTY] = g_param_spec_object ("last-new-message-folder", "last-new-message-folder", "last-new-message-folder", GEARY_TYPE_FOLDER, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NEW_MESSAGES_MONITOR_LAST_NEW_MESSAGE_PROPERTY, new_messages_monitor_properties[NEW_MESSAGES_MONITOR_LAST_NEW_MESSAGE_PROPERTY] = g_param_spec_object ("last-new-message", "last-new-message", "last-new-message", GEARY_TYPE_EMAIL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	new_messages_monitor_signals[NEW_MESSAGES_MONITOR_FOLDER_ADDED_SIGNAL] = g_signal_new ("folder-added", TYPE_NEW_MESSAGES_MONITOR, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, GEARY_TYPE_FOLDER);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	new_messages_monitor_signals[NEW_MESSAGES_MONITOR_FOLDER_REMOVED_SIGNAL] = g_signal_new ("folder-removed", TYPE_NEW_MESSAGES_MONITOR, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, GEARY_TYPE_FOLDER);
#line 1838 "new-messages-monitor.c"
	/**
	     * Fired when the monitor finds new messages on a folder.
	     */
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	new_messages_monitor_signals[NEW_MESSAGES_MONITOR_NEW_MESSAGES_ARRIVED_SIGNAL] = g_signal_new ("new-messages-arrived", TYPE_NEW_MESSAGES_MONITOR, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_INT_INT, G_TYPE_NONE, 3, GEARY_TYPE_FOLDER, G_TYPE_INT, G_TYPE_INT);
#line 1844 "new-messages-monitor.c"
	/**
	     * Fired when the monitor clears the "new" status of some messages in the
	     * folder.
	     */
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	new_messages_monitor_signals[NEW_MESSAGES_MONITOR_NEW_MESSAGES_RETIRED_SIGNAL] = g_signal_new ("new-messages-retired", TYPE_NEW_MESSAGES_MONITOR, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_INT, G_TYPE_NONE, 2, GEARY_TYPE_FOLDER, G_TYPE_INT);
#line 1851 "new-messages-monitor.c"
}


static void
new_messages_monitor_instance_init (NewMessagesMonitor * self)
{
	GeeHashMap* _tmp0_;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	self->priv = NEW_MESSAGES_MONITOR_GET_PRIVATE (self);
#line 30 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	self->priv->_required_fields = GEARY_EMAIL_FIELD_FLAGS;
#line 31 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	self->priv->_total_new_messages = 0;
#line 32 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	self->priv->_last_new_message_folder = NULL;
#line 33 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	self->priv->_last_new_message = NULL;
#line 35 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	_tmp0_ = gee_hash_map_new (GEARY_TYPE_FOLDER, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NEW_MESSAGES_MONITOR_TYPE_MONITOR_INFORMATION, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 35 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	self->priv->folder_information = _tmp0_;
#line 1873 "new-messages-monitor.c"
}


static void
new_messages_monitor_finalize (GObject * obj)
{
	NewMessagesMonitor * self;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_NEW_MESSAGES_MONITOR, NewMessagesMonitor);
#line 32 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	_g_object_unref0 (self->priv->_last_new_message_folder);
#line 33 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	_g_object_unref0 (self->priv->_last_new_message);
#line 35 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	_g_object_unref0 (self->priv->folder_information);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	G_OBJECT_CLASS (new_messages_monitor_parent_class)->finalize (obj);
#line 1891 "new-messages-monitor.c"
}


GType
new_messages_monitor_get_type (void)
{
	static volatile gsize new_messages_monitor_type_id__volatile = 0;
	if (g_once_init_enter (&new_messages_monitor_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (NewMessagesMonitorClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) new_messages_monitor_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NewMessagesMonitor), 0, (GInstanceInitFunc) new_messages_monitor_instance_init, NULL };
		GType new_messages_monitor_type_id;
		new_messages_monitor_type_id = g_type_register_static (GEARY_TYPE_BASE_OBJECT, "NewMessagesMonitor", &g_define_type_info, 0);
		g_once_init_leave (&new_messages_monitor_type_id__volatile, new_messages_monitor_type_id);
	}
	return new_messages_monitor_type_id__volatile;
}


static void
_vala_new_messages_monitor_get_property (GObject * object,
                                         guint property_id,
                                         GValue * value,
                                         GParamSpec * pspec)
{
	NewMessagesMonitor * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_NEW_MESSAGES_MONITOR, NewMessagesMonitor);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	switch (property_id) {
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
		case NEW_MESSAGES_MONITOR_REQUIRED_FIELDS_PROPERTY:
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
		g_value_set_enum (value, new_messages_monitor_get_required_fields (self));
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
		break;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
		case NEW_MESSAGES_MONITOR_TOTAL_NEW_MESSAGES_PROPERTY:
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
		g_value_set_int (value, new_messages_monitor_get_total_new_messages (self));
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
		break;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
		case NEW_MESSAGES_MONITOR_LAST_NEW_MESSAGE_FOLDER_PROPERTY:
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
		g_value_set_object (value, new_messages_monitor_get_last_new_message_folder (self));
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
		break;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
		case NEW_MESSAGES_MONITOR_LAST_NEW_MESSAGE_PROPERTY:
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
		g_value_set_object (value, new_messages_monitor_get_last_new_message (self));
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
		break;
#line 1943 "new-messages-monitor.c"
		default:
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
		break;
#line 1949 "new-messages-monitor.c"
	}
}


static void
_vala_new_messages_monitor_set_property (GObject * object,
                                         guint property_id,
                                         const GValue * value,
                                         GParamSpec * pspec)
{
	NewMessagesMonitor * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_NEW_MESSAGES_MONITOR, NewMessagesMonitor);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
	switch (property_id) {
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
		case NEW_MESSAGES_MONITOR_REQUIRED_FIELDS_PROPERTY:
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
		new_messages_monitor_set_required_fields (self, g_value_get_enum (value));
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
		break;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
		case NEW_MESSAGES_MONITOR_TOTAL_NEW_MESSAGES_PROPERTY:
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
		new_messages_monitor_set_total_new_messages (self, g_value_get_int (value));
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
		break;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
		case NEW_MESSAGES_MONITOR_LAST_NEW_MESSAGE_FOLDER_PROPERTY:
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
		new_messages_monitor_set_last_new_message_folder (self, g_value_get_object (value));
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
		break;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
		case NEW_MESSAGES_MONITOR_LAST_NEW_MESSAGE_PROPERTY:
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
		new_messages_monitor_set_last_new_message (self, g_value_get_object (value));
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
		break;
#line 1988 "new-messages-monitor.c"
		default:
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/client/notification/new-messages-monitor.vala"
		break;
#line 1994 "new-messages-monitor.c"
	}
}



