/* util-webkit.c generated by valac 0.39.7, the Vala compiler
 * generated from util-webkit.vala, do not modify */

/*
 * Copyright 2017 Michael James Gratton <mike@vee.net>
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution.
 */

#include <glib.h>
#include <glib-object.h>
#include <webkit2/webkit2.h>
#include <geary-engine.h>
#include <JavaScriptCore/JavaScript.h>
#include <float.h>
#include <math.h>
#include <stdlib.h>
#include <string.h>

#define _g_free0(var) (var = (g_free (var), NULL))



gboolean web_kit_util_to_bool (WebKitJavascriptResult* _result_,
                               GError** error);
gdouble web_kit_util_to_number (WebKitJavascriptResult* _result_,
                                GError** error);
gchar* web_kit_util_to_string (WebKitJavascriptResult* _result_,
                               GError** error);
gchar* web_kit_util_as_string (WebKitJavascriptResult* _result_,
                               GError** error);
static JSValueRef* _JS_value_dup (JSValueRef* self);
JSObjectRef* web_kit_util_to_object (WebKitJavascriptResult* _result_,
                                     GError** error);


/**
     * Returns a WebKit {@link WebKit.JavascriptResult} as a `bool`.
     *
     * This will raise a {@link Geary.JS.Error.TYPE} error if the
     * result is not a JavaScript `Boolean`.
     */
gboolean
web_kit_util_to_bool (WebKitJavascriptResult* _result_,
                      GError** error)
{
	gboolean result = FALSE;
	JSGlobalContextRef context = {0};
	JSValueRef value = {0};
	JSGlobalContextRef _tmp0_;
	JSGlobalContextRef _tmp4_;
	GError * _inner_error_ = NULL;
#line 19 "/builddir/build/BUILD/geary-0.12.1/src/client/util/util-webkit.vala"
	g_return_val_if_fail (_result_ != NULL, FALSE);
#line 21 "/builddir/build/BUILD/geary-0.12.1/src/client/util/util-webkit.vala"
	context = webkit_javascript_result_get_global_context (_result_);
#line 22 "/builddir/build/BUILD/geary-0.12.1/src/client/util/util-webkit.vala"
	value = webkit_javascript_result_get_value (_result_);
#line 23 "/builddir/build/BUILD/geary-0.12.1/src/client/util/util-webkit.vala"
	_tmp0_ = context;
#line 23 "/builddir/build/BUILD/geary-0.12.1/src/client/util/util-webkit.vala"
	if (!JSValueIsBoolean ((JSContextRef) _tmp0_, value)) {
#line 65 "util-webkit.c"
		GError* _tmp1_;
#line 24 "/builddir/build/BUILD/geary-0.12.1/src/client/util/util-webkit.vala"
		_tmp1_ = g_error_new_literal (GEARY_JS_ERROR, GEARY_JS_ERROR_TYPE, "Result is not a JS Boolean object");
#line 24 "/builddir/build/BUILD/geary-0.12.1/src/client/util/util-webkit.vala"
		_inner_error_ = _tmp1_;
#line 24 "/builddir/build/BUILD/geary-0.12.1/src/client/util/util-webkit.vala"
		if (_inner_error_->domain == GEARY_JS_ERROR) {
#line 73 "util-webkit.c"
			gboolean _tmp2_ = FALSE;
#line 24 "/builddir/build/BUILD/geary-0.12.1/src/client/util/util-webkit.vala"
			g_propagate_error (error, _inner_error_);
#line 24 "/builddir/build/BUILD/geary-0.12.1/src/client/util/util-webkit.vala"
			return _tmp2_;
#line 79 "util-webkit.c"
		} else {
			gboolean _tmp3_ = FALSE;
#line 24 "/builddir/build/BUILD/geary-0.12.1/src/client/util/util-webkit.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 24 "/builddir/build/BUILD/geary-0.12.1/src/client/util/util-webkit.vala"
			g_clear_error (&_inner_error_);
#line 24 "/builddir/build/BUILD/geary-0.12.1/src/client/util/util-webkit.vala"
			return _tmp3_;
#line 88 "util-webkit.c"
		}
	}
#line 26 "/builddir/build/BUILD/geary-0.12.1/src/client/util/util-webkit.vala"
	_tmp4_ = context;
#line 26 "/builddir/build/BUILD/geary-0.12.1/src/client/util/util-webkit.vala"
	result = JSValueToBoolean ((JSContextRef) _tmp4_, value);
#line 26 "/builddir/build/BUILD/geary-0.12.1/src/client/util/util-webkit.vala"
	return result;
#line 97 "util-webkit.c"
}


/**
     * Returns a WebKit {@link WebKit.JavascriptResult} as a `double`.
     *
     * This will raise a {@link Geary.JS.Error.TYPE} error if the
     * result is not a JavaScript `Number`.
     */
inline gdouble
web_kit_util_to_number (WebKitJavascriptResult* _result_,
                        GError** error)
{
	gdouble result = 0.0;
	gdouble _tmp0_ = 0.0;
	GError * _inner_error_ = NULL;
#line 35 "/builddir/build/BUILD/geary-0.12.1/src/client/util/util-webkit.vala"
	g_return_val_if_fail (_result_ != NULL, 0.0);
#line 37 "/builddir/build/BUILD/geary-0.12.1/src/client/util/util-webkit.vala"
	_tmp0_ = geary_js_to_number ((JSContextRef) webkit_javascript_result_get_global_context (_result_), webkit_javascript_result_get_value (_result_), &_inner_error_);
#line 37 "/builddir/build/BUILD/geary-0.12.1/src/client/util/util-webkit.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 37 "/builddir/build/BUILD/geary-0.12.1/src/client/util/util-webkit.vala"
		if (_inner_error_->domain == GEARY_JS_ERROR) {
#line 122 "util-webkit.c"
			gdouble _tmp1_ = 0.0;
#line 37 "/builddir/build/BUILD/geary-0.12.1/src/client/util/util-webkit.vala"
			g_propagate_error (error, _inner_error_);
#line 37 "/builddir/build/BUILD/geary-0.12.1/src/client/util/util-webkit.vala"
			return _tmp1_;
#line 128 "util-webkit.c"
		} else {
			gdouble _tmp2_ = 0.0;
#line 37 "/builddir/build/BUILD/geary-0.12.1/src/client/util/util-webkit.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 37 "/builddir/build/BUILD/geary-0.12.1/src/client/util/util-webkit.vala"
			g_clear_error (&_inner_error_);
#line 37 "/builddir/build/BUILD/geary-0.12.1/src/client/util/util-webkit.vala"
			return _tmp2_;
#line 137 "util-webkit.c"
		}
	}
#line 37 "/builddir/build/BUILD/geary-0.12.1/src/client/util/util-webkit.vala"
	result = _tmp0_;
#line 37 "/builddir/build/BUILD/geary-0.12.1/src/client/util/util-webkit.vala"
	return result;
#line 144 "util-webkit.c"
}


/**
     * Returns a WebKit {@link WebKit.JavascriptResult} as a Vala {@link string}.
     *
     * This will raise a {@link Geary.JS.Error.TYPE} error if the
     * result is not a JavaScript `String`.
     */
inline gchar*
web_kit_util_to_string (WebKitJavascriptResult* _result_,
                        GError** error)
{
	gchar* result = NULL;
	gchar* _tmp0_ = NULL;
	gchar* _tmp1_;
	gchar* _tmp2_;
	GError * _inner_error_ = NULL;
#line 47 "/builddir/build/BUILD/geary-0.12.1/src/client/util/util-webkit.vala"
	g_return_val_if_fail (_result_ != NULL, NULL);
#line 49 "/builddir/build/BUILD/geary-0.12.1/src/client/util/util-webkit.vala"
	_tmp1_ = geary_js_to_string ((JSContextRef) webkit_javascript_result_get_global_context (_result_), webkit_javascript_result_get_value (_result_), &_inner_error_);
#line 49 "/builddir/build/BUILD/geary-0.12.1/src/client/util/util-webkit.vala"
	_tmp0_ = _tmp1_;
#line 49 "/builddir/build/BUILD/geary-0.12.1/src/client/util/util-webkit.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 49 "/builddir/build/BUILD/geary-0.12.1/src/client/util/util-webkit.vala"
		if (_inner_error_->domain == GEARY_JS_ERROR) {
#line 49 "/builddir/build/BUILD/geary-0.12.1/src/client/util/util-webkit.vala"
			g_propagate_error (error, _inner_error_);
#line 49 "/builddir/build/BUILD/geary-0.12.1/src/client/util/util-webkit.vala"
			return NULL;
#line 177 "util-webkit.c"
		} else {
#line 49 "/builddir/build/BUILD/geary-0.12.1/src/client/util/util-webkit.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 49 "/builddir/build/BUILD/geary-0.12.1/src/client/util/util-webkit.vala"
			g_clear_error (&_inner_error_);
#line 49 "/builddir/build/BUILD/geary-0.12.1/src/client/util/util-webkit.vala"
			return NULL;
#line 185 "util-webkit.c"
		}
	}
#line 49 "/builddir/build/BUILD/geary-0.12.1/src/client/util/util-webkit.vala"
	_tmp2_ = _tmp0_;
#line 49 "/builddir/build/BUILD/geary-0.12.1/src/client/util/util-webkit.vala"
	_tmp0_ = NULL;
#line 49 "/builddir/build/BUILD/geary-0.12.1/src/client/util/util-webkit.vala"
	result = _tmp2_;
#line 49 "/builddir/build/BUILD/geary-0.12.1/src/client/util/util-webkit.vala"
	_g_free0 (_tmp0_);
#line 49 "/builddir/build/BUILD/geary-0.12.1/src/client/util/util-webkit.vala"
	return result;
#line 198 "util-webkit.c"
}


/**
     * Converts a WebKit {@link WebKit.JavascriptResult} to a {@link string}.
     *
     * Unlike the other `get_foo_result` methods, this will coax the
     * result to a string, effectively by calling the JavaScript
     * `toString()` method on it, and returning that value.
     */
static JSValueRef*
_JS_value_dup (JSValueRef* self)
{
	JSValueRef* dup;
#line 65 "/builddir/build/BUILD/geary-0.12.1/src/client/util/util-webkit.vala"
	dup = g_new0 (JSValueRef, 1);
#line 65 "/builddir/build/BUILD/geary-0.12.1/src/client/util/util-webkit.vala"
	memcpy (dup, self, sizeof (JSValueRef));
#line 65 "/builddir/build/BUILD/geary-0.12.1/src/client/util/util-webkit.vala"
	return dup;
#line 219 "util-webkit.c"
}


static gpointer
__JS_value_dup0 (gpointer self)
{
#line 65 "/builddir/build/BUILD/geary-0.12.1/src/client/util/util-webkit.vala"
	return self ? _JS_value_dup (self) : NULL;
#line 228 "util-webkit.c"
}


gchar*
web_kit_util_as_string (WebKitJavascriptResult* _result_,
                        GError** error)
{
	gchar* result = NULL;
	JSGlobalContextRef context = {0};
	JSValueRef js_str_value = {0};
	JSValueRef* err = NULL;
	JSStringRef js_str = {0};
	JSValueRef _tmp0_ = {0};
	JSStringRef _tmp1_;
	JSValueRef _tmp2_;
	JSValueRef* _tmp3_;
	JSValueRef* _tmp4_;
	gchar* _tmp5_;
	GError * _inner_error_ = NULL;
#line 60 "/builddir/build/BUILD/geary-0.12.1/src/client/util/util-webkit.vala"
	g_return_val_if_fail (_result_ != NULL, NULL);
#line 62 "/builddir/build/BUILD/geary-0.12.1/src/client/util/util-webkit.vala"
	context = webkit_javascript_result_get_global_context (_result_);
#line 63 "/builddir/build/BUILD/geary-0.12.1/src/client/util/util-webkit.vala"
	js_str_value = webkit_javascript_result_get_value (_result_);
#line 64 "/builddir/build/BUILD/geary-0.12.1/src/client/util/util-webkit.vala"
	err = NULL;
#line 65 "/builddir/build/BUILD/geary-0.12.1/src/client/util/util-webkit.vala"
	_tmp1_ = JSValueToStringCopy ((JSContextRef) context, js_str_value, &_tmp0_);
#line 65 "/builddir/build/BUILD/geary-0.12.1/src/client/util/util-webkit.vala"
	_g_free0 (err);
#line 65 "/builddir/build/BUILD/geary-0.12.1/src/client/util/util-webkit.vala"
	_tmp2_ = _tmp0_;
#line 65 "/builddir/build/BUILD/geary-0.12.1/src/client/util/util-webkit.vala"
	_tmp3_ = __JS_value_dup0 (&_tmp2_);
#line 65 "/builddir/build/BUILD/geary-0.12.1/src/client/util/util-webkit.vala"
	err = _tmp3_;
#line 65 "/builddir/build/BUILD/geary-0.12.1/src/client/util/util-webkit.vala"
	js_str = _tmp1_;
#line 66 "/builddir/build/BUILD/geary-0.12.1/src/client/util/util-webkit.vala"
	_tmp4_ = err;
#line 66 "/builddir/build/BUILD/geary-0.12.1/src/client/util/util-webkit.vala"
	geary_js_check_exception ((JSContextRef) context, _tmp4_, &_inner_error_);
#line 66 "/builddir/build/BUILD/geary-0.12.1/src/client/util/util-webkit.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 66 "/builddir/build/BUILD/geary-0.12.1/src/client/util/util-webkit.vala"
		if (_inner_error_->domain == GEARY_JS_ERROR) {
#line 66 "/builddir/build/BUILD/geary-0.12.1/src/client/util/util-webkit.vala"
			g_propagate_error (error, _inner_error_);
#line 66 "/builddir/build/BUILD/geary-0.12.1/src/client/util/util-webkit.vala"
			_g_free0 (err);
#line 66 "/builddir/build/BUILD/geary-0.12.1/src/client/util/util-webkit.vala"
			return NULL;
#line 282 "util-webkit.c"
		} else {
#line 66 "/builddir/build/BUILD/geary-0.12.1/src/client/util/util-webkit.vala"
			_g_free0 (err);
#line 66 "/builddir/build/BUILD/geary-0.12.1/src/client/util/util-webkit.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 66 "/builddir/build/BUILD/geary-0.12.1/src/client/util/util-webkit.vala"
			g_clear_error (&_inner_error_);
#line 66 "/builddir/build/BUILD/geary-0.12.1/src/client/util/util-webkit.vala"
			return NULL;
#line 292 "util-webkit.c"
		}
	}
#line 67 "/builddir/build/BUILD/geary-0.12.1/src/client/util/util-webkit.vala"
	_tmp5_ = geary_js_to_string_released (js_str);
#line 67 "/builddir/build/BUILD/geary-0.12.1/src/client/util/util-webkit.vala"
	result = _tmp5_;
#line 67 "/builddir/build/BUILD/geary-0.12.1/src/client/util/util-webkit.vala"
	_g_free0 (err);
#line 67 "/builddir/build/BUILD/geary-0.12.1/src/client/util/util-webkit.vala"
	return result;
#line 303 "util-webkit.c"
}


/**
     * Returns a WebKit {@link WebKit.JavascriptResult} as an Object.
     *
     * This will raise a {@link Geary.JS.Error.TYPE} error if the
     * result is not a JavaScript `Object`.
     *
     * Return type is nullable as a workaround for Bug 778046, it will
     * never actually be null.
     */
JSObjectRef*
web_kit_util_to_object (WebKitJavascriptResult* _result_,
                        GError** error)
{
	JSObjectRef* result = NULL;
	JSObjectRef* _tmp0_ = NULL;
	JSObjectRef* _tmp1_;
	JSObjectRef* _tmp2_;
	GError * _inner_error_ = NULL;
#line 79 "/builddir/build/BUILD/geary-0.12.1/src/client/util/util-webkit.vala"
	g_return_val_if_fail (_result_ != NULL, NULL);
#line 81 "/builddir/build/BUILD/geary-0.12.1/src/client/util/util-webkit.vala"
	_tmp1_ = geary_js_to_object ((JSContextRef) webkit_javascript_result_get_global_context (_result_), webkit_javascript_result_get_value (_result_), &_inner_error_);
#line 81 "/builddir/build/BUILD/geary-0.12.1/src/client/util/util-webkit.vala"
	_tmp0_ = _tmp1_;
#line 81 "/builddir/build/BUILD/geary-0.12.1/src/client/util/util-webkit.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 81 "/builddir/build/BUILD/geary-0.12.1/src/client/util/util-webkit.vala"
		if (_inner_error_->domain == GEARY_JS_ERROR) {
#line 81 "/builddir/build/BUILD/geary-0.12.1/src/client/util/util-webkit.vala"
			g_propagate_error (error, _inner_error_);
#line 81 "/builddir/build/BUILD/geary-0.12.1/src/client/util/util-webkit.vala"
			return NULL;
#line 339 "util-webkit.c"
		} else {
#line 81 "/builddir/build/BUILD/geary-0.12.1/src/client/util/util-webkit.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 81 "/builddir/build/BUILD/geary-0.12.1/src/client/util/util-webkit.vala"
			g_clear_error (&_inner_error_);
#line 81 "/builddir/build/BUILD/geary-0.12.1/src/client/util/util-webkit.vala"
			return NULL;
#line 347 "util-webkit.c"
		}
	}
#line 81 "/builddir/build/BUILD/geary-0.12.1/src/client/util/util-webkit.vala"
	_tmp2_ = _tmp0_;
#line 81 "/builddir/build/BUILD/geary-0.12.1/src/client/util/util-webkit.vala"
	_tmp0_ = NULL;
#line 81 "/builddir/build/BUILD/geary-0.12.1/src/client/util/util-webkit.vala"
	result = _tmp2_;
#line 81 "/builddir/build/BUILD/geary-0.12.1/src/client/util/util-webkit.vala"
	_g_free0 (_tmp0_);
#line 81 "/builddir/build/BUILD/geary-0.12.1/src/client/util/util-webkit.vala"
	return result;
#line 360 "util-webkit.c"
}



