/* mime-disposition-type.c generated by valac 0.39.7, the Vala compiler
 * generated from mime-disposition-type.vala, do not modify */

/* Copyright 2016 Software Freedom Conservancy Inc.
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution.
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>


#define GEARY_MIME_TYPE_DISPOSITION_TYPE (geary_mime_disposition_type_get_type ())

typedef enum  {
	GEARY_MIME_DISPOSITION_TYPE_UNSPECIFIED = -1,
	GEARY_MIME_DISPOSITION_TYPE_ATTACHMENT = 0,
	GEARY_MIME_DISPOSITION_TYPE_INLINE = 1
} GearyMimeDispositionType;



GType geary_mime_disposition_type_get_type (void) G_GNUC_CONST;
GearyMimeDispositionType geary_mime_disposition_type_deserialize (const gchar* str,
                                                                  gboolean* is_unknown);
gboolean geary_string_is_empty_or_whitespace (const gchar* str);
gchar* geary_mime_disposition_type_serialize (GearyMimeDispositionType self);
GearyMimeDispositionType geary_mime_disposition_type_from_int (gint i);


/**
     * Convert the disposition-type field into an internal representation.
     *
     * Empty or blank fields result in {@link UNSPECIFIED}.  Unknown fields are converted to
     * {@link ATTACHMENT} as per RFC 2183 Section 2.8.  However, since the caller may want to
     * make a decision about unknown vs. unspecified type fields, is_unknown is returned as well.
     */
GearyMimeDispositionType
geary_mime_disposition_type_deserialize (const gchar* str,
                                         gboolean* is_unknown)
{
	gboolean _vala_is_unknown = FALSE;
	GearyMimeDispositionType result = 0;
	gchar* _tmp0_;
	gchar* _tmp1_;
	GQuark _tmp3_ = 0U;
#line 38 "/builddir/build/BUILD/geary-0.12.1/src/engine/mime/mime-disposition-type.vala"
	static GQuark _tmp2_label0 = 0;
#line 38 "/builddir/build/BUILD/geary-0.12.1/src/engine/mime/mime-disposition-type.vala"
	static GQuark _tmp2_label1 = 0;
#line 33 "/builddir/build/BUILD/geary-0.12.1/src/engine/mime/mime-disposition-type.vala"
	_vala_is_unknown = FALSE;
#line 35 "/builddir/build/BUILD/geary-0.12.1/src/engine/mime/mime-disposition-type.vala"
	if (geary_string_is_empty_or_whitespace (str)) {
#line 36 "/builddir/build/BUILD/geary-0.12.1/src/engine/mime/mime-disposition-type.vala"
		result = GEARY_MIME_DISPOSITION_TYPE_UNSPECIFIED;
#line 36 "/builddir/build/BUILD/geary-0.12.1/src/engine/mime/mime-disposition-type.vala"
		if (is_unknown) {
#line 36 "/builddir/build/BUILD/geary-0.12.1/src/engine/mime/mime-disposition-type.vala"
			*is_unknown = _vala_is_unknown;
#line 65 "mime-disposition-type.c"
		}
#line 36 "/builddir/build/BUILD/geary-0.12.1/src/engine/mime/mime-disposition-type.vala"
		return result;
#line 69 "mime-disposition-type.c"
	}
#line 38 "/builddir/build/BUILD/geary-0.12.1/src/engine/mime/mime-disposition-type.vala"
	_tmp0_ = g_utf8_strdown (str, (gssize) -1);
#line 38 "/builddir/build/BUILD/geary-0.12.1/src/engine/mime/mime-disposition-type.vala"
	_tmp1_ = _tmp0_;
#line 38 "/builddir/build/BUILD/geary-0.12.1/src/engine/mime/mime-disposition-type.vala"
	_tmp3_ = (NULL == _tmp1_) ? 0 : g_quark_from_string (_tmp1_);
#line 38 "/builddir/build/BUILD/geary-0.12.1/src/engine/mime/mime-disposition-type.vala"
	g_free (_tmp1_);
#line 38 "/builddir/build/BUILD/geary-0.12.1/src/engine/mime/mime-disposition-type.vala"
	if (_tmp3_ == ((0 != _tmp2_label0) ? _tmp2_label0 : (_tmp2_label0 = g_quark_from_static_string ("inline")))) {
#line 38 "/builddir/build/BUILD/geary-0.12.1/src/engine/mime/mime-disposition-type.vala"
		switch (0) {
#line 83 "mime-disposition-type.c"
			default:
			{
#line 40 "/builddir/build/BUILD/geary-0.12.1/src/engine/mime/mime-disposition-type.vala"
				result = GEARY_MIME_DISPOSITION_TYPE_INLINE;
#line 40 "/builddir/build/BUILD/geary-0.12.1/src/engine/mime/mime-disposition-type.vala"
				if (is_unknown) {
#line 40 "/builddir/build/BUILD/geary-0.12.1/src/engine/mime/mime-disposition-type.vala"
					*is_unknown = _vala_is_unknown;
#line 92 "mime-disposition-type.c"
				}
#line 40 "/builddir/build/BUILD/geary-0.12.1/src/engine/mime/mime-disposition-type.vala"
				return result;
#line 96 "mime-disposition-type.c"
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label1) ? _tmp2_label1 : (_tmp2_label1 = g_quark_from_static_string ("attachment")))) {
#line 38 "/builddir/build/BUILD/geary-0.12.1/src/engine/mime/mime-disposition-type.vala"
		switch (0) {
#line 102 "mime-disposition-type.c"
			default:
			{
#line 43 "/builddir/build/BUILD/geary-0.12.1/src/engine/mime/mime-disposition-type.vala"
				result = GEARY_MIME_DISPOSITION_TYPE_ATTACHMENT;
#line 43 "/builddir/build/BUILD/geary-0.12.1/src/engine/mime/mime-disposition-type.vala"
				if (is_unknown) {
#line 43 "/builddir/build/BUILD/geary-0.12.1/src/engine/mime/mime-disposition-type.vala"
					*is_unknown = _vala_is_unknown;
#line 111 "mime-disposition-type.c"
				}
#line 43 "/builddir/build/BUILD/geary-0.12.1/src/engine/mime/mime-disposition-type.vala"
				return result;
#line 115 "mime-disposition-type.c"
			}
		}
	} else {
#line 38 "/builddir/build/BUILD/geary-0.12.1/src/engine/mime/mime-disposition-type.vala"
		switch (0) {
#line 121 "mime-disposition-type.c"
			default:
			{
#line 46 "/builddir/build/BUILD/geary-0.12.1/src/engine/mime/mime-disposition-type.vala"
				_vala_is_unknown = TRUE;
#line 48 "/builddir/build/BUILD/geary-0.12.1/src/engine/mime/mime-disposition-type.vala"
				result = GEARY_MIME_DISPOSITION_TYPE_ATTACHMENT;
#line 48 "/builddir/build/BUILD/geary-0.12.1/src/engine/mime/mime-disposition-type.vala"
				if (is_unknown) {
#line 48 "/builddir/build/BUILD/geary-0.12.1/src/engine/mime/mime-disposition-type.vala"
					*is_unknown = _vala_is_unknown;
#line 132 "mime-disposition-type.c"
				}
#line 48 "/builddir/build/BUILD/geary-0.12.1/src/engine/mime/mime-disposition-type.vala"
				return result;
#line 136 "mime-disposition-type.c"
			}
		}
	}
#line 32 "/builddir/build/BUILD/geary-0.12.1/src/engine/mime/mime-disposition-type.vala"
	if (is_unknown) {
#line 32 "/builddir/build/BUILD/geary-0.12.1/src/engine/mime/mime-disposition-type.vala"
		*is_unknown = _vala_is_unknown;
#line 144 "mime-disposition-type.c"
	}
}


/**
     * Returns null if value is {@link UNSPECIFIED}
     */
gchar*
geary_mime_disposition_type_serialize (GearyMimeDispositionType self)
{
	gchar* result = NULL;
#line 56 "/builddir/build/BUILD/geary-0.12.1/src/engine/mime/mime-disposition-type.vala"
	switch (self) {
#line 56 "/builddir/build/BUILD/geary-0.12.1/src/engine/mime/mime-disposition-type.vala"
		case GEARY_MIME_DISPOSITION_TYPE_UNSPECIFIED:
#line 160 "mime-disposition-type.c"
		{
#line 58 "/builddir/build/BUILD/geary-0.12.1/src/engine/mime/mime-disposition-type.vala"
			result = NULL;
#line 58 "/builddir/build/BUILD/geary-0.12.1/src/engine/mime/mime-disposition-type.vala"
			return result;
#line 166 "mime-disposition-type.c"
		}
#line 56 "/builddir/build/BUILD/geary-0.12.1/src/engine/mime/mime-disposition-type.vala"
		case GEARY_MIME_DISPOSITION_TYPE_ATTACHMENT:
#line 170 "mime-disposition-type.c"
		{
			gchar* _tmp0_;
#line 61 "/builddir/build/BUILD/geary-0.12.1/src/engine/mime/mime-disposition-type.vala"
			_tmp0_ = g_strdup ("attachment");
#line 61 "/builddir/build/BUILD/geary-0.12.1/src/engine/mime/mime-disposition-type.vala"
			result = _tmp0_;
#line 61 "/builddir/build/BUILD/geary-0.12.1/src/engine/mime/mime-disposition-type.vala"
			return result;
#line 179 "mime-disposition-type.c"
		}
#line 56 "/builddir/build/BUILD/geary-0.12.1/src/engine/mime/mime-disposition-type.vala"
		case GEARY_MIME_DISPOSITION_TYPE_INLINE:
#line 183 "mime-disposition-type.c"
		{
			gchar* _tmp1_;
#line 64 "/builddir/build/BUILD/geary-0.12.1/src/engine/mime/mime-disposition-type.vala"
			_tmp1_ = g_strdup ("inline");
#line 64 "/builddir/build/BUILD/geary-0.12.1/src/engine/mime/mime-disposition-type.vala"
			result = _tmp1_;
#line 64 "/builddir/build/BUILD/geary-0.12.1/src/engine/mime/mime-disposition-type.vala"
			return result;
#line 192 "mime-disposition-type.c"
		}
		default:
		{
#line 67 "/builddir/build/BUILD/geary-0.12.1/src/engine/mime/mime-disposition-type.vala"
			g_assert_not_reached ();
#line 198 "mime-disposition-type.c"
		}
	}
}


GearyMimeDispositionType
geary_mime_disposition_type_from_int (gint i)
{
	GearyMimeDispositionType result = 0;
#line 72 "/builddir/build/BUILD/geary-0.12.1/src/engine/mime/mime-disposition-type.vala"
	switch (i) {
#line 72 "/builddir/build/BUILD/geary-0.12.1/src/engine/mime/mime-disposition-type.vala"
		case GEARY_MIME_DISPOSITION_TYPE_INLINE:
#line 212 "mime-disposition-type.c"
		{
#line 74 "/builddir/build/BUILD/geary-0.12.1/src/engine/mime/mime-disposition-type.vala"
			result = GEARY_MIME_DISPOSITION_TYPE_INLINE;
#line 74 "/builddir/build/BUILD/geary-0.12.1/src/engine/mime/mime-disposition-type.vala"
			return result;
#line 218 "mime-disposition-type.c"
		}
#line 72 "/builddir/build/BUILD/geary-0.12.1/src/engine/mime/mime-disposition-type.vala"
		case GEARY_MIME_DISPOSITION_TYPE_UNSPECIFIED:
#line 222 "mime-disposition-type.c"
		{
#line 77 "/builddir/build/BUILD/geary-0.12.1/src/engine/mime/mime-disposition-type.vala"
			result = GEARY_MIME_DISPOSITION_TYPE_UNSPECIFIED;
#line 77 "/builddir/build/BUILD/geary-0.12.1/src/engine/mime/mime-disposition-type.vala"
			return result;
#line 228 "mime-disposition-type.c"
		}
		default:
#line 72 "/builddir/build/BUILD/geary-0.12.1/src/engine/mime/mime-disposition-type.vala"
		case GEARY_MIME_DISPOSITION_TYPE_ATTACHMENT:
#line 233 "mime-disposition-type.c"
		{
#line 83 "/builddir/build/BUILD/geary-0.12.1/src/engine/mime/mime-disposition-type.vala"
			result = GEARY_MIME_DISPOSITION_TYPE_ATTACHMENT;
#line 83 "/builddir/build/BUILD/geary-0.12.1/src/engine/mime/mime-disposition-type.vala"
			return result;
#line 239 "mime-disposition-type.c"
		}
	}
}


/**
 * A representation of a MIME Content-Disposition type field.
 *
 * Note that NONE only indicates that the Content-Disposition type field was not present.
 * RFC 2183 Section 2.8 specifies that unknown type fields should be treated as attachments,
 * which is true in this code as well.
 *
 * These values may be persisted on disk and should not be modified unless you know what
 * you're doing.  (Legacy code requires that NONE be -1.)
 *
 * See [[https://tools.ietf.org/html/rfc2183#section-2]]
 */
GType
geary_mime_disposition_type_get_type (void)
{
	static volatile gsize geary_mime_disposition_type_type_id__volatile = 0;
	if (g_once_init_enter (&geary_mime_disposition_type_type_id__volatile)) {
		static const GEnumValue values[] = {{GEARY_MIME_DISPOSITION_TYPE_UNSPECIFIED, "GEARY_MIME_DISPOSITION_TYPE_UNSPECIFIED", "unspecified"}, {GEARY_MIME_DISPOSITION_TYPE_ATTACHMENT, "GEARY_MIME_DISPOSITION_TYPE_ATTACHMENT", "attachment"}, {GEARY_MIME_DISPOSITION_TYPE_INLINE, "GEARY_MIME_DISPOSITION_TYPE_INLINE", "inline"}, {0, NULL, NULL}};
		GType geary_mime_disposition_type_type_id;
		geary_mime_disposition_type_type_id = g_enum_register_static ("GearyMimeDispositionType", values);
		g_once_init_leave (&geary_mime_disposition_type_type_id__volatile, geary_mime_disposition_type_type_id);
	}
	return geary_mime_disposition_type_type_id__volatile;
}



