/* util-js.c generated by valac 0.39.7, the Vala compiler
 * generated from util-js.vala, do not modify */

/*
 * Copyright 2017 Michael James Gratton <mike@vee.net>
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution.
 */

#include <glib.h>
#include <glib-object.h>
#include <JavaScriptCore/JavaScript.h>
#include <float.h>
#include <math.h>
#include <string.h>
#include <stdlib.h>
#include <gobject/gvaluecollector.h>

#define _g_free0(var) ((var == NULL) ? NULL : (var = (g_free (var), NULL)))
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))

#define GEARY_JS_TYPE_CALLABLE (geary_js_callable_get_type ())
#define GEARY_JS_CALLABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GEARY_JS_TYPE_CALLABLE, GearyJSCallable))
#define GEARY_JS_CALLABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GEARY_JS_TYPE_CALLABLE, GearyJSCallableClass))
#define GEARY_JS_IS_CALLABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GEARY_JS_TYPE_CALLABLE))
#define GEARY_JS_IS_CALLABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GEARY_JS_TYPE_CALLABLE))
#define GEARY_JS_CALLABLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GEARY_JS_TYPE_CALLABLE, GearyJSCallableClass))

typedef struct _GearyJSCallable GearyJSCallable;
typedef struct _GearyJSCallableClass GearyJSCallableClass;
typedef struct _GearyJSCallablePrivate GearyJSCallablePrivate;
typedef struct _GearyJSParamSpecCallable GearyJSParamSpecCallable;

/**
     * Errors produced by functions in {@link Geary.JS}.
     */
typedef enum  {
	GEARY_JS_ERROR_EXCEPTION,
	GEARY_JS_ERROR_TYPE
} GearyJSError;
#define GEARY_JS_ERROR geary_js_error_quark ()
struct _GearyJSCallable {
	GTypeInstance parent_instance;
	volatile int ref_count;
	GearyJSCallablePrivate * priv;
};

struct _GearyJSCallableClass {
	GTypeClass parent_class;
	void (*finalize) (GearyJSCallable *self);
};

struct _GearyJSCallablePrivate {
	gchar* base_name;
	gchar** safe_args;
	gint safe_args_length1;
	gint _safe_args_size_;
};

struct _GearyJSParamSpecCallable {
	GParamSpec parent_instance;
};


static gpointer geary_js_callable_parent_class = NULL;

GQuark geary_js_error_quark (void);
gboolean geary_js_is_null (JSContextRef context,
                           JSValueRef* js);
gdouble geary_js_to_number (JSContextRef context,
                            JSValueRef value,
                            GError** error);
static JSValueRef* _JS_value_dup (JSValueRef* self);
void geary_js_check_exception (JSContextRef context,
                               JSValueRef* err_value,
                               GError** error);
gchar* geary_js_to_string (JSContextRef context,
                           JSValueRef value,
                           GError** error);
gchar* geary_js_to_string_released (JSStringRef js);
JSObjectRef* geary_js_to_object (JSContextRef context,
                                 JSValueRef value,
                                 GError** error);
static JSObjectRef* _JS_object_dup (JSObjectRef* self);
JSValueRef* geary_js_get_property (JSContextRef context,
                                   JSObjectRef object,
                                   const gchar* name,
                                   GError** error);
const gchar* JS_type_to_string (JSType self);
static const char* _JS_type_to_string (JSType value);
gchar* geary_js_escape_string (const gchar* value);
gpointer geary_js_callable_ref (gpointer instance);
void geary_js_callable_unref (gpointer instance);
GParamSpec* geary_js_param_spec_callable (const gchar* name,
                                          const gchar* nick,
                                          const gchar* blurb,
                                          GType object_type,
                                          GParamFlags flags);
void geary_js_value_set_callable (GValue* value,
                                  gpointer v_object);
void geary_js_value_take_callable (GValue* value,
                                   gpointer v_object);
gpointer geary_js_value_get_callable (const GValue* value);
GType geary_js_callable_get_type (void) G_GNUC_CONST;
GearyJSCallable* geary_js_callable (const gchar* base_name);
GearyJSCallable* geary_js_callable_new (const gchar* base_name);
GearyJSCallable* geary_js_callable_construct (GType object_type,
                                              const gchar* base_name);
#define GEARY_JS_CALLABLE_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), GEARY_JS_TYPE_CALLABLE, GearyJSCallablePrivate))
gchar* geary_js_callable_to_string (GearyJSCallable* self);
GearyJSCallable* geary_js_callable_string (GearyJSCallable* self,
                                           const gchar* value);
static inline void geary_js_callable_add_param (GearyJSCallable* self,
                                  const gchar* value);
GearyJSCallable* geary_js_callable_double (GearyJSCallable* self,
                                           gdouble value);
GearyJSCallable* geary_js_callable_int (GearyJSCallable* self,
                                        gint value);
GearyJSCallable* geary_js_callable_bool (GearyJSCallable* self,
                                         gboolean value);
static void _vala_array_add23 (gchar** * array,
                        int* length,
                        int* size,
                        gchar* value);
static void geary_js_callable_finalize (GearyJSCallable * obj);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);


GQuark
geary_js_error_quark (void)
{
	return g_quark_from_static_string ("geary_js_error-quark");
}


/**
     * Determines if a {@link JS.Value} object is {{{null}}}.
     *
     * @return `true` if `js` is `null` or has a {@link JS.Type} of
     * `NULL` according to `context`.
     */
inline gboolean
geary_js_is_null (JSContextRef context,
                  JSValueRef* js)
{
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
#line 36 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
	if (js == NULL) {
#line 36 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
		_tmp0_ = TRUE;
#line 159 "util-js.c"
	} else {
#line 36 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
		_tmp0_ = JSValueGetType (context, *js) == kJSTypeNull;
#line 163 "util-js.c"
	}
#line 36 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
	result = _tmp0_;
#line 36 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
	return result;
#line 169 "util-js.c"
}


/**
     * Returns a JSC Value as a number.
     *
     * This will raise a {@link Geary.JS.Error.TYPE} error if the
     * value is not a JavaScript `Number`.
     */
static JSValueRef*
_JS_value_dup (JSValueRef* self)
{
	JSValueRef* dup;
#line 53 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
	dup = g_new0 (JSValueRef, 1);
#line 53 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
	memcpy (dup, self, sizeof (JSValueRef));
#line 53 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
	return dup;
#line 189 "util-js.c"
}


static gpointer
__JS_value_dup0 (gpointer self)
{
#line 53 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
	return self ? _JS_value_dup (self) : NULL;
#line 198 "util-js.c"
}


gdouble
geary_js_to_number (JSContextRef context,
                    JSValueRef value,
                    GError** error)
{
	gdouble result = 0.0;
	JSValueRef* err = NULL;
	gdouble number = 0.0;
	JSValueRef _tmp3_ = {0};
	gdouble _tmp4_;
	JSValueRef _tmp5_;
	JSValueRef* _tmp6_;
	JSValueRef* _tmp7_;
	GError * _inner_error_ = NULL;
#line 48 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
	if (!JSValueIsNumber (context, value)) {
#line 218 "util-js.c"
		GError* _tmp0_;
#line 49 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
		_tmp0_ = g_error_new_literal (GEARY_JS_ERROR, GEARY_JS_ERROR_TYPE, "Value is not a JS Number object");
#line 49 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
		_inner_error_ = _tmp0_;
#line 49 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
		if (_inner_error_->domain == GEARY_JS_ERROR) {
#line 226 "util-js.c"
			gdouble _tmp1_ = 0.0;
#line 49 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
			g_propagate_error (error, _inner_error_);
#line 49 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
			return _tmp1_;
#line 232 "util-js.c"
		} else {
			gdouble _tmp2_ = 0.0;
#line 49 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 49 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
			g_clear_error (&_inner_error_);
#line 49 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
			return _tmp2_;
#line 241 "util-js.c"
		}
	}
#line 52 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
	err = NULL;
#line 53 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
	_tmp4_ = JSValueToNumber (context, value, &_tmp3_);
#line 53 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
	_g_free0 (err);
#line 53 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
	_tmp5_ = _tmp3_;
#line 53 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
	_tmp6_ = __JS_value_dup0 (&_tmp5_);
#line 53 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
	err = _tmp6_;
#line 53 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
	number = _tmp4_;
#line 54 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
	_tmp7_ = err;
#line 54 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
	geary_js_check_exception (context, _tmp7_, &_inner_error_);
#line 54 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 54 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
		if (_inner_error_->domain == GEARY_JS_ERROR) {
#line 266 "util-js.c"
			gdouble _tmp8_ = 0.0;
#line 54 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
			g_propagate_error (error, _inner_error_);
#line 54 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
			_g_free0 (err);
#line 54 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
			return _tmp8_;
#line 274 "util-js.c"
		} else {
			gdouble _tmp9_ = 0.0;
#line 54 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
			_g_free0 (err);
#line 54 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 54 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
			g_clear_error (&_inner_error_);
#line 54 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
			return _tmp9_;
#line 285 "util-js.c"
		}
	}
#line 55 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
	result = number;
#line 55 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
	_g_free0 (err);
#line 55 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
	return result;
#line 294 "util-js.c"
}


/**
     * Returns a JSC Value as a string.
     *
     * This will raise a {@link Geary.JS.Error.TYPE} error if the
     * value is not a JavaScript `String`.
     */
gchar*
geary_js_to_string (JSContextRef context,
                    JSValueRef value,
                    GError** error)
{
	gchar* result = NULL;
	JSValueRef* err = NULL;
	JSStringRef js_str = {0};
	JSValueRef _tmp1_ = {0};
	JSStringRef _tmp2_;
	JSValueRef _tmp3_;
	JSValueRef* _tmp4_;
	JSValueRef* _tmp5_;
	gchar* _tmp6_;
	GError * _inner_error_ = NULL;
#line 67 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
	if (!JSValueIsString (context, value)) {
#line 321 "util-js.c"
		GError* _tmp0_;
#line 68 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
		_tmp0_ = g_error_new_literal (GEARY_JS_ERROR, GEARY_JS_ERROR_TYPE, "Value is not a JS String object");
#line 68 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
		_inner_error_ = _tmp0_;
#line 68 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
		if (_inner_error_->domain == GEARY_JS_ERROR) {
#line 68 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
			g_propagate_error (error, _inner_error_);
#line 68 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
			return NULL;
#line 333 "util-js.c"
		} else {
#line 68 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 68 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
			g_clear_error (&_inner_error_);
#line 68 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
			return NULL;
#line 341 "util-js.c"
		}
	}
#line 71 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
	err = NULL;
#line 72 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
	_tmp2_ = JSValueToStringCopy (context, value, &_tmp1_);
#line 72 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
	_g_free0 (err);
#line 72 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
	_tmp3_ = _tmp1_;
#line 72 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
	_tmp4_ = __JS_value_dup0 (&_tmp3_);
#line 72 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
	err = _tmp4_;
#line 72 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
	js_str = _tmp2_;
#line 73 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
	_tmp5_ = err;
#line 73 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
	geary_js_check_exception (context, _tmp5_, &_inner_error_);
#line 73 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 73 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
		if (_inner_error_->domain == GEARY_JS_ERROR) {
#line 73 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
			g_propagate_error (error, _inner_error_);
#line 73 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
			_g_free0 (err);
#line 73 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
			return NULL;
#line 372 "util-js.c"
		} else {
#line 73 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
			_g_free0 (err);
#line 73 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 73 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
			g_clear_error (&_inner_error_);
#line 73 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
			return NULL;
#line 382 "util-js.c"
		}
	}
#line 75 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
	_tmp6_ = geary_js_to_string_released (js_str);
#line 75 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
	result = _tmp6_;
#line 75 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
	_g_free0 (err);
#line 75 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
	return result;
#line 393 "util-js.c"
}


/**
     * Returns a JSC Value as an object.
     *
     * This will raise a {@link Geary.JS.Error.TYPE} error if the
     * value is not a JavaScript `Object`.
     *
     * Return type is nullable as a workaround for Bug 778046, it will
     * never actually be null.
     */
static JSObjectRef*
_JS_object_dup (JSObjectRef* self)
{
	JSObjectRef* dup;
#line 98 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
	dup = g_new0 (JSObjectRef, 1);
#line 98 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
	memcpy (dup, self, sizeof (JSObjectRef));
#line 98 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
	return dup;
#line 416 "util-js.c"
}


static gpointer
__JS_object_dup0 (gpointer self)
{
#line 98 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
	return self ? _JS_object_dup (self) : NULL;
#line 425 "util-js.c"
}


JSObjectRef*
geary_js_to_object (JSContextRef context,
                    JSValueRef value,
                    GError** error)
{
	JSObjectRef* result = NULL;
	JSValueRef* err = NULL;
	JSObjectRef js_obj = {0};
	JSValueRef _tmp1_ = {0};
	JSObjectRef _tmp2_;
	JSValueRef _tmp3_;
	JSValueRef* _tmp4_;
	JSValueRef* _tmp5_;
	JSObjectRef* _tmp6_;
	GError * _inner_error_ = NULL;
#line 90 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
	if (!JSValueIsObject (context, value)) {
#line 446 "util-js.c"
		GError* _tmp0_;
#line 91 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
		_tmp0_ = g_error_new_literal (GEARY_JS_ERROR, GEARY_JS_ERROR_TYPE, "Value is not a JS Object");
#line 91 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
		_inner_error_ = _tmp0_;
#line 91 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
		if (_inner_error_->domain == GEARY_JS_ERROR) {
#line 91 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
			g_propagate_error (error, _inner_error_);
#line 91 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
			return NULL;
#line 458 "util-js.c"
		} else {
#line 91 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 91 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
			g_clear_error (&_inner_error_);
#line 91 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
			return NULL;
#line 466 "util-js.c"
		}
	}
#line 94 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
	err = NULL;
#line 95 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
	_tmp2_ = JSValueToObject (context, value, &_tmp1_);
#line 95 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
	_g_free0 (err);
#line 95 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
	_tmp3_ = _tmp1_;
#line 95 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
	_tmp4_ = __JS_value_dup0 (&_tmp3_);
#line 95 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
	err = _tmp4_;
#line 95 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
	js_obj = _tmp2_;
#line 96 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
	_tmp5_ = err;
#line 96 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
	geary_js_check_exception (context, _tmp5_, &_inner_error_);
#line 96 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 96 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
		if (_inner_error_->domain == GEARY_JS_ERROR) {
#line 96 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
			g_propagate_error (error, _inner_error_);
#line 96 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
			_g_free0 (err);
#line 96 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
			return NULL;
#line 497 "util-js.c"
		} else {
#line 96 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
			_g_free0 (err);
#line 96 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 96 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
			g_clear_error (&_inner_error_);
#line 96 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
			return NULL;
#line 507 "util-js.c"
		}
	}
#line 98 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
	_tmp6_ = __JS_object_dup0 (&js_obj);
#line 98 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
	result = _tmp6_;
#line 98 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
	_g_free0 (err);
#line 98 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
	return result;
#line 518 "util-js.c"
}


/**
     * Returns a JSC {@link JS.String} as a Vala {@link string}.
     */
inline gchar*
geary_js_to_string_released (JSStringRef js)
{
	gchar* result = NULL;
	gint len = 0;
	gchar* str = NULL;
	gchar* _tmp0_;
#line 105 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
	len = JSStringGetMaximumUTF8CStringSize (js);
#line 106 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
	_tmp0_ = g_strnfill ((gsize) len, (gchar) 0);
#line 106 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
	str = _tmp0_;
#line 107 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
	JSStringGetUTF8CString (js, str, len);
#line 108 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
	JSStringRelease (js);
#line 109 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
	result = str;
#line 109 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
	return result;
#line 546 "util-js.c"
}


/**
     * Returns the value of an object's property.
     *
     * This will raise a {@link Geary.JS.Error.TYPE} error if the
     * object does not contain the named property.
     *
     * Return type is nullable as a workaround for Bug 778046, it will
     * never actually be null.
     */
inline JSValueRef*
geary_js_get_property (JSContextRef context,
                       JSObjectRef object,
                       const gchar* name,
                       GError** error)
{
	JSValueRef* result = NULL;
	JSStringRef js_name = {0};
	JSStringRef _tmp0_;
	JSValueRef* err = NULL;
	JSValueRef prop = {0};
	JSStringRef _tmp1_;
	JSValueRef* _tmp2_ = NULL;
	JSValueRef _tmp3_;
	JSValueRef* _tmp5_;
	GError * _inner_error_ = NULL;
#line 121 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 125 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
	_tmp0_ = JSStringCreateWithUTF8CString (name);
#line 125 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
	js_name = _tmp0_;
#line 126 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
	err = NULL;
#line 127 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
	_tmp1_ = js_name;
#line 127 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
	_tmp3_ = JSObjectGetProperty (context, object, _tmp1_, &_tmp2_);
#line 127 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
	_g_free0 (err);
#line 127 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
	err = _tmp2_;
#line 127 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
	prop = _tmp3_;
#line 593 "util-js.c"
	{
		JSValueRef* _tmp4_;
#line 129 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
		_tmp4_ = err;
#line 129 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
		geary_js_check_exception (context, _tmp4_, &_inner_error_);
#line 129 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 602 "util-js.c"
			goto __finally319;
		}
	}
	__finally319:
	{
#line 131 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
		JSStringRelease (js_name);
#line 610 "util-js.c"
	}
#line 128 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 128 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
		if (_inner_error_->domain == GEARY_JS_ERROR) {
#line 128 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
			g_propagate_error (error, _inner_error_);
#line 128 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
			_g_free0 (err);
#line 128 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
			return NULL;
#line 622 "util-js.c"
		} else {
#line 128 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
			_g_free0 (err);
#line 128 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 128 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
			g_clear_error (&_inner_error_);
#line 128 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
			return NULL;
#line 632 "util-js.c"
		}
	}
#line 133 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
	_tmp5_ = __JS_value_dup0 (&prop);
#line 133 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
	result = _tmp5_;
#line 133 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
	_g_free0 (err);
#line 133 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
	return result;
#line 643 "util-js.c"
}


/**
     * Checks an JS exception returned from a JSC call.
     *
     * This method will raise a {@link Geary.JS.Error} if the given
     * `err_value` is not null (in a Vala or JS sense).
     */
static const char*
_JS_type_to_string (JSType value)
{
#line 152 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
	switch (value) {
#line 152 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
		case kJSTypeUndefined:
#line 152 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
		return "kJSTypeUndefined";
#line 152 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
		case kJSTypeNull:
#line 152 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
		return "kJSTypeNull";
#line 152 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
		case kJSTypeBoolean:
#line 152 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
		return "kJSTypeBoolean";
#line 152 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
		case kJSTypeNumber:
#line 152 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
		return "kJSTypeNumber";
#line 152 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
		case kJSTypeString:
#line 152 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
		return "kJSTypeString";
#line 152 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
		case kJSTypeObject:
#line 152 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
		return "kJSTypeObject";
#line 682 "util-js.c"
	}
#line 152 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
	return NULL;
#line 686 "util-js.c"
}


inline void
geary_js_check_exception (JSContextRef context,
                          JSValueRef* err_value,
                          GError** error)
{
	GError * _inner_error_ = NULL;
#line 145 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
	if (!geary_js_is_null (context, err_value)) {
#line 698 "util-js.c"
		JSValueRef* nested_err = NULL;
		JSType err_type = 0;
		JSStringRef err_str = {0};
		JSValueRef _tmp0_ = {0};
		JSStringRef _tmp1_;
		JSValueRef _tmp2_;
		JSValueRef* _tmp3_;
		JSValueRef* _tmp4_;
		JSType _tmp8_;
		const gchar* _tmp9_;
		JSStringRef _tmp10_;
		gchar* _tmp11_;
		gchar* _tmp12_;
		gchar* _tmp13_;
		gchar* _tmp14_;
		GError* _tmp15_;
		GError* _tmp16_;
#line 146 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
		nested_err = NULL;
#line 147 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
		err_type = JSValueGetType (context, *err_value);
#line 148 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
		_tmp1_ = JSValueToStringCopy (context, *err_value, &_tmp0_);
#line 148 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
		_g_free0 (nested_err);
#line 148 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
		_tmp2_ = _tmp0_;
#line 148 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
		_tmp3_ = __JS_value_dup0 (&_tmp2_);
#line 148 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
		nested_err = _tmp3_;
#line 148 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
		err_str = _tmp1_;
#line 151 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
		_tmp4_ = nested_err;
#line 151 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
		if (!geary_js_is_null (context, _tmp4_)) {
#line 736 "util-js.c"
			JSType _tmp5_;
			const gchar* _tmp6_;
			GError* _tmp7_;
#line 152 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
			_tmp5_ = err_type;
#line 152 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
			_tmp6_ = _JS_type_to_string (_tmp5_);
#line 152 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
			_tmp7_ = g_error_new (GEARY_JS_ERROR, GEARY_JS_ERROR_EXCEPTION, "Nested exception getting exception %s as a string", _tmp6_);
#line 152 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
			_inner_error_ = _tmp7_;
#line 152 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
			if (_inner_error_->domain == GEARY_JS_ERROR) {
#line 152 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
				g_propagate_error (error, _inner_error_);
#line 152 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
				_g_free0 (nested_err);
#line 152 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
				return;
#line 756 "util-js.c"
			} else {
#line 152 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
				_g_free0 (nested_err);
#line 152 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 152 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
				g_clear_error (&_inner_error_);
#line 152 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
				return;
#line 766 "util-js.c"
			}
		}
#line 158 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
		_tmp8_ = err_type;
#line 158 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
		_tmp9_ = _JS_type_to_string (_tmp8_);
#line 158 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
		_tmp10_ = err_str;
#line 158 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
		_tmp11_ = geary_js_to_string_released (_tmp10_);
#line 158 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
		_tmp12_ = _tmp11_;
#line 158 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
		_tmp13_ = g_strdup_printf ("JS exception thrown [%s]: %s", _tmp9_, _tmp12_);
#line 158 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
		_tmp14_ = _tmp13_;
#line 158 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
		_tmp15_ = g_error_new_literal (GEARY_JS_ERROR, GEARY_JS_ERROR_EXCEPTION, _tmp14_);
#line 158 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
		_tmp16_ = _tmp15_;
#line 158 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
		_g_free0 (_tmp14_);
#line 158 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
		_g_free0 (_tmp12_);
#line 158 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
		_inner_error_ = _tmp16_;
#line 158 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
		if (_inner_error_->domain == GEARY_JS_ERROR) {
#line 158 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
			g_propagate_error (error, _inner_error_);
#line 158 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
			_g_free0 (nested_err);
#line 158 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
			return;
#line 801 "util-js.c"
		} else {
#line 158 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
			_g_free0 (nested_err);
#line 158 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 158 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
			g_clear_error (&_inner_error_);
#line 158 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
			return;
#line 811 "util-js.c"
		}
#line 145 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
		_g_free0 (nested_err);
#line 815 "util-js.c"
	}
}


/**
     * Escapes a string so as to be safe to use as a JS string literal.
     *
     * This does not append opening or closing quotes.
     */
static gboolean
string_valid_char (const gchar* self,
                   gint index)
{
	gboolean result = FALSE;
	guint8 c = 0U;
	guint8 _tmp0_;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	guint8 _tmp3_;
#line 1130 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1131 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_tmp0_ = ((guint8*) self)[index];
#line 1131 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	c = _tmp0_;
#line 1132 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_tmp3_ = c;
#line 1132 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	if (((gint) _tmp3_) == 0x00) {
#line 1132 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp2_ = TRUE;
#line 847 "util-js.c"
	} else {
		gboolean _tmp4_ = FALSE;
		guint8 _tmp5_;
#line 1132 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp5_ = c;
#line 1132 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		if (((gint) _tmp5_) >= 0x80) {
#line 855 "util-js.c"
			guint8 _tmp6_;
#line 1132 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
			_tmp6_ = c;
#line 1132 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
			_tmp4_ = ((gint) _tmp6_) < 0xc2;
#line 861 "util-js.c"
		} else {
#line 1132 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
			_tmp4_ = FALSE;
#line 865 "util-js.c"
		}
#line 1132 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp2_ = _tmp4_;
#line 869 "util-js.c"
	}
#line 1132 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	if (_tmp2_) {
#line 1132 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp1_ = TRUE;
#line 875 "util-js.c"
	} else {
		guint8 _tmp7_;
#line 1132 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp7_ = c;
#line 1132 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp1_ = ((gint) _tmp7_) >= 0xf5;
#line 882 "util-js.c"
	}
#line 1132 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	if (_tmp1_) {
#line 1133 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		result = FALSE;
#line 1133 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		return result;
#line 890 "util-js.c"
	} else {
#line 1135 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		result = TRUE;
#line 1135 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		return result;
#line 896 "util-js.c"
	}
}


static gunichar
string_get_char (const gchar* self,
                 glong index)
{
	gunichar result = 0U;
#line 1154 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, 0U);
#line 1155 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	result = g_utf8_get_char (((gchar*) self) + index);
#line 1155 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	return result;
#line 912 "util-js.c"
}


static guint8*
g_string_get_data (GString* self,
                   int* result_length1)
{
	guint8* result;
	guint8* res = NULL;
	const gchar* _tmp0_;
	gint res_length1;
	gint _res_size_;
	gssize _tmp1_;
	gint _tmp2_;
	guint8* _tmp3_;
	gint _tmp3__length1;
	guint8* _tmp4_;
	gint _tmp4__length1;
#line 4899 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 4900 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_tmp0_ = self->str;
#line 4900 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	res = (guint8*) _tmp0_;
#line 4900 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	res_length1 = -1;
#line 4900 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_res_size_ = res_length1;
#line 4901 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_tmp1_ = self->len;
#line 4901 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	res_length1 = (gint) _tmp1_;
#line 4901 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_tmp2_ = res_length1;
#line 4902 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_tmp3_ = res;
#line 4902 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_tmp3__length1 = res_length1;
#line 4902 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_tmp4_ = _tmp3_;
#line 4902 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_tmp4__length1 = _tmp3__length1;
#line 4902 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	if (result_length1) {
#line 4902 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		*result_length1 = _tmp4__length1;
#line 959 "util-js.c"
	}
#line 4902 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	result = _tmp4_;
#line 4902 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	return result;
#line 965 "util-js.c"
}


gchar*
geary_js_escape_string (const gchar* value)
{
	gchar* result = NULL;
	GString* builder = NULL;
	gint _tmp0_;
	gint _tmp1_;
	GString* _tmp2_;
	GString* _tmp23_;
	guint8* _tmp24_;
	gint _tmp24__length1;
	guint8* _tmp25_;
	gint _tmp25__length1;
	gchar* _tmp26_;
#line 170 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
	g_return_val_if_fail (value != NULL, NULL);
#line 171 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
	_tmp0_ = strlen (value);
#line 171 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
	_tmp1_ = _tmp0_;
#line 171 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
	_tmp2_ = g_string_sized_new ((gsize) _tmp1_);
#line 171 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
	builder = _tmp2_;
#line 993 "util-js.c"
	{
		gint i = 0;
#line 172 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
		i = 0;
#line 998 "util-js.c"
		{
			gboolean _tmp3_ = FALSE;
#line 172 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
			_tmp3_ = TRUE;
#line 172 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
			while (TRUE) {
#line 1005 "util-js.c"
				gint _tmp5_;
				gint _tmp6_;
				gint _tmp7_;
				gint _tmp8_;
#line 172 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
				if (!_tmp3_) {
#line 1012 "util-js.c"
					gint _tmp4_;
#line 172 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
					_tmp4_ = i;
#line 172 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
					i = _tmp4_ + 1;
#line 1018 "util-js.c"
				}
#line 172 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
				_tmp3_ = FALSE;
#line 172 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
				_tmp5_ = i;
#line 172 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
				_tmp6_ = strlen (value);
#line 172 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
				_tmp7_ = _tmp6_;
#line 172 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
				if (!(_tmp5_ < _tmp7_)) {
#line 172 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
					break;
#line 1032 "util-js.c"
				}
#line 173 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
				_tmp8_ = i;
#line 173 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
				if (string_valid_char (value, _tmp8_)) {
#line 1038 "util-js.c"
					gunichar c = 0U;
					gint _tmp9_;
					gunichar _tmp10_;
#line 174 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
					_tmp9_ = i;
#line 174 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
					c = string_get_char (value, (glong) _tmp9_);
#line 175 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
					_tmp10_ = c;
#line 175 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
					switch (_tmp10_) {
#line 175 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
						case '\x00':
#line 1052 "util-js.c"
						{
							GString* _tmp11_;
#line 177 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
							_tmp11_ = builder;
#line 177 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
							g_string_append (_tmp11_, "\x00");
#line 178 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
							break;
#line 1061 "util-js.c"
						}
#line 175 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
						case '\'':
#line 1065 "util-js.c"
						{
							GString* _tmp12_;
#line 180 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
							_tmp12_ = builder;
#line 180 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
							g_string_append (_tmp12_, "\\'");
#line 181 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
							break;
#line 1074 "util-js.c"
						}
#line 175 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
						case '"':
#line 1078 "util-js.c"
						{
							GString* _tmp13_;
#line 183 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
							_tmp13_ = builder;
#line 183 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
							g_string_append (_tmp13_, "\\\"");
#line 184 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
							break;
#line 1087 "util-js.c"
						}
#line 175 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
						case '\\':
#line 1091 "util-js.c"
						{
							GString* _tmp14_;
#line 186 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
							_tmp14_ = builder;
#line 186 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
							g_string_append (_tmp14_, "\\\\");
#line 187 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
							break;
#line 1100 "util-js.c"
						}
#line 175 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
						case '\n':
#line 1104 "util-js.c"
						{
							GString* _tmp15_;
#line 189 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
							_tmp15_ = builder;
#line 189 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
							g_string_append (_tmp15_, "\\n");
#line 190 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
							break;
#line 1113 "util-js.c"
						}
#line 175 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
						case '\r':
#line 1117 "util-js.c"
						{
							GString* _tmp16_;
#line 192 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
							_tmp16_ = builder;
#line 192 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
							g_string_append (_tmp16_, "\\r");
#line 193 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
							break;
#line 1126 "util-js.c"
						}
#line 175 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
						case '\x0b':
#line 1130 "util-js.c"
						{
							GString* _tmp17_;
#line 195 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
							_tmp17_ = builder;
#line 195 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
							g_string_append (_tmp17_, "\x0b");
#line 196 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
							break;
#line 1139 "util-js.c"
						}
#line 175 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
						case '\t':
#line 1143 "util-js.c"
						{
							GString* _tmp18_;
#line 198 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
							_tmp18_ = builder;
#line 198 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
							g_string_append (_tmp18_, "\\t");
#line 199 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
							break;
#line 1152 "util-js.c"
						}
#line 175 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
						case '\b':
#line 1156 "util-js.c"
						{
							GString* _tmp19_;
#line 201 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
							_tmp19_ = builder;
#line 201 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
							g_string_append (_tmp19_, "\\b");
#line 202 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
							break;
#line 1165 "util-js.c"
						}
#line 175 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
						case '\f':
#line 1169 "util-js.c"
						{
							GString* _tmp20_;
#line 204 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
							_tmp20_ = builder;
#line 204 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
							g_string_append (_tmp20_, "\\f");
#line 205 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
							break;
#line 1178 "util-js.c"
						}
						default:
						{
							GString* _tmp21_;
							gunichar _tmp22_;
#line 207 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
							_tmp21_ = builder;
#line 207 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
							_tmp22_ = c;
#line 207 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
							g_string_append_unichar (_tmp21_, _tmp22_);
#line 208 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
							break;
#line 1192 "util-js.c"
						}
					}
				}
			}
		}
	}
#line 212 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
	_tmp23_ = builder;
#line 212 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
	_tmp24_ = g_string_get_data (_tmp23_, &_tmp24__length1);
#line 212 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
	_tmp25_ = _tmp24_;
#line 212 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
	_tmp25__length1 = _tmp24__length1;
#line 212 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
	_tmp26_ = g_strdup ((const gchar*) _tmp25_);
#line 212 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
	result = _tmp26_;
#line 212 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
	_g_string_free0 (builder);
#line 212 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
	return result;
#line 1215 "util-js.c"
}


/**
     * Convenience method for returning a new Callable instance.
     */
GearyJSCallable*
geary_js_callable (const gchar* base_name)
{
	GearyJSCallable* result = NULL;
	GearyJSCallable* _tmp0_;
#line 218 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
	g_return_val_if_fail (base_name != NULL, NULL);
#line 219 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
	_tmp0_ = geary_js_callable_new (base_name);
#line 219 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
	result = _tmp0_;
#line 219 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
	return result;
#line 1235 "util-js.c"
}


GearyJSCallable*
geary_js_callable_construct (GType object_type,
                             const gchar* base_name)
{
	GearyJSCallable* self = NULL;
	gchar* _tmp0_;
#line 231 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
	g_return_val_if_fail (base_name != NULL, NULL);
#line 231 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
	self = (GearyJSCallable*) g_type_create_instance (object_type);
#line 232 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
	_tmp0_ = g_strdup (base_name);
#line 232 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
	_g_free0 (self->priv->base_name);
#line 232 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
	self->priv->base_name = _tmp0_;
#line 231 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
	return self;
#line 1257 "util-js.c"
}


GearyJSCallable*
geary_js_callable_new (const gchar* base_name)
{
#line 231 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
	return geary_js_callable_construct (GEARY_JS_TYPE_CALLABLE, base_name);
#line 1266 "util-js.c"
}


static gchar*
_vala_g_strjoinv (const gchar* separator,
                  gchar** str_array,
                  int str_array_length1)
{
	gchar* result = NULL;
	gboolean _tmp0_ = FALSE;
#line 1092 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	if (separator == NULL) {
#line 1093 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		separator = "";
#line 1281 "util-js.c"
	}
#line 1095 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	if (str_array != NULL) {
#line 1285 "util-js.c"
		gboolean _tmp1_ = FALSE;
#line 1095 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		if (str_array_length1 > 0) {
#line 1095 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
			_tmp1_ = TRUE;
#line 1291 "util-js.c"
		} else {
			gboolean _tmp2_ = FALSE;
#line 1095 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
			if (str_array_length1 == -1) {
#line 1296 "util-js.c"
				const gchar* _tmp3_;
#line 1095 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
				_tmp3_ = str_array[0];
#line 1095 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
				_tmp2_ = _tmp3_ != NULL;
#line 1302 "util-js.c"
			} else {
#line 1095 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
				_tmp2_ = FALSE;
#line 1306 "util-js.c"
			}
#line 1095 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
			_tmp1_ = _tmp2_;
#line 1310 "util-js.c"
		}
#line 1095 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp0_ = _tmp1_;
#line 1314 "util-js.c"
	} else {
#line 1095 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 1318 "util-js.c"
	}
#line 1095 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	if (_tmp0_) {
#line 1322 "util-js.c"
		gint i = 0;
		gsize len = 0UL;
		gint _tmp20_;
		gint _tmp22_;
		gint _tmp23_;
		gsize _tmp24_;
		gint _tmp25_;
		gint _tmp26_;
		gint _tmp27_;
		const gchar* res = NULL;
		gsize _tmp28_;
		void* _tmp29_;
		void* ptr = NULL;
		const gchar* _tmp30_;
		const gchar* _tmp31_;
		void* _tmp32_;
		const gchar* _tmp45_;
#line 1097 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		len = (gsize) 1;
#line 1342 "util-js.c"
		{
			gboolean _tmp4_ = FALSE;
#line 1098 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
			i = 0;
#line 1098 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
			_tmp4_ = TRUE;
#line 1098 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
			while (TRUE) {
#line 1351 "util-js.c"
				gboolean _tmp6_ = FALSE;
				gboolean _tmp7_ = FALSE;
				gint _tmp12_ = 0;
				gint _tmp13_;
				const gchar* _tmp14_;
				gsize _tmp19_;
#line 1098 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
				if (!_tmp4_) {
#line 1360 "util-js.c"
					gint _tmp5_;
#line 1098 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
					_tmp5_ = i;
#line 1098 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
					i = _tmp5_ + 1;
#line 1366 "util-js.c"
				}
#line 1098 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
				_tmp4_ = FALSE;
#line 1098 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
				if (str_array_length1 != -1) {
#line 1372 "util-js.c"
					gint _tmp8_;
#line 1098 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
					_tmp8_ = i;
#line 1098 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
					_tmp7_ = _tmp8_ < str_array_length1;
#line 1378 "util-js.c"
				} else {
#line 1098 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
					_tmp7_ = FALSE;
#line 1382 "util-js.c"
				}
#line 1098 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
				if (_tmp7_) {
#line 1098 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
					_tmp6_ = TRUE;
#line 1388 "util-js.c"
				} else {
					gboolean _tmp9_ = FALSE;
#line 1098 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
					if (str_array_length1 == -1) {
#line 1393 "util-js.c"
						gint _tmp10_;
						const gchar* _tmp11_;
#line 1098 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
						_tmp10_ = i;
#line 1098 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
						_tmp11_ = str_array[_tmp10_];
#line 1098 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
						_tmp9_ = _tmp11_ != NULL;
#line 1402 "util-js.c"
					} else {
#line 1098 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
						_tmp9_ = FALSE;
#line 1406 "util-js.c"
					}
#line 1098 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
					_tmp6_ = _tmp9_;
#line 1410 "util-js.c"
				}
#line 1098 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
				if (!_tmp6_) {
#line 1098 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
					break;
#line 1416 "util-js.c"
				}
#line 1099 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
				_tmp13_ = i;
#line 1099 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
				_tmp14_ = str_array[_tmp13_];
#line 1099 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
				if (_tmp14_ != NULL) {
#line 1424 "util-js.c"
					gint _tmp15_;
					const gchar* _tmp16_;
					gint _tmp17_;
					gint _tmp18_;
#line 1099 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
					_tmp15_ = i;
#line 1099 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
					_tmp16_ = str_array[_tmp15_];
#line 1099 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
					_tmp17_ = strlen ((const gchar*) _tmp16_);
#line 1099 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
					_tmp18_ = _tmp17_;
#line 1099 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
					_tmp12_ = _tmp18_;
#line 1439 "util-js.c"
				} else {
#line 1099 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
					_tmp12_ = 0;
#line 1443 "util-js.c"
				}
#line 1099 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
				_tmp19_ = len;
#line 1099 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
				len = _tmp19_ + _tmp12_;
#line 1449 "util-js.c"
			}
		}
#line 1101 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp20_ = i;
#line 1101 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		if (_tmp20_ == 0) {
#line 1456 "util-js.c"
			gchar* _tmp21_;
#line 1102 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
			_tmp21_ = g_strdup ("");
#line 1102 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
			result = _tmp21_;
#line 1102 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
			return result;
#line 1464 "util-js.c"
		}
#line 1104 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp22_ = i;
#line 1104 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		str_array_length1 = _tmp22_;
#line 1104 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp23_ = str_array_length1;
#line 1105 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp24_ = len;
#line 1105 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp25_ = strlen ((const gchar*) separator);
#line 1105 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp26_ = _tmp25_;
#line 1105 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp27_ = i;
#line 1105 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		len = _tmp24_ + (_tmp26_ * (_tmp27_ - 1));
#line 1107 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp28_ = len;
#line 1107 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp29_ = g_malloc (_tmp28_);
#line 1107 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		res = _tmp29_;
#line 1108 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp30_ = res;
#line 1108 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp31_ = str_array[0];
#line 1108 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp32_ = g_stpcpy ((void*) _tmp30_, (const gchar*) _tmp31_);
#line 1108 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		ptr = _tmp32_;
#line 1496 "util-js.c"
		{
			gboolean _tmp33_ = FALSE;
#line 1109 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
			i = 1;
#line 1109 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
			_tmp33_ = TRUE;
#line 1109 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
			while (TRUE) {
#line 1505 "util-js.c"
				gint _tmp35_;
				void* _tmp36_;
				void* _tmp37_;
				const gchar* _tmp38_ = NULL;
				gint _tmp39_;
				const gchar* _tmp40_;
				void* _tmp43_;
				void* _tmp44_;
#line 1109 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
				if (!_tmp33_) {
#line 1516 "util-js.c"
					gint _tmp34_;
#line 1109 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
					_tmp34_ = i;
#line 1109 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
					i = _tmp34_ + 1;
#line 1522 "util-js.c"
				}
#line 1109 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
				_tmp33_ = FALSE;
#line 1109 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
				_tmp35_ = i;
#line 1109 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
				if (!(_tmp35_ < str_array_length1)) {
#line 1109 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
					break;
#line 1532 "util-js.c"
				}
#line 1110 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
				_tmp36_ = ptr;
#line 1110 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
				_tmp37_ = g_stpcpy (_tmp36_, (const gchar*) separator);
#line 1110 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
				ptr = _tmp37_;
#line 1111 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
				_tmp39_ = i;
#line 1111 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
				_tmp40_ = str_array[_tmp39_];
#line 1111 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
				if (_tmp40_ != NULL) {
#line 1546 "util-js.c"
					gint _tmp41_;
					const gchar* _tmp42_;
#line 1111 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
					_tmp41_ = i;
#line 1111 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
					_tmp42_ = str_array[_tmp41_];
#line 1111 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
					_tmp38_ = (const gchar*) _tmp42_;
#line 1555 "util-js.c"
				} else {
#line 1111 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
					_tmp38_ = "";
#line 1559 "util-js.c"
				}
#line 1111 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
				_tmp43_ = ptr;
#line 1111 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
				_tmp44_ = g_stpcpy (_tmp43_, _tmp38_);
#line 1111 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
				ptr = _tmp44_;
#line 1567 "util-js.c"
			}
		}
#line 1114 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp45_ = res;
#line 1114 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		res = NULL;
#line 1114 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		result = (gchar*) _tmp45_;
#line 1114 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		return result;
#line 1578 "util-js.c"
	} else {
		gchar* _tmp46_;
#line 1116 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp46_ = g_strdup ("");
#line 1116 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		result = _tmp46_;
#line 1116 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		return result;
#line 1587 "util-js.c"
	}
}


gchar*
geary_js_callable_to_string (GearyJSCallable* self)
{
	gchar* result = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar** _tmp3_;
	gint _tmp3__length1;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
#line 235 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
	g_return_val_if_fail (GEARY_JS_IS_CALLABLE (self), NULL);
#line 236 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
	_tmp0_ = self->priv->base_name;
#line 236 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
	_tmp1_ = g_strconcat (_tmp0_, "(", NULL);
#line 236 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
	_tmp2_ = _tmp1_;
#line 236 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
	_tmp3_ = self->priv->safe_args;
#line 236 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
	_tmp3__length1 = self->priv->safe_args_length1;
#line 236 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
	_tmp4_ = _vala_g_strjoinv (",", _tmp3_, _tmp3__length1);
#line 236 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
	_tmp5_ = _tmp4_;
#line 236 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
	_tmp6_ = g_strconcat (_tmp2_, _tmp5_, NULL);
#line 236 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
	_tmp7_ = _tmp6_;
#line 236 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
	_tmp8_ = g_strconcat (_tmp7_, ");", NULL);
#line 236 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
	_tmp9_ = _tmp8_;
#line 236 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
	_g_free0 (_tmp7_);
#line 236 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
	_g_free0 (_tmp5_);
#line 236 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
	_g_free0 (_tmp2_);
#line 236 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
	result = _tmp9_;
#line 236 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
	return result;
#line 1641 "util-js.c"
}


static gpointer
_geary_js_callable_ref0 (gpointer self)
{
#line 241 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
	return self ? geary_js_callable_ref (self) : NULL;
#line 1650 "util-js.c"
}


GearyJSCallable*
geary_js_callable_string (GearyJSCallable* self,
                          const gchar* value)
{
	GearyJSCallable* result = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	GearyJSCallable* _tmp6_;
#line 239 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
	g_return_val_if_fail (GEARY_JS_IS_CALLABLE (self), NULL);
#line 239 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
	g_return_val_if_fail (value != NULL, NULL);
#line 240 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
	_tmp0_ = geary_js_escape_string (value);
#line 240 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
	_tmp1_ = _tmp0_;
#line 240 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
	_tmp2_ = g_strconcat ("\"", _tmp1_, NULL);
#line 240 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
	_tmp3_ = _tmp2_;
#line 240 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
	_tmp4_ = g_strconcat (_tmp3_, "\"", NULL);
#line 240 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
	_tmp5_ = _tmp4_;
#line 240 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
	geary_js_callable_add_param (self, _tmp5_);
#line 240 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
	_g_free0 (_tmp5_);
#line 240 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
	_g_free0 (_tmp3_);
#line 240 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
	_g_free0 (_tmp1_);
#line 241 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
	_tmp6_ = _geary_js_callable_ref0 (self);
#line 241 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
	result = _tmp6_;
#line 241 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
	return result;
#line 1696 "util-js.c"
}


static gchar*
double_to_string (gdouble self)
{
	gchar* result = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gint _tmp1__length1;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
#line 883 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_tmp0_ = g_new0 (gchar, G_ASCII_DTOSTR_BUF_SIZE);
#line 883 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_tmp1_ = _tmp0_;
#line 883 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_tmp1__length1 = G_ASCII_DTOSTR_BUF_SIZE;
#line 883 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_tmp2_ = g_ascii_dtostr (_tmp1_, G_ASCII_DTOSTR_BUF_SIZE, self);
#line 883 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_tmp3_ = g_strdup (_tmp2_);
#line 883 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_tmp4_ = _tmp3_;
#line 883 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_tmp1_ = (g_free (_tmp1_), NULL);
#line 883 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	result = _tmp4_;
#line 883 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	return result;
#line 1728 "util-js.c"
}


GearyJSCallable*
geary_js_callable_double (GearyJSCallable* self,
                          gdouble value)
{
	GearyJSCallable* result = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	GearyJSCallable* _tmp2_;
#line 244 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
	g_return_val_if_fail (GEARY_JS_IS_CALLABLE (self), NULL);
#line 245 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
	_tmp0_ = double_to_string (value);
#line 245 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
	_tmp1_ = _tmp0_;
#line 245 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
	geary_js_callable_add_param (self, _tmp1_);
#line 245 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
	_g_free0 (_tmp1_);
#line 246 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
	_tmp2_ = _geary_js_callable_ref0 (self);
#line 246 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
	result = _tmp2_;
#line 246 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
	return result;
#line 1756 "util-js.c"
}


GearyJSCallable*
geary_js_callable_int (GearyJSCallable* self,
                       gint value)
{
	GearyJSCallable* result = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	GearyJSCallable* _tmp2_;
#line 249 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
	g_return_val_if_fail (GEARY_JS_IS_CALLABLE (self), NULL);
#line 250 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
	_tmp0_ = g_strdup_printf ("%i", value);
#line 250 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
	_tmp1_ = _tmp0_;
#line 250 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
	geary_js_callable_add_param (self, _tmp1_);
#line 250 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
	_g_free0 (_tmp1_);
#line 251 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
	_tmp2_ = _geary_js_callable_ref0 (self);
#line 251 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
	result = _tmp2_;
#line 251 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
	return result;
#line 1784 "util-js.c"
}


GearyJSCallable*
geary_js_callable_bool (GearyJSCallable* self,
                        gboolean value)
{
	GearyJSCallable* result = NULL;
	const gchar* _tmp0_ = NULL;
	GearyJSCallable* _tmp1_;
#line 254 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
	g_return_val_if_fail (GEARY_JS_IS_CALLABLE (self), NULL);
#line 255 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
	if (value) {
#line 255 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
		_tmp0_ = "true";
#line 1801 "util-js.c"
	} else {
#line 255 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
		_tmp0_ = "false";
#line 1805 "util-js.c"
	}
#line 255 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
	geary_js_callable_add_param (self, _tmp0_);
#line 256 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
	_tmp1_ = _geary_js_callable_ref0 (self);
#line 256 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
	result = _tmp1_;
#line 256 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
	return result;
#line 1815 "util-js.c"
}


static void
_vala_array_add23 (gchar** * array,
                   int* length,
                   int* size,
                   gchar* value)
{
#line 260 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
	if ((*length) == (*size)) {
#line 260 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 260 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 1831 "util-js.c"
	}
#line 260 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
	(*array)[(*length)++] = value;
#line 260 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
	(*array)[*length] = NULL;
#line 1837 "util-js.c"
}


static inline void
geary_js_callable_add_param (GearyJSCallable* self,
                             const gchar* value)
{
	gchar** _tmp0_;
	gint _tmp0__length1;
	gchar* _tmp1_;
#line 259 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
	g_return_if_fail (GEARY_JS_IS_CALLABLE (self));
#line 259 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
	g_return_if_fail (value != NULL);
#line 260 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
	_tmp0_ = self->priv->safe_args;
#line 260 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
	_tmp0__length1 = self->priv->safe_args_length1;
#line 260 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
	_tmp1_ = g_strdup (value);
#line 260 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
	_vala_array_add23 (&self->priv->safe_args, &self->priv->safe_args_length1, &self->priv->_safe_args_size_, _tmp1_);
#line 1860 "util-js.c"
}


static void
geary_js_value_callable_init (GValue* value)
{
#line 225 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
	value->data[0].v_pointer = NULL;
#line 1869 "util-js.c"
}


static void
geary_js_value_callable_free_value (GValue* value)
{
#line 225 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
	if (value->data[0].v_pointer) {
#line 225 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
		geary_js_callable_unref (value->data[0].v_pointer);
#line 1880 "util-js.c"
	}
}


static void
geary_js_value_callable_copy_value (const GValue* src_value,
                                    GValue* dest_value)
{
#line 225 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
	if (src_value->data[0].v_pointer) {
#line 225 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
		dest_value->data[0].v_pointer = geary_js_callable_ref (src_value->data[0].v_pointer);
#line 1893 "util-js.c"
	} else {
#line 225 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
		dest_value->data[0].v_pointer = NULL;
#line 1897 "util-js.c"
	}
}


static gpointer
geary_js_value_callable_peek_pointer (const GValue* value)
{
#line 225 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
	return value->data[0].v_pointer;
#line 1907 "util-js.c"
}


static gchar*
geary_js_value_callable_collect_value (GValue* value,
                                       guint n_collect_values,
                                       GTypeCValue* collect_values,
                                       guint collect_flags)
{
#line 225 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
	if (collect_values[0].v_pointer) {
#line 1919 "util-js.c"
		GearyJSCallable * object;
		object = collect_values[0].v_pointer;
#line 225 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
		if (object->parent_instance.g_class == NULL) {
#line 225 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 1926 "util-js.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 225 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 1930 "util-js.c"
		}
#line 225 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
		value->data[0].v_pointer = geary_js_callable_ref (object);
#line 1934 "util-js.c"
	} else {
#line 225 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
		value->data[0].v_pointer = NULL;
#line 1938 "util-js.c"
	}
#line 225 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
	return NULL;
#line 1942 "util-js.c"
}


static gchar*
geary_js_value_callable_lcopy_value (const GValue* value,
                                     guint n_collect_values,
                                     GTypeCValue* collect_values,
                                     guint collect_flags)
{
	GearyJSCallable ** object_p;
	object_p = collect_values[0].v_pointer;
#line 225 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
	if (!object_p) {
#line 225 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 1958 "util-js.c"
	}
#line 225 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
	if (!value->data[0].v_pointer) {
#line 225 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
		*object_p = NULL;
#line 1964 "util-js.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 225 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
		*object_p = value->data[0].v_pointer;
#line 1968 "util-js.c"
	} else {
#line 225 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
		*object_p = geary_js_callable_ref (value->data[0].v_pointer);
#line 1972 "util-js.c"
	}
#line 225 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
	return NULL;
#line 1976 "util-js.c"
}


GParamSpec*
geary_js_param_spec_callable (const gchar* name,
                              const gchar* nick,
                              const gchar* blurb,
                              GType object_type,
                              GParamFlags flags)
{
	GearyJSParamSpecCallable* spec;
#line 225 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
	g_return_val_if_fail (g_type_is_a (object_type, GEARY_JS_TYPE_CALLABLE), NULL);
#line 225 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 225 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 225 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
	return G_PARAM_SPEC (spec);
#line 1996 "util-js.c"
}


gpointer
geary_js_value_get_callable (const GValue* value)
{
#line 225 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, GEARY_JS_TYPE_CALLABLE), NULL);
#line 225 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
	return value->data[0].v_pointer;
#line 2007 "util-js.c"
}


void
geary_js_value_set_callable (GValue* value,
                             gpointer v_object)
{
	GearyJSCallable * old;
#line 225 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, GEARY_JS_TYPE_CALLABLE));
#line 225 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
	old = value->data[0].v_pointer;
#line 225 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
	if (v_object) {
#line 225 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, GEARY_JS_TYPE_CALLABLE));
#line 225 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 225 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
		value->data[0].v_pointer = v_object;
#line 225 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
		geary_js_callable_ref (value->data[0].v_pointer);
#line 2030 "util-js.c"
	} else {
#line 225 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
		value->data[0].v_pointer = NULL;
#line 2034 "util-js.c"
	}
#line 225 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
	if (old) {
#line 225 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
		geary_js_callable_unref (old);
#line 2040 "util-js.c"
	}
}


void
geary_js_value_take_callable (GValue* value,
                              gpointer v_object)
{
	GearyJSCallable * old;
#line 225 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, GEARY_JS_TYPE_CALLABLE));
#line 225 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
	old = value->data[0].v_pointer;
#line 225 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
	if (v_object) {
#line 225 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, GEARY_JS_TYPE_CALLABLE));
#line 225 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 225 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
		value->data[0].v_pointer = v_object;
#line 2062 "util-js.c"
	} else {
#line 225 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
		value->data[0].v_pointer = NULL;
#line 2066 "util-js.c"
	}
#line 225 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
	if (old) {
#line 225 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
		geary_js_callable_unref (old);
#line 2072 "util-js.c"
	}
}


static void
geary_js_callable_class_init (GearyJSCallableClass * klass)
{
#line 225 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
	geary_js_callable_parent_class = g_type_class_peek_parent (klass);
#line 225 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
	((GearyJSCallableClass *) klass)->finalize = geary_js_callable_finalize;
#line 225 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
	g_type_class_add_private (klass, sizeof (GearyJSCallablePrivate));
#line 2086 "util-js.c"
}


static void
geary_js_callable_instance_init (GearyJSCallable * self)
{
	gchar** _tmp0_;
#line 225 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
	self->priv = GEARY_JS_CALLABLE_GET_PRIVATE (self);
#line 228 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
	_tmp0_ = g_new0 (gchar*, 0 + 1);
#line 228 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
	self->priv->safe_args = _tmp0_;
#line 228 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
	self->priv->safe_args_length1 = 0;
#line 228 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
	self->priv->_safe_args_size_ = self->priv->safe_args_length1;
#line 225 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
	self->ref_count = 1;
#line 2106 "util-js.c"
}


static void
geary_js_callable_finalize (GearyJSCallable * obj)
{
	GearyJSCallable * self;
#line 225 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GEARY_JS_TYPE_CALLABLE, GearyJSCallable);
#line 225 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
	g_signal_handlers_destroy (self);
#line 227 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
	_g_free0 (self->priv->base_name);
#line 228 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
	self->priv->safe_args = (_vala_array_free (self->priv->safe_args, self->priv->safe_args_length1, (GDestroyNotify) g_free), NULL);
#line 2122 "util-js.c"
}


/**
     * A class for constructing a well formed, safe, invokable JS call.
     */
GType
geary_js_callable_get_type (void)
{
	static volatile gsize geary_js_callable_type_id__volatile = 0;
	if (g_once_init_enter (&geary_js_callable_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { geary_js_value_callable_init, geary_js_value_callable_free_value, geary_js_value_callable_copy_value, geary_js_value_callable_peek_pointer, "p", geary_js_value_callable_collect_value, "p", geary_js_value_callable_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (GearyJSCallableClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) geary_js_callable_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GearyJSCallable), 0, (GInstanceInitFunc) geary_js_callable_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType geary_js_callable_type_id;
		geary_js_callable_type_id = g_type_register_fundamental (g_type_fundamental_next (), "GearyJSCallable", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&geary_js_callable_type_id__volatile, geary_js_callable_type_id);
	}
	return geary_js_callable_type_id__volatile;
}


gpointer
geary_js_callable_ref (gpointer instance)
{
	GearyJSCallable * self;
	self = instance;
#line 225 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
	g_atomic_int_inc (&self->ref_count);
#line 225 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
	return instance;
#line 2154 "util-js.c"
}


void
geary_js_callable_unref (gpointer instance)
{
	GearyJSCallable * self;
	self = instance;
#line 225 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 225 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
		GEARY_JS_CALLABLE_GET_CLASS (self)->finalize (self);
#line 225 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-js.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 2169 "util-js.c"
	}
}


static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}



