/* util-string.c generated by valac 0.39.7, the Vala compiler
 * generated from util-string.vala, do not modify */

/* Copyright 2016 Software Freedom Conservancy Inc.
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution.
 */
/* GLib's character-based substring function.*/

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>

#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))



gchar* g_utf8_substring (const gchar* str,
                         glong start_pos,
                         glong end_pos);
#define GEARY_STRING_EOS '\0'
gboolean geary_string_is_empty_or_whitespace (const gchar* str);
gboolean geary_string_is_empty (const gchar* str);
gint geary_string_count_char (const gchar* s,
                              gunichar c);
gboolean geary_string_contains_any_char (const gchar* str,
                                         gunichar* chars,
                                         int chars_length1);
static gboolean _vala_unichar_array_contains (gunichar * stack,
                                       int stack_length,
                                       gunichar needle);
guint geary_string_stri_hash (const gchar* str);
gboolean geary_string_stri_equal (const gchar* a,
                                  const gchar* b);
gint geary_string_stri_cmp (const gchar* a,
                            const gchar* b);
gchar* geary_string_reduce_whitespace (const gchar* _s);
gchar* geary_string_safe_byte_substring (const gchar* s,
                                         gssize max_length);


static gchar
string_get (const gchar* self,
            glong index)
{
	gchar result = '\0';
	gchar _tmp0_;
#line 1124 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, '\0');
#line 1125 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_tmp0_ = ((gchar*) self)[index];
#line 1125 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	result = _tmp0_;
#line 1125 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	return result;
#line 61 "util-string.c"
}


static gchar*
string_strip (const gchar* self)
{
	gchar* result = NULL;
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
#line 1248 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1249 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_tmp0_ = g_strdup (self);
#line 1249 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1250 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_tmp1_ = _result_;
#line 1250 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	g_strstrip (_tmp1_);
#line 1251 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	result = _result_;
#line 1251 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	return result;
#line 86 "util-string.c"
}


gboolean
geary_string_is_empty_or_whitespace (const gchar* str)
{
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
#line 16 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-string.vala"
	if (str == NULL) {
#line 16 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-string.vala"
		_tmp1_ = TRUE;
#line 100 "util-string.c"
	} else {
#line 16 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-string.vala"
		_tmp1_ = string_get (str, (glong) 0) == GEARY_STRING_EOS;
#line 104 "util-string.c"
	}
#line 16 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-string.vala"
	if (_tmp1_) {
#line 16 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-string.vala"
		_tmp0_ = TRUE;
#line 110 "util-string.c"
	} else {
		gchar* _tmp2_;
		gchar* _tmp3_;
#line 16 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-string.vala"
		_tmp2_ = string_strip (str);
#line 16 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-string.vala"
		_tmp3_ = _tmp2_;
#line 16 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-string.vala"
		_tmp0_ = string_get (_tmp3_, (glong) 0) == GEARY_STRING_EOS;
#line 16 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-string.vala"
		_g_free0 (_tmp3_);
#line 122 "util-string.c"
	}
#line 16 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-string.vala"
	result = _tmp0_;
#line 16 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-string.vala"
	return result;
#line 128 "util-string.c"
}


inline gboolean
geary_string_is_empty (const gchar* str)
{
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
#line 20 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-string.vala"
	if (str == NULL) {
#line 20 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-string.vala"
		_tmp0_ = TRUE;
#line 141 "util-string.c"
	} else {
#line 20 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-string.vala"
		_tmp0_ = string_get (str, (glong) 0) == GEARY_STRING_EOS;
#line 145 "util-string.c"
	}
#line 20 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-string.vala"
	result = _tmp0_;
#line 20 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-string.vala"
	return result;
#line 151 "util-string.c"
}


static gint
string_index_of_char (const gchar* self,
                      gunichar c,
                      gint start_index)
{
	gint result = 0;
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
#line 1045 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, 0);
#line 1046 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_tmp0_ = g_utf8_strchr (((gchar*) self) + start_index, (gssize) -1, c);
#line 1046 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1048 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_tmp1_ = _result_;
#line 1048 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	if (_tmp1_ != NULL) {
#line 174 "util-string.c"
		gchar* _tmp2_;
#line 1049 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp2_ = _result_;
#line 1049 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		result = (gint) (_tmp2_ - ((gchar*) self));
#line 1049 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		return result;
#line 182 "util-string.c"
	} else {
#line 1051 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		result = -1;
#line 1051 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		return result;
#line 188 "util-string.c"
	}
}


gint
geary_string_count_char (const gchar* s,
                         gunichar c)
{
	gint result = 0;
	gint count = 0;
#line 23 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-string.vala"
	g_return_val_if_fail (s != NULL, 0);
#line 24 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-string.vala"
	count = 0;
#line 203 "util-string.c"
	{
		gint index = 0;
#line 25 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-string.vala"
		index = 0;
#line 208 "util-string.c"
		{
			gboolean _tmp0_ = FALSE;
#line 25 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-string.vala"
			_tmp0_ = TRUE;
#line 25 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-string.vala"
			while (TRUE) {
#line 215 "util-string.c"
				gint _tmp3_;
				gint _tmp4_;
#line 25 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-string.vala"
				if (!_tmp0_) {
#line 220 "util-string.c"
					gint _tmp1_;
					gint _tmp2_;
#line 25 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-string.vala"
					_tmp1_ = index;
#line 25 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-string.vala"
					index = _tmp1_ + 1;
#line 25 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-string.vala"
					_tmp2_ = count;
#line 25 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-string.vala"
					count = _tmp2_ + 1;
#line 231 "util-string.c"
				}
#line 25 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-string.vala"
				_tmp0_ = FALSE;
#line 25 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-string.vala"
				_tmp3_ = index;
#line 25 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-string.vala"
				index = string_index_of_char (s, c, _tmp3_);
#line 25 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-string.vala"
				_tmp4_ = index;
#line 25 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-string.vala"
				if (!(_tmp4_ >= 0)) {
#line 25 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-string.vala"
					break;
#line 245 "util-string.c"
				}
			}
		}
	}
#line 27 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-string.vala"
	result = count;
#line 27 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-string.vala"
	return result;
#line 254 "util-string.c"
}


static gboolean
string_get_next_char (const gchar* self,
                      gint* index,
                      gunichar* c)
{
	gunichar _vala_c = 0U;
	gboolean result = FALSE;
	gunichar _tmp0_;
#line 1143 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1144 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_vala_c = g_utf8_get_char (((gchar*) self) + (*index));
#line 1145 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_tmp0_ = _vala_c;
#line 1145 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	if (_tmp0_ != ((gunichar) 0)) {
#line 274 "util-string.c"
		gchar* _tmp1_;
#line 1146 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp1_ = g_utf8_next_char (((gchar*) self) + (*index));
#line 1146 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		*index = (gint) (_tmp1_ - ((gchar*) self));
#line 1147 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		result = TRUE;
#line 1147 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		if (c) {
#line 1147 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
			*c = _vala_c;
#line 286 "util-string.c"
		}
#line 1147 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		return result;
#line 290 "util-string.c"
	} else {
#line 1149 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		result = FALSE;
#line 1149 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		if (c) {
#line 1149 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
			*c = _vala_c;
#line 298 "util-string.c"
		}
#line 1149 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		return result;
#line 302 "util-string.c"
	}
#line 1143 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	if (c) {
#line 1143 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		*c = _vala_c;
#line 308 "util-string.c"
	}
}


static gboolean
_vala_unichar_array_contains (gunichar * stack,
                              int stack_length,
                              gunichar needle)
{
	int i;
#line 34 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-string.vala"
	for (i = 0; i < stack_length; i++) {
#line 34 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-string.vala"
		if (needle == stack[i]) {
#line 34 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-string.vala"
			return TRUE;
#line 325 "util-string.c"
		}
	}
#line 34 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-string.vala"
	return FALSE;
#line 330 "util-string.c"
}


gboolean
geary_string_contains_any_char (const gchar* str,
                                gunichar* chars,
                                int chars_length1)
{
	gboolean result = FALSE;
	gint index = 0;
	gunichar ch = 0U;
#line 30 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-string.vala"
	g_return_val_if_fail (str != NULL, FALSE);
#line 31 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-string.vala"
	index = 0;
#line 33 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-string.vala"
	while (TRUE) {
#line 348 "util-string.c"
		gunichar _tmp0_ = 0U;
		gboolean _tmp1_;
		gunichar _tmp2_;
#line 33 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-string.vala"
		_tmp1_ = string_get_next_char (str, &index, &_tmp0_);
#line 33 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-string.vala"
		ch = _tmp0_;
#line 33 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-string.vala"
		if (!_tmp1_) {
#line 33 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-string.vala"
			break;
#line 360 "util-string.c"
		}
#line 34 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-string.vala"
		_tmp2_ = ch;
#line 34 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-string.vala"
		if (_vala_unichar_array_contains (chars, chars_length1, _tmp2_)) {
#line 35 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-string.vala"
			result = TRUE;
#line 35 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-string.vala"
			return result;
#line 370 "util-string.c"
		}
	}
#line 38 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-string.vala"
	result = FALSE;
#line 38 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-string.vala"
	return result;
#line 377 "util-string.c"
}


guint
geary_string_stri_hash (const gchar* str)
{
	guint result = 0U;
	GHashFunc _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	guint _tmp3_;
#line 41 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-string.vala"
	g_return_val_if_fail (str != NULL, 0U);
#line 42 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-string.vala"
	_tmp0_ = g_str_hash;
#line 42 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-string.vala"
	_tmp1_ = g_utf8_strdown (str, (gssize) -1);
#line 42 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-string.vala"
	_tmp2_ = _tmp1_;
#line 42 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-string.vala"
	_tmp3_ = _tmp0_ (_tmp2_);
#line 42 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-string.vala"
	_g_free0 (_tmp2_);
#line 42 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-string.vala"
	result = _tmp3_;
#line 42 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-string.vala"
	return result;
#line 405 "util-string.c"
}


gboolean
geary_string_stri_equal (const gchar* a,
                         const gchar* b)
{
	gboolean result = FALSE;
	GEqualFunc _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gboolean _tmp5_;
#line 45 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-string.vala"
	g_return_val_if_fail (a != NULL, FALSE);
#line 45 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-string.vala"
	g_return_val_if_fail (b != NULL, FALSE);
#line 46 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-string.vala"
	_tmp0_ = g_str_equal;
#line 46 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-string.vala"
	_tmp1_ = g_utf8_strdown (a, (gssize) -1);
#line 46 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-string.vala"
	_tmp2_ = _tmp1_;
#line 46 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-string.vala"
	_tmp3_ = g_utf8_strdown (b, (gssize) -1);
#line 46 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-string.vala"
	_tmp4_ = _tmp3_;
#line 46 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-string.vala"
	_tmp5_ = _tmp0_ (_tmp2_, _tmp4_);
#line 46 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-string.vala"
	_g_free0 (_tmp4_);
#line 46 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-string.vala"
	_g_free0 (_tmp2_);
#line 46 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-string.vala"
	result = _tmp5_;
#line 46 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-string.vala"
	return result;
#line 444 "util-string.c"
}


gint
geary_string_stri_cmp (const gchar* a,
                       const gchar* b)
{
	gint result = 0;
	GCompareFunc _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gint _tmp5_;
#line 49 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-string.vala"
	g_return_val_if_fail (a != NULL, 0);
#line 49 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-string.vala"
	g_return_val_if_fail (b != NULL, 0);
#line 50 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-string.vala"
	_tmp0_ = g_strcmp0;
#line 50 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-string.vala"
	_tmp1_ = g_utf8_strdown (a, (gssize) -1);
#line 50 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-string.vala"
	_tmp2_ = _tmp1_;
#line 50 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-string.vala"
	_tmp3_ = g_utf8_strdown (b, (gssize) -1);
#line 50 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-string.vala"
	_tmp4_ = _tmp3_;
#line 50 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-string.vala"
	_tmp5_ = _tmp0_ (_tmp2_, _tmp4_);
#line 50 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-string.vala"
	_g_free0 (_tmp4_);
#line 50 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-string.vala"
	_g_free0 (_tmp2_);
#line 50 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-string.vala"
	result = _tmp5_;
#line 50 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-string.vala"
	return result;
#line 483 "util-string.c"
}


static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gchar* result = NULL;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError * _inner_error_ = NULL;
#line 1421 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1421 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	g_return_val_if_fail (old != NULL, NULL);
#line 1421 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	g_return_val_if_fail (replacement != NULL, NULL);
#line 1422 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	if ((*((gchar*) self)) == '\0') {
#line 1422 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp1_ = TRUE;
#line 506 "util-string.c"
	} else {
#line 1422 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp1_ = (*((gchar*) old)) == '\0';
#line 510 "util-string.c"
	}
#line 1422 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	if (_tmp1_) {
#line 1422 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp0_ = TRUE;
#line 516 "util-string.c"
	} else {
#line 1422 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
#line 520 "util-string.c"
	}
#line 1422 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	if (_tmp0_) {
#line 524 "util-string.c"
		gchar* _tmp2_;
#line 1423 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp2_ = g_strdup (self);
#line 1423 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		result = _tmp2_;
#line 1423 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		return result;
#line 532 "util-string.c"
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
#line 1426 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp3_ = g_regex_escape_string (old, -1);
#line 1426 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp4_ = _tmp3_;
#line 1426 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error_);
#line 1426 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp6_ = _tmp5_;
#line 1426 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_g_free0 (_tmp4_);
#line 1426 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		regex = _tmp6_;
#line 1426 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1426 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
			if (_inner_error_->domain == G_REGEX_ERROR) {
#line 560 "util-string.c"
				goto __catch320_g_regex_error;
			}
#line 1426 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1426 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
			g_clear_error (&_inner_error_);
#line 1426 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
			return NULL;
#line 569 "util-string.c"
		}
#line 1427 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp8_ = regex;
#line 1427 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error_);
#line 1427 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp7_ = _tmp9_;
#line 1427 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1427 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1427 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
			if (_inner_error_->domain == G_REGEX_ERROR) {
#line 583 "util-string.c"
				goto __catch320_g_regex_error;
			}
#line 1427 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1427 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1427 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
			g_clear_error (&_inner_error_);
#line 1427 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
			return NULL;
#line 594 "util-string.c"
		}
#line 1427 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp10_ = _tmp7_;
#line 1427 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp7_ = NULL;
#line 1427 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		result = _tmp10_;
#line 1427 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_g_free0 (_tmp7_);
#line 1427 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_g_regex_unref0 (regex);
#line 1427 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		return result;
#line 608 "util-string.c"
	}
	goto __finally320;
	__catch320_g_regex_error:
	{
		GError* e = NULL;
#line 1425 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		e = _inner_error_;
#line 1425 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_inner_error_ = NULL;
#line 1429 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		g_assert_not_reached ();
#line 1425 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_g_error_free0 (e);
#line 622 "util-string.c"
	}
	__finally320:
#line 1425 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1425 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1425 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		g_clear_error (&_inner_error_);
#line 1425 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		return NULL;
#line 633 "util-string.c"
	}
}


static gunichar
string_get_char (const gchar* self,
                 glong index)
{
	gunichar result = 0U;
#line 1154 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, 0U);
#line 1155 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	result = g_utf8_get_char (((gchar*) self) + index);
#line 1155 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	return result;
#line 649 "util-string.c"
}


static gchar*
string_slice (const gchar* self,
              glong start,
              glong end)
{
	gchar* result = NULL;
	glong string_length = 0L;
	gint _tmp0_;
	gint _tmp1_;
	gboolean _tmp4_ = FALSE;
	gboolean _tmp6_ = FALSE;
	gchar* _tmp8_;
#line 1369 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1370 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_tmp0_ = strlen (self);
#line 1370 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_tmp1_ = _tmp0_;
#line 1370 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	string_length = (glong) _tmp1_;
#line 1371 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	if (start < ((glong) 0)) {
#line 675 "util-string.c"
		glong _tmp2_;
#line 1372 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp2_ = string_length;
#line 1372 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		start = _tmp2_ + start;
#line 681 "util-string.c"
	}
#line 1374 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	if (end < ((glong) 0)) {
#line 685 "util-string.c"
		glong _tmp3_;
#line 1375 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp3_ = string_length;
#line 1375 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		end = _tmp3_ + end;
#line 691 "util-string.c"
	}
#line 1377 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	if (start >= ((glong) 0)) {
#line 695 "util-string.c"
		glong _tmp5_;
#line 1377 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp5_ = string_length;
#line 1377 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp4_ = start <= _tmp5_;
#line 701 "util-string.c"
	} else {
#line 1377 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp4_ = FALSE;
#line 705 "util-string.c"
	}
#line 1377 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	g_return_val_if_fail (_tmp4_, NULL);
#line 1378 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	if (end >= ((glong) 0)) {
#line 711 "util-string.c"
		glong _tmp7_;
#line 1378 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp7_ = string_length;
#line 1378 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp6_ = end <= _tmp7_;
#line 717 "util-string.c"
	} else {
#line 1378 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp6_ = FALSE;
#line 721 "util-string.c"
	}
#line 1378 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	g_return_val_if_fail (_tmp6_, NULL);
#line 1379 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	g_return_val_if_fail (start <= end, NULL);
#line 1380 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_tmp8_ = g_strndup (((gchar*) self) + start, (gsize) (end - start));
#line 1380 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	result = _tmp8_;
#line 1380 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	return result;
#line 733 "util-string.c"
}


gchar*
geary_string_reduce_whitespace (const gchar* _s)
{
	gchar* result = NULL;
	gchar* s = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	const gchar* _tmp5_;
	gchar* _tmp6_;
	const gchar* _tmp7_;
	gchar* _tmp8_;
#line 54 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-string.vala"
	g_return_val_if_fail (_s != NULL, NULL);
#line 55 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-string.vala"
	_tmp0_ = g_strdup (_s);
#line 55 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-string.vala"
	s = _tmp0_;
#line 56 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-string.vala"
	_tmp1_ = s;
#line 56 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-string.vala"
	_tmp2_ = string_replace (_tmp1_, "\n", " ");
#line 56 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-string.vala"
	_g_free0 (s);
#line 56 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-string.vala"
	s = _tmp2_;
#line 57 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-string.vala"
	_tmp3_ = s;
#line 57 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-string.vala"
	_tmp4_ = string_replace (_tmp3_, "\r", " ");
#line 57 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-string.vala"
	_g_free0 (s);
#line 57 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-string.vala"
	s = _tmp4_;
#line 58 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-string.vala"
	_tmp5_ = s;
#line 58 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-string.vala"
	_tmp6_ = string_replace (_tmp5_, "\t", " ");
#line 58 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-string.vala"
	_g_free0 (s);
#line 58 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-string.vala"
	s = _tmp6_;
#line 59 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-string.vala"
	_tmp7_ = s;
#line 59 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-string.vala"
	_tmp8_ = string_strip (_tmp7_);
#line 59 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-string.vala"
	_g_free0 (s);
#line 59 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-string.vala"
	s = _tmp8_;
#line 789 "util-string.c"
	{
		gint i = 0;
#line 62 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-string.vala"
		i = 1;
#line 794 "util-string.c"
		{
			gboolean _tmp9_ = FALSE;
#line 62 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-string.vala"
			_tmp9_ = TRUE;
#line 62 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-string.vala"
			while (TRUE) {
#line 801 "util-string.c"
				gint _tmp11_;
				const gchar* _tmp12_;
				gint _tmp13_;
				gint _tmp14_;
				gboolean _tmp15_ = FALSE;
				const gchar* _tmp16_;
				gint _tmp17_;
#line 62 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-string.vala"
				if (!_tmp9_) {
#line 811 "util-string.c"
					gint _tmp10_;
#line 62 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-string.vala"
					_tmp10_ = i;
#line 62 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-string.vala"
					i = _tmp10_ + 1;
#line 817 "util-string.c"
				}
#line 62 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-string.vala"
				_tmp9_ = FALSE;
#line 62 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-string.vala"
				_tmp11_ = i;
#line 62 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-string.vala"
				_tmp12_ = s;
#line 62 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-string.vala"
				_tmp13_ = strlen (_tmp12_);
#line 62 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-string.vala"
				_tmp14_ = _tmp13_;
#line 62 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-string.vala"
				if (!(_tmp11_ < _tmp14_)) {
#line 62 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-string.vala"
					break;
#line 833 "util-string.c"
				}
#line 63 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-string.vala"
				_tmp16_ = s;
#line 63 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-string.vala"
				_tmp17_ = i;
#line 63 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-string.vala"
				if (string_get_char (_tmp16_, (glong) _tmp17_) == ((gunichar) ' ')) {
#line 841 "util-string.c"
					const gchar* _tmp18_;
					gint _tmp19_;
#line 63 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-string.vala"
					_tmp18_ = s;
#line 63 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-string.vala"
					_tmp19_ = i;
#line 63 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-string.vala"
					_tmp15_ = string_get_char (_tmp18_, (glong) (_tmp19_ - 1)) == ((gunichar) ' ');
#line 850 "util-string.c"
				} else {
#line 63 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-string.vala"
					_tmp15_ = FALSE;
#line 854 "util-string.c"
				}
#line 63 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-string.vala"
				if (_tmp15_) {
#line 858 "util-string.c"
					const gchar* _tmp20_;
					gint _tmp21_;
					gchar* _tmp22_;
					gchar* _tmp23_;
					const gchar* _tmp24_;
					gint _tmp25_;
					const gchar* _tmp26_;
					gint _tmp27_;
					gint _tmp28_;
					gchar* _tmp29_;
					gchar* _tmp30_;
					gchar* _tmp31_;
					gint _tmp32_;
#line 64 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-string.vala"
					_tmp20_ = s;
#line 64 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-string.vala"
					_tmp21_ = i;
#line 64 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-string.vala"
					_tmp22_ = string_slice (_tmp20_, (glong) 0, (glong) (_tmp21_ - 1));
#line 64 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-string.vala"
					_tmp23_ = _tmp22_;
#line 64 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-string.vala"
					_tmp24_ = s;
#line 64 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-string.vala"
					_tmp25_ = i;
#line 64 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-string.vala"
					_tmp26_ = s;
#line 64 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-string.vala"
					_tmp27_ = strlen (_tmp26_);
#line 64 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-string.vala"
					_tmp28_ = _tmp27_;
#line 64 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-string.vala"
					_tmp29_ = string_slice (_tmp24_, (glong) _tmp25_, (glong) _tmp28_);
#line 64 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-string.vala"
					_tmp30_ = _tmp29_;
#line 64 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-string.vala"
					_tmp31_ = g_strconcat (_tmp23_, _tmp30_, NULL);
#line 64 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-string.vala"
					_g_free0 (s);
#line 64 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-string.vala"
					s = _tmp31_;
#line 64 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-string.vala"
					_g_free0 (_tmp30_);
#line 64 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-string.vala"
					_g_free0 (_tmp23_);
#line 65 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-string.vala"
					_tmp32_ = i;
#line 65 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-string.vala"
					i = _tmp32_ - 1;
#line 908 "util-string.c"
				}
			}
		}
	}
#line 69 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-string.vala"
	result = s;
#line 69 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-string.vala"
	return result;
#line 917 "util-string.c"
}


gchar*
geary_string_safe_byte_substring (const gchar* s,
                                  gssize max_length)
{
	gchar* result = NULL;
	gint _tmp0_;
	gint _tmp1_;
	gchar* _tmp3_;
#line 76 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-string.vala"
	g_return_val_if_fail (s != NULL, NULL);
#line 77 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-string.vala"
	_tmp0_ = strlen (s);
#line 77 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-string.vala"
	_tmp1_ = _tmp0_;
#line 77 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-string.vala"
	if (((gssize) _tmp1_) < max_length) {
#line 937 "util-string.c"
		gchar* _tmp2_;
#line 78 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-string.vala"
		_tmp2_ = g_strdup (s);
#line 78 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-string.vala"
		result = _tmp2_;
#line 78 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-string.vala"
		return result;
#line 945 "util-string.c"
	}
#line 80 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-string.vala"
	_tmp3_ = g_utf8_substring (s, (glong) 0, (glong) g_utf8_strlen (s, max_length));
#line 80 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-string.vala"
	result = _tmp3_;
#line 80 "/builddir/build/BUILD/geary-0.12.1/src/engine/util/util-string.vala"
	return result;
#line 953 "util-string.c"
}



