/* smtp-outbox-folder.c generated by valac 0.39.7, the Vala compiler
 * generated from smtp-outbox-folder.vala, do not modify */

/* Copyright 2016 Software Freedom Conservancy Inc.
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution.
 */
/* Special type of folder that runs an asynchronous send queue.  Messages are*/
/* saved to the database, then queued up for sending.*/
/**/
/* The Outbox table is not currently maintained in its own database, so it must piggy-back*/
/* on the ImapDB.Database.  SmtpOutboxFolder assumes the database is opened before it's passed in*/
/* to the constructor -- it does not open or close the database itself and will start using it*/
/* immediately.*/

#include <glib.h>
#include <glib-object.h>
#include <gee.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <gobject/gvaluecollector.h>


#define GEARY_TYPE_BASE_OBJECT (geary_base_object_get_type ())
#define GEARY_BASE_OBJECT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GEARY_TYPE_BASE_OBJECT, GearyBaseObject))
#define GEARY_BASE_OBJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GEARY_TYPE_BASE_OBJECT, GearyBaseObjectClass))
#define GEARY_IS_BASE_OBJECT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GEARY_TYPE_BASE_OBJECT))
#define GEARY_IS_BASE_OBJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GEARY_TYPE_BASE_OBJECT))
#define GEARY_BASE_OBJECT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GEARY_TYPE_BASE_OBJECT, GearyBaseObjectClass))

typedef struct _GearyBaseObject GearyBaseObject;
typedef struct _GearyBaseObjectClass GearyBaseObjectClass;
typedef struct _GearyBaseObjectPrivate GearyBaseObjectPrivate;

#define GEARY_TYPE_FOLDER (geary_folder_get_type ())
#define GEARY_FOLDER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GEARY_TYPE_FOLDER, GearyFolder))
#define GEARY_FOLDER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GEARY_TYPE_FOLDER, GearyFolderClass))
#define GEARY_IS_FOLDER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GEARY_TYPE_FOLDER))
#define GEARY_IS_FOLDER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GEARY_TYPE_FOLDER))
#define GEARY_FOLDER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GEARY_TYPE_FOLDER, GearyFolderClass))

typedef struct _GearyFolder GearyFolder;
typedef struct _GearyFolderClass GearyFolderClass;
typedef struct _GearyFolderPrivate GearyFolderPrivate;

#define GEARY_FOLDER_TYPE_OPEN_STATE (geary_folder_open_state_get_type ())

#define GEARY_FOLDER_TYPE_OPEN_FAILED (geary_folder_open_failed_get_type ())

#define GEARY_FOLDER_TYPE_CLOSE_REASON (geary_folder_close_reason_get_type ())

#define GEARY_TYPE_EMAIL_IDENTIFIER (geary_email_identifier_get_type ())
#define GEARY_EMAIL_IDENTIFIER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GEARY_TYPE_EMAIL_IDENTIFIER, GearyEmailIdentifier))
#define GEARY_EMAIL_IDENTIFIER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GEARY_TYPE_EMAIL_IDENTIFIER, GearyEmailIdentifierClass))
#define GEARY_IS_EMAIL_IDENTIFIER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GEARY_TYPE_EMAIL_IDENTIFIER))
#define GEARY_IS_EMAIL_IDENTIFIER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GEARY_TYPE_EMAIL_IDENTIFIER))
#define GEARY_EMAIL_IDENTIFIER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GEARY_TYPE_EMAIL_IDENTIFIER, GearyEmailIdentifierClass))

typedef struct _GearyEmailIdentifier GearyEmailIdentifier;
typedef struct _GearyEmailIdentifierClass GearyEmailIdentifierClass;

#define GEARY_FOLDER_TYPE_COUNT_CHANGE_REASON (geary_folder_count_change_reason_get_type ())

#define GEARY_TYPE_NAMED_FLAGS (geary_named_flags_get_type ())
#define GEARY_NAMED_FLAGS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GEARY_TYPE_NAMED_FLAGS, GearyNamedFlags))
#define GEARY_NAMED_FLAGS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GEARY_TYPE_NAMED_FLAGS, GearyNamedFlagsClass))
#define GEARY_IS_NAMED_FLAGS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GEARY_TYPE_NAMED_FLAGS))
#define GEARY_IS_NAMED_FLAGS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GEARY_TYPE_NAMED_FLAGS))
#define GEARY_NAMED_FLAGS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GEARY_TYPE_NAMED_FLAGS, GearyNamedFlagsClass))

typedef struct _GearyNamedFlags GearyNamedFlags;
typedef struct _GearyNamedFlagsClass GearyNamedFlagsClass;

#define GEARY_TYPE_EMAIL_FLAGS (geary_email_flags_get_type ())
#define GEARY_EMAIL_FLAGS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GEARY_TYPE_EMAIL_FLAGS, GearyEmailFlags))
#define GEARY_EMAIL_FLAGS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GEARY_TYPE_EMAIL_FLAGS, GearyEmailFlagsClass))
#define GEARY_IS_EMAIL_FLAGS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GEARY_TYPE_EMAIL_FLAGS))
#define GEARY_IS_EMAIL_FLAGS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GEARY_TYPE_EMAIL_FLAGS))
#define GEARY_EMAIL_FLAGS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GEARY_TYPE_EMAIL_FLAGS, GearyEmailFlagsClass))

typedef struct _GearyEmailFlags GearyEmailFlags;
typedef struct _GearyEmailFlagsClass GearyEmailFlagsClass;

#define GEARY_TYPE_SPECIAL_FOLDER_TYPE (geary_special_folder_type_get_type ())

#define GEARY_FOLDER_TYPE_OPEN_FLAGS (geary_folder_open_flags_get_type ())

#define GEARY_EMAIL_TYPE_FIELD (geary_email_field_get_type ())

#define GEARY_FOLDER_TYPE_LIST_FLAGS (geary_folder_list_flags_get_type ())

#define GEARY_TYPE_EMAIL (geary_email_get_type ())
#define GEARY_EMAIL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GEARY_TYPE_EMAIL, GearyEmail))
#define GEARY_EMAIL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GEARY_TYPE_EMAIL, GearyEmailClass))
#define GEARY_IS_EMAIL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GEARY_TYPE_EMAIL))
#define GEARY_IS_EMAIL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GEARY_TYPE_EMAIL))
#define GEARY_EMAIL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GEARY_TYPE_EMAIL, GearyEmailClass))

typedef struct _GearyEmail GearyEmail;
typedef struct _GearyEmailClass GearyEmailClass;

#define GEARY_TYPE_ACCOUNT (geary_account_get_type ())
#define GEARY_ACCOUNT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GEARY_TYPE_ACCOUNT, GearyAccount))
#define GEARY_ACCOUNT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GEARY_TYPE_ACCOUNT, GearyAccountClass))
#define GEARY_IS_ACCOUNT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GEARY_TYPE_ACCOUNT))
#define GEARY_IS_ACCOUNT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GEARY_TYPE_ACCOUNT))
#define GEARY_ACCOUNT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GEARY_TYPE_ACCOUNT, GearyAccountClass))

typedef struct _GearyAccount GearyAccount;
typedef struct _GearyAccountClass GearyAccountClass;

#define GEARY_TYPE_FOLDER_PROPERTIES (geary_folder_properties_get_type ())
#define GEARY_FOLDER_PROPERTIES(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GEARY_TYPE_FOLDER_PROPERTIES, GearyFolderProperties))
#define GEARY_FOLDER_PROPERTIES_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GEARY_TYPE_FOLDER_PROPERTIES, GearyFolderPropertiesClass))
#define GEARY_IS_FOLDER_PROPERTIES(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GEARY_TYPE_FOLDER_PROPERTIES))
#define GEARY_IS_FOLDER_PROPERTIES_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GEARY_TYPE_FOLDER_PROPERTIES))
#define GEARY_FOLDER_PROPERTIES_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GEARY_TYPE_FOLDER_PROPERTIES, GearyFolderPropertiesClass))

typedef struct _GearyFolderProperties GearyFolderProperties;
typedef struct _GearyFolderPropertiesClass GearyFolderPropertiesClass;

#define GEARY_TYPE_FOLDER_PATH (geary_folder_path_get_type ())
#define GEARY_FOLDER_PATH(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GEARY_TYPE_FOLDER_PATH, GearyFolderPath))
#define GEARY_FOLDER_PATH_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GEARY_TYPE_FOLDER_PATH, GearyFolderPathClass))
#define GEARY_IS_FOLDER_PATH(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GEARY_TYPE_FOLDER_PATH))
#define GEARY_IS_FOLDER_PATH_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GEARY_TYPE_FOLDER_PATH))
#define GEARY_FOLDER_PATH_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GEARY_TYPE_FOLDER_PATH, GearyFolderPathClass))

typedef struct _GearyFolderPath GearyFolderPath;
typedef struct _GearyFolderPathClass GearyFolderPathClass;

#define GEARY_TYPE_PROGRESS_MONITOR (geary_progress_monitor_get_type ())
#define GEARY_PROGRESS_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GEARY_TYPE_PROGRESS_MONITOR, GearyProgressMonitor))
#define GEARY_PROGRESS_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GEARY_TYPE_PROGRESS_MONITOR, GearyProgressMonitorClass))
#define GEARY_IS_PROGRESS_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GEARY_TYPE_PROGRESS_MONITOR))
#define GEARY_IS_PROGRESS_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GEARY_TYPE_PROGRESS_MONITOR))
#define GEARY_PROGRESS_MONITOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GEARY_TYPE_PROGRESS_MONITOR, GearyProgressMonitorClass))

typedef struct _GearyProgressMonitor GearyProgressMonitor;
typedef struct _GearyProgressMonitorClass GearyProgressMonitorClass;

#define GEARY_TYPE_ABSTRACT_LOCAL_FOLDER (geary_abstract_local_folder_get_type ())
#define GEARY_ABSTRACT_LOCAL_FOLDER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GEARY_TYPE_ABSTRACT_LOCAL_FOLDER, GearyAbstractLocalFolder))
#define GEARY_ABSTRACT_LOCAL_FOLDER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GEARY_TYPE_ABSTRACT_LOCAL_FOLDER, GearyAbstractLocalFolderClass))
#define GEARY_IS_ABSTRACT_LOCAL_FOLDER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GEARY_TYPE_ABSTRACT_LOCAL_FOLDER))
#define GEARY_IS_ABSTRACT_LOCAL_FOLDER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GEARY_TYPE_ABSTRACT_LOCAL_FOLDER))
#define GEARY_ABSTRACT_LOCAL_FOLDER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GEARY_TYPE_ABSTRACT_LOCAL_FOLDER, GearyAbstractLocalFolderClass))

typedef struct _GearyAbstractLocalFolder GearyAbstractLocalFolder;
typedef struct _GearyAbstractLocalFolderClass GearyAbstractLocalFolderClass;
typedef struct _GearyAbstractLocalFolderPrivate GearyAbstractLocalFolderPrivate;

#define GEARY_FOLDER_SUPPORT_TYPE_REMOVE (geary_folder_support_remove_get_type ())
#define GEARY_FOLDER_SUPPORT_REMOVE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GEARY_FOLDER_SUPPORT_TYPE_REMOVE, GearyFolderSupportRemove))
#define GEARY_FOLDER_SUPPORT_IS_REMOVE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GEARY_FOLDER_SUPPORT_TYPE_REMOVE))
#define GEARY_FOLDER_SUPPORT_REMOVE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), GEARY_FOLDER_SUPPORT_TYPE_REMOVE, GearyFolderSupportRemoveIface))

typedef struct _GearyFolderSupportRemove GearyFolderSupportRemove;
typedef struct _GearyFolderSupportRemoveIface GearyFolderSupportRemoveIface;

#define GEARY_FOLDER_SUPPORT_TYPE_CREATE (geary_folder_support_create_get_type ())
#define GEARY_FOLDER_SUPPORT_CREATE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GEARY_FOLDER_SUPPORT_TYPE_CREATE, GearyFolderSupportCreate))
#define GEARY_FOLDER_SUPPORT_IS_CREATE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GEARY_FOLDER_SUPPORT_TYPE_CREATE))
#define GEARY_FOLDER_SUPPORT_CREATE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), GEARY_FOLDER_SUPPORT_TYPE_CREATE, GearyFolderSupportCreateIface))

typedef struct _GearyFolderSupportCreate GearyFolderSupportCreate;
typedef struct _GearyFolderSupportCreateIface GearyFolderSupportCreateIface;

#define GEARY_RF_C822_TYPE_MESSAGE (geary_rf_c822_message_get_type ())
#define GEARY_RF_C822_MESSAGE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GEARY_RF_C822_TYPE_MESSAGE, GearyRFC822Message))
#define GEARY_RF_C822_MESSAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GEARY_RF_C822_TYPE_MESSAGE, GearyRFC822MessageClass))
#define GEARY_RF_C822_IS_MESSAGE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GEARY_RF_C822_TYPE_MESSAGE))
#define GEARY_RF_C822_IS_MESSAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GEARY_RF_C822_TYPE_MESSAGE))
#define GEARY_RF_C822_MESSAGE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GEARY_RF_C822_TYPE_MESSAGE, GearyRFC822MessageClass))

typedef struct _GearyRFC822Message GearyRFC822Message;
typedef struct _GearyRFC822MessageClass GearyRFC822MessageClass;

#define GEARY_TYPE_SMTP_OUTBOX_FOLDER (geary_smtp_outbox_folder_get_type ())
#define GEARY_SMTP_OUTBOX_FOLDER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GEARY_TYPE_SMTP_OUTBOX_FOLDER, GearySmtpOutboxFolder))
#define GEARY_SMTP_OUTBOX_FOLDER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GEARY_TYPE_SMTP_OUTBOX_FOLDER, GearySmtpOutboxFolderClass))
#define GEARY_IS_SMTP_OUTBOX_FOLDER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GEARY_TYPE_SMTP_OUTBOX_FOLDER))
#define GEARY_IS_SMTP_OUTBOX_FOLDER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GEARY_TYPE_SMTP_OUTBOX_FOLDER))
#define GEARY_SMTP_OUTBOX_FOLDER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GEARY_TYPE_SMTP_OUTBOX_FOLDER, GearySmtpOutboxFolderClass))

typedef struct _GearySmtpOutboxFolder GearySmtpOutboxFolder;
typedef struct _GearySmtpOutboxFolderClass GearySmtpOutboxFolderClass;
typedef struct _GearySmtpOutboxFolderPrivate GearySmtpOutboxFolderPrivate;

#define GEARY_TYPE_FOLDER_ROOT (geary_folder_root_get_type ())
#define GEARY_FOLDER_ROOT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GEARY_TYPE_FOLDER_ROOT, GearyFolderRoot))
#define GEARY_FOLDER_ROOT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GEARY_TYPE_FOLDER_ROOT, GearyFolderRootClass))
#define GEARY_IS_FOLDER_ROOT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GEARY_TYPE_FOLDER_ROOT))
#define GEARY_IS_FOLDER_ROOT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GEARY_TYPE_FOLDER_ROOT))
#define GEARY_FOLDER_ROOT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GEARY_TYPE_FOLDER_ROOT, GearyFolderRootClass))

typedef struct _GearyFolderRoot GearyFolderRoot;
typedef struct _GearyFolderRootClass GearyFolderRootClass;

#define GEARY_TYPE_SMTP_OUTBOX_FOLDER_ROOT (geary_smtp_outbox_folder_root_get_type ())
#define GEARY_SMTP_OUTBOX_FOLDER_ROOT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GEARY_TYPE_SMTP_OUTBOX_FOLDER_ROOT, GearySmtpOutboxFolderRoot))
#define GEARY_SMTP_OUTBOX_FOLDER_ROOT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GEARY_TYPE_SMTP_OUTBOX_FOLDER_ROOT, GearySmtpOutboxFolderRootClass))
#define GEARY_IS_SMTP_OUTBOX_FOLDER_ROOT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GEARY_TYPE_SMTP_OUTBOX_FOLDER_ROOT))
#define GEARY_IS_SMTP_OUTBOX_FOLDER_ROOT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GEARY_TYPE_SMTP_OUTBOX_FOLDER_ROOT))
#define GEARY_SMTP_OUTBOX_FOLDER_ROOT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GEARY_TYPE_SMTP_OUTBOX_FOLDER_ROOT, GearySmtpOutboxFolderRootClass))

typedef struct _GearySmtpOutboxFolderRoot GearySmtpOutboxFolderRoot;
typedef struct _GearySmtpOutboxFolderRootClass GearySmtpOutboxFolderRootClass;

#define GEARY_DB_TYPE_CONTEXT (geary_db_context_get_type ())
#define GEARY_DB_CONTEXT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GEARY_DB_TYPE_CONTEXT, GearyDbContext))
#define GEARY_DB_CONTEXT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GEARY_DB_TYPE_CONTEXT, GearyDbContextClass))
#define GEARY_DB_IS_CONTEXT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GEARY_DB_TYPE_CONTEXT))
#define GEARY_DB_IS_CONTEXT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GEARY_DB_TYPE_CONTEXT))
#define GEARY_DB_CONTEXT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GEARY_DB_TYPE_CONTEXT, GearyDbContextClass))

typedef struct _GearyDbContext GearyDbContext;
typedef struct _GearyDbContextClass GearyDbContextClass;

#define GEARY_DB_TYPE_DATABASE (geary_db_database_get_type ())
#define GEARY_DB_DATABASE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GEARY_DB_TYPE_DATABASE, GearyDbDatabase))
#define GEARY_DB_DATABASE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GEARY_DB_TYPE_DATABASE, GearyDbDatabaseClass))
#define GEARY_DB_IS_DATABASE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GEARY_DB_TYPE_DATABASE))
#define GEARY_DB_IS_DATABASE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GEARY_DB_TYPE_DATABASE))
#define GEARY_DB_DATABASE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GEARY_DB_TYPE_DATABASE, GearyDbDatabaseClass))

typedef struct _GearyDbDatabase GearyDbDatabase;
typedef struct _GearyDbDatabaseClass GearyDbDatabaseClass;

#define GEARY_DB_TYPE_VERSIONED_DATABASE (geary_db_versioned_database_get_type ())
#define GEARY_DB_VERSIONED_DATABASE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GEARY_DB_TYPE_VERSIONED_DATABASE, GearyDbVersionedDatabase))
#define GEARY_DB_VERSIONED_DATABASE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GEARY_DB_TYPE_VERSIONED_DATABASE, GearyDbVersionedDatabaseClass))
#define GEARY_DB_IS_VERSIONED_DATABASE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GEARY_DB_TYPE_VERSIONED_DATABASE))
#define GEARY_DB_IS_VERSIONED_DATABASE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GEARY_DB_TYPE_VERSIONED_DATABASE))
#define GEARY_DB_VERSIONED_DATABASE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GEARY_DB_TYPE_VERSIONED_DATABASE, GearyDbVersionedDatabaseClass))

typedef struct _GearyDbVersionedDatabase GearyDbVersionedDatabase;
typedef struct _GearyDbVersionedDatabaseClass GearyDbVersionedDatabaseClass;

#define GEARY_IMAP_DB_TYPE_DATABASE (geary_imap_db_database_get_type ())
#define GEARY_IMAP_DB_DATABASE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GEARY_IMAP_DB_TYPE_DATABASE, GearyImapDBDatabase))
#define GEARY_IMAP_DB_DATABASE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GEARY_IMAP_DB_TYPE_DATABASE, GearyImapDBDatabaseClass))
#define GEARY_IMAP_DB_IS_DATABASE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GEARY_IMAP_DB_TYPE_DATABASE))
#define GEARY_IMAP_DB_IS_DATABASE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GEARY_IMAP_DB_TYPE_DATABASE))
#define GEARY_IMAP_DB_DATABASE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GEARY_IMAP_DB_TYPE_DATABASE, GearyImapDBDatabaseClass))

typedef struct _GearyImapDBDatabase GearyImapDBDatabase;
typedef struct _GearyImapDBDatabaseClass GearyImapDBDatabaseClass;

#define GEARY_SMTP_TYPE_CLIENT_SESSION (geary_smtp_client_session_get_type ())
#define GEARY_SMTP_CLIENT_SESSION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GEARY_SMTP_TYPE_CLIENT_SESSION, GearySmtpClientSession))
#define GEARY_SMTP_CLIENT_SESSION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GEARY_SMTP_TYPE_CLIENT_SESSION, GearySmtpClientSessionClass))
#define GEARY_SMTP_IS_CLIENT_SESSION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GEARY_SMTP_TYPE_CLIENT_SESSION))
#define GEARY_SMTP_IS_CLIENT_SESSION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GEARY_SMTP_TYPE_CLIENT_SESSION))
#define GEARY_SMTP_CLIENT_SESSION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GEARY_SMTP_TYPE_CLIENT_SESSION, GearySmtpClientSessionClass))

typedef struct _GearySmtpClientSession GearySmtpClientSession;
typedef struct _GearySmtpClientSessionClass GearySmtpClientSessionClass;

#define GEARY_NONBLOCKING_TYPE_MAILBOX (geary_nonblocking_mailbox_get_type ())
#define GEARY_NONBLOCKING_MAILBOX(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GEARY_NONBLOCKING_TYPE_MAILBOX, GearyNonblockingMailbox))
#define GEARY_NONBLOCKING_MAILBOX_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GEARY_NONBLOCKING_TYPE_MAILBOX, GearyNonblockingMailboxClass))
#define GEARY_NONBLOCKING_IS_MAILBOX(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GEARY_NONBLOCKING_TYPE_MAILBOX))
#define GEARY_NONBLOCKING_IS_MAILBOX_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GEARY_NONBLOCKING_TYPE_MAILBOX))
#define GEARY_NONBLOCKING_MAILBOX_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GEARY_NONBLOCKING_TYPE_MAILBOX, GearyNonblockingMailboxClass))

typedef struct _GearyNonblockingMailbox GearyNonblockingMailbox;
typedef struct _GearyNonblockingMailboxClass GearyNonblockingMailboxClass;

#define GEARY_SMTP_OUTBOX_FOLDER_TYPE_OUTBOX_ROW (geary_smtp_outbox_folder_outbox_row_get_type ())
#define GEARY_SMTP_OUTBOX_FOLDER_OUTBOX_ROW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GEARY_SMTP_OUTBOX_FOLDER_TYPE_OUTBOX_ROW, GearySmtpOutboxFolderOutboxRow))
#define GEARY_SMTP_OUTBOX_FOLDER_OUTBOX_ROW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GEARY_SMTP_OUTBOX_FOLDER_TYPE_OUTBOX_ROW, GearySmtpOutboxFolderOutboxRowClass))
#define GEARY_SMTP_OUTBOX_FOLDER_IS_OUTBOX_ROW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GEARY_SMTP_OUTBOX_FOLDER_TYPE_OUTBOX_ROW))
#define GEARY_SMTP_OUTBOX_FOLDER_IS_OUTBOX_ROW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GEARY_SMTP_OUTBOX_FOLDER_TYPE_OUTBOX_ROW))
#define GEARY_SMTP_OUTBOX_FOLDER_OUTBOX_ROW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GEARY_SMTP_OUTBOX_FOLDER_TYPE_OUTBOX_ROW, GearySmtpOutboxFolderOutboxRowClass))

typedef struct _GearySmtpOutboxFolderOutboxRow GearySmtpOutboxFolderOutboxRow;
typedef struct _GearySmtpOutboxFolderOutboxRowClass GearySmtpOutboxFolderOutboxRowClass;

#define GEARY_TYPE_SMTP_OUTBOX_FOLDER_PROPERTIES (geary_smtp_outbox_folder_properties_get_type ())
#define GEARY_SMTP_OUTBOX_FOLDER_PROPERTIES(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GEARY_TYPE_SMTP_OUTBOX_FOLDER_PROPERTIES, GearySmtpOutboxFolderProperties))
#define GEARY_SMTP_OUTBOX_FOLDER_PROPERTIES_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GEARY_TYPE_SMTP_OUTBOX_FOLDER_PROPERTIES, GearySmtpOutboxFolderPropertiesClass))
#define GEARY_IS_SMTP_OUTBOX_FOLDER_PROPERTIES(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GEARY_TYPE_SMTP_OUTBOX_FOLDER_PROPERTIES))
#define GEARY_IS_SMTP_OUTBOX_FOLDER_PROPERTIES_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GEARY_TYPE_SMTP_OUTBOX_FOLDER_PROPERTIES))
#define GEARY_SMTP_OUTBOX_FOLDER_PROPERTIES_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GEARY_TYPE_SMTP_OUTBOX_FOLDER_PROPERTIES, GearySmtpOutboxFolderPropertiesClass))

typedef struct _GearySmtpOutboxFolderProperties GearySmtpOutboxFolderProperties;
typedef struct _GearySmtpOutboxFolderPropertiesClass GearySmtpOutboxFolderPropertiesClass;
enum  {
	GEARY_SMTP_OUTBOX_FOLDER_0_PROPERTY,
	GEARY_SMTP_OUTBOX_FOLDER_ACCOUNT_PROPERTY,
	GEARY_SMTP_OUTBOX_FOLDER_PROPERTIES_PROPERTY,
	GEARY_SMTP_OUTBOX_FOLDER_PATH_PROPERTY,
	GEARY_SMTP_OUTBOX_FOLDER_SPECIAL_FOLDER_TYPE_PROPERTY,
	GEARY_SMTP_OUTBOX_FOLDER_NUM_PROPERTIES
};
static GParamSpec* geary_smtp_outbox_folder_properties[GEARY_SMTP_OUTBOX_FOLDER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _geary_smtp_client_session_unref0(var) ((var == NULL) ? NULL : (var = (geary_smtp_client_session_unref (var), NULL)))

#define GEARY_TYPE_ACCOUNT_INFORMATION (geary_account_information_get_type ())
#define GEARY_ACCOUNT_INFORMATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GEARY_TYPE_ACCOUNT_INFORMATION, GearyAccountInformation))
#define GEARY_ACCOUNT_INFORMATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GEARY_TYPE_ACCOUNT_INFORMATION, GearyAccountInformationClass))
#define GEARY_IS_ACCOUNT_INFORMATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GEARY_TYPE_ACCOUNT_INFORMATION))
#define GEARY_IS_ACCOUNT_INFORMATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GEARY_TYPE_ACCOUNT_INFORMATION))
#define GEARY_ACCOUNT_INFORMATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GEARY_TYPE_ACCOUNT_INFORMATION, GearyAccountInformationClass))

typedef struct _GearyAccountInformation GearyAccountInformation;
typedef struct _GearyAccountInformationClass GearyAccountInformationClass;

#define GEARY_TYPE_ENDPOINT (geary_endpoint_get_type ())
#define GEARY_ENDPOINT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GEARY_TYPE_ENDPOINT, GearyEndpoint))
#define GEARY_ENDPOINT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GEARY_TYPE_ENDPOINT, GearyEndpointClass))
#define GEARY_IS_ENDPOINT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GEARY_TYPE_ENDPOINT))
#define GEARY_IS_ENDPOINT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GEARY_TYPE_ENDPOINT))
#define GEARY_ENDPOINT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GEARY_TYPE_ENDPOINT, GearyEndpointClass))

typedef struct _GearyEndpoint GearyEndpoint;
typedef struct _GearyEndpointClass GearyEndpointClass;

#define GEARY_TYPE_SMTP_OUTBOX_EMAIL_IDENTIFIER (geary_smtp_outbox_email_identifier_get_type ())
#define GEARY_SMTP_OUTBOX_EMAIL_IDENTIFIER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GEARY_TYPE_SMTP_OUTBOX_EMAIL_IDENTIFIER, GearySmtpOutboxEmailIdentifier))
#define GEARY_SMTP_OUTBOX_EMAIL_IDENTIFIER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GEARY_TYPE_SMTP_OUTBOX_EMAIL_IDENTIFIER, GearySmtpOutboxEmailIdentifierClass))
#define GEARY_IS_SMTP_OUTBOX_EMAIL_IDENTIFIER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GEARY_TYPE_SMTP_OUTBOX_EMAIL_IDENTIFIER))
#define GEARY_IS_SMTP_OUTBOX_EMAIL_IDENTIFIER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GEARY_TYPE_SMTP_OUTBOX_EMAIL_IDENTIFIER))
#define GEARY_SMTP_OUTBOX_EMAIL_IDENTIFIER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GEARY_TYPE_SMTP_OUTBOX_EMAIL_IDENTIFIER, GearySmtpOutboxEmailIdentifierClass))

typedef struct _GearySmtpOutboxEmailIdentifier GearySmtpOutboxEmailIdentifier;
typedef struct _GearySmtpOutboxEmailIdentifierClass GearySmtpOutboxEmailIdentifierClass;
typedef struct _Block73Data Block73Data;

#define GEARY_DB_TYPE_TRANSACTION_TYPE (geary_db_transaction_type_get_type ())

#define GEARY_DB_TYPE_TRANSACTION_OUTCOME (geary_db_transaction_outcome_get_type ())

#define GEARY_DB_TYPE_CONNECTION (geary_db_connection_get_type ())
#define GEARY_DB_CONNECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GEARY_DB_TYPE_CONNECTION, GearyDbConnection))
#define GEARY_DB_CONNECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GEARY_DB_TYPE_CONNECTION, GearyDbConnectionClass))
#define GEARY_DB_IS_CONNECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GEARY_DB_TYPE_CONNECTION))
#define GEARY_DB_IS_CONNECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GEARY_DB_TYPE_CONNECTION))
#define GEARY_DB_CONNECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GEARY_DB_TYPE_CONNECTION, GearyDbConnectionClass))

typedef struct _GearyDbConnection GearyDbConnection;
typedef struct _GearyDbConnectionClass GearyDbConnectionClass;
#define _geary_smtp_outbox_folder_outbox_row_unref0(var) ((var == NULL) ? NULL : (var = (geary_smtp_outbox_folder_outbox_row_unref (var), NULL)))
typedef struct _GearySmtpOutboxFolderFindBoundariesAsyncData GearySmtpOutboxFolderFindBoundariesAsyncData;
typedef struct _Block74Data Block74Data;
typedef struct _GearySmtpOutboxFolderAddToContainingFoldersAsyncData GearySmtpOutboxFolderAddToContainingFoldersAsyncData;

#define GEARY_MESSAGE_DATA_TYPE_ABSTRACT_MESSAGE_DATA (geary_message_data_abstract_message_data_get_type ())
#define GEARY_MESSAGE_DATA_ABSTRACT_MESSAGE_DATA(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GEARY_MESSAGE_DATA_TYPE_ABSTRACT_MESSAGE_DATA, GearyMessageDataAbstractMessageData))
#define GEARY_MESSAGE_DATA_ABSTRACT_MESSAGE_DATA_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GEARY_MESSAGE_DATA_TYPE_ABSTRACT_MESSAGE_DATA, GearyMessageDataAbstractMessageDataClass))
#define GEARY_MESSAGE_DATA_IS_ABSTRACT_MESSAGE_DATA(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GEARY_MESSAGE_DATA_TYPE_ABSTRACT_MESSAGE_DATA))
#define GEARY_MESSAGE_DATA_IS_ABSTRACT_MESSAGE_DATA_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GEARY_MESSAGE_DATA_TYPE_ABSTRACT_MESSAGE_DATA))
#define GEARY_MESSAGE_DATA_ABSTRACT_MESSAGE_DATA_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GEARY_MESSAGE_DATA_TYPE_ABSTRACT_MESSAGE_DATA, GearyMessageDataAbstractMessageDataClass))

typedef struct _GearyMessageDataAbstractMessageData GearyMessageDataAbstractMessageData;
typedef struct _GearyMessageDataAbstractMessageDataClass GearyMessageDataAbstractMessageDataClass;

#define GEARY_MESSAGE_DATA_TYPE_STRING_MESSAGE_DATA (geary_message_data_string_message_data_get_type ())
#define GEARY_MESSAGE_DATA_STRING_MESSAGE_DATA(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GEARY_MESSAGE_DATA_TYPE_STRING_MESSAGE_DATA, GearyMessageDataStringMessageData))
#define GEARY_MESSAGE_DATA_STRING_MESSAGE_DATA_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GEARY_MESSAGE_DATA_TYPE_STRING_MESSAGE_DATA, GearyMessageDataStringMessageDataClass))
#define GEARY_MESSAGE_DATA_IS_STRING_MESSAGE_DATA(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GEARY_MESSAGE_DATA_TYPE_STRING_MESSAGE_DATA))
#define GEARY_MESSAGE_DATA_IS_STRING_MESSAGE_DATA_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GEARY_MESSAGE_DATA_TYPE_STRING_MESSAGE_DATA))
#define GEARY_MESSAGE_DATA_STRING_MESSAGE_DATA_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GEARY_MESSAGE_DATA_TYPE_STRING_MESSAGE_DATA, GearyMessageDataStringMessageDataClass))

typedef struct _GearyMessageDataStringMessageData GearyMessageDataStringMessageData;
typedef struct _GearyMessageDataStringMessageDataClass GearyMessageDataStringMessageDataClass;

#define GEARY_RF_C822_TYPE_SUBJECT (geary_rf_c822_subject_get_type ())
#define GEARY_RF_C822_SUBJECT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GEARY_RF_C822_TYPE_SUBJECT, GearyRFC822Subject))
#define GEARY_RF_C822_SUBJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GEARY_RF_C822_TYPE_SUBJECT, GearyRFC822SubjectClass))
#define GEARY_RF_C822_IS_SUBJECT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GEARY_RF_C822_TYPE_SUBJECT))
#define GEARY_RF_C822_IS_SUBJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GEARY_RF_C822_TYPE_SUBJECT))
#define GEARY_RF_C822_SUBJECT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GEARY_RF_C822_TYPE_SUBJECT, GearyRFC822SubjectClass))

typedef struct _GearyRFC822Subject GearyRFC822Subject;
typedef struct _GearyRFC822SubjectClass GearyRFC822SubjectClass;
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _Block75Data Block75Data;

#define GEARY_DB_TYPE_STATEMENT (geary_db_statement_get_type ())
#define GEARY_DB_STATEMENT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GEARY_DB_TYPE_STATEMENT, GearyDbStatement))
#define GEARY_DB_STATEMENT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GEARY_DB_TYPE_STATEMENT, GearyDbStatementClass))
#define GEARY_DB_IS_STATEMENT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GEARY_DB_TYPE_STATEMENT))
#define GEARY_DB_IS_STATEMENT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GEARY_DB_TYPE_STATEMENT))
#define GEARY_DB_STATEMENT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GEARY_DB_TYPE_STATEMENT, GearyDbStatementClass))

typedef struct _GearyDbStatement GearyDbStatement;
typedef struct _GearyDbStatementClass GearyDbStatementClass;

#define GEARY_DB_TYPE_RESULT (geary_db_result_get_type ())
#define GEARY_DB_RESULT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GEARY_DB_TYPE_RESULT, GearyDbResult))
#define GEARY_DB_RESULT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GEARY_DB_TYPE_RESULT, GearyDbResultClass))
#define GEARY_DB_IS_RESULT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GEARY_DB_TYPE_RESULT))
#define GEARY_DB_IS_RESULT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GEARY_DB_TYPE_RESULT))
#define GEARY_DB_RESULT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GEARY_DB_TYPE_RESULT, GearyDbResultClass))

typedef struct _GearyDbResult GearyDbResult;
typedef struct _GearyDbResultClass GearyDbResultClass;

#define GEARY_MEMORY_TYPE_BUFFER (geary_memory_buffer_get_type ())
#define GEARY_MEMORY_BUFFER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GEARY_MEMORY_TYPE_BUFFER, GearyMemoryBuffer))
#define GEARY_MEMORY_BUFFER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GEARY_MEMORY_TYPE_BUFFER, GearyMemoryBufferClass))
#define GEARY_MEMORY_IS_BUFFER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GEARY_MEMORY_TYPE_BUFFER))
#define GEARY_MEMORY_IS_BUFFER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GEARY_MEMORY_TYPE_BUFFER))
#define GEARY_MEMORY_BUFFER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GEARY_MEMORY_TYPE_BUFFER, GearyMemoryBufferClass))

typedef struct _GearyMemoryBuffer GearyMemoryBuffer;
typedef struct _GearyMemoryBufferClass GearyMemoryBufferClass;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _GearySmtpOutboxFolderFillOutboxQueueData GearySmtpOutboxFolderFillOutboxQueueData;
typedef struct _GearySmtpOutboxFolderOutboxRowPrivate GearySmtpOutboxFolderOutboxRowPrivate;

#define GEARY_TYPE_CREDENTIALS (geary_credentials_get_type ())
#define GEARY_CREDENTIALS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GEARY_TYPE_CREDENTIALS, GearyCredentials))
#define GEARY_CREDENTIALS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GEARY_TYPE_CREDENTIALS, GearyCredentialsClass))
#define GEARY_IS_CREDENTIALS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GEARY_TYPE_CREDENTIALS))
#define GEARY_IS_CREDENTIALS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GEARY_TYPE_CREDENTIALS))
#define GEARY_CREDENTIALS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GEARY_TYPE_CREDENTIALS, GearyCredentialsClass))

typedef struct _GearyCredentials GearyCredentials;
typedef struct _GearyCredentialsClass GearyCredentialsClass;

#define GEARY_TYPE_SERVICE_FLAG (geary_service_flag_get_type ())

#define GEARY_ACCOUNT_TYPE_PROBLEM (geary_account_problem_get_type ())
typedef struct _GearySmtpOutboxFolderDoPostmanAsyncData GearySmtpOutboxFolderDoPostmanAsyncData;
typedef struct _Block76Data Block76Data;
typedef struct _GearySmtpOutboxFolderGetEmailCountAsyncData GearySmtpOutboxFolderGetEmailCountAsyncData;
typedef struct _Block77Data Block77Data;
typedef struct _GearySmtpOutboxFolderEnqueueEmailAsyncData GearySmtpOutboxFolderEnqueueEmailAsyncData;
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))
typedef struct _GearySmtpOutboxFolderCreateEmailAsyncData GearySmtpOutboxFolderCreateEmailAsyncData;
typedef struct _Block78Data Block78Data;
typedef struct _GearySmtpOutboxFolderListEmailByIdAsyncData GearySmtpOutboxFolderListEmailByIdAsyncData;
typedef struct _Block79Data Block79Data;
typedef struct _GearySmtpOutboxFolderListEmailBySparseIdAsyncData GearySmtpOutboxFolderListEmailBySparseIdAsyncData;
typedef struct _Block80Data Block80Data;

#define GEARY_DB_TYPE_RESET_SCOPE (geary_db_reset_scope_get_type ())
typedef struct _GearySmtpOutboxFolderListLocalEmailFieldsAsyncData GearySmtpOutboxFolderListLocalEmailFieldsAsyncData;
typedef struct _Block81Data Block81Data;
typedef struct _GearySmtpOutboxFolderFetchEmailAsyncData GearySmtpOutboxFolderFetchEmailAsyncData;
typedef struct _Block82Data Block82Data;

#define GEARY_TYPE_NAMED_FLAG (geary_named_flag_get_type ())
#define GEARY_NAMED_FLAG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GEARY_TYPE_NAMED_FLAG, GearyNamedFlag))
#define GEARY_NAMED_FLAG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GEARY_TYPE_NAMED_FLAG, GearyNamedFlagClass))
#define GEARY_IS_NAMED_FLAG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GEARY_TYPE_NAMED_FLAG))
#define GEARY_IS_NAMED_FLAG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GEARY_TYPE_NAMED_FLAG))
#define GEARY_NAMED_FLAG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GEARY_TYPE_NAMED_FLAG, GearyNamedFlagClass))

typedef struct _GearyNamedFlag GearyNamedFlag;
typedef struct _GearyNamedFlagClass GearyNamedFlagClass;
typedef struct _GearySmtpOutboxFolderMarkEmailAsSentAsyncData GearySmtpOutboxFolderMarkEmailAsSentAsyncData;
typedef struct _GearySmtpOutboxFolderRemoveEmailAsyncData GearySmtpOutboxFolderRemoveEmailAsyncData;
typedef struct _Block83Data Block83Data;
typedef struct _GearySmtpOutboxFolderInternalRemoveEmailAsyncData GearySmtpOutboxFolderInternalRemoveEmailAsyncData;
typedef struct _GearySmtpOutboxFolderRemoveSingleEmailAsyncData GearySmtpOutboxFolderRemoveSingleEmailAsyncData;

#define GEARY_TYPE_EMAIL_PROPERTIES (geary_email_properties_get_type ())
#define GEARY_EMAIL_PROPERTIES(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GEARY_TYPE_EMAIL_PROPERTIES, GearyEmailProperties))
#define GEARY_EMAIL_PROPERTIES_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GEARY_TYPE_EMAIL_PROPERTIES, GearyEmailPropertiesClass))
#define GEARY_IS_EMAIL_PROPERTIES(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GEARY_TYPE_EMAIL_PROPERTIES))
#define GEARY_IS_EMAIL_PROPERTIES_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GEARY_TYPE_EMAIL_PROPERTIES))
#define GEARY_EMAIL_PROPERTIES_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GEARY_TYPE_EMAIL_PROPERTIES, GearyEmailPropertiesClass))

typedef struct _GearyEmailProperties GearyEmailProperties;
typedef struct _GearyEmailPropertiesClass GearyEmailPropertiesClass;

#define GEARY_TYPE_SMTP_OUTBOX_EMAIL_PROPERTIES (geary_smtp_outbox_email_properties_get_type ())
#define GEARY_SMTP_OUTBOX_EMAIL_PROPERTIES(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GEARY_TYPE_SMTP_OUTBOX_EMAIL_PROPERTIES, GearySmtpOutboxEmailProperties))
#define GEARY_SMTP_OUTBOX_EMAIL_PROPERTIES_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GEARY_TYPE_SMTP_OUTBOX_EMAIL_PROPERTIES, GearySmtpOutboxEmailPropertiesClass))
#define GEARY_IS_SMTP_OUTBOX_EMAIL_PROPERTIES(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GEARY_TYPE_SMTP_OUTBOX_EMAIL_PROPERTIES))
#define GEARY_IS_SMTP_OUTBOX_EMAIL_PROPERTIES_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GEARY_TYPE_SMTP_OUTBOX_EMAIL_PROPERTIES))
#define GEARY_SMTP_OUTBOX_EMAIL_PROPERTIES_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GEARY_TYPE_SMTP_OUTBOX_EMAIL_PROPERTIES, GearySmtpOutboxEmailPropertiesClass))

typedef struct _GearySmtpOutboxEmailProperties GearySmtpOutboxEmailProperties;
typedef struct _GearySmtpOutboxEmailPropertiesClass GearySmtpOutboxEmailPropertiesClass;

#define GEARY_SMTP_TYPE_RESPONSE (geary_smtp_response_get_type ())
#define GEARY_SMTP_RESPONSE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GEARY_SMTP_TYPE_RESPONSE, GearySmtpResponse))
#define GEARY_SMTP_RESPONSE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GEARY_SMTP_TYPE_RESPONSE, GearySmtpResponseClass))
#define GEARY_SMTP_IS_RESPONSE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GEARY_SMTP_TYPE_RESPONSE))
#define GEARY_SMTP_IS_RESPONSE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GEARY_SMTP_TYPE_RESPONSE))
#define GEARY_SMTP_RESPONSE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GEARY_SMTP_TYPE_RESPONSE, GearySmtpResponseClass))

typedef struct _GearySmtpResponse GearySmtpResponse;
typedef struct _GearySmtpResponseClass GearySmtpResponseClass;

#define GEARY_SMTP_TYPE_GREETING (geary_smtp_greeting_get_type ())
#define GEARY_SMTP_GREETING(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GEARY_SMTP_TYPE_GREETING, GearySmtpGreeting))
#define GEARY_SMTP_GREETING_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GEARY_SMTP_TYPE_GREETING, GearySmtpGreetingClass))
#define GEARY_SMTP_IS_GREETING(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GEARY_SMTP_TYPE_GREETING))
#define GEARY_SMTP_IS_GREETING_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GEARY_SMTP_TYPE_GREETING))
#define GEARY_SMTP_GREETING_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GEARY_SMTP_TYPE_GREETING, GearySmtpGreetingClass))

typedef struct _GearySmtpGreeting GearySmtpGreeting;
typedef struct _GearySmtpGreetingClass GearySmtpGreetingClass;
#define _geary_smtp_response_unref0(var) ((var == NULL) ? NULL : (var = (geary_smtp_response_unref (var), NULL)))

#define GEARY_RF_C822_TYPE_MAILBOX_ADDRESS (geary_rf_c822_mailbox_address_get_type ())
#define GEARY_RF_C822_MAILBOX_ADDRESS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GEARY_RF_C822_TYPE_MAILBOX_ADDRESS, GearyRFC822MailboxAddress))
#define GEARY_RF_C822_MAILBOX_ADDRESS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GEARY_RF_C822_TYPE_MAILBOX_ADDRESS, GearyRFC822MailboxAddressClass))
#define GEARY_RF_C822_IS_MAILBOX_ADDRESS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GEARY_RF_C822_TYPE_MAILBOX_ADDRESS))
#define GEARY_RF_C822_IS_MAILBOX_ADDRESS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GEARY_RF_C822_TYPE_MAILBOX_ADDRESS))
#define GEARY_RF_C822_MAILBOX_ADDRESS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GEARY_RF_C822_TYPE_MAILBOX_ADDRESS, GearyRFC822MailboxAddressClass))

typedef struct _GearyRFC822MailboxAddress GearyRFC822MailboxAddress;
typedef struct _GearyRFC822MailboxAddressClass GearyRFC822MailboxAddressClass;
typedef struct _GearySmtpOutboxFolderSendEmailAsyncData GearySmtpOutboxFolderSendEmailAsyncData;
typedef struct _GearySmtpOutboxFolderSaveSentMailAsyncData GearySmtpOutboxFolderSaveSentMailAsyncData;
typedef struct _Block84Data Block84Data;
typedef struct _GearySmtpOutboxFolderIsUnsentAsyncData GearySmtpOutboxFolderIsUnsentAsyncData;
typedef struct _GearySmtpOutboxFolderParamSpecOutboxRow GearySmtpOutboxFolderParamSpecOutboxRow;
enum  {
	GEARY_SMTP_OUTBOX_FOLDER_REPORT_PROBLEM_SIGNAL,
	GEARY_SMTP_OUTBOX_FOLDER_EMAIL_SENT_SIGNAL,
	GEARY_SMTP_OUTBOX_FOLDER_NUM_SIGNALS
};
static guint geary_smtp_outbox_folder_signals[GEARY_SMTP_OUTBOX_FOLDER_NUM_SIGNALS] = {0};
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _GearyBaseObject {
	GObject parent_instance;
	GearyBaseObjectPrivate * priv;
};

struct _GearyBaseObjectClass {
	GObjectClass parent_class;
};

typedef enum  {
	GEARY_FOLDER_OPEN_STATE_CLOSED,
	GEARY_FOLDER_OPEN_STATE_OPENING,
	GEARY_FOLDER_OPEN_STATE_REMOTE,
	GEARY_FOLDER_OPEN_STATE_LOCAL,
	GEARY_FOLDER_OPEN_STATE_BOTH
} GearyFolderOpenState;

typedef enum  {
	GEARY_FOLDER_OPEN_FAILED_LOCAL_FAILED,
	GEARY_FOLDER_OPEN_FAILED_REMOTE_FAILED,
	GEARY_FOLDER_OPEN_FAILED_CANCELLED
} GearyFolderOpenFailed;

typedef enum  {
	GEARY_FOLDER_CLOSE_REASON_LOCAL_CLOSE,
	GEARY_FOLDER_CLOSE_REASON_LOCAL_ERROR,
	GEARY_FOLDER_CLOSE_REASON_REMOTE_CLOSE,
	GEARY_FOLDER_CLOSE_REASON_REMOTE_ERROR,
	GEARY_FOLDER_CLOSE_REASON_FOLDER_CLOSED
} GearyFolderCloseReason;

typedef enum  {
	GEARY_FOLDER_COUNT_CHANGE_REASON_NONE = 0,
	GEARY_FOLDER_COUNT_CHANGE_REASON_APPENDED = 1 << 0,
	GEARY_FOLDER_COUNT_CHANGE_REASON_INSERTED = 1 << 1,
	GEARY_FOLDER_COUNT_CHANGE_REASON_REMOVED = 1 << 2
} GearyFolderCountChangeReason;

typedef enum  {
	GEARY_SPECIAL_FOLDER_TYPE_NONE,
	GEARY_SPECIAL_FOLDER_TYPE_INBOX,
	GEARY_SPECIAL_FOLDER_TYPE_SEARCH,
	GEARY_SPECIAL_FOLDER_TYPE_DRAFTS,
	GEARY_SPECIAL_FOLDER_TYPE_SENT,
	GEARY_SPECIAL_FOLDER_TYPE_FLAGGED,
	GEARY_SPECIAL_FOLDER_TYPE_IMPORTANT,
	GEARY_SPECIAL_FOLDER_TYPE_ALL_MAIL,
	GEARY_SPECIAL_FOLDER_TYPE_SPAM,
	GEARY_SPECIAL_FOLDER_TYPE_TRASH,
	GEARY_SPECIAL_FOLDER_TYPE_OUTBOX,
	GEARY_SPECIAL_FOLDER_TYPE_ARCHIVE
} GearySpecialFolderType;

typedef enum  {
	GEARY_FOLDER_OPEN_FLAGS_NONE = 0,
	GEARY_FOLDER_OPEN_FLAGS_FAST_OPEN = 1 << 0,
	GEARY_FOLDER_OPEN_FLAGS_NO_DELAY = 1 << 1
} GearyFolderOpenFlags;

typedef enum  {
	GEARY_EMAIL_FIELD_NONE = 0,
	GEARY_EMAIL_FIELD_DATE = 1 << 0,
	GEARY_EMAIL_FIELD_ORIGINATORS = 1 << 1,
	GEARY_EMAIL_FIELD_RECEIVERS = 1 << 2,
	GEARY_EMAIL_FIELD_REFERENCES = 1 << 3,
	GEARY_EMAIL_FIELD_SUBJECT = 1 << 4,
	GEARY_EMAIL_FIELD_HEADER = 1 << 5,
	GEARY_EMAIL_FIELD_BODY = 1 << 6,
	GEARY_EMAIL_FIELD_PROPERTIES = 1 << 7,
	GEARY_EMAIL_FIELD_PREVIEW = 1 << 8,
	GEARY_EMAIL_FIELD_FLAGS = 1 << 9,
	GEARY_EMAIL_FIELD_ENVELOPE = (((GEARY_EMAIL_FIELD_DATE | GEARY_EMAIL_FIELD_ORIGINATORS) | GEARY_EMAIL_FIELD_RECEIVERS) | GEARY_EMAIL_FIELD_REFERENCES) | GEARY_EMAIL_FIELD_SUBJECT,
	GEARY_EMAIL_FIELD_ALL = ((((((((GEARY_EMAIL_FIELD_DATE | GEARY_EMAIL_FIELD_ORIGINATORS) | GEARY_EMAIL_FIELD_RECEIVERS) | GEARY_EMAIL_FIELD_REFERENCES) | GEARY_EMAIL_FIELD_SUBJECT) | GEARY_EMAIL_FIELD_HEADER) | GEARY_EMAIL_FIELD_BODY) | GEARY_EMAIL_FIELD_PROPERTIES) | GEARY_EMAIL_FIELD_PREVIEW) | GEARY_EMAIL_FIELD_FLAGS
} GearyEmailField;

typedef enum  {
	GEARY_FOLDER_LIST_FLAGS_NONE = 0,
	GEARY_FOLDER_LIST_FLAGS_LOCAL_ONLY = 1 << 0,
	GEARY_FOLDER_LIST_FLAGS_FORCE_UPDATE = 1 << 1,
	GEARY_FOLDER_LIST_FLAGS_INCLUDING_ID = 1 << 2,
	GEARY_FOLDER_LIST_FLAGS_OLDEST_TO_NEWEST = 1 << 3
} GearyFolderListFlags;

struct _GearyFolder {
	GearyBaseObject parent_instance;
	GearyFolderPrivate * priv;
};

struct _GearyFolderClass {
	GearyBaseObjectClass parent_class;
	void (*notify_opened) (GearyFolder* self, GearyFolderOpenState state, gint count);
	void (*notify_open_failed) (GearyFolder* self, GearyFolderOpenFailed failure, GError* err);
	void (*notify_closed) (GearyFolder* self, GearyFolderCloseReason reason);
	void (*notify_email_appended) (GearyFolder* self, GeeCollection* ids);
	void (*notify_email_locally_appended) (GearyFolder* self, GeeCollection* ids);
	void (*notify_email_inserted) (GearyFolder* self, GeeCollection* ids);
	void (*notify_email_locally_inserted) (GearyFolder* self, GeeCollection* ids);
	void (*notify_email_removed) (GearyFolder* self, GeeCollection* ids);
	void (*notify_email_count_changed) (GearyFolder* self, gint new_count, GearyFolderCountChangeReason reason);
	void (*notify_email_flags_changed) (GearyFolder* self, GeeMap* flag_map);
	void (*notify_email_locally_complete) (GearyFolder* self, GeeCollection* ids);
	void (*notify_special_folder_type_changed) (GearyFolder* self, GearySpecialFolderType old_type, GearySpecialFolderType new_type);
	void (*notify_display_name_changed) (GearyFolder* self);
	gchar* (*get_display_name) (GearyFolder* self);
	GearyFolderOpenState (*get_open_state) (GearyFolder* self);
	void (*open_async) (GearyFolder* self, GearyFolderOpenFlags open_flags, GCancellable* cancellable, GAsyncReadyCallback _callback_, gpointer _user_data_);
	gboolean (*open_finish) (GearyFolder* self, GAsyncResult* _res_, GError** error);
	void (*wait_for_open_async) (GearyFolder* self, GCancellable* cancellable, GAsyncReadyCallback _callback_, gpointer _user_data_);
	void (*wait_for_open_finish) (GearyFolder* self, GAsyncResult* _res_, GError** error);
	void (*close_async) (GearyFolder* self, GCancellable* cancellable, GAsyncReadyCallback _callback_, gpointer _user_data_);
	gboolean (*close_finish) (GearyFolder* self, GAsyncResult* _res_, GError** error);
	void (*wait_for_close_async) (GearyFolder* self, GCancellable* cancellable, GAsyncReadyCallback _callback_, gpointer _user_data_);
	void (*wait_for_close_finish) (GearyFolder* self, GAsyncResult* _res_, GError** error);
	void (*find_boundaries_async) (GearyFolder* self, GeeCollection* ids, GCancellable* cancellable, GAsyncReadyCallback _callback_, gpointer _user_data_);
	void (*find_boundaries_finish) (GearyFolder* self, GAsyncResult* _res_, GearyEmailIdentifier* * low, GearyEmailIdentifier* * high, GError** error);
	void (*list_email_by_id_async) (GearyFolder* self, GearyEmailIdentifier* initial_id, gint count, GearyEmailField required_fields, GearyFolderListFlags flags, GCancellable* cancellable, GAsyncReadyCallback _callback_, gpointer _user_data_);
	GeeList* (*list_email_by_id_finish) (GearyFolder* self, GAsyncResult* _res_, GError** error);
	void (*list_email_by_sparse_id_async) (GearyFolder* self, GeeCollection* ids, GearyEmailField required_fields, GearyFolderListFlags flags, GCancellable* cancellable, GAsyncReadyCallback _callback_, gpointer _user_data_);
	GeeList* (*list_email_by_sparse_id_finish) (GearyFolder* self, GAsyncResult* _res_, GError** error);
	void (*list_local_email_fields_async) (GearyFolder* self, GeeCollection* ids, GCancellable* cancellable, GAsyncReadyCallback _callback_, gpointer _user_data_);
	GeeMap* (*list_local_email_fields_finish) (GearyFolder* self, GAsyncResult* _res_, GError** error);
	void (*fetch_email_async) (GearyFolder* self, GearyEmailIdentifier* email_id, GearyEmailField required_fields, GearyFolderListFlags flags, GCancellable* cancellable, GAsyncReadyCallback _callback_, gpointer _user_data_);
	GearyEmail* (*fetch_email_finish) (GearyFolder* self, GAsyncResult* _res_, GError** error);
	gchar* (*to_string) (GearyFolder* self);
	GearyAccount* (*get_account) (GearyFolder* self);
	GearyFolderProperties* (*get_properties) (GearyFolder* self);
	GearyFolderPath* (*get_path) (GearyFolder* self);
	GearySpecialFolderType (*get_special_folder_type) (GearyFolder* self);
	GearyProgressMonitor* (*get_opening_monitor) (GearyFolder* self);
};

struct _GearyAbstractLocalFolder {
	GearyFolder parent_instance;
	GearyAbstractLocalFolderPrivate * priv;
};

struct _GearyAbstractLocalFolderClass {
	GearyFolderClass parent_class;
};

struct _GearyFolderSupportRemoveIface {
	GTypeInterface parent_iface;
	void (*remove_email_async) (GearyFolderSupportRemove* self, GeeList* email_ids, GCancellable* cancellable, GAsyncReadyCallback _callback_, gpointer _user_data_);
	void (*remove_email_finish) (GearyFolderSupportRemove* self, GAsyncResult* _res_, GError** error);
};

struct _GearyFolderSupportCreateIface {
	GTypeInterface parent_iface;
	void (*create_email_async) (GearyFolderSupportCreate* self, GearyRFC822Message* rfc822, GearyEmailFlags* flags, GDateTime* date_received, GearyEmailIdentifier* id, GCancellable* cancellable, GAsyncReadyCallback _callback_, gpointer _user_data_);
	GearyEmailIdentifier* (*create_email_finish) (GearyFolderSupportCreate* self, GAsyncResult* _res_, GError** error);
};

struct _GearySmtpOutboxFolder {
	GearyAbstractLocalFolder parent_instance;
	GearySmtpOutboxFolderPrivate * priv;
};

struct _GearySmtpOutboxFolderClass {
	GearyAbstractLocalFolderClass parent_class;
	void (*create_email_async) (GearySmtpOutboxFolder* self, GearyRFC822Message* rfc822, GearyEmailFlags* flags, GDateTime* date_received, GearyEmailIdentifier* id, GCancellable* cancellable, GAsyncReadyCallback _callback_, gpointer _user_data_);
	GearyEmailIdentifier* (*create_email_finish) (GearySmtpOutboxFolder* self, GAsyncResult* _res_, GError** error);
	void (*remove_email_async) (GearySmtpOutboxFolder* self, GeeList* email_ids, GCancellable* cancellable, GAsyncReadyCallback _callback_, gpointer _user_data_);
	void (*remove_email_finish) (GearySmtpOutboxFolder* self, GAsyncResult* _res_, GError** error);
	void (*remove_single_email_async) (GearySmtpOutboxFolder* self, GearyEmailIdentifier* id, GCancellable* cancellable, GAsyncReadyCallback _callback_, gpointer _user_data_);
	void (*remove_single_email_finish) (GearySmtpOutboxFolder* self, GAsyncResult* _res_, GError** error);
};

struct _GearySmtpOutboxFolderPrivate {
	GearySmtpOutboxFolderRoot* _path;
	GearyImapDBDatabase* db;
	GearyAccount* _account;
	GearyProgressMonitor* sending_monitor;
	GearySmtpClientSession* smtp;
	GearyNonblockingMailbox* outbox_queue;
	GearySmtpOutboxFolderProperties* _properties;
	gint64 next_ordering;
	GRecMutex __lock_next_ordering;
};

struct _Block73Data {
	int _ref_count_;
	GearySmtpOutboxFolder* self;
	GearySmtpOutboxEmailIdentifier* outbox_low;
	GearySmtpOutboxEmailIdentifier* outbox_high;
	GeeCollection* ids;
	GCancellable* cancellable;
	gpointer _async_data_;
};

typedef enum  {
	GEARY_DB_TRANSACTION_TYPE_DEFERRED,
	GEARY_DB_TRANSACTION_TYPE_IMMEDIATE,
	GEARY_DB_TRANSACTION_TYPE_EXCLUSIVE,
	GEARY_DB_TRANSACTION_TYPE_RO = GEARY_DB_TRANSACTION_TYPE_DEFERRED,
	GEARY_DB_TRANSACTION_TYPE_RW = GEARY_DB_TRANSACTION_TYPE_IMMEDIATE,
	GEARY_DB_TRANSACTION_TYPE_WR = GEARY_DB_TRANSACTION_TYPE_EXCLUSIVE,
	GEARY_DB_TRANSACTION_TYPE_WO = GEARY_DB_TRANSACTION_TYPE_EXCLUSIVE
} GearyDbTransactionType;

typedef enum  {
	GEARY_DB_TRANSACTION_OUTCOME_ROLLBACK = 0,
	GEARY_DB_TRANSACTION_OUTCOME_COMMIT = 1,
	GEARY_DB_TRANSACTION_OUTCOME_SUCCESS = GEARY_DB_TRANSACTION_OUTCOME_COMMIT,
	GEARY_DB_TRANSACTION_OUTCOME_FAILURE = GEARY_DB_TRANSACTION_OUTCOME_ROLLBACK,
	GEARY_DB_TRANSACTION_OUTCOME_DONE = GEARY_DB_TRANSACTION_OUTCOME_COMMIT
} GearyDbTransactionOutcome;

typedef GearyDbTransactionOutcome (*GearyDbTransactionMethod) (GearyDbConnection* cx, GCancellable* cancellable, void* user_data, GError** error);
struct _GearySmtpOutboxFolderFindBoundariesAsyncData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GAsyncReadyCallback _callback_;
	gboolean _task_complete_;
	GearySmtpOutboxFolder* self;
	GeeCollection* ids;
	GearyEmailIdentifier* low;
	GearyEmailIdentifier* high;
	GCancellable* cancellable;
	Block73Data* _data73_;
	GearyImapDBDatabase* _tmp0_;
	GearyEmailIdentifier* _tmp1_;
	GearyEmailIdentifier* _tmp2_;
	GError * _inner_error_;
};

struct _Block74Data {
	int _ref_count_;
	GearySmtpOutboxFolder* self;
	GeeCollection* ids;
	GeeHashMultiMap* map;
	gpointer _async_data_;
};

struct _GearySmtpOutboxFolderAddToContainingFoldersAsyncData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GAsyncReadyCallback _callback_;
	gboolean _task_complete_;
	GearySmtpOutboxFolder* self;
	GeeCollection* ids;
	GeeHashMultiMap* map;
	GCancellable* cancellable;
	Block74Data* _data74_;
	GearyImapDBDatabase* _tmp0_;
	GError * _inner_error_;
};

struct _Block75Data {
	int _ref_count_;
	GearySmtpOutboxFolder* self;
	GeeArrayList* list;
};

typedef enum  {
	GEARY_DATABASE_ERROR_GENERAL,
	GEARY_DATABASE_ERROR_OPEN_REQUIRED,
	GEARY_DATABASE_ERROR_BUSY,
	GEARY_DATABASE_ERROR_CORRUPT,
	GEARY_DATABASE_ERROR_ACCESS,
	GEARY_DATABASE_ERROR_MEMORY,
	GEARY_DATABASE_ERROR_ABORT,
	GEARY_DATABASE_ERROR_INTERRUPT,
	GEARY_DATABASE_ERROR_LIMITS,
	GEARY_DATABASE_ERROR_TYPESPEC,
	GEARY_DATABASE_ERROR_FINISHED,
	GEARY_DATABASE_ERROR_SCHEMA_VERSION
} GearyDatabaseError;
#define GEARY_DATABASE_ERROR geary_database_error_quark ()
struct _GearySmtpOutboxFolderFillOutboxQueueData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GAsyncReadyCallback _callback_;
	gboolean _task_complete_;
	GearySmtpOutboxFolder* self;
	Block75Data* _data75_;
	GeeArrayList* _tmp0_;
	GearyImapDBDatabase* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	GearySmtpOutboxFolderProperties* _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
	gint _tmp7_;
	gint _tmp8_;
	GeeArrayList* _row_list;
	GeeArrayList* _tmp9_;
	gint _row_size;
	GeeArrayList* _tmp10_;
	gint _tmp11_;
	gint _tmp12_;
	gint _row_index;
	gint _tmp13_;
	gint _tmp14_;
	gint _tmp15_;
	GearySmtpOutboxFolderOutboxRow* row;
	GeeArrayList* _tmp16_;
	gint _tmp17_;
	gpointer _tmp18_;
	GearyNonblockingMailbox* _tmp19_;
	GearySmtpOutboxFolderOutboxRow* _tmp20_;
	GError* prime_err;
	GError* _tmp21_;
	const gchar* _tmp22_;
	GError * _inner_error_;
};

struct _GearySmtpOutboxFolderOutboxRow {
	GTypeInstance parent_instance;
	volatile int ref_count;
	GearySmtpOutboxFolderOutboxRowPrivate * priv;
	gint64 id;
	gint position;
	gint64 ordering;
	gboolean sent;
	GearyMemoryBuffer* message;
	GearySmtpOutboxEmailIdentifier* outbox_id;
};

struct _GearySmtpOutboxFolderOutboxRowClass {
	GTypeClass parent_class;
	void (*finalize) (GearySmtpOutboxFolderOutboxRow *self);
};

typedef enum  {
	GEARY_RF_C822_ERROR_INVALID,
	GEARY_RF_C822_ERROR_NOT_FOUND,
	GEARY_RF_C822_ERROR_FAILED
} GearyRFC822Error;
#define GEARY_RF_C822_ERROR geary_rf_c822_error_quark ()
typedef enum  {
	GEARY_SERVICE_FLAG_IMAP = 1 << 0,
	GEARY_SERVICE_FLAG_SMTP = 1 << 1
} GearyServiceFlag;

typedef enum  {
	GEARY_SMTP_ERROR_PARSE_ERROR,
	GEARY_SMTP_ERROR_STARTTLS_FAILED,
	GEARY_SMTP_ERROR_AUTHENTICATION_FAILED,
	GEARY_SMTP_ERROR_SERVER_ERROR,
	GEARY_SMTP_ERROR_ALREADY_CONNECTED,
	GEARY_SMTP_ERROR_NOT_CONNECTED,
	GEARY_SMTP_ERROR_REQUIRED_FIELD,
	GEARY_SMTP_ERROR_NOT_SUPPORTED
} GearySmtpError;
#define GEARY_SMTP_ERROR geary_smtp_error_quark ()
typedef enum  {
	GEARY_ACCOUNT_PROBLEM_RECV_EMAIL_LOGIN_FAILED,
	GEARY_ACCOUNT_PROBLEM_SEND_EMAIL_LOGIN_FAILED,
	GEARY_ACCOUNT_PROBLEM_HOST_UNREACHABLE,
	GEARY_ACCOUNT_PROBLEM_NETWORK_UNAVAILABLE,
	GEARY_ACCOUNT_PROBLEM_DATABASE_FAILURE,
	GEARY_ACCOUNT_PROBLEM_EMAIL_DELIVERY_FAILURE,
	GEARY_ACCOUNT_PROBLEM_SAVE_SENT_MAIL_FAILED,
	GEARY_ACCOUNT_PROBLEM_CONNECTION_FAILURE
} GearyAccountProblem;

struct _GearySmtpOutboxFolderDoPostmanAsyncData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GAsyncReadyCallback _callback_;
	gboolean _task_complete_;
	GearySmtpOutboxFolder* self;
	guint send_retry_seconds;
	gboolean _tmp0_;
	GearySmtpOutboxFolderOutboxRow* row;
	gboolean mail_sent;
	GearySmtpOutboxFolderOutboxRow* _tmp1_;
	GearyNonblockingMailbox* _tmp2_;
	gpointer _tmp3_;
	GearySmtpOutboxFolderOutboxRow* _tmp4_;
	gboolean _tmp5_;
	GearySmtpOutboxFolderOutboxRow* _tmp6_;
	gint64 _tmp7_;
	GError* wait_err;
	const gchar* _tmp8_;
	GearyRFC822Message* message;
	GearyRFC822Message* _tmp9_;
	GearySmtpOutboxFolderOutboxRow* _tmp10_;
	GearyMemoryBuffer* _tmp11_;
	GearyRFC822Message* _tmp12_;
	GearyRFC822Message* _tmp13_;
	GError* msg_err;
	GError* _tmp14_;
	const gchar* _tmp15_;
	gboolean _tmp16_;
	gboolean _tmp17_;
	GearyAccount* _tmp18_;
	GearyAccountInformation* _tmp19_;
	GearyAccountInformation* _tmp20_;
	GearyCredentials* _tmp21_;
	GearyCredentials* _tmp22_;
	GearyAccount* _tmp23_;
	GearyAccountInformation* _tmp24_;
	GearyAccountInformation* _tmp25_;
	GearyCredentials* _tmp26_;
	GearyCredentials* _tmp27_;
	GearyAccount* _tmp28_;
	GearyAccountInformation* _tmp29_;
	GearyAccountInformation* _tmp30_;
	GError* e;
	GError* _tmp31_;
	const gchar* _tmp32_;
	gboolean should_nap;
	GearyAccount* _tmp33_;
	GearyAccountInformation* _tmp34_;
	GearyAccountInformation* _tmp35_;
	GearyEndpoint* _tmp36_;
	GearyEndpoint* _tmp37_;
	gboolean _tmp38_;
	gboolean _tmp39_;
	gboolean _tmp40_;
	GearyRFC822Message* _tmp41_;
	gchar* _tmp42_;
	gchar* _tmp43_;
	GearySmtpOutboxFolderOutboxRow* _tmp44_;
	GearySmtpOutboxEmailIdentifier* _tmp45_;
	gchar* _tmp46_;
	gchar* _tmp47_;
	GearyRFC822Message* _tmp48_;
	GearyNonblockingMailbox* _tmp49_;
	GearySmtpOutboxFolderOutboxRow* _tmp50_;
	GError* send_err;
	GError* _tmp51_;
	const gchar* _tmp52_;
	GError* _tmp53_;
	gboolean report;
	gboolean _tmp54_;
	GearyAccount* _tmp55_;
	GearyAccountInformation* _tmp56_;
	GearyAccountInformation* _tmp57_;
	GError* _vala1_e;
	GError* _tmp58_;
	const gchar* _tmp59_;
	gboolean _tmp60_;
	GError* _tmp61_;
	GError* _tmp62_;
	GearyAccount* _tmp63_;
	GearyAccountInformation* _tmp64_;
	GearyAccountInformation* _tmp65_;
	GearyEndpoint* _tmp66_;
	GearyEndpoint* _tmp67_;
	gchar* _tmp68_;
	gchar* _tmp69_;
	GError* _tmp70_;
	gboolean _tmp71_;
	guint _tmp72_;
	guint _tmp73_;
	guint _tmp74_;
	gboolean _tmp75_;
	GearySmtpOutboxFolderOutboxRow* _tmp76_;
	GearySmtpOutboxEmailIdentifier* _tmp77_;
	gchar* _tmp78_;
	gchar* _tmp79_;
	GearySmtpOutboxFolderOutboxRow* _tmp80_;
	GearySmtpOutboxEmailIdentifier* _tmp81_;
	GError* _vala2_e;
	GError* _tmp82_;
	const gchar* _tmp83_;
	gboolean _tmp84_;
	GearyNonblockingMailbox* _tmp85_;
	GearySmtpOutboxFolderOutboxRow* _tmp86_;
	gboolean mail_saved;
	gboolean _tmp87_;
	GearyAccount* _tmp88_;
	GearyAccountInformation* _tmp89_;
	GearyAccountInformation* _tmp90_;
	GearyAccount* _tmp91_;
	GearyAccountInformation* _tmp92_;
	GearyAccountInformation* _tmp93_;
	gboolean _tmp94_;
	gboolean _tmp95_;
	GearySmtpOutboxFolderOutboxRow* _tmp96_;
	GearySmtpOutboxEmailIdentifier* _tmp97_;
	gchar* _tmp98_;
	gchar* _tmp99_;
	GearyRFC822Message* _tmp100_;
	GError* _vala3_e;
	GError* _tmp101_;
	const gchar* _tmp102_;
	GError* _tmp103_;
	gboolean _tmp104_;
	GearyNonblockingMailbox* _tmp105_;
	GearySmtpOutboxFolderOutboxRow* _tmp106_;
	GearySmtpOutboxFolderOutboxRow* _tmp107_;
	GearySmtpOutboxEmailIdentifier* _tmp108_;
	gchar* _tmp109_;
	gchar* _tmp110_;
	GeeArrayList* list;
	GeeArrayList* _tmp111_;
	GeeArrayList* _tmp112_;
	GearySmtpOutboxFolderOutboxRow* _tmp113_;
	GearySmtpOutboxEmailIdentifier* _tmp114_;
	GeeArrayList* _tmp115_;
	GError* _vala4_e;
	GError* _tmp116_;
	const gchar* _tmp117_;
	GError * _inner_error_;
};

struct _Block76Data {
	int _ref_count_;
	GearySmtpOutboxFolder* self;
	gint count;
	GCancellable* cancellable;
	gpointer _async_data_;
};

struct _GearySmtpOutboxFolderGetEmailCountAsyncData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GAsyncReadyCallback _callback_;
	gboolean _task_complete_;
	GearySmtpOutboxFolder* self;
	GCancellable* cancellable;
	gint result;
	Block76Data* _data76_;
	GearyImapDBDatabase* _tmp0_;
	GError * _inner_error_;
};

struct _Block77Data {
	int _ref_count_;
	GearySmtpOutboxFolder* self;
	gint email_count;
	GearySmtpOutboxFolderOutboxRow* row;
	GearyRFC822Message* rfc822;
	GCancellable* cancellable;
	gpointer _async_data_;
};

struct _GearySmtpOutboxFolderEnqueueEmailAsyncData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GAsyncReadyCallback _callback_;
	gboolean _task_complete_;
	GearySmtpOutboxFolder* self;
	GearyRFC822Message* rfc822;
	GCancellable* cancellable;
	GearySmtpOutboxEmailIdentifier* result;
	Block77Data* _data77_;
	GearyImapDBDatabase* _tmp0_;
	GearySmtpOutboxFolderOutboxRow* _tmp1_;
	gint _tmp2_;
	GearySmtpOutboxFolderProperties* _tmp3_;
	GearyNonblockingMailbox* _tmp4_;
	GearySmtpOutboxFolderOutboxRow* _tmp5_;
	GeeList* list;
	GeeArrayList* _tmp6_;
	GeeList* _tmp7_;
	GearySmtpOutboxFolderOutboxRow* _tmp8_;
	GearySmtpOutboxEmailIdentifier* _tmp9_;
	GeeList* _tmp10_;
	GeeList* _tmp11_;
	gint _tmp12_;
	GearySmtpOutboxFolderOutboxRow* _tmp13_;
	GearySmtpOutboxEmailIdentifier* _tmp14_;
	GearySmtpOutboxEmailIdentifier* _tmp15_;
	GError * _inner_error_;
};

typedef enum  {
	GEARY_ENGINE_ERROR_OPEN_REQUIRED,
	GEARY_ENGINE_ERROR_ALREADY_OPEN,
	GEARY_ENGINE_ERROR_ALREADY_EXISTS,
	GEARY_ENGINE_ERROR_NOT_FOUND,
	GEARY_ENGINE_ERROR_BAD_PARAMETERS,
	GEARY_ENGINE_ERROR_BAD_RESPONSE,
	GEARY_ENGINE_ERROR_INCOMPLETE_MESSAGE,
	GEARY_ENGINE_ERROR_SERVER_UNAVAILABLE,
	GEARY_ENGINE_ERROR_ALREADY_CLOSED,
	GEARY_ENGINE_ERROR_CLOSE_REQUIRED,
	GEARY_ENGINE_ERROR_CORRUPT,
	GEARY_ENGINE_ERROR_PERMISSIONS,
	GEARY_ENGINE_ERROR_VERSION,
	GEARY_ENGINE_ERROR_UNSUPPORTED
} GearyEngineError;
#define GEARY_ENGINE_ERROR geary_engine_error_quark ()
struct _GearySmtpOutboxFolderCreateEmailAsyncData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GAsyncReadyCallback _callback_;
	gboolean _task_complete_;
	GearySmtpOutboxFolder* self;
	GearyRFC822Message* rfc822;
	GearyEmailFlags* flags;
	GDateTime* date_received;
	GearyEmailIdentifier* id;
	GCancellable* cancellable;
	GearyEmailIdentifier* result;
	GearySmtpOutboxEmailIdentifier* _tmp0_;
	GearySmtpOutboxEmailIdentifier* _tmp1_;
	GearySmtpOutboxEmailIdentifier* _tmp2_;
	GError * _inner_error_;
};

struct _Block78Data {
	int _ref_count_;
	GearySmtpOutboxFolder* self;
	GearySmtpOutboxEmailIdentifier* initial_id;
	GeeList* list;
	gint count;
	GearyFolderListFlags flags;
	GCancellable* cancellable;
	gpointer _async_data_;
};

struct _GearySmtpOutboxFolderListEmailByIdAsyncData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GAsyncReadyCallback _callback_;
	gboolean _task_complete_;
	GearySmtpOutboxFolder* self;
	GearyEmailIdentifier* _initial_id;
	gint count;
	GearyEmailField required_fields;
	GearyFolderListFlags flags;
	GCancellable* cancellable;
	GeeList* result;
	Block78Data* _data78_;
	GearySmtpOutboxEmailIdentifier* _tmp0_;
	gboolean _tmp1_;
	GearySmtpOutboxEmailIdentifier* _tmp2_;
	GearySmtpOutboxEmailIdentifier* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	GError* _tmp6_;
	GError* _tmp7_;
	GearyImapDBDatabase* _tmp8_;
	GeeList* _tmp9_;
	GeeList* _tmp10_;
	GError * _inner_error_;
};

struct _Block79Data {
	int _ref_count_;
	GearySmtpOutboxFolder* self;
	GeeList* list;
	GeeCollection* ids;
	GCancellable* cancellable;
	gpointer _async_data_;
};

struct _GearySmtpOutboxFolderListEmailBySparseIdAsyncData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GAsyncReadyCallback _callback_;
	gboolean _task_complete_;
	GearySmtpOutboxFolder* self;
	GeeCollection* ids;
	GearyEmailField required_fields;
	GearyFolderListFlags flags;
	GCancellable* cancellable;
	GeeList* result;
	Block79Data* _data79_;
	GeeArrayList* _tmp0_;
	GearyImapDBDatabase* _tmp1_;
	GeeList* _tmp2_;
	GeeList* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	GeeList* _tmp6_;
	GeeList* _tmp7_;
	GError * _inner_error_;
};

struct _Block80Data {
	int _ref_count_;
	GearySmtpOutboxFolder* self;
	GeeMap* map;
	GeeCollection* ids;
	GCancellable* cancellable;
	gpointer _async_data_;
};

typedef enum  {
	GEARY_DB_RESET_SCOPE_SAVE_BINDINGS,
	GEARY_DB_RESET_SCOPE_CLEAR_BINDINGS
} GearyDbResetScope;

struct _GearySmtpOutboxFolderListLocalEmailFieldsAsyncData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GAsyncReadyCallback _callback_;
	gboolean _task_complete_;
	GearySmtpOutboxFolder* self;
	GeeCollection* ids;
	GCancellable* cancellable;
	GeeMap* result;
	Block80Data* _data80_;
	GeeHashMap* _tmp0_;
	GearyImapDBDatabase* _tmp1_;
	GeeMap* _tmp2_;
	GeeMap* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	GeeMap* _tmp6_;
	GeeMap* _tmp7_;
	GError * _inner_error_;
};

struct _Block81Data {
	int _ref_count_;
	GearySmtpOutboxFolder* self;
	GearySmtpOutboxEmailIdentifier* outbox_id;
	GearySmtpOutboxFolderOutboxRow* row;
	GCancellable* cancellable;
	gpointer _async_data_;
};

struct _GearySmtpOutboxFolderFetchEmailAsyncData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GAsyncReadyCallback _callback_;
	gboolean _task_complete_;
	GearySmtpOutboxFolder* self;
	GearyEmailIdentifier* id;
	GearyEmailField required_fields;
	GearyFolderListFlags flags;
	GCancellable* cancellable;
	GearyEmail* result;
	Block81Data* _data81_;
	GearySmtpOutboxEmailIdentifier* _tmp0_;
	GearySmtpOutboxEmailIdentifier* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	GError* _tmp4_;
	GError* _tmp5_;
	GearyImapDBDatabase* _tmp6_;
	GearySmtpOutboxFolderOutboxRow* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	GError* _tmp10_;
	GError* _tmp11_;
	GearyEmail* _tmp12_;
	GearySmtpOutboxFolderOutboxRow* _tmp13_;
	GearyEmail* _tmp14_;
	GearyEmail* _tmp15_;
	GError * _inner_error_;
};

struct _Block82Data {
	int _ref_count_;
	GearySmtpOutboxFolder* self;
	GearySmtpOutboxEmailIdentifier* outbox_id;
	GCancellable* cancellable;
	gpointer _async_data_;
};

struct _GearySmtpOutboxFolderMarkEmailAsSentAsyncData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GAsyncReadyCallback _callback_;
	gboolean _task_complete_;
	GearySmtpOutboxFolder* self;
	GearySmtpOutboxEmailIdentifier* outbox_id;
	GCancellable* cancellable;
	Block82Data* _data82_;
	GearyImapDBDatabase* _tmp0_;
	GearyEmailFlags* flags;
	GearyEmailFlags* _tmp1_;
	GearyEmailFlags* _tmp2_;
	GearyNamedFlag* _tmp3_;
	GearyNamedFlag* _tmp4_;
	GearyNamedFlag* _tmp5_;
	GeeHashMap* changed_map;
	GeeHashMap* _tmp6_;
	GeeHashMap* _tmp7_;
	GearyEmailFlags* _tmp8_;
	GeeHashMap* _tmp9_;
	GError * _inner_error_;
};

struct _GearySmtpOutboxFolderRemoveEmailAsyncData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GAsyncReadyCallback _callback_;
	gboolean _task_complete_;
	GearySmtpOutboxFolder* self;
	GeeList* email_ids;
	GCancellable* cancellable;
	GError * _inner_error_;
};

struct _Block83Data {
	int _ref_count_;
	GearySmtpOutboxFolder* self;
	GeeList* removed;
	gint final_count;
	GeeList* email_ids;
	GCancellable* cancellable;
	gpointer _async_data_;
};

struct _GearySmtpOutboxFolderInternalRemoveEmailAsyncData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GAsyncReadyCallback _callback_;
	gboolean _task_complete_;
	GearySmtpOutboxFolder* self;
	GeeList* email_ids;
	GCancellable* cancellable;
	gboolean result;
	Block83Data* _data83_;
	GeeArrayList* _tmp0_;
	GearyImapDBDatabase* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	GearySmtpOutboxFolderProperties* _tmp4_;
	GError * _inner_error_;
};

struct _GearySmtpOutboxFolderRemoveSingleEmailAsyncData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GAsyncReadyCallback _callback_;
	gboolean _task_complete_;
	GearySmtpOutboxFolder* self;
	GearyEmailIdentifier* id;
	GCancellable* cancellable;
	GeeList* list;
	GeeArrayList* _tmp0_;
	GError * _inner_error_;
};

struct _GearySmtpOutboxFolderSendEmailAsyncData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GAsyncReadyCallback _callback_;
	gboolean _task_complete_;
	GearySmtpOutboxFolder* self;
	GearyRFC822Message* rfc822;
	GCancellable* cancellable;
	GearyProgressMonitor* _tmp0_;
	GError* smtp_err;
	GearySmtpClientSession* _tmp1_;
	GearyAccount* _tmp2_;
	GearyAccountInformation* _tmp3_;
	GearyAccountInformation* _tmp4_;
	GearyCredentials* _tmp5_;
	GearyCredentials* _tmp6_;
	GearySmtpGreeting* _tmp7_;
	GearySmtpGreeting* _tmp8_;
	GError* login_err;
	GError* _tmp9_;
	const gchar* _tmp10_;
	GError* _tmp11_;
	GError* _tmp12_;
	GError* _tmp13_;
	GearySmtpClientSession* _tmp14_;
	GearyAccount* _tmp15_;
	GearyAccountInformation* _tmp16_;
	GearyAccountInformation* _tmp17_;
	GearyRFC822MailboxAddress* _tmp18_;
	GearyRFC822MailboxAddress* _tmp19_;
	GError* send_err;
	GError* _tmp20_;
	const gchar* _tmp21_;
	GError* _tmp22_;
	GError* _tmp23_;
	GearySmtpClientSession* _tmp24_;
	GearySmtpResponse* _tmp25_;
	GearySmtpResponse* _tmp26_;
	GError* err;
	GearySmtpClientSession* _tmp27_;
	gchar* _tmp28_;
	gchar* _tmp29_;
	GError* _tmp30_;
	const gchar* _tmp31_;
	GearyProgressMonitor* _tmp32_;
	GError* _tmp33_;
	GError* _tmp34_;
	GError* _tmp35_;
	GError * _inner_error_;
};

struct _GearySmtpOutboxFolderSaveSentMailAsyncData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GAsyncReadyCallback _callback_;
	gboolean _task_complete_;
	GearySmtpOutboxFolder* self;
	GearyRFC822Message* rfc822;
	GCancellable* cancellable;
	GearyFolder* _tmp0_;
	GearyAccount* _tmp1_;
	GearyFolder* _tmp2_;
	GearyFolderSupportCreate* create;
	GearyFolderSupportCreate* _tmp3_;
	GearyFolderSupportCreate* _tmp4_;
	GError* _tmp5_;
	gboolean open;
	GearyFolderSupportCreate* _tmp6_;
	GearyFolderSupportCreate* _tmp7_;
	GearyEmailIdentifier* _tmp8_;
	GearyEmailIdentifier* _tmp9_;
	GearyFolderSupportCreate* _tmp10_;
	GError* e;
	gboolean _tmp11_;
	GearyFolderSupportCreate* _tmp12_;
	GError* _vala1_e;
	GearyFolderSupportCreate* _tmp13_;
	gchar* _tmp14_;
	gchar* _tmp15_;
	GError* _tmp16_;
	const gchar* _tmp17_;
	GError* _tmp18_;
	GError* _tmp19_;
	GError * _inner_error_;
};

struct _Block84Data {
	int _ref_count_;
	GearySmtpOutboxFolder* self;
	gboolean exists;
	gint64 ordering;
	GCancellable* cancellable;
	gpointer _async_data_;
};

struct _GearySmtpOutboxFolderIsUnsentAsyncData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GAsyncReadyCallback _callback_;
	gboolean _task_complete_;
	GearySmtpOutboxFolder* self;
	gint64 ordering;
	GCancellable* cancellable;
	gboolean result;
	Block84Data* _data84_;
	GearyImapDBDatabase* _tmp0_;
	GError * _inner_error_;
};

struct _GearySmtpOutboxFolderParamSpecOutboxRow {
	GParamSpec parent_instance;
};


static gpointer geary_smtp_outbox_folder_parent_class = NULL;
static gpointer geary_smtp_outbox_folder_outbox_row_parent_class = NULL;
static GearyFolderSupportRemoveIface * geary_smtp_outbox_folder_geary_folder_support_remove_parent_iface = NULL;
static GearyFolderSupportCreateIface * geary_smtp_outbox_folder_geary_folder_support_create_parent_iface = NULL;

GType geary_base_object_get_type (void) G_GNUC_CONST;
GType geary_folder_get_type (void) G_GNUC_CONST;
GType geary_folder_open_state_get_type (void) G_GNUC_CONST;
GType geary_folder_open_failed_get_type (void) G_GNUC_CONST;
GType geary_folder_close_reason_get_type (void) G_GNUC_CONST;
GType geary_email_identifier_get_type (void) G_GNUC_CONST;
GType geary_folder_count_change_reason_get_type (void) G_GNUC_CONST;
GType geary_named_flags_get_type (void) G_GNUC_CONST;
GType geary_email_flags_get_type (void) G_GNUC_CONST;
GType geary_special_folder_type_get_type (void) G_GNUC_CONST;
GType geary_folder_open_flags_get_type (void) G_GNUC_CONST;
GType geary_email_field_get_type (void) G_GNUC_CONST;
GType geary_folder_list_flags_get_type (void) G_GNUC_CONST;
GType geary_email_get_type (void) G_GNUC_CONST;
GType geary_account_get_type (void) G_GNUC_CONST;
GType geary_folder_properties_get_type (void) G_GNUC_CONST;
GType geary_folder_path_get_type (void) G_GNUC_CONST;
GType geary_progress_monitor_get_type (void) G_GNUC_CONST;
GType geary_abstract_local_folder_get_type (void) G_GNUC_CONST;
GType geary_folder_support_remove_get_type (void) G_GNUC_CONST;
GType geary_rf_c822_message_get_type (void) G_GNUC_CONST;
GType geary_folder_support_create_get_type (void) G_GNUC_CONST;
GType geary_smtp_outbox_folder_get_type (void) G_GNUC_CONST;
GType geary_folder_root_get_type (void) G_GNUC_CONST;
GType geary_smtp_outbox_folder_root_get_type (void) G_GNUC_CONST;
GType geary_db_context_get_type (void) G_GNUC_CONST;
GType geary_db_database_get_type (void) G_GNUC_CONST;
GType geary_db_versioned_database_get_type (void) G_GNUC_CONST;
GType geary_imap_db_database_get_type (void) G_GNUC_CONST;
gpointer geary_smtp_client_session_ref (gpointer instance);
void geary_smtp_client_session_unref (gpointer instance);
GParamSpec* geary_smtp_param_spec_client_session (const gchar* name,
                                                  const gchar* nick,
                                                  const gchar* blurb,
                                                  GType object_type,
                                                  GParamFlags flags);
void geary_smtp_value_set_client_session (GValue* value,
                                          gpointer v_object);
void geary_smtp_value_take_client_session (GValue* value,
                                           gpointer v_object);
gpointer geary_smtp_value_get_client_session (const GValue* value);
GType geary_smtp_client_session_get_type (void) G_GNUC_CONST;
GType geary_nonblocking_mailbox_get_type (void) G_GNUC_CONST;
static gpointer geary_smtp_outbox_folder_outbox_row_ref (gpointer instance);
static void geary_smtp_outbox_folder_outbox_row_unref (gpointer instance);
static GParamSpec* geary_smtp_outbox_folder_param_spec_outbox_row (const gchar* name,
                                                            const gchar* nick,
                                                            const gchar* blurb,
                                                            GType object_type,
                                                            GParamFlags flags) G_GNUC_UNUSED;
static void geary_smtp_outbox_folder_value_set_outbox_row (GValue* value,
                                                    gpointer v_object) G_GNUC_UNUSED;
static void geary_smtp_outbox_folder_value_take_outbox_row (GValue* value,
                                                     gpointer v_object) G_GNUC_UNUSED;
static gpointer geary_smtp_outbox_folder_value_get_outbox_row (const GValue* value) G_GNUC_UNUSED;
static GType geary_smtp_outbox_folder_outbox_row_get_type (void) G_GNUC_CONST G_GNUC_UNUSED;
GType geary_smtp_outbox_folder_properties_get_type (void) G_GNUC_CONST;
#define GEARY_SMTP_OUTBOX_FOLDER_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), GEARY_TYPE_SMTP_OUTBOX_FOLDER, GearySmtpOutboxFolderPrivate))
GearySmtpOutboxFolderRoot* geary_smtp_outbox_folder_root_new (void);
GearySmtpOutboxFolderRoot* geary_smtp_outbox_folder_root_construct (GType object_type);
GearyNonblockingMailbox* geary_nonblocking_mailbox_new (GType g_type,
                                                        GBoxedCopyFunc g_dup_func,
                                                        GDestroyNotify g_destroy_func,
                                                        GCompareDataFunc comparator,
                                                        void* comparator_target,
                                                        GDestroyNotify comparator_target_destroy_notify);
GearyNonblockingMailbox* geary_nonblocking_mailbox_construct (GType object_type,
                                                              GType g_type,
                                                              GBoxedCopyFunc g_dup_func,
                                                              GDestroyNotify g_destroy_func,
                                                              GCompareDataFunc comparator,
                                                              void* comparator_target,
                                                              GDestroyNotify comparator_target_destroy_notify);
GearySmtpOutboxFolderProperties* geary_smtp_outbox_folder_properties_new (gint total,
                                                                          gint unread);
GearySmtpOutboxFolderProperties* geary_smtp_outbox_folder_properties_construct (GType object_type,
                                                                                gint total,
                                                                                gint unread);
#define GEARY_SMTP_OUTBOX_FOLDER_MIN_SEND_RETRY_INTERVAL_SEC ((guint) 4)
#define GEARY_SMTP_OUTBOX_FOLDER_MAX_SEND_RETRY_INTERVAL_SEC ((guint) 64)
GearySmtpOutboxFolder* geary_smtp_outbox_folder_new (GearyImapDBDatabase* db,
                                                     GearyAccount* account,
                                                     GearyProgressMonitor* sending_monitor);
GearySmtpOutboxFolder* geary_smtp_outbox_folder_construct (GType object_type,
                                                           GearyImapDBDatabase* db,
                                                           GearyAccount* account,
                                                           GearyProgressMonitor* sending_monitor);
GearyAbstractLocalFolder* geary_abstract_local_folder_construct (GType object_type);
static void __lambda83_ (GearySmtpOutboxFolder* self);
static void geary_smtp_outbox_folder_fill_outbox_queue (GearySmtpOutboxFolder* self,
                                                 GAsyncReadyCallback _callback_,
                                                 gpointer _user_data_);
static void geary_smtp_outbox_folder_fill_outbox_queue_finish (GearySmtpOutboxFolder* self,
                                                        GAsyncResult* _res_);
static void ___lambda83__geary_account_opened (GearyAccount* _sender,
                                        gpointer self);
GType geary_account_information_get_type (void) G_GNUC_CONST;
GearyAccountInformation* geary_account_get_information (GearyAccount* self);
GType geary_endpoint_get_type (void) G_GNUC_CONST;
GearyEndpoint* geary_account_information_get_smtp_endpoint (GearyAccountInformation* self);
GearySmtpClientSession* geary_smtp_client_session_new (GearyEndpoint* endpoint);
GearySmtpClientSession* geary_smtp_client_session_construct (GType object_type,
                                                             GearyEndpoint* endpoint);
static void geary_smtp_outbox_folder_do_postman_async (GearySmtpOutboxFolder* self,
                                                GAsyncReadyCallback _callback_,
                                                gpointer _user_data_);
static void geary_smtp_outbox_folder_do_postman_finish (GearySmtpOutboxFolder* self,
                                                 GAsyncResult* _res_);
static void geary_smtp_outbox_folder_real_find_boundaries_async_data_free (gpointer _data);
static void geary_smtp_outbox_folder_real_find_boundaries_async_async_ready_wrapper (GObject *source_object,
                                                                              GAsyncResult *res,
                                                                              void *user_data);
static void geary_smtp_outbox_folder_real_find_boundaries_async (GearyFolder* base,
                                                          GeeCollection* ids,
                                                          GCancellable* cancellable,
                                                          GAsyncReadyCallback _callback_,
                                                          gpointer _user_data_);
static gboolean geary_smtp_outbox_folder_real_find_boundaries_async_co (GearySmtpOutboxFolderFindBoundariesAsyncData* _data_);
GType geary_smtp_outbox_email_identifier_get_type (void) G_GNUC_CONST;
static Block73Data* block73_data_ref (Block73Data* _data73_);
static void block73_data_unref (void * _userdata_);
GType geary_db_transaction_type_get_type (void) G_GNUC_CONST;
GType geary_db_transaction_outcome_get_type (void) G_GNUC_CONST;
GType geary_db_connection_get_type (void) G_GNUC_CONST;
void geary_db_database_exec_transaction_async (GearyDbDatabase* self,
                                               GearyDbTransactionType type,
                                               GearyDbTransactionMethod cb,
                                               void* cb_target,
                                               GCancellable* cancellable,
                                               GAsyncReadyCallback _callback_,
                                               gpointer _user_data_);
GearyDbTransactionOutcome geary_db_database_exec_transaction_finish (GearyDbDatabase* self,
                                                                     GAsyncResult* _res_,
                                                                     GError** error);
static GearyDbTransactionOutcome __lambda98_ (Block73Data* _data73_,
                                       GearyDbConnection* cx,
                                       GError** error);
static GearySmtpOutboxFolderOutboxRow* geary_smtp_outbox_folder_do_fetch_row_by_ordering (GearySmtpOutboxFolder* self,
                                                                                   GearyDbConnection* cx,
                                                                                   gint64 ordering,
                                                                                   GCancellable* cancellable,
                                                                                   GError** error);
gint64 geary_smtp_outbox_email_identifier_get_ordering (GearySmtpOutboxEmailIdentifier* self);
static GearyDbTransactionOutcome ___lambda98__geary_db_transaction_method (GearyDbConnection* cx,
                                                                    GCancellable* cancellable,
                                                                    gpointer self,
                                                                    GError** error);
static void geary_smtp_outbox_folder_find_boundaries_async_ready (GObject* source_object,
                                                           GAsyncResult* _res_,
                                                           gpointer _user_data_);
static void geary_smtp_outbox_folder_add_to_containing_folders_async_data_free (gpointer _data);
static void geary_smtp_outbox_folder_add_to_containing_folders_async_async_ready_wrapper (GObject *source_object,
                                                                                   GAsyncResult *res,
                                                                                   void *user_data);
void geary_smtp_outbox_folder_add_to_containing_folders_async (GearySmtpOutboxFolder* self,
                                                               GeeCollection* ids,
                                                               GeeHashMultiMap* map,
                                                               GCancellable* cancellable,
                                                               GAsyncReadyCallback _callback_,
                                                               gpointer _user_data_);
void geary_smtp_outbox_folder_add_to_containing_folders_finish (GearySmtpOutboxFolder* self,
                                                                GAsyncResult* _res_,
                                                                GError** error);
static gboolean geary_smtp_outbox_folder_add_to_containing_folders_async_co (GearySmtpOutboxFolderAddToContainingFoldersAsyncData* _data_);
static Block74Data* block74_data_ref (Block74Data* _data74_);
static void block74_data_unref (void * _userdata_);
static GearyDbTransactionOutcome __lambda99_ (Block74Data* _data74_,
                                       GearyDbConnection* cx,
                                       GCancellable* cancellable,
                                       GError** error);
GearyFolderPath* geary_folder_get_path (GearyFolder* self);
static GearyDbTransactionOutcome ___lambda99__geary_db_transaction_method (GearyDbConnection* cx,
                                                                    GCancellable* cancellable,
                                                                    gpointer self,
                                                                    GError** error);
static void geary_smtp_outbox_folder_add_to_containing_folders_async_ready (GObject* source_object,
                                                                     GAsyncResult* _res_,
                                                                     gpointer _user_data_);
static gchar* geary_smtp_outbox_folder_message_subject (GearyRFC822Message* message);
GType geary_message_data_abstract_message_data_get_type (void) G_GNUC_CONST;
GType geary_message_data_string_message_data_get_type (void) G_GNUC_CONST;
GType geary_rf_c822_subject_get_type (void) G_GNUC_CONST;
GearyRFC822Subject* geary_rf_c822_message_get_subject (GearyRFC822Message* self);
gboolean geary_string_is_empty (const gchar* str);
gchar* geary_message_data_abstract_message_data_to_string (GearyMessageDataAbstractMessageData* self);
static void geary_smtp_outbox_folder_fill_outbox_queue_data_free (gpointer _data);
static void geary_smtp_outbox_folder_fill_outbox_queue_async_ready_wrapper (GObject *source_object,
                                                                     GAsyncResult *res,
                                                                     void *user_data);
static gboolean geary_smtp_outbox_folder_fill_outbox_queue_co (GearySmtpOutboxFolderFillOutboxQueueData* _data_);
static Block75Data* block75_data_ref (Block75Data* _data75_);
static void block75_data_unref (void * _userdata_);
static GearyDbTransactionOutcome ___lambda84_ (Block75Data* _data75_,
                                        GearyDbConnection* cx,
                                        GCancellable* cancellable,
                                        GError** error);
GType geary_db_statement_get_type (void) G_GNUC_CONST;
GQuark geary_database_error_quark (void);
GearyDbStatement* geary_db_connection_prepare (GearyDbConnection* self,
                                               const gchar* sql,
                                               GError** error);
GType geary_db_result_get_type (void) G_GNUC_CONST;
GearyDbResult* geary_db_statement_exec (GearyDbStatement* self,
                                        GCancellable* cancellable,
                                        GError** error);
gboolean geary_db_result_get_finished (GearyDbResult* self);
gint64 geary_db_result_rowid_at (GearyDbResult* self,
                                 gint column,
                                 GError** error);
gint64 geary_db_result_int64_at (GearyDbResult* self,
                                 gint column,
                                 GError** error);
GType geary_memory_buffer_get_type (void) G_GNUC_CONST;
GearyMemoryBuffer* geary_db_result_string_buffer_at (GearyDbResult* self,
                                                     gint column,
                                                     GError** error);
static GearySmtpOutboxFolderOutboxRow* geary_smtp_outbox_folder_outbox_row_new (gint64 id,
                                                                         gint position,
                                                                         gint64 ordering,
                                                                         gboolean sent,
                                                                         GearyMemoryBuffer* message,
                                                                         GearySmtpOutboxFolderRoot* root);
static GearySmtpOutboxFolderOutboxRow* geary_smtp_outbox_folder_outbox_row_construct (GType object_type,
                                                                               gint64 id,
                                                                               gint position,
                                                                               gint64 ordering,
                                                                               gboolean sent,
                                                                               GearyMemoryBuffer* message,
                                                                               GearySmtpOutboxFolderRoot* root);
gboolean geary_db_result_next (GearyDbResult* self,
                               GCancellable* cancellable,
                               GError** error);
static GearyDbTransactionOutcome ____lambda84__geary_db_transaction_method (GearyDbConnection* cx,
                                                                     GCancellable* cancellable,
                                                                     gpointer self,
                                                                     GError** error);
static void geary_smtp_outbox_folder_fill_outbox_queue_ready (GObject* source_object,
                                                       GAsyncResult* _res_,
                                                       gpointer _user_data_);
void geary_smtp_outbox_folder_properties_set_total (GearySmtpOutboxFolderProperties* self,
                                                    gint total);
gboolean geary_nonblocking_mailbox_send (GearyNonblockingMailbox* self,
                                         gconstpointer msg);
static void geary_smtp_outbox_folder_do_postman_async_data_free (gpointer _data);
static void geary_smtp_outbox_folder_do_postman_async_async_ready_wrapper (GObject *source_object,
                                                                    GAsyncResult *res,
                                                                    void *user_data);
static gboolean geary_smtp_outbox_folder_do_postman_async_co (GearySmtpOutboxFolderDoPostmanAsyncData* _data_);
void geary_nonblocking_mailbox_recv_async (GearyNonblockingMailbox* self,
                                           GCancellable* cancellable,
                                           GAsyncReadyCallback _callback_,
                                           gpointer _user_data_);
gpointer geary_nonblocking_mailbox_recv_finish (GearyNonblockingMailbox* self,
                                                GAsyncResult* _res_,
                                                GError** error);
static void geary_smtp_outbox_folder_do_postman_async_ready (GObject* source_object,
                                                      GAsyncResult* _res_,
                                                      gpointer _user_data_);
static void geary_smtp_outbox_folder_is_unsent_async (GearySmtpOutboxFolder* self,
                                               gint64 ordering,
                                               GCancellable* cancellable,
                                               GAsyncReadyCallback _callback_,
                                               gpointer _user_data_);
static gboolean geary_smtp_outbox_folder_is_unsent_finish (GearySmtpOutboxFolder* self,
                                                    GAsyncResult* _res_,
                                                    GError** error);
GQuark geary_rf_c822_error_quark (void);
GearyRFC822Message* geary_rf_c822_message_new_from_buffer (GearyMemoryBuffer* full_email,
                                                           GError** error);
GearyRFC822Message* geary_rf_c822_message_construct_from_buffer (GType object_type,
                                                                 GearyMemoryBuffer* full_email,
                                                                 GError** error);
GType geary_credentials_get_type (void) G_GNUC_CONST;
GearyCredentials* geary_account_information_get_smtp_credentials (GearyAccountInformation* self);
gboolean geary_credentials_is_complete (GearyCredentials* self);
GType geary_service_flag_get_type (void) G_GNUC_CONST;
void geary_account_information_get_passwords_async (GearyAccountInformation* self,
                                                    GearyServiceFlag services,
                                                    GAsyncReadyCallback _callback_,
                                                    gpointer _user_data_);
GearyServiceFlag geary_account_information_get_passwords_finish (GearyAccountInformation* self,
                                                                 GAsyncResult* _res_,
                                                                 GError** error);
gboolean geary_endpoint_get_is_trusted_or_never_connected (GearyEndpoint* self);
gchar* geary_email_identifier_to_string (GearyEmailIdentifier* self);
static void geary_smtp_outbox_folder_send_email_async (GearySmtpOutboxFolder* self,
                                                GearyRFC822Message* rfc822,
                                                GCancellable* cancellable,
                                                GAsyncReadyCallback _callback_,
                                                gpointer _user_data_);
static void geary_smtp_outbox_folder_send_email_finish (GearySmtpOutboxFolder* self,
                                                 GAsyncResult* _res_,
                                                 GError** error);
GQuark geary_smtp_error_quark (void);
void geary_account_information_fetch_passwords_async (GearyAccountInformation* self,
                                                      GearyServiceFlag services,
                                                      gboolean force_request,
                                                      GAsyncReadyCallback _callback_,
                                                      gpointer _user_data_);
gboolean geary_account_information_fetch_passwords_finish (GearyAccountInformation* self,
                                                           GAsyncResult* _res_,
                                                           GError** error);
GType geary_account_problem_get_type (void) G_GNUC_CONST;
gchar* geary_endpoint_to_string (GearyEndpoint* self);
void geary_scheduler_sleep_async (guint seconds,
                                  GAsyncReadyCallback _callback_,
                                  gpointer _user_data_);
void geary_scheduler_sleep_finish (GAsyncResult* _res_);
guint geary_numeric_uint_ceiling (guint value,
                                  guint ceiling);
static void geary_smtp_outbox_folder_mark_email_as_sent_async (GearySmtpOutboxFolder* self,
                                                        GearySmtpOutboxEmailIdentifier* outbox_id,
                                                        GCancellable* cancellable,
                                                        GAsyncReadyCallback _callback_,
                                                        gpointer _user_data_);
static void geary_smtp_outbox_folder_mark_email_as_sent_finish (GearySmtpOutboxFolder* self,
                                                         GAsyncResult* _res_,
                                                         GError** error);
gboolean geary_account_information_allow_save_sent_mail (GearyAccountInformation* self);
gboolean geary_account_information_get_save_sent_mail (GearyAccountInformation* self);
static void geary_smtp_outbox_folder_save_sent_mail_async (GearySmtpOutboxFolder* self,
                                                    GearyRFC822Message* rfc822,
                                                    GCancellable* cancellable,
                                                    GAsyncReadyCallback _callback_,
                                                    gpointer _user_data_);
static void geary_smtp_outbox_folder_save_sent_mail_finish (GearySmtpOutboxFolder* self,
                                                     GAsyncResult* _res_,
                                                     GError** error);
static void geary_smtp_outbox_folder_internal_remove_email_async (GearySmtpOutboxFolder* self,
                                                           GeeList* email_ids,
                                                           GCancellable* cancellable,
                                                           GAsyncReadyCallback _callback_,
                                                           gpointer _user_data_);
static gboolean geary_smtp_outbox_folder_internal_remove_email_finish (GearySmtpOutboxFolder* self,
                                                                GAsyncResult* _res_,
                                                                GError** error);
static GearyFolderOpenState geary_smtp_outbox_folder_real_get_open_state (GearyFolder* base);
gboolean geary_abstract_local_folder_is_open (GearyAbstractLocalFolder* self);
static void geary_smtp_outbox_folder_get_email_count_async_data_free (gpointer _data);
static void geary_smtp_outbox_folder_get_email_count_async_async_ready_wrapper (GObject *source_object,
                                                                         GAsyncResult *res,
                                                                         void *user_data);
static void geary_smtp_outbox_folder_get_email_count_async (GearySmtpOutboxFolder* self,
                                                     GCancellable* cancellable,
                                                     GAsyncReadyCallback _callback_,
                                                     gpointer _user_data_);
static gint geary_smtp_outbox_folder_get_email_count_finish (GearySmtpOutboxFolder* self,
                                                      GAsyncResult* _res_,
                                                      GError** error);
static gboolean geary_smtp_outbox_folder_get_email_count_async_co (GearySmtpOutboxFolderGetEmailCountAsyncData* _data_);
static Block76Data* block76_data_ref (Block76Data* _data76_);
static void block76_data_unref (void * _userdata_);
static GearyDbTransactionOutcome __lambda100_ (Block76Data* _data76_,
                                        GearyDbConnection* cx,
                                        GError** error);
static gint geary_smtp_outbox_folder_do_get_email_count (GearySmtpOutboxFolder* self,
                                                  GearyDbConnection* cx,
                                                  GCancellable* cancellable,
                                                  GError** error);
static GearyDbTransactionOutcome ___lambda100__geary_db_transaction_method (GearyDbConnection* cx,
                                                                     GCancellable* cancellable,
                                                                     gpointer self,
                                                                     GError** error);
static void geary_smtp_outbox_folder_get_email_count_async_ready (GObject* source_object,
                                                           GAsyncResult* _res_,
                                                           gpointer _user_data_);
static void geary_smtp_outbox_folder_enqueue_email_async_data_free (gpointer _data);
static void geary_smtp_outbox_folder_enqueue_email_async_async_ready_wrapper (GObject *source_object,
                                                                       GAsyncResult *res,
                                                                       void *user_data);
void geary_smtp_outbox_folder_enqueue_email_async (GearySmtpOutboxFolder* self,
                                                   GearyRFC822Message* rfc822,
                                                   GCancellable* cancellable,
                                                   GAsyncReadyCallback _callback_,
                                                   gpointer _user_data_);
GearySmtpOutboxEmailIdentifier* geary_smtp_outbox_folder_enqueue_email_finish (GearySmtpOutboxFolder* self,
                                                                               GAsyncResult* _res_,
                                                                               GError** error);
static gboolean geary_smtp_outbox_folder_enqueue_email_async_co (GearySmtpOutboxFolderEnqueueEmailAsyncData* _data_);
static Block77Data* block77_data_ref (Block77Data* _data77_);
static void block77_data_unref (void * _userdata_);
static GearyDbTransactionOutcome __lambda101_ (Block77Data* _data77_,
                                        GearyDbConnection* cx,
                                        GError** error);
static gint64 geary_smtp_outbox_folder_do_get_next_ordering (GearySmtpOutboxFolder* self,
                                                      GearyDbConnection* cx,
                                                      GCancellable* cancellable,
                                                      GError** error);
GearyMemoryBuffer* geary_rf_c822_message_get_network_buffer (GearyRFC822Message* self,
                                                             gboolean dotstuffed,
                                                             GError** error);
GearyDbStatement* geary_db_statement_bind_string_buffer (GearyDbStatement* self,
                                                         gint index,
                                                         GearyMemoryBuffer* buffer,
                                                         GError** error);
GearyDbStatement* geary_db_statement_bind_int64 (GearyDbStatement* self,
                                                 gint index,
                                                 gint64 i64,
                                                 GError** error);
gint64 geary_db_statement_exec_insert (GearyDbStatement* self,
                                       GCancellable* cancellable,
                                       GError** error);
GearyDbStatement* geary_db_statement_bind_rowid (GearyDbStatement* self,
                                                 gint index,
                                                 gint64 rowid,
                                                 GError** error);
static gint geary_smtp_outbox_folder_do_get_position_by_ordering (GearySmtpOutboxFolder* self,
                                                           GearyDbConnection* cx,
                                                           gint64 ordering,
                                                           GCancellable* cancellable,
                                                           GError** error);
static GearyDbTransactionOutcome ___lambda101__geary_db_transaction_method (GearyDbConnection* cx,
                                                                     GCancellable* cancellable,
                                                                     gpointer self,
                                                                     GError** error);
static void geary_smtp_outbox_folder_enqueue_email_async_ready (GObject* source_object,
                                                         GAsyncResult* _res_,
                                                         gpointer _user_data_);
void geary_folder_notify_email_appended (GearyFolder* self,
                                         GeeCollection* ids);
void geary_folder_notify_email_locally_appended (GearyFolder* self,
                                                 GeeCollection* ids);
void geary_folder_notify_email_count_changed (GearyFolder* self,
                                              gint new_count,
                                              GearyFolderCountChangeReason reason);
static void geary_smtp_outbox_folder_real_create_email_async_data_free (gpointer _data);
static void geary_smtp_outbox_folder_real_create_email_async_async_ready_wrapper (GObject *source_object,
                                                                           GAsyncResult *res,
                                                                           void *user_data);
static void geary_smtp_outbox_folder_real_create_email_async (GearySmtpOutboxFolder* self,
                                                       GearyRFC822Message* rfc822,
                                                       GearyEmailFlags* flags,
                                                       GDateTime* date_received,
                                                       GearyEmailIdentifier* id,
                                                       GCancellable* cancellable,
                                                       GAsyncReadyCallback _callback_,
                                                       gpointer _user_data_);
void geary_smtp_outbox_folder_create_email_async (GearySmtpOutboxFolder* self,
                                                  GearyRFC822Message* rfc822,
                                                  GearyEmailFlags* flags,
                                                  GDateTime* date_received,
                                                  GearyEmailIdentifier* id,
                                                  GCancellable* cancellable,
                                                  GAsyncReadyCallback _callback_,
                                                  gpointer _user_data_);
GearyEmailIdentifier* geary_smtp_outbox_folder_create_email_finish (GearySmtpOutboxFolder* self,
                                                                    GAsyncResult* _res_,
                                                                    GError** error);
static gboolean geary_smtp_outbox_folder_real_create_email_async_co (GearySmtpOutboxFolderCreateEmailAsyncData* _data_);
GQuark geary_engine_error_quark (void);
void geary_abstract_local_folder_check_open (GearyAbstractLocalFolder* self,
                                             GError** error);
static void geary_smtp_outbox_folder_create_email_async_ready (GObject* source_object,
                                                        GAsyncResult* _res_,
                                                        gpointer _user_data_);
static void geary_smtp_outbox_folder_real_list_email_by_id_async_data_free (gpointer _data);
static void geary_smtp_outbox_folder_real_list_email_by_id_async_async_ready_wrapper (GObject *source_object,
                                                                               GAsyncResult *res,
                                                                               void *user_data);
static void geary_smtp_outbox_folder_real_list_email_by_id_async (GearyFolder* base,
                                                           GearyEmailIdentifier* _initial_id,
                                                           gint count,
                                                           GearyEmailField required_fields,
                                                           GearyFolderListFlags flags,
                                                           GCancellable* cancellable,
                                                           GAsyncReadyCallback _callback_,
                                                           gpointer _user_data_);
static gboolean geary_smtp_outbox_folder_real_list_email_by_id_async_co (GearySmtpOutboxFolderListEmailByIdAsyncData* _data_);
static Block78Data* block78_data_ref (Block78Data* _data78_);
static void block78_data_unref (void * _userdata_);
static GearyDbTransactionOutcome __lambda102_ (Block78Data* _data78_,
                                        GearyDbConnection* cx,
                                        GError** error);
gboolean geary_folder_list_flags_is_newest_to_oldest (GearyFolderListFlags self);
gboolean geary_folder_list_flags_is_including_id (GearyFolderListFlags self);
GearyDbStatement* geary_db_statement_bind_int (GearyDbStatement* self,
                                               gint index,
                                               gint i,
                                               GError** error);
gboolean geary_db_result_bool_at (GearyDbResult* self,
                                  gint column,
                                  GError** error);
static GearyEmail* geary_smtp_outbox_folder_row_to_email (GearySmtpOutboxFolder* self,
                                                   GearySmtpOutboxFolderOutboxRow* row,
                                                   GError** error);
static GearyDbTransactionOutcome ___lambda102__geary_db_transaction_method (GearyDbConnection* cx,
                                                                     GCancellable* cancellable,
                                                                     gpointer self,
                                                                     GError** error);
static void geary_smtp_outbox_folder_list_email_by_id_async_ready (GObject* source_object,
                                                            GAsyncResult* _res_,
                                                            gpointer _user_data_);
static void geary_smtp_outbox_folder_real_list_email_by_sparse_id_async_data_free (gpointer _data);
static void geary_smtp_outbox_folder_real_list_email_by_sparse_id_async_async_ready_wrapper (GObject *source_object,
                                                                                      GAsyncResult *res,
                                                                                      void *user_data);
static void geary_smtp_outbox_folder_real_list_email_by_sparse_id_async (GearyFolder* base,
                                                                  GeeCollection* ids,
                                                                  GearyEmailField required_fields,
                                                                  GearyFolderListFlags flags,
                                                                  GCancellable* cancellable,
                                                                  GAsyncReadyCallback _callback_,
                                                                  gpointer _user_data_);
static gboolean geary_smtp_outbox_folder_real_list_email_by_sparse_id_async_co (GearySmtpOutboxFolderListEmailBySparseIdAsyncData* _data_);
static Block79Data* block79_data_ref (Block79Data* _data79_);
static void block79_data_unref (void * _userdata_);
static GearyDbTransactionOutcome __lambda103_ (Block79Data* _data79_,
                                        GearyDbConnection* cx,
                                        GError** error);
static GearyDbTransactionOutcome ___lambda103__geary_db_transaction_method (GearyDbConnection* cx,
                                                                     GCancellable* cancellable,
                                                                     gpointer self,
                                                                     GError** error);
static void geary_smtp_outbox_folder_list_email_by_sparse_id_async_ready (GObject* source_object,
                                                                   GAsyncResult* _res_,
                                                                   gpointer _user_data_);
static void geary_smtp_outbox_folder_real_list_local_email_fields_async_data_free (gpointer _data);
static void geary_smtp_outbox_folder_real_list_local_email_fields_async_async_ready_wrapper (GObject *source_object,
                                                                                      GAsyncResult *res,
                                                                                      void *user_data);
static void geary_smtp_outbox_folder_real_list_local_email_fields_async (GearyFolder* base,
                                                                  GeeCollection* ids,
                                                                  GCancellable* cancellable,
                                                                  GAsyncReadyCallback _callback_,
                                                                  gpointer _user_data_);
static gboolean geary_smtp_outbox_folder_real_list_local_email_fields_async_co (GearySmtpOutboxFolderListLocalEmailFieldsAsyncData* _data_);
static Block80Data* block80_data_ref (Block80Data* _data80_);
static void block80_data_unref (void * _userdata_);
static GearyDbTransactionOutcome __lambda104_ (Block80Data* _data80_,
                                        GearyDbConnection* cx,
                                        GError** error);
GType geary_db_reset_scope_get_type (void) G_GNUC_CONST;
GearyDbStatement* geary_db_statement_reset (GearyDbStatement* self,
                                            GearyDbResetScope reset_scope,
                                            GError** error);
static GearyDbTransactionOutcome ___lambda104__geary_db_transaction_method (GearyDbConnection* cx,
                                                                     GCancellable* cancellable,
                                                                     gpointer self,
                                                                     GError** error);
static void geary_smtp_outbox_folder_list_local_email_fields_async_ready (GObject* source_object,
                                                                   GAsyncResult* _res_,
                                                                   gpointer _user_data_);
static void geary_smtp_outbox_folder_real_fetch_email_async_data_free (gpointer _data);
static void geary_smtp_outbox_folder_real_fetch_email_async_async_ready_wrapper (GObject *source_object,
                                                                          GAsyncResult *res,
                                                                          void *user_data);
static void geary_smtp_outbox_folder_real_fetch_email_async (GearyFolder* base,
                                                      GearyEmailIdentifier* id,
                                                      GearyEmailField required_fields,
                                                      GearyFolderListFlags flags,
                                                      GCancellable* cancellable,
                                                      GAsyncReadyCallback _callback_,
                                                      gpointer _user_data_);
static gboolean geary_smtp_outbox_folder_real_fetch_email_async_co (GearySmtpOutboxFolderFetchEmailAsyncData* _data_);
static Block81Data* block81_data_ref (Block81Data* _data81_);
static void block81_data_unref (void * _userdata_);
static GearyDbTransactionOutcome __lambda105_ (Block81Data* _data81_,
                                        GearyDbConnection* cx,
                                        GError** error);
static GearyDbTransactionOutcome ___lambda105__geary_db_transaction_method (GearyDbConnection* cx,
                                                                     GCancellable* cancellable,
                                                                     gpointer self,
                                                                     GError** error);
static void geary_smtp_outbox_folder_fetch_email_async_ready (GObject* source_object,
                                                       GAsyncResult* _res_,
                                                       gpointer _user_data_);
static void geary_smtp_outbox_folder_mark_email_as_sent_async_data_free (gpointer _data);
static void geary_smtp_outbox_folder_mark_email_as_sent_async_async_ready_wrapper (GObject *source_object,
                                                                            GAsyncResult *res,
                                                                            void *user_data);
static gboolean geary_smtp_outbox_folder_mark_email_as_sent_async_co (GearySmtpOutboxFolderMarkEmailAsSentAsyncData* _data_);
static Block82Data* block82_data_ref (Block82Data* _data82_);
static void block82_data_unref (void * _userdata_);
static GearyDbTransactionOutcome __lambda96_ (Block82Data* _data82_,
                                       GearyDbConnection* cx,
                                       GError** error);
static void geary_smtp_outbox_folder_do_mark_email_as_sent (GearySmtpOutboxFolder* self,
                                                     GearyDbConnection* cx,
                                                     GearySmtpOutboxEmailIdentifier* id,
                                                     GCancellable* cancellable,
                                                     GError** error);
static GearyDbTransactionOutcome ___lambda96__geary_db_transaction_method (GearyDbConnection* cx,
                                                                    GCancellable* cancellable,
                                                                    gpointer self,
                                                                    GError** error);
static void geary_smtp_outbox_folder_mark_email_as_sent_async_ready (GObject* source_object,
                                                              GAsyncResult* _res_,
                                                              gpointer _user_data_);
GearyEmailFlags* geary_email_flags_new (void);
GearyEmailFlags* geary_email_flags_construct (GType object_type);
GType geary_named_flag_get_type (void) G_GNUC_CONST;
void geary_named_flags_add (GearyNamedFlags* self,
                            GearyNamedFlag* flag);
GearyNamedFlag* geary_email_flags_get_OUTBOX_SENT (void);
void geary_folder_notify_email_flags_changed (GearyFolder* self,
                                              GeeMap* flag_map);
static void geary_smtp_outbox_folder_real_remove_email_async_data_free (gpointer _data);
static void geary_smtp_outbox_folder_real_remove_email_async_async_ready_wrapper (GObject *source_object,
                                                                           GAsyncResult *res,
                                                                           void *user_data);
static void geary_smtp_outbox_folder_real_remove_email_async (GearySmtpOutboxFolder* self,
                                                       GeeList* email_ids,
                                                       GCancellable* cancellable,
                                                       GAsyncReadyCallback _callback_,
                                                       gpointer _user_data_);
void geary_smtp_outbox_folder_remove_email_async (GearySmtpOutboxFolder* self,
                                                  GeeList* email_ids,
                                                  GCancellable* cancellable,
                                                  GAsyncReadyCallback _callback_,
                                                  gpointer _user_data_);
void geary_smtp_outbox_folder_remove_email_finish (GearySmtpOutboxFolder* self,
                                                   GAsyncResult* _res_,
                                                   GError** error);
static gboolean geary_smtp_outbox_folder_real_remove_email_async_co (GearySmtpOutboxFolderRemoveEmailAsyncData* _data_);
static void geary_smtp_outbox_folder_remove_email_async_ready (GObject* source_object,
                                                        GAsyncResult* _res_,
                                                        gpointer _user_data_);
static void geary_smtp_outbox_folder_internal_remove_email_async_data_free (gpointer _data);
static void geary_smtp_outbox_folder_internal_remove_email_async_async_ready_wrapper (GObject *source_object,
                                                                               GAsyncResult *res,
                                                                               void *user_data);
static gboolean geary_smtp_outbox_folder_internal_remove_email_async_co (GearySmtpOutboxFolderInternalRemoveEmailAsyncData* _data_);
static Block83Data* block83_data_ref (Block83Data* _data83_);
static void block83_data_unref (void * _userdata_);
static GearyDbTransactionOutcome __lambda97_ (Block83Data* _data83_,
                                       GearyDbConnection* cx,
                                       GError** error);
static gboolean geary_smtp_outbox_folder_do_remove_email (GearySmtpOutboxFolder* self,
                                                   GearyDbConnection* cx,
                                                   GearySmtpOutboxEmailIdentifier* id,
                                                   GCancellable* cancellable,
                                                   GError** error);
static GearyDbTransactionOutcome ___lambda97__geary_db_transaction_method (GearyDbConnection* cx,
                                                                    GCancellable* cancellable,
                                                                    gpointer self,
                                                                    GError** error);
static void geary_smtp_outbox_folder_internal_remove_email_async_ready (GObject* source_object,
                                                                 GAsyncResult* _res_,
                                                                 gpointer _user_data_);
void geary_folder_notify_email_removed (GearyFolder* self,
                                        GeeCollection* ids);
static void geary_smtp_outbox_folder_real_remove_single_email_async_data_free (gpointer _data);
static void geary_smtp_outbox_folder_real_remove_single_email_async_async_ready_wrapper (GObject *source_object,
                                                                                  GAsyncResult *res,
                                                                                  void *user_data);
static void geary_smtp_outbox_folder_real_remove_single_email_async (GearySmtpOutboxFolder* self,
                                                              GearyEmailIdentifier* id,
                                                              GCancellable* cancellable,
                                                              GAsyncReadyCallback _callback_,
                                                              gpointer _user_data_);
void geary_smtp_outbox_folder_remove_single_email_async (GearySmtpOutboxFolder* self,
                                                         GearyEmailIdentifier* id,
                                                         GCancellable* cancellable,
                                                         GAsyncReadyCallback _callback_,
                                                         gpointer _user_data_);
void geary_smtp_outbox_folder_remove_single_email_finish (GearySmtpOutboxFolder* self,
                                                          GAsyncResult* _res_,
                                                          GError** error);
static gboolean geary_smtp_outbox_folder_real_remove_single_email_async_co (GearySmtpOutboxFolderRemoveSingleEmailAsyncData* _data_);
static void geary_smtp_outbox_folder_remove_single_email_async_ready (GObject* source_object,
                                                               GAsyncResult* _res_,
                                                               gpointer _user_data_);
GearyEmail* geary_rf_c822_message_get_email (GearyRFC822Message* self,
                                             GearyEmailIdentifier* id,
                                             GError** error);
GType geary_email_properties_get_type (void) G_GNUC_CONST;
void geary_email_set_email_properties (GearyEmail* self,
                                       GearyEmailProperties* properties);
GearySmtpOutboxEmailProperties* geary_smtp_outbox_email_properties_new (GDateTime* date_received,
                                                                        glong total_bytes);
GearySmtpOutboxEmailProperties* geary_smtp_outbox_email_properties_construct (GType object_type,
                                                                              GDateTime* date_received,
                                                                              glong total_bytes);
GType geary_smtp_outbox_email_properties_get_type (void) G_GNUC_CONST;
void geary_email_set_flags (GearyEmail* self,
                            GearyEmailFlags* email_flags);
static void geary_smtp_outbox_folder_send_email_async_data_free (gpointer _data);
static void geary_smtp_outbox_folder_send_email_async_async_ready_wrapper (GObject *source_object,
                                                                    GAsyncResult *res,
                                                                    void *user_data);
static gboolean geary_smtp_outbox_folder_send_email_async_co (GearySmtpOutboxFolderSendEmailAsyncData* _data_);
void geary_progress_monitor_notify_start (GearyProgressMonitor* self);
void geary_smtp_client_session_login_async (GearySmtpClientSession* self,
                                            GearyCredentials* creds,
                                            GCancellable* cancellable,
                                            GAsyncReadyCallback _callback_,
                                            gpointer _user_data_);
gpointer geary_smtp_response_ref (gpointer instance);
void geary_smtp_response_unref (gpointer instance);
GParamSpec* geary_smtp_param_spec_response (const gchar* name,
                                            const gchar* nick,
                                            const gchar* blurb,
                                            GType object_type,
                                            GParamFlags flags);
void geary_smtp_value_set_response (GValue* value,
                                    gpointer v_object);
void geary_smtp_value_take_response (GValue* value,
                                     gpointer v_object);
gpointer geary_smtp_value_get_response (const GValue* value);
GType geary_smtp_response_get_type (void) G_GNUC_CONST;
GType geary_smtp_greeting_get_type (void) G_GNUC_CONST;
GearySmtpGreeting* geary_smtp_client_session_login_finish (GearySmtpClientSession* self,
                                                           GAsyncResult* _res_,
                                                           GError** error);
static void geary_smtp_outbox_folder_send_email_async_ready (GObject* source_object,
                                                      GAsyncResult* _res_,
                                                      gpointer _user_data_);
GType geary_rf_c822_mailbox_address_get_type (void) G_GNUC_CONST;
void geary_smtp_client_session_send_email_async (GearySmtpClientSession* self,
                                                 GearyRFC822MailboxAddress* from,
                                                 GearyRFC822Message* email,
                                                 GCancellable* cancellable,
                                                 GAsyncReadyCallback _callback_,
                                                 gpointer _user_data_);
void geary_smtp_client_session_send_email_finish (GearySmtpClientSession* self,
                                                  GAsyncResult* _res_,
                                                  GError** error);
GearyRFC822MailboxAddress* geary_account_information_get_primary_mailbox (GearyAccountInformation* self);
void geary_smtp_client_session_logout_async (GearySmtpClientSession* self,
                                             gboolean force,
                                             GCancellable* cancellable,
                                             GAsyncReadyCallback _callback_,
                                             gpointer _user_data_);
GearySmtpResponse* geary_smtp_client_session_logout_finish (GearySmtpClientSession* self,
                                                            GAsyncResult* _res_,
                                                            GError** error);
gchar* geary_smtp_client_session_to_string (GearySmtpClientSession* self);
void geary_progress_monitor_notify_finish (GearyProgressMonitor* self);
static void geary_smtp_outbox_folder_save_sent_mail_async_data_free (gpointer _data);
static void geary_smtp_outbox_folder_save_sent_mail_async_async_ready_wrapper (GObject *source_object,
                                                                        GAsyncResult *res,
                                                                        void *user_data);
static gboolean geary_smtp_outbox_folder_save_sent_mail_async_co (GearySmtpOutboxFolderSaveSentMailAsyncData* _data_);
void geary_account_get_required_special_folder_async (GearyAccount* self,
                                                      GearySpecialFolderType special,
                                                      GCancellable* cancellable,
                                                      GAsyncReadyCallback _callback_,
                                                      gpointer _user_data_);
GearyFolder* geary_account_get_required_special_folder_finish (GearyAccount* self,
                                                               GAsyncResult* _res_,
                                                               GError** error);
static void geary_smtp_outbox_folder_save_sent_mail_async_ready (GObject* source_object,
                                                          GAsyncResult* _res_,
                                                          gpointer _user_data_);
void geary_folder_open_async (GearyFolder* self,
                              GearyFolderOpenFlags open_flags,
                              GCancellable* cancellable,
                              GAsyncReadyCallback _callback_,
                              gpointer _user_data_);
gboolean geary_folder_open_finish (GearyFolder* self,
                                   GAsyncResult* _res_,
                                   GError** error);
void geary_folder_support_create_create_email_async (GearyFolderSupportCreate* self,
                                                     GearyRFC822Message* rfc822,
                                                     GearyEmailFlags* flags,
                                                     GDateTime* date_received,
                                                     GearyEmailIdentifier* id,
                                                     GCancellable* cancellable,
                                                     GAsyncReadyCallback _callback_,
                                                     gpointer _user_data_);
GearyEmailIdentifier* geary_folder_support_create_create_email_finish (GearyFolderSupportCreate* self,
                                                                       GAsyncResult* _res_,
                                                                       GError** error);
void geary_folder_close_async (GearyFolder* self,
                               GCancellable* cancellable,
                               GAsyncReadyCallback _callback_,
                               gpointer _user_data_);
gboolean geary_folder_close_finish (GearyFolder* self,
                                    GAsyncResult* _res_,
                                    GError** error);
gchar* geary_folder_to_string (GearyFolder* self);
static void geary_smtp_outbox_folder_is_unsent_async_data_free (gpointer _data);
static void geary_smtp_outbox_folder_is_unsent_async_async_ready_wrapper (GObject *source_object,
                                                                   GAsyncResult *res,
                                                                   void *user_data);
static gboolean geary_smtp_outbox_folder_is_unsent_async_co (GearySmtpOutboxFolderIsUnsentAsyncData* _data_);
static Block84Data* block84_data_ref (Block84Data* _data84_);
static void block84_data_unref (void * _userdata_);
static GearyDbTransactionOutcome __lambda95_ (Block84Data* _data84_,
                                       GearyDbConnection* cx,
                                       GError** error);
static GearyDbTransactionOutcome ___lambda95__geary_db_transaction_method (GearyDbConnection* cx,
                                                                    GCancellable* cancellable,
                                                                    gpointer self,
                                                                    GError** error);
static void geary_smtp_outbox_folder_is_unsent_async_ready (GObject* source_object,
                                                     GAsyncResult* _res_,
                                                     gpointer _user_data_);
gint geary_db_result_int_at (GearyDbResult* self,
                             gint column,
                             GError** error);
gint geary_db_statement_exec_get_modified (GearyDbStatement* self,
                                           GCancellable* cancellable,
                                           GError** error);
static void g_cclosure_user_marshal_VOID__ENUM_POINTER (GClosure * closure,
                                                 GValue * return_value,
                                                 guint n_param_values,
                                                 const GValue * param_values,
                                                 gpointer invocation_hint,
                                                 gpointer marshal_data);
GearySmtpOutboxEmailIdentifier* geary_smtp_outbox_email_identifier_new (gint64 message_id,
                                                                        gint64 ordering);
GearySmtpOutboxEmailIdentifier* geary_smtp_outbox_email_identifier_construct (GType object_type,
                                                                              gint64 message_id,
                                                                              gint64 ordering);
static void geary_smtp_outbox_folder_outbox_row_finalize (GearySmtpOutboxFolderOutboxRow * obj);
static void geary_smtp_outbox_folder_finalize (GObject * obj);
GearyAccount* geary_folder_get_account (GearyFolder* self);
GearyFolderProperties* geary_folder_get_properties (GearyFolder* self);
GearySpecialFolderType geary_folder_get_special_folder_type (GearyFolder* self);
static void _vala_geary_smtp_outbox_folder_get_property (GObject * object,
                                                  guint property_id,
                                                  GValue * value,
                                                  GParamSpec * pspec);


static gpointer
_g_object_ref0 (gpointer self)
{
#line 75 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return self ? g_object_ref (self) : NULL;
#line 2331 "smtp-outbox-folder.c"
}


static void
__lambda83_ (GearySmtpOutboxFolder* self)
{
#line 77 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	geary_smtp_outbox_folder_fill_outbox_queue (self, NULL, NULL);
#line 2340 "smtp-outbox-folder.c"
}


static void
___lambda83__geary_account_opened (GearyAccount* _sender,
                                   gpointer self)
{
#line 77 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	__lambda83_ ((GearySmtpOutboxFolder*) self);
#line 2350 "smtp-outbox-folder.c"
}


GearySmtpOutboxFolder*
geary_smtp_outbox_folder_construct (GType object_type,
                                    GearyImapDBDatabase* db,
                                    GearyAccount* account,
                                    GearyProgressMonitor* sending_monitor)
{
	GearySmtpOutboxFolder * self = NULL;
	GearyImapDBDatabase* _tmp0_;
	GearyAccount* _tmp1_;
	GearyProgressMonitor* _tmp2_;
	GearyAccount* _tmp3_;
	GearyAccountInformation* _tmp4_;
	GearyAccountInformation* _tmp5_;
	GearyEndpoint* _tmp6_;
	GearyEndpoint* _tmp7_;
	GearySmtpClientSession* _tmp8_;
#line 72 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_return_val_if_fail (GEARY_IMAP_DB_IS_DATABASE (db), NULL);
#line 72 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_return_val_if_fail (GEARY_IS_ACCOUNT (account), NULL);
#line 72 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_return_val_if_fail (GEARY_IS_PROGRESS_MONITOR (sending_monitor), NULL);
#line 73 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	self = (GearySmtpOutboxFolder*) geary_abstract_local_folder_construct (object_type);
#line 75 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp0_ = _g_object_ref0 (db);
#line 75 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (self->priv->db);
#line 75 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	self->priv->db = _tmp0_;
#line 76 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	self->priv->_account = account;
#line 77 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp1_ = self->priv->_account;
#line 77 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_signal_connect_object (_tmp1_, "opened", (GCallback) ___lambda83__geary_account_opened, self, 0);
#line 78 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp2_ = _g_object_ref0 (sending_monitor);
#line 78 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (self->priv->sending_monitor);
#line 78 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	self->priv->sending_monitor = _tmp2_;
#line 80 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp3_ = self->priv->_account;
#line 80 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp4_ = geary_account_get_information (_tmp3_);
#line 80 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp5_ = _tmp4_;
#line 80 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp6_ = geary_account_information_get_smtp_endpoint (_tmp5_);
#line 80 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp7_ = _tmp6_;
#line 80 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp8_ = geary_smtp_client_session_new (_tmp7_);
#line 80 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_geary_smtp_client_session_unref0 (self->priv->smtp);
#line 80 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	self->priv->smtp = _tmp8_;
#line 80 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_tmp7_);
#line 82 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	geary_smtp_outbox_folder_do_postman_async (self, NULL, NULL);
#line 72 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return self;
#line 2418 "smtp-outbox-folder.c"
}


GearySmtpOutboxFolder*
geary_smtp_outbox_folder_new (GearyImapDBDatabase* db,
                              GearyAccount* account,
                              GearyProgressMonitor* sending_monitor)
{
#line 72 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return geary_smtp_outbox_folder_construct (GEARY_TYPE_SMTP_OUTBOX_FOLDER, db, account, sending_monitor);
#line 2429 "smtp-outbox-folder.c"
}


static void
geary_smtp_outbox_folder_real_find_boundaries_async_data_free (gpointer _data)
{
	GearySmtpOutboxFolderFindBoundariesAsyncData* _data_;
	_data_ = _data;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_data_->self);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_slice_free (GearySmtpOutboxFolderFindBoundariesAsyncData, _data_);
#line 2442 "smtp-outbox-folder.c"
}


static void
geary_smtp_outbox_folder_real_find_boundaries_async_async_ready_wrapper (GObject *source_object,
                                                                         GAsyncResult *res,
                                                                         void *user_data)
{
	GearySmtpOutboxFolderFindBoundariesAsyncData* _task_data_;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_task_data_ = g_task_get_task_data (G_TASK (res));
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (_task_data_->_callback_ != NULL) {
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_task_data_->_callback_ (source_object, res, user_data);
#line 2458 "smtp-outbox-folder.c"
	}
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_task_data_->_task_complete_ = TRUE;
#line 2462 "smtp-outbox-folder.c"
}


static void
geary_smtp_outbox_folder_real_find_boundaries_async (GearyFolder* base,
                                                     GeeCollection* ids,
                                                     GCancellable* cancellable,
                                                     GAsyncReadyCallback _callback_,
                                                     gpointer _user_data_)
{
	GearySmtpOutboxFolder * self;
	GearySmtpOutboxFolderFindBoundariesAsyncData* _data_;
	GearySmtpOutboxFolder* _tmp0_;
	GeeCollection* _tmp1_;
	GCancellable* _tmp2_;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, GEARY_TYPE_SMTP_OUTBOX_FOLDER, GearySmtpOutboxFolder);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_ = g_slice_new0 (GearySmtpOutboxFolderFindBoundariesAsyncData);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_callback_ = _callback_;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), cancellable, geary_smtp_outbox_folder_real_find_boundaries_async_async_ready_wrapper, _user_data_);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (_callback_ == NULL) {
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_task_complete_ = TRUE;
#line 2490 "smtp-outbox-folder.c"
	}
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_task_set_task_data (_data_->_async_result, _data_, geary_smtp_outbox_folder_real_find_boundaries_async_data_free);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->self = _tmp0_;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp1_ = _g_object_ref0 (ids);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_data_->ids);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->ids = _tmp1_;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp2_ = _g_object_ref0 (cancellable);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_data_->cancellable);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->cancellable = _tmp2_;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	geary_smtp_outbox_folder_real_find_boundaries_async_co (_data_);
#line 2512 "smtp-outbox-folder.c"
}


static void
geary_smtp_outbox_folder_real_find_boundaries_finish (GearyFolder* base,
                                                      GAsyncResult* _res_,
                                                      GearyEmailIdentifier* * low,
                                                      GearyEmailIdentifier* * high,
                                                      GError** error)
{
	GearySmtpOutboxFolderFindBoundariesAsyncData* _data_;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (NULL == _data_) {
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return;
#line 2530 "smtp-outbox-folder.c"
	}
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (low) {
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		*low = _data_->low;
#line 2536 "smtp-outbox-folder.c"
	} else {
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (_data_->low);
#line 2540 "smtp-outbox-folder.c"
	}
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->low = NULL;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (high) {
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		*high = _data_->high;
#line 2548 "smtp-outbox-folder.c"
	} else {
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (_data_->high);
#line 2552 "smtp-outbox-folder.c"
	}
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->high = NULL;
#line 2556 "smtp-outbox-folder.c"
}


static Block73Data*
block73_data_ref (Block73Data* _data73_)
{
#line 85 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_atomic_int_inc (&_data73_->_ref_count_);
#line 85 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return _data73_;
#line 2567 "smtp-outbox-folder.c"
}


static void
block73_data_unref (void * _userdata_)
{
	Block73Data* _data73_;
	_data73_ = (Block73Data*) _userdata_;
#line 85 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (g_atomic_int_dec_and_test (&_data73_->_ref_count_)) {
#line 2578 "smtp-outbox-folder.c"
		GearySmtpOutboxFolder* self;
#line 85 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		self = _data73_->self;
#line 85 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (_data73_->outbox_high);
#line 85 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (_data73_->outbox_low);
#line 85 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (_data73_->ids);
#line 85 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (_data73_->cancellable);
#line 85 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (self);
#line 85 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_slice_free (Block73Data, _data73_);
#line 2594 "smtp-outbox-folder.c"
	}
}


static GearyDbTransactionOutcome
__lambda98_ (Block73Data* _data73_,
             GearyDbConnection* cx,
             GError** error)
{
	GearySmtpOutboxFolder* self;
	GearyDbTransactionOutcome result = 0;
	GError * _inner_error_ = NULL;
#line 90 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	self = _data73_->self;
#line 90 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_return_val_if_fail (GEARY_DB_IS_CONNECTION (cx), 0);
#line 2611 "smtp-outbox-folder.c"
	{
		GeeIterator* _id_it = NULL;
		GeeIterator* _tmp0_;
#line 91 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_tmp0_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_data73_->ids, GEE_TYPE_ITERABLE, GeeIterable));
#line 91 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_id_it = _tmp0_;
#line 91 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		while (TRUE) {
#line 2621 "smtp-outbox-folder.c"
			GeeIterator* _tmp1_;
			GearyEmailIdentifier* id = NULL;
			GeeIterator* _tmp2_;
			gpointer _tmp3_;
			GearySmtpOutboxEmailIdentifier* outbox_id = NULL;
			GearyEmailIdentifier* _tmp4_;
			GearySmtpOutboxEmailIdentifier* _tmp5_;
			GearySmtpOutboxEmailIdentifier* _tmp6_;
			GearySmtpOutboxFolderOutboxRow* row = NULL;
			GearySmtpOutboxEmailIdentifier* _tmp7_;
			gint64 _tmp8_;
			gint64 _tmp9_;
			GearySmtpOutboxFolderOutboxRow* _tmp10_;
			GearySmtpOutboxFolderOutboxRow* _tmp11_;
			gboolean _tmp12_ = FALSE;
			gboolean _tmp20_ = FALSE;
#line 91 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp1_ = _id_it;
#line 91 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			if (!gee_iterator_next (_tmp1_)) {
#line 91 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				break;
#line 2644 "smtp-outbox-folder.c"
			}
#line 91 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp2_ = _id_it;
#line 91 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp3_ = gee_iterator_get (_tmp2_);
#line 91 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			id = (GearyEmailIdentifier*) _tmp3_;
#line 92 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp4_ = id;
#line 92 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp5_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp4_, GEARY_TYPE_SMTP_OUTBOX_EMAIL_IDENTIFIER) ? ((GearySmtpOutboxEmailIdentifier*) _tmp4_) : NULL);
#line 92 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			outbox_id = _tmp5_;
#line 93 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp6_ = outbox_id;
#line 93 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			if (_tmp6_ == NULL) {
#line 94 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_g_object_unref0 (outbox_id);
#line 94 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_g_object_unref0 (id);
#line 94 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				continue;
#line 2668 "smtp-outbox-folder.c"
			}
#line 96 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp7_ = outbox_id;
#line 96 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp8_ = geary_smtp_outbox_email_identifier_get_ordering (_tmp7_);
#line 96 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp9_ = _tmp8_;
#line 96 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp10_ = geary_smtp_outbox_folder_do_fetch_row_by_ordering (self, cx, _tmp9_, _data73_->cancellable, &_inner_error_);
#line 96 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			row = _tmp10_;
#line 96 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 96 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				g_propagate_error (error, _inner_error_);
#line 96 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_g_object_unref0 (outbox_id);
#line 96 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_g_object_unref0 (id);
#line 96 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_g_object_unref0 (_id_it);
#line 96 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				return 0;
#line 2692 "smtp-outbox-folder.c"
			}
#line 97 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp11_ = row;
#line 97 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			if (_tmp11_ == NULL) {
#line 98 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_geary_smtp_outbox_folder_outbox_row_unref0 (row);
#line 98 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_g_object_unref0 (outbox_id);
#line 98 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_g_object_unref0 (id);
#line 98 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				continue;
#line 2706 "smtp-outbox-folder.c"
			}
#line 100 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			if (_data73_->outbox_low == NULL) {
#line 100 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_tmp12_ = TRUE;
#line 2712 "smtp-outbox-folder.c"
			} else {
				GearySmtpOutboxEmailIdentifier* _tmp13_;
				gint64 _tmp14_;
				gint64 _tmp15_;
				gint64 _tmp16_;
				gint64 _tmp17_;
#line 100 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_tmp13_ = outbox_id;
#line 100 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_tmp14_ = geary_smtp_outbox_email_identifier_get_ordering (_tmp13_);
#line 100 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_tmp15_ = _tmp14_;
#line 100 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_tmp16_ = geary_smtp_outbox_email_identifier_get_ordering (_data73_->outbox_low);
#line 100 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_tmp17_ = _tmp16_;
#line 100 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_tmp12_ = _tmp15_ < _tmp17_;
#line 2731 "smtp-outbox-folder.c"
			}
#line 100 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			if (_tmp12_) {
#line 2735 "smtp-outbox-folder.c"
				GearySmtpOutboxEmailIdentifier* _tmp18_;
				GearySmtpOutboxEmailIdentifier* _tmp19_;
#line 101 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_tmp18_ = outbox_id;
#line 101 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_tmp19_ = _g_object_ref0 (_tmp18_);
#line 101 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_g_object_unref0 (_data73_->outbox_low);
#line 101 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data73_->outbox_low = _tmp19_;
#line 2746 "smtp-outbox-folder.c"
			}
#line 102 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			if (_data73_->outbox_high == NULL) {
#line 102 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_tmp20_ = TRUE;
#line 2752 "smtp-outbox-folder.c"
			} else {
				GearySmtpOutboxEmailIdentifier* _tmp21_;
				gint64 _tmp22_;
				gint64 _tmp23_;
				gint64 _tmp24_;
				gint64 _tmp25_;
#line 102 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_tmp21_ = outbox_id;
#line 102 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_tmp22_ = geary_smtp_outbox_email_identifier_get_ordering (_tmp21_);
#line 102 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_tmp23_ = _tmp22_;
#line 102 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_tmp24_ = geary_smtp_outbox_email_identifier_get_ordering (_data73_->outbox_high);
#line 102 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_tmp25_ = _tmp24_;
#line 102 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_tmp20_ = _tmp23_ > _tmp25_;
#line 2771 "smtp-outbox-folder.c"
			}
#line 102 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			if (_tmp20_) {
#line 2775 "smtp-outbox-folder.c"
				GearySmtpOutboxEmailIdentifier* _tmp26_;
				GearySmtpOutboxEmailIdentifier* _tmp27_;
#line 103 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_tmp26_ = outbox_id;
#line 103 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_tmp27_ = _g_object_ref0 (_tmp26_);
#line 103 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_g_object_unref0 (_data73_->outbox_high);
#line 103 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data73_->outbox_high = _tmp27_;
#line 2786 "smtp-outbox-folder.c"
			}
#line 91 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_geary_smtp_outbox_folder_outbox_row_unref0 (row);
#line 91 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_g_object_unref0 (outbox_id);
#line 91 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_g_object_unref0 (id);
#line 2794 "smtp-outbox-folder.c"
		}
#line 91 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (_id_it);
#line 2798 "smtp-outbox-folder.c"
	}
#line 106 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	result = GEARY_DB_TRANSACTION_OUTCOME_DONE;
#line 106 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return result;
#line 2804 "smtp-outbox-folder.c"
}


static GearyDbTransactionOutcome
___lambda98__geary_db_transaction_method (GearyDbConnection* cx,
                                          GCancellable* cancellable,
                                          gpointer self,
                                          GError** error)
{
	GearyDbTransactionOutcome result;
	result = __lambda98_ (self, cx, error);
#line 90 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return result;
#line 2818 "smtp-outbox-folder.c"
}


static void
geary_smtp_outbox_folder_find_boundaries_async_ready (GObject* source_object,
                                                      GAsyncResult* _res_,
                                                      gpointer _user_data_)
{
	GearySmtpOutboxFolderFindBoundariesAsyncData* _data_;
#line 90 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_ = _user_data_;
#line 90 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_source_object_ = source_object;
#line 90 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_res_ = _res_;
#line 90 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_task_complete_ = TRUE;
#line 90 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	geary_smtp_outbox_folder_real_find_boundaries_async_co (_data_);
#line 2838 "smtp-outbox-folder.c"
}


static gboolean
geary_smtp_outbox_folder_real_find_boundaries_async_co (GearySmtpOutboxFolderFindBoundariesAsyncData* _data_)
{
#line 85 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	switch (_data_->_state_) {
#line 85 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		case 0:
#line 2849 "smtp-outbox-folder.c"
		goto _state_0;
#line 85 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		case 1:
#line 2853 "smtp-outbox-folder.c"
		goto _state_1;
		default:
#line 85 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_assert_not_reached ();
#line 2858 "smtp-outbox-folder.c"
	}
	_state_0:
#line 85 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_data73_ = g_slice_new0 (Block73Data);
#line 85 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_data73_->_ref_count_ = 1;
#line 85 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_data73_->self = g_object_ref (_data_->self);
#line 85 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_data_->_data73_->ids);
#line 85 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_data73_->ids = _data_->ids;
#line 85 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_data_->_data73_->cancellable);
#line 85 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_data73_->cancellable = _data_->cancellable;
#line 85 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_data73_->_async_data_ = _data_;
#line 88 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_data73_->outbox_low = NULL;
#line 89 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_data73_->outbox_high = NULL;
#line 90 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp0_ = _data_->self->priv->db;
#line 90 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_state_ = 1;
#line 90 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	geary_db_database_exec_transaction_async (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp0_, GEARY_DB_TYPE_DATABASE, GearyDbDatabase), GEARY_DB_TRANSACTION_TYPE_RO, ___lambda98__geary_db_transaction_method, _data_->_data73_, _data_->_data73_->cancellable, geary_smtp_outbox_folder_find_boundaries_async_ready, _data_);
#line 90 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return FALSE;
#line 2889 "smtp-outbox-folder.c"
	_state_1:
#line 90 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	geary_db_database_exec_transaction_finish (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp0_, GEARY_DB_TYPE_DATABASE, GearyDbDatabase), _data_->_res_, &_data_->_inner_error_);
#line 90 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
#line 90 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error_);
#line 90 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		block73_data_unref (_data_->_data73_);
#line 90 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_data73_ = NULL;
#line 90 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_object_unref (_data_->_async_result);
#line 90 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return FALSE;
#line 2905 "smtp-outbox-folder.c"
	}
#line 109 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp1_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_data_->_data73_->outbox_low, GEARY_TYPE_EMAIL_IDENTIFIER, GearyEmailIdentifier));
#line 109 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_data_->low);
#line 109 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->low = _data_->_tmp1_;
#line 110 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp2_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_data_->_data73_->outbox_high, GEARY_TYPE_EMAIL_IDENTIFIER, GearyEmailIdentifier));
#line 110 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_data_->high);
#line 110 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->high = _data_->_tmp2_;
#line 85 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	block73_data_unref (_data_->_data73_);
#line 85 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_data73_ = NULL;
#line 85 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 85 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (_data_->_state_ != 0) {
#line 85 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		while (_data_->_task_complete_ != TRUE) {
#line 85 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 2931 "smtp-outbox-folder.c"
		}
	}
#line 85 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_object_unref (_data_->_async_result);
#line 85 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return FALSE;
#line 2938 "smtp-outbox-folder.c"
}


static void
geary_smtp_outbox_folder_add_to_containing_folders_async_data_free (gpointer _data)
{
	GearySmtpOutboxFolderAddToContainingFoldersAsyncData* _data_;
	_data_ = _data;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_data_->cancellable);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_data_->self);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_slice_free (GearySmtpOutboxFolderAddToContainingFoldersAsyncData, _data_);
#line 2953 "smtp-outbox-folder.c"
}


static void
geary_smtp_outbox_folder_add_to_containing_folders_async_async_ready_wrapper (GObject *source_object,
                                                                              GAsyncResult *res,
                                                                              void *user_data)
{
	GearySmtpOutboxFolderAddToContainingFoldersAsyncData* _task_data_;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_task_data_ = g_task_get_task_data (G_TASK (res));
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (_task_data_->_callback_ != NULL) {
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_task_data_->_callback_ (source_object, res, user_data);
#line 2969 "smtp-outbox-folder.c"
	}
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_task_data_->_task_complete_ = TRUE;
#line 2973 "smtp-outbox-folder.c"
}


void
geary_smtp_outbox_folder_add_to_containing_folders_async (GearySmtpOutboxFolder* self,
                                                          GeeCollection* ids,
                                                          GeeHashMultiMap* map,
                                                          GCancellable* cancellable,
                                                          GAsyncReadyCallback _callback_,
                                                          gpointer _user_data_)
{
	GearySmtpOutboxFolderAddToContainingFoldersAsyncData* _data_;
	GearySmtpOutboxFolder* _tmp0_;
	GeeCollection* _tmp1_;
	GeeHashMultiMap* _tmp2_;
	GCancellable* _tmp3_;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_ = g_slice_new0 (GearySmtpOutboxFolderAddToContainingFoldersAsyncData);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_callback_ = _callback_;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), cancellable, geary_smtp_outbox_folder_add_to_containing_folders_async_async_ready_wrapper, _user_data_);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (_callback_ == NULL) {
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_task_complete_ = TRUE;
#line 3000 "smtp-outbox-folder.c"
	}
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_task_set_task_data (_data_->_async_result, _data_, geary_smtp_outbox_folder_add_to_containing_folders_async_data_free);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->self = _tmp0_;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp1_ = _g_object_ref0 (ids);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_data_->ids);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->ids = _tmp1_;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp2_ = _g_object_ref0 (map);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_data_->map);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->map = _tmp2_;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp3_ = _g_object_ref0 (cancellable);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_data_->cancellable);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->cancellable = _tmp3_;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	geary_smtp_outbox_folder_add_to_containing_folders_async_co (_data_);
#line 3028 "smtp-outbox-folder.c"
}


void
geary_smtp_outbox_folder_add_to_containing_folders_finish (GearySmtpOutboxFolder* self,
                                                           GAsyncResult* _res_,
                                                           GError** error)
{
	GearySmtpOutboxFolderAddToContainingFoldersAsyncData* _data_;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (NULL == _data_) {
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return;
#line 3044 "smtp-outbox-folder.c"
	}
}


static Block74Data*
block74_data_ref (Block74Data* _data74_)
{
#line 113 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_atomic_int_inc (&_data74_->_ref_count_);
#line 113 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return _data74_;
#line 3056 "smtp-outbox-folder.c"
}


static void
block74_data_unref (void * _userdata_)
{
	Block74Data* _data74_;
	_data74_ = (Block74Data*) _userdata_;
#line 113 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (g_atomic_int_dec_and_test (&_data74_->_ref_count_)) {
#line 3067 "smtp-outbox-folder.c"
		GearySmtpOutboxFolder* self;
#line 113 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		self = _data74_->self;
#line 113 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (_data74_->ids);
#line 113 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (_data74_->map);
#line 113 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (self);
#line 113 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_slice_free (Block74Data, _data74_);
#line 3079 "smtp-outbox-folder.c"
	}
}


static GearyDbTransactionOutcome
__lambda99_ (Block74Data* _data74_,
             GearyDbConnection* cx,
             GCancellable* cancellable,
             GError** error)
{
	GearySmtpOutboxFolder* self;
	GearyDbTransactionOutcome result = 0;
	GError * _inner_error_ = NULL;
#line 115 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	self = _data74_->self;
#line 115 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_return_val_if_fail (GEARY_DB_IS_CONNECTION (cx), 0);
#line 115 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_return_val_if_fail ((cancellable == NULL) || G_IS_CANCELLABLE (cancellable), 0);
#line 3099 "smtp-outbox-folder.c"
	{
		GeeIterator* _id_it = NULL;
		GeeIterator* _tmp0_;
#line 116 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_tmp0_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_data74_->ids, GEE_TYPE_ITERABLE, GeeIterable));
#line 116 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_id_it = _tmp0_;
#line 116 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		while (TRUE) {
#line 3109 "smtp-outbox-folder.c"
			GeeIterator* _tmp1_;
			GearyEmailIdentifier* id = NULL;
			GeeIterator* _tmp2_;
			gpointer _tmp3_;
			GearySmtpOutboxEmailIdentifier* outbox_id = NULL;
			GearyEmailIdentifier* _tmp4_;
			GearySmtpOutboxEmailIdentifier* _tmp5_;
			GearySmtpOutboxEmailIdentifier* _tmp6_;
			GearySmtpOutboxFolderOutboxRow* row = NULL;
			GearySmtpOutboxEmailIdentifier* _tmp7_;
			gint64 _tmp8_;
			gint64 _tmp9_;
			GearySmtpOutboxFolderOutboxRow* _tmp10_;
			GearySmtpOutboxFolderOutboxRow* _tmp11_;
			GearyEmailIdentifier* _tmp12_;
			GearyFolderPath* _tmp13_;
			GearyFolderPath* _tmp14_;
#line 116 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp1_ = _id_it;
#line 116 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			if (!gee_iterator_next (_tmp1_)) {
#line 116 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				break;
#line 3133 "smtp-outbox-folder.c"
			}
#line 116 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp2_ = _id_it;
#line 116 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp3_ = gee_iterator_get (_tmp2_);
#line 116 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			id = (GearyEmailIdentifier*) _tmp3_;
#line 117 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp4_ = id;
#line 117 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp5_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp4_, GEARY_TYPE_SMTP_OUTBOX_EMAIL_IDENTIFIER) ? ((GearySmtpOutboxEmailIdentifier*) _tmp4_) : NULL);
#line 117 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			outbox_id = _tmp5_;
#line 118 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp6_ = outbox_id;
#line 118 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			if (_tmp6_ == NULL) {
#line 119 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_g_object_unref0 (outbox_id);
#line 119 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_g_object_unref0 (id);
#line 119 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				continue;
#line 3157 "smtp-outbox-folder.c"
			}
#line 121 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp7_ = outbox_id;
#line 121 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp8_ = geary_smtp_outbox_email_identifier_get_ordering (_tmp7_);
#line 121 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp9_ = _tmp8_;
#line 121 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp10_ = geary_smtp_outbox_folder_do_fetch_row_by_ordering (self, cx, _tmp9_, cancellable, &_inner_error_);
#line 121 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			row = _tmp10_;
#line 121 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 121 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				g_propagate_error (error, _inner_error_);
#line 121 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_g_object_unref0 (outbox_id);
#line 121 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_g_object_unref0 (id);
#line 121 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_g_object_unref0 (_id_it);
#line 121 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				return 0;
#line 3181 "smtp-outbox-folder.c"
			}
#line 122 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp11_ = row;
#line 122 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			if (_tmp11_ == NULL) {
#line 123 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_geary_smtp_outbox_folder_outbox_row_unref0 (row);
#line 123 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_g_object_unref0 (outbox_id);
#line 123 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_g_object_unref0 (id);
#line 123 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				continue;
#line 3195 "smtp-outbox-folder.c"
			}
#line 125 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp12_ = id;
#line 125 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp13_ = geary_folder_get_path (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_TYPE_FOLDER, GearyFolder));
#line 125 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp14_ = _tmp13_;
#line 125 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			gee_multi_map_set (G_TYPE_CHECK_INSTANCE_CAST (_data74_->map, GEE_TYPE_MULTI_MAP, GeeMultiMap), _tmp12_, _tmp14_);
#line 116 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_geary_smtp_outbox_folder_outbox_row_unref0 (row);
#line 116 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_g_object_unref0 (outbox_id);
#line 116 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_g_object_unref0 (id);
#line 3211 "smtp-outbox-folder.c"
		}
#line 116 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (_id_it);
#line 3215 "smtp-outbox-folder.c"
	}
#line 128 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	result = GEARY_DB_TRANSACTION_OUTCOME_DONE;
#line 128 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return result;
#line 3221 "smtp-outbox-folder.c"
}


static GearyDbTransactionOutcome
___lambda99__geary_db_transaction_method (GearyDbConnection* cx,
                                          GCancellable* cancellable,
                                          gpointer self,
                                          GError** error)
{
	GearyDbTransactionOutcome result;
	result = __lambda99_ (self, cx, cancellable, error);
#line 115 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return result;
#line 3235 "smtp-outbox-folder.c"
}


static void
geary_smtp_outbox_folder_add_to_containing_folders_async_ready (GObject* source_object,
                                                                GAsyncResult* _res_,
                                                                gpointer _user_data_)
{
	GearySmtpOutboxFolderAddToContainingFoldersAsyncData* _data_;
#line 115 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_ = _user_data_;
#line 115 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_source_object_ = source_object;
#line 115 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_res_ = _res_;
#line 115 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_task_complete_ = TRUE;
#line 115 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	geary_smtp_outbox_folder_add_to_containing_folders_async_co (_data_);
#line 3255 "smtp-outbox-folder.c"
}


static gboolean
geary_smtp_outbox_folder_add_to_containing_folders_async_co (GearySmtpOutboxFolderAddToContainingFoldersAsyncData* _data_)
{
#line 113 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	switch (_data_->_state_) {
#line 113 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		case 0:
#line 3266 "smtp-outbox-folder.c"
		goto _state_0;
#line 113 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		case 1:
#line 3270 "smtp-outbox-folder.c"
		goto _state_1;
		default:
#line 113 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_assert_not_reached ();
#line 3275 "smtp-outbox-folder.c"
	}
	_state_0:
#line 113 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_data74_ = g_slice_new0 (Block74Data);
#line 113 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_data74_->_ref_count_ = 1;
#line 113 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_data74_->self = g_object_ref (_data_->self);
#line 113 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_data_->_data74_->ids);
#line 113 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_data74_->ids = _data_->ids;
#line 113 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_data_->_data74_->map);
#line 113 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_data74_->map = _data_->map;
#line 113 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_data74_->_async_data_ = _data_;
#line 115 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp0_ = _data_->self->priv->db;
#line 115 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_state_ = 1;
#line 115 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	geary_db_database_exec_transaction_async (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp0_, GEARY_DB_TYPE_DATABASE, GearyDbDatabase), GEARY_DB_TRANSACTION_TYPE_RO, ___lambda99__geary_db_transaction_method, _data_->_data74_, _data_->cancellable, geary_smtp_outbox_folder_add_to_containing_folders_async_ready, _data_);
#line 115 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return FALSE;
#line 3302 "smtp-outbox-folder.c"
	_state_1:
#line 115 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	geary_db_database_exec_transaction_finish (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp0_, GEARY_DB_TYPE_DATABASE, GearyDbDatabase), _data_->_res_, &_data_->_inner_error_);
#line 115 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
#line 115 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error_);
#line 115 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		block74_data_unref (_data_->_data74_);
#line 115 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_data74_ = NULL;
#line 115 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_object_unref (_data_->_async_result);
#line 115 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return FALSE;
#line 3318 "smtp-outbox-folder.c"
	}
#line 113 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	block74_data_unref (_data_->_data74_);
#line 113 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_data74_ = NULL;
#line 113 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 113 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (_data_->_state_ != 0) {
#line 113 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		while (_data_->_task_complete_ != TRUE) {
#line 113 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 3332 "smtp-outbox-folder.c"
		}
	}
#line 113 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_object_unref (_data_->_async_result);
#line 113 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return FALSE;
#line 3339 "smtp-outbox-folder.c"
}


static gchar*
geary_smtp_outbox_folder_message_subject (GearyRFC822Message* message)
{
	gchar* result = NULL;
	gchar* _tmp0_ = NULL;
	gboolean _tmp1_ = FALSE;
	GearyRFC822Subject* _tmp2_;
	GearyRFC822Subject* _tmp3_;
#line 133 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_return_val_if_fail (GEARY_RF_C822_IS_MESSAGE (message), NULL);
#line 134 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp2_ = geary_rf_c822_message_get_subject (message);
#line 134 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp3_ = _tmp2_;
#line 134 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (_tmp3_ != NULL) {
#line 3359 "smtp-outbox-folder.c"
		GearyRFC822Subject* _tmp4_;
		GearyRFC822Subject* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
#line 134 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_tmp4_ = geary_rf_c822_message_get_subject (message);
#line 134 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_tmp5_ = _tmp4_;
#line 134 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_tmp6_ = geary_message_data_abstract_message_data_to_string (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, GEARY_MESSAGE_DATA_TYPE_ABSTRACT_MESSAGE_DATA, GearyMessageDataAbstractMessageData));
#line 134 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_tmp7_ = _tmp6_;
#line 134 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_tmp1_ = !geary_string_is_empty (_tmp7_);
#line 134 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_free0 (_tmp7_);
#line 3376 "smtp-outbox-folder.c"
	} else {
#line 134 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_tmp1_ = FALSE;
#line 3380 "smtp-outbox-folder.c"
	}
#line 134 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (_tmp1_) {
#line 3384 "smtp-outbox-folder.c"
		GearyRFC822Subject* _tmp8_;
		GearyRFC822Subject* _tmp9_;
		gchar* _tmp10_;
#line 135 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_tmp8_ = geary_rf_c822_message_get_subject (message);
#line 135 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_tmp9_ = _tmp8_;
#line 135 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_tmp10_ = geary_message_data_abstract_message_data_to_string (G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, GEARY_MESSAGE_DATA_TYPE_ABSTRACT_MESSAGE_DATA, GearyMessageDataAbstractMessageData));
#line 135 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_free0 (_tmp0_);
#line 135 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_tmp0_ = _tmp10_;
#line 3398 "smtp-outbox-folder.c"
	} else {
		gchar* _tmp11_;
#line 135 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_tmp11_ = g_strdup ("(no subject)");
#line 135 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_free0 (_tmp0_);
#line 135 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_tmp0_ = _tmp11_;
#line 3407 "smtp-outbox-folder.c"
	}
#line 134 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	result = _tmp0_;
#line 134 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return result;
#line 3413 "smtp-outbox-folder.c"
}


static void
geary_smtp_outbox_folder_fill_outbox_queue_data_free (gpointer _data)
{
	GearySmtpOutboxFolderFillOutboxQueueData* _data_;
	_data_ = _data;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_data_->self);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_slice_free (GearySmtpOutboxFolderFillOutboxQueueData, _data_);
#line 3426 "smtp-outbox-folder.c"
}


static void
geary_smtp_outbox_folder_fill_outbox_queue_async_ready_wrapper (GObject *source_object,
                                                                GAsyncResult *res,
                                                                void *user_data)
{
	GearySmtpOutboxFolderFillOutboxQueueData* _task_data_;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_task_data_ = g_task_get_task_data (G_TASK (res));
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (_task_data_->_callback_ != NULL) {
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_task_data_->_callback_ (source_object, res, user_data);
#line 3442 "smtp-outbox-folder.c"
	}
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_task_data_->_task_complete_ = TRUE;
#line 3446 "smtp-outbox-folder.c"
}


static void
geary_smtp_outbox_folder_fill_outbox_queue (GearySmtpOutboxFolder* self,
                                            GAsyncReadyCallback _callback_,
                                            gpointer _user_data_)
{
	GearySmtpOutboxFolderFillOutboxQueueData* _data_;
	GearySmtpOutboxFolder* _tmp0_;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_ = g_slice_new0 (GearySmtpOutboxFolderFillOutboxQueueData);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_callback_ = _callback_;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, geary_smtp_outbox_folder_fill_outbox_queue_async_ready_wrapper, _user_data_);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (_callback_ == NULL) {
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_task_complete_ = TRUE;
#line 3467 "smtp-outbox-folder.c"
	}
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_task_set_task_data (_data_->_async_result, _data_, geary_smtp_outbox_folder_fill_outbox_queue_data_free);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->self = _tmp0_;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	geary_smtp_outbox_folder_fill_outbox_queue_co (_data_);
#line 3477 "smtp-outbox-folder.c"
}


static void
geary_smtp_outbox_folder_fill_outbox_queue_finish (GearySmtpOutboxFolder* self,
                                                   GAsyncResult* _res_)
{
	GearySmtpOutboxFolderFillOutboxQueueData* _data_;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 3488 "smtp-outbox-folder.c"
}


static Block75Data*
block75_data_ref (Block75Data* _data75_)
{
#line 142 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_atomic_int_inc (&_data75_->_ref_count_);
#line 142 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return _data75_;
#line 3499 "smtp-outbox-folder.c"
}


static void
block75_data_unref (void * _userdata_)
{
	Block75Data* _data75_;
	_data75_ = (Block75Data*) _userdata_;
#line 142 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (g_atomic_int_dec_and_test (&_data75_->_ref_count_)) {
#line 3510 "smtp-outbox-folder.c"
		GearySmtpOutboxFolder* self;
#line 142 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		self = _data75_->self;
#line 142 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (_data75_->list);
#line 142 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (self);
#line 142 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_slice_free (Block75Data, _data75_);
#line 3520 "smtp-outbox-folder.c"
	}
}


static GearyDbTransactionOutcome
___lambda84_ (Block75Data* _data75_,
              GearyDbConnection* cx,
              GCancellable* cancellable,
              GError** error)
{
	GearySmtpOutboxFolder* self;
	GearyDbTransactionOutcome result = 0;
	GearyDbStatement* stmt = NULL;
	GearyDbStatement* _tmp0_;
	GearyDbResult* results = NULL;
	GearyDbStatement* _tmp1_;
	GearyDbResult* _tmp2_;
	gint position = 0;
	GError * _inner_error_ = NULL;
#line 144 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	self = _data75_->self;
#line 144 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_return_val_if_fail (GEARY_DB_IS_CONNECTION (cx), 0);
#line 144 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_return_val_if_fail ((cancellable == NULL) || G_IS_CANCELLABLE (cancellable), 0);
#line 145 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp0_ = geary_db_connection_prepare (cx, "\n" \
"                    SELECT id, ordering, message\n" \
"                    FROM SmtpOutboxTable\n" \
"                    ORDER BY ordering\n" \
"                ", &_inner_error_);
#line 145 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	stmt = _tmp0_;
#line 145 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 145 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_propagate_error (error, _inner_error_);
#line 145 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return 0;
#line 3556 "smtp-outbox-folder.c"
	}
#line 151 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp1_ = stmt;
#line 151 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp2_ = geary_db_statement_exec (_tmp1_, cancellable, &_inner_error_);
#line 151 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	results = _tmp2_;
#line 151 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 151 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_propagate_error (error, _inner_error_);
#line 151 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (stmt);
#line 151 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return 0;
#line 3572 "smtp-outbox-folder.c"
	}
#line 152 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	position = 1;
#line 153 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	while (TRUE) {
#line 3578 "smtp-outbox-folder.c"
		GearyDbResult* _tmp3_;
		gboolean _tmp4_;
		gboolean _tmp5_;
		gint64 _tmp6_ = 0LL;
		GearyDbResult* _tmp7_;
		gint64 _tmp8_ = 0LL;
		GearyDbResult* _tmp9_;
		GearyMemoryBuffer* _tmp10_ = NULL;
		GearyDbResult* _tmp11_;
		GearyMemoryBuffer* _tmp12_;
		gint _tmp13_;
		GearySmtpOutboxFolderRoot* _tmp14_;
		GearySmtpOutboxFolderOutboxRow* _tmp15_;
		GearySmtpOutboxFolderOutboxRow* _tmp16_;
		GearyDbResult* _tmp17_;
#line 153 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_tmp3_ = results;
#line 153 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_tmp4_ = geary_db_result_get_finished (_tmp3_);
#line 153 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_tmp5_ = _tmp4_;
#line 153 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		if (!(!_tmp5_)) {
#line 153 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			break;
#line 3604 "smtp-outbox-folder.c"
		}
#line 154 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_tmp7_ = results;
#line 154 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_tmp6_ = geary_db_result_rowid_at (_tmp7_, 0, &_inner_error_);
#line 154 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 154 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			g_propagate_error (error, _inner_error_);
#line 154 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_g_object_unref0 (results);
#line 154 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_g_object_unref0 (stmt);
#line 154 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			return 0;
#line 3620 "smtp-outbox-folder.c"
		}
#line 154 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_tmp9_ = results;
#line 154 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_tmp8_ = geary_db_result_int64_at (_tmp9_, 1, &_inner_error_);
#line 154 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 154 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			g_propagate_error (error, _inner_error_);
#line 154 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_g_object_unref0 (results);
#line 154 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_g_object_unref0 (stmt);
#line 154 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			return 0;
#line 3636 "smtp-outbox-folder.c"
		}
#line 155 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_tmp11_ = results;
#line 155 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_tmp12_ = geary_db_result_string_buffer_at (_tmp11_, 2, &_inner_error_);
#line 155 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_tmp10_ = _tmp12_;
#line 155 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 155 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			g_propagate_error (error, _inner_error_);
#line 155 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_g_object_unref0 (results);
#line 155 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_g_object_unref0 (stmt);
#line 155 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			return 0;
#line 3654 "smtp-outbox-folder.c"
		}
#line 154 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_tmp13_ = position;
#line 154 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		position = _tmp13_ + 1;
#line 154 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_tmp14_ = self->priv->_path;
#line 154 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_tmp15_ = geary_smtp_outbox_folder_outbox_row_new (_tmp6_, _tmp13_, _tmp8_, FALSE, _tmp10_, _tmp14_);
#line 154 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_tmp16_ = _tmp15_;
#line 154 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		gee_abstract_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_data75_->list, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), _tmp16_);
#line 154 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_geary_smtp_outbox_folder_outbox_row_unref0 (_tmp16_);
#line 156 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_tmp17_ = results;
#line 156 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		geary_db_result_next (_tmp17_, cancellable, &_inner_error_);
#line 156 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 156 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			g_propagate_error (error, _inner_error_);
#line 156 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_g_object_unref0 (_tmp10_);
#line 156 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_g_object_unref0 (results);
#line 156 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_g_object_unref0 (stmt);
#line 156 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			return 0;
#line 3686 "smtp-outbox-folder.c"
		}
#line 153 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (_tmp10_);
#line 3690 "smtp-outbox-folder.c"
	}
#line 159 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	result = GEARY_DB_TRANSACTION_OUTCOME_DONE;
#line 159 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (results);
#line 159 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (stmt);
#line 159 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return result;
#line 3700 "smtp-outbox-folder.c"
}


static GearyDbTransactionOutcome
____lambda84__geary_db_transaction_method (GearyDbConnection* cx,
                                           GCancellable* cancellable,
                                           gpointer self,
                                           GError** error)
{
	GearyDbTransactionOutcome result;
	result = ___lambda84_ (self, cx, cancellable, error);
#line 144 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return result;
#line 3714 "smtp-outbox-folder.c"
}


static void
geary_smtp_outbox_folder_fill_outbox_queue_ready (GObject* source_object,
                                                  GAsyncResult* _res_,
                                                  gpointer _user_data_)
{
	GearySmtpOutboxFolderFillOutboxQueueData* _data_;
#line 144 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_ = _user_data_;
#line 144 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_source_object_ = source_object;
#line 144 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_res_ = _res_;
#line 144 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_task_complete_ = TRUE;
#line 144 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	geary_smtp_outbox_folder_fill_outbox_queue_co (_data_);
#line 3734 "smtp-outbox-folder.c"
}


static gboolean
geary_smtp_outbox_folder_fill_outbox_queue_co (GearySmtpOutboxFolderFillOutboxQueueData* _data_)
{
#line 140 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	switch (_data_->_state_) {
#line 140 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		case 0:
#line 3745 "smtp-outbox-folder.c"
		goto _state_0;
#line 140 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		case 1:
#line 3749 "smtp-outbox-folder.c"
		goto _state_1;
		default:
#line 140 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_assert_not_reached ();
#line 3754 "smtp-outbox-folder.c"
	}
	_state_0:
#line 141 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_debug ("smtp-outbox-folder.vala:141: Filling outbox queue");
#line 3759 "smtp-outbox-folder.c"
	{
#line 142 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_data75_ = g_slice_new0 (Block75Data);
#line 142 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_data75_->_ref_count_ = 1;
#line 142 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_data75_->self = g_object_ref (_data_->self);
#line 143 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_tmp0_ = gee_array_list_new (GEARY_SMTP_OUTBOX_FOLDER_TYPE_OUTBOX_ROW, (GBoxedCopyFunc) geary_smtp_outbox_folder_outbox_row_ref, (GDestroyNotify) geary_smtp_outbox_folder_outbox_row_unref, NULL, NULL, NULL);
#line 143 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_data75_->list = _data_->_tmp0_;
#line 144 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_tmp1_ = _data_->self->priv->db;
#line 144 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_state_ = 1;
#line 144 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		geary_db_database_exec_transaction_async (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp1_, GEARY_DB_TYPE_DATABASE, GearyDbDatabase), GEARY_DB_TRANSACTION_TYPE_RO, ____lambda84__geary_db_transaction_method, _data_->_data75_, NULL, geary_smtp_outbox_folder_fill_outbox_queue_ready, _data_);
#line 144 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return FALSE;
#line 3779 "smtp-outbox-folder.c"
		_state_1:
#line 144 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		geary_db_database_exec_transaction_finish (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp1_, GEARY_DB_TYPE_DATABASE, GearyDbDatabase), _data_->_res_, &_data_->_inner_error_);
#line 144 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
#line 144 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			block75_data_unref (_data_->_data75_);
#line 144 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_data_->_data75_ = NULL;
#line 3789 "smtp-outbox-folder.c"
			goto __catch196_g_error;
		}
#line 162 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_tmp2_ = gee_abstract_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_data_->_data75_->list, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection));
#line 162 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_tmp3_ = _data_->_tmp2_;
#line 162 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		if (_data_->_tmp3_ > 0) {
#line 164 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_data_->_tmp4_ = _data_->self->priv->_properties;
#line 164 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_data_->_tmp5_ = gee_abstract_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_data_->_data75_->list, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection));
#line 164 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_data_->_tmp6_ = _data_->_tmp5_;
#line 164 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			geary_smtp_outbox_folder_properties_set_total (_data_->_tmp4_, _data_->_tmp6_);
#line 166 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_data_->_tmp7_ = gee_abstract_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_data_->_data75_->list, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection));
#line 166 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_data_->_tmp8_ = _data_->_tmp7_;
#line 166 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			g_debug ("smtp-outbox-folder.vala:166: Priming outbox postman with %d stored mes" \
"sages", _data_->_tmp8_);
#line 3812 "smtp-outbox-folder.c"
			{
#line 167 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_tmp9_ = _g_object_ref0 (_data_->_data75_->list);
#line 167 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_row_list = _data_->_tmp9_;
#line 167 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_tmp10_ = _data_->_row_list;
#line 167 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_tmp11_ = gee_abstract_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp10_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection));
#line 167 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_tmp12_ = _data_->_tmp11_;
#line 167 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_row_size = _data_->_tmp12_;
#line 167 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_row_index = -1;
#line 167 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				while (TRUE) {
#line 167 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					_data_->_tmp13_ = _data_->_row_index;
#line 167 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					_data_->_row_index = _data_->_tmp13_ + 1;
#line 167 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					_data_->_tmp14_ = _data_->_row_index;
#line 167 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					_data_->_tmp15_ = _data_->_row_size;
#line 167 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					if (!(_data_->_tmp14_ < _data_->_tmp15_)) {
#line 167 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
						break;
#line 3842 "smtp-outbox-folder.c"
					}
#line 167 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					_data_->_tmp16_ = _data_->_row_list;
#line 167 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					_data_->_tmp17_ = _data_->_row_index;
#line 167 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					_data_->_tmp18_ = gee_abstract_list_get (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp16_, GEE_TYPE_ABSTRACT_LIST, GeeAbstractList), _data_->_tmp17_);
#line 167 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					_data_->row = (GearySmtpOutboxFolderOutboxRow*) _data_->_tmp18_;
#line 168 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					_data_->_tmp19_ = _data_->self->priv->outbox_queue;
#line 168 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					_data_->_tmp20_ = _data_->row;
#line 168 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					geary_nonblocking_mailbox_send (_data_->_tmp19_, _data_->_tmp20_);
#line 167 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					_geary_smtp_outbox_folder_outbox_row_unref0 (_data_->row);
#line 3860 "smtp-outbox-folder.c"
				}
#line 167 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_g_object_unref0 (_data_->_row_list);
#line 3864 "smtp-outbox-folder.c"
			}
		}
#line 142 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		block75_data_unref (_data_->_data75_);
#line 142 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_data75_ = NULL;
#line 3871 "smtp-outbox-folder.c"
	}
	goto __finally196;
	__catch196_g_error:
	{
#line 142 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->prime_err = _data_->_inner_error_;
#line 142 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_inner_error_ = NULL;
#line 171 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_tmp21_ = _data_->prime_err;
#line 171 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_tmp22_ = _data_->_tmp21_->message;
#line 171 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_warning ("smtp-outbox-folder.vala:171: Error priming outbox: %s", _data_->_tmp22_);
#line 142 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_error_free0 (_data_->prime_err);
#line 3888 "smtp-outbox-folder.c"
	}
	__finally196:
#line 142 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
#line 142 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error_->message, g_quark_to_string (_data_->_inner_error_->domain), _data_->_inner_error_->code);
#line 142 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_clear_error (&_data_->_inner_error_);
#line 142 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_object_unref (_data_->_async_result);
#line 142 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return FALSE;
#line 3901 "smtp-outbox-folder.c"
	}
#line 140 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 140 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (_data_->_state_ != 0) {
#line 140 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		while (_data_->_task_complete_ != TRUE) {
#line 140 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 3911 "smtp-outbox-folder.c"
		}
	}
#line 140 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_object_unref (_data_->_async_result);
#line 140 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return FALSE;
#line 3918 "smtp-outbox-folder.c"
}


static void
geary_smtp_outbox_folder_do_postman_async_data_free (gpointer _data)
{
	GearySmtpOutboxFolderDoPostmanAsyncData* _data_;
	_data_ = _data;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_data_->self);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_slice_free (GearySmtpOutboxFolderDoPostmanAsyncData, _data_);
#line 3931 "smtp-outbox-folder.c"
}


static void
geary_smtp_outbox_folder_do_postman_async_async_ready_wrapper (GObject *source_object,
                                                               GAsyncResult *res,
                                                               void *user_data)
{
	GearySmtpOutboxFolderDoPostmanAsyncData* _task_data_;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_task_data_ = g_task_get_task_data (G_TASK (res));
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (_task_data_->_callback_ != NULL) {
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_task_data_->_callback_ (source_object, res, user_data);
#line 3947 "smtp-outbox-folder.c"
	}
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_task_data_->_task_complete_ = TRUE;
#line 3951 "smtp-outbox-folder.c"
}


static void
geary_smtp_outbox_folder_do_postman_async (GearySmtpOutboxFolder* self,
                                           GAsyncReadyCallback _callback_,
                                           gpointer _user_data_)
{
	GearySmtpOutboxFolderDoPostmanAsyncData* _data_;
	GearySmtpOutboxFolder* _tmp0_;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_ = g_slice_new0 (GearySmtpOutboxFolderDoPostmanAsyncData);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_callback_ = _callback_;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, geary_smtp_outbox_folder_do_postman_async_async_ready_wrapper, _user_data_);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (_callback_ == NULL) {
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_task_complete_ = TRUE;
#line 3972 "smtp-outbox-folder.c"
	}
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_task_set_task_data (_data_->_async_result, _data_, geary_smtp_outbox_folder_do_postman_async_data_free);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->self = _tmp0_;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	geary_smtp_outbox_folder_do_postman_async_co (_data_);
#line 3982 "smtp-outbox-folder.c"
}


static void
geary_smtp_outbox_folder_do_postman_finish (GearySmtpOutboxFolder* self,
                                            GAsyncResult* _res_)
{
	GearySmtpOutboxFolderDoPostmanAsyncData* _data_;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 3993 "smtp-outbox-folder.c"
}


static void
geary_smtp_outbox_folder_do_postman_async_ready (GObject* source_object,
                                                 GAsyncResult* _res_,
                                                 gpointer _user_data_)
{
	GearySmtpOutboxFolderDoPostmanAsyncData* _data_;
#line 187 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_ = _user_data_;
#line 187 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_source_object_ = source_object;
#line 187 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_res_ = _res_;
#line 187 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_task_complete_ = TRUE;
#line 187 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	geary_smtp_outbox_folder_do_postman_async_co (_data_);
#line 4013 "smtp-outbox-folder.c"
}


static gboolean
geary_smtp_outbox_folder_do_postman_async_co (GearySmtpOutboxFolderDoPostmanAsyncData* _data_)
{
#line 177 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	switch (_data_->_state_) {
#line 177 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		case 0:
#line 4024 "smtp-outbox-folder.c"
		goto _state_0;
#line 177 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		case 1:
#line 4028 "smtp-outbox-folder.c"
		goto _state_1;
#line 177 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		case 2:
#line 4032 "smtp-outbox-folder.c"
		goto _state_2;
#line 177 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		case 3:
#line 4036 "smtp-outbox-folder.c"
		goto _state_3;
#line 177 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		case 4:
#line 4040 "smtp-outbox-folder.c"
		goto _state_4;
#line 177 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		case 5:
#line 4044 "smtp-outbox-folder.c"
		goto _state_5;
#line 177 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		case 6:
#line 4048 "smtp-outbox-folder.c"
		goto _state_6;
#line 177 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		case 7:
#line 4052 "smtp-outbox-folder.c"
		goto _state_7;
#line 177 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		case 8:
#line 4056 "smtp-outbox-folder.c"
		goto _state_8;
#line 177 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		case 9:
#line 4060 "smtp-outbox-folder.c"
		goto _state_9;
		default:
#line 177 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_assert_not_reached ();
#line 4065 "smtp-outbox-folder.c"
	}
	_state_0:
#line 178 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_debug ("smtp-outbox-folder.vala:178: Starting outbox postman");
#line 179 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->send_retry_seconds = GEARY_SMTP_OUTBOX_FOLDER_MIN_SEND_RETRY_INTERVAL_SEC;
#line 4072 "smtp-outbox-folder.c"
	{
#line 182 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_tmp0_ = TRUE;
#line 182 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		while (TRUE) {
#line 182 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			if (!_data_->_tmp0_) {
#line 4080 "smtp-outbox-folder.c"
			}
#line 182 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_data_->_tmp0_ = FALSE;
#line 4084 "smtp-outbox-folder.c"
			{
#line 187 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_tmp2_ = _data_->self->priv->outbox_queue;
#line 187 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_state_ = 1;
#line 187 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				geary_nonblocking_mailbox_recv_async (_data_->_tmp2_, NULL, geary_smtp_outbox_folder_do_postman_async_ready, _data_);
#line 187 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				return FALSE;
#line 4094 "smtp-outbox-folder.c"
				_state_1:
#line 187 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_tmp3_ = geary_nonblocking_mailbox_recv_finish (_data_->_tmp2_, _data_->_res_, &_data_->_inner_error_);
#line 187 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_tmp1_ = (GearySmtpOutboxFolderOutboxRow*) _data_->_tmp3_;
#line 187 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
#line 4102 "smtp-outbox-folder.c"
					goto __catch197_g_error;
				}
#line 187 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_tmp4_ = _data_->_tmp1_;
#line 187 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_tmp1_ = NULL;
#line 187 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_geary_smtp_outbox_folder_outbox_row_unref0 (_data_->row);
#line 187 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->row = _data_->_tmp4_;
#line 188 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_tmp6_ = _data_->row;
#line 188 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_tmp7_ = _data_->_tmp6_->ordering;
#line 188 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_state_ = 2;
#line 188 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				geary_smtp_outbox_folder_is_unsent_async (_data_->self, _data_->_tmp7_, NULL, geary_smtp_outbox_folder_do_postman_async_ready, _data_);
#line 188 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				return FALSE;
#line 4123 "smtp-outbox-folder.c"
				_state_2:
#line 188 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_tmp5_ = geary_smtp_outbox_folder_is_unsent_finish (_data_->self, _data_->_res_, &_data_->_inner_error_);
#line 188 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
#line 188 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					_geary_smtp_outbox_folder_outbox_row_unref0 (_data_->_tmp1_);
#line 4131 "smtp-outbox-folder.c"
					goto __catch197_g_error;
				}
#line 188 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->mail_sent = !_data_->_tmp5_;
#line 186 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_geary_smtp_outbox_folder_outbox_row_unref0 (_data_->_tmp1_);
#line 4138 "smtp-outbox-folder.c"
			}
			goto __finally197;
			__catch197_g_error:
			{
#line 186 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->wait_err = _data_->_inner_error_;
#line 186 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_inner_error_ = NULL;
#line 190 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_tmp8_ = _data_->wait_err->message;
#line 190 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				g_debug ("smtp-outbox-folder.vala:190: Outbox postman queue error: %s", _data_->_tmp8_);
#line 192 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_g_error_free0 (_data_->wait_err);
#line 192 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_geary_smtp_outbox_folder_outbox_row_unref0 (_data_->row);
#line 192 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				break;
#line 4157 "smtp-outbox-folder.c"
			}
			__finally197:
#line 186 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
#line 186 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_geary_smtp_outbox_folder_outbox_row_unref0 (_data_->row);
#line 186 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error_->message, g_quark_to_string (_data_->_inner_error_->domain), _data_->_inner_error_->code);
#line 186 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				g_clear_error (&_data_->_inner_error_);
#line 186 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				g_object_unref (_data_->_async_result);
#line 186 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				return FALSE;
#line 4172 "smtp-outbox-folder.c"
			}
			{
#line 198 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_tmp10_ = _data_->row;
#line 198 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_tmp11_ = _data_->_tmp10_->message;
#line 198 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_tmp12_ = geary_rf_c822_message_new_from_buffer (_data_->_tmp11_, &_data_->_inner_error_);
#line 198 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_tmp9_ = _data_->_tmp12_;
#line 198 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
#line 198 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					if (_data_->_inner_error_->domain == GEARY_RF_C822_ERROR) {
#line 4187 "smtp-outbox-folder.c"
						goto __catch198_geary_rf_c822_error;
					}
#line 198 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					_g_object_unref0 (_data_->message);
#line 198 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					_geary_smtp_outbox_folder_outbox_row_unref0 (_data_->row);
#line 198 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error_->message, g_quark_to_string (_data_->_inner_error_->domain), _data_->_inner_error_->code);
#line 198 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					g_clear_error (&_data_->_inner_error_);
#line 198 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					g_object_unref (_data_->_async_result);
#line 198 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					return FALSE;
#line 4202 "smtp-outbox-folder.c"
				}
#line 198 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_tmp13_ = _data_->_tmp9_;
#line 198 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_tmp9_ = NULL;
#line 198 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_g_object_unref0 (_data_->message);
#line 198 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->message = _data_->_tmp13_;
#line 197 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_g_object_unref0 (_data_->_tmp9_);
#line 4214 "smtp-outbox-folder.c"
			}
			goto __finally198;
			__catch198_geary_rf_c822_error:
			{
#line 197 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->msg_err = _data_->_inner_error_;
#line 197 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_inner_error_ = NULL;
#line 201 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_tmp14_ = _data_->msg_err;
#line 201 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_tmp15_ = _data_->_tmp14_->message;
#line 201 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				g_debug ("smtp-outbox-folder.vala:201: Outbox postman message error: %s", _data_->_tmp15_);
#line 203 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_g_error_free0 (_data_->msg_err);
#line 203 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_g_object_unref0 (_data_->message);
#line 203 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_geary_smtp_outbox_folder_outbox_row_unref0 (_data_->row);
#line 203 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				continue;
#line 4237 "smtp-outbox-folder.c"
			}
			__finally198:
#line 197 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
#line 197 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_g_object_unref0 (_data_->message);
#line 197 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_geary_smtp_outbox_folder_outbox_row_unref0 (_data_->row);
#line 197 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error_->message, g_quark_to_string (_data_->_inner_error_->domain), _data_->_inner_error_->code);
#line 197 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				g_clear_error (&_data_->_inner_error_);
#line 197 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				g_object_unref (_data_->_async_result);
#line 197 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				return FALSE;
#line 4254 "smtp-outbox-folder.c"
			}
#line 206 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_data_->_tmp16_ = _data_->mail_sent;
#line 206 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			if (!_data_->_tmp16_) {
#line 210 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_tmp18_ = _data_->self->priv->_account;
#line 210 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_tmp19_ = geary_account_get_information (_data_->_tmp18_);
#line 210 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_tmp20_ = _data_->_tmp19_;
#line 210 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_tmp21_ = geary_account_information_get_smtp_credentials (_data_->_tmp20_);
#line 210 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_tmp22_ = _data_->_tmp21_;
#line 210 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				if (_data_->_tmp22_ != NULL) {
#line 211 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					_data_->_tmp23_ = _data_->self->priv->_account;
#line 211 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					_data_->_tmp24_ = geary_account_get_information (_data_->_tmp23_);
#line 211 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					_data_->_tmp25_ = _data_->_tmp24_;
#line 211 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					_data_->_tmp26_ = geary_account_information_get_smtp_credentials (_data_->_tmp25_);
#line 211 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					_data_->_tmp27_ = _data_->_tmp26_;
#line 211 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					_data_->_tmp17_ = !geary_credentials_is_complete (_data_->_tmp27_);
#line 4284 "smtp-outbox-folder.c"
				} else {
#line 210 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					_data_->_tmp17_ = FALSE;
#line 4288 "smtp-outbox-folder.c"
				}
#line 210 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				if (_data_->_tmp17_) {
#line 4292 "smtp-outbox-folder.c"
					{
#line 213 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
						_data_->_tmp28_ = _data_->self->priv->_account;
#line 213 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
						_data_->_tmp29_ = geary_account_get_information (_data_->_tmp28_);
#line 213 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
						_data_->_tmp30_ = _data_->_tmp29_;
#line 213 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
						_data_->_state_ = 3;
#line 213 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
						geary_account_information_get_passwords_async (_data_->_tmp30_, GEARY_SERVICE_FLAG_SMTP, geary_smtp_outbox_folder_do_postman_async_ready, _data_);
#line 213 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
						return FALSE;
#line 4306 "smtp-outbox-folder.c"
						_state_3:
#line 213 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
						geary_account_information_get_passwords_finish (_data_->_tmp30_, _data_->_res_, &_data_->_inner_error_);
#line 213 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
						if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
#line 4312 "smtp-outbox-folder.c"
							goto __catch199_g_error;
						}
					}
					goto __finally199;
					__catch199_g_error:
					{
#line 212 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
						_data_->e = _data_->_inner_error_;
#line 212 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
						_data_->_inner_error_ = NULL;
#line 215 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
						_data_->_tmp31_ = _data_->e;
#line 215 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
						_data_->_tmp32_ = _data_->_tmp31_->message;
#line 215 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
						g_debug ("smtp-outbox-folder.vala:215: SMTP password fetch error: %s", _data_->_tmp32_);
#line 212 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
						_g_error_free0 (_data_->e);
#line 4331 "smtp-outbox-folder.c"
					}
					__finally199:
#line 212 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
#line 212 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
						_g_object_unref0 (_data_->message);
#line 212 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
						_geary_smtp_outbox_folder_outbox_row_unref0 (_data_->row);
#line 212 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error_->message, g_quark_to_string (_data_->_inner_error_->domain), _data_->_inner_error_->code);
#line 212 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
						g_clear_error (&_data_->_inner_error_);
#line 212 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
						g_object_unref (_data_->_async_result);
#line 212 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
						return FALSE;
#line 4348 "smtp-outbox-folder.c"
					}
				}
#line 220 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->should_nap = FALSE;
#line 4353 "smtp-outbox-folder.c"
				{
#line 224 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					_data_->_tmp33_ = _data_->self->priv->_account;
#line 224 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					_data_->_tmp34_ = geary_account_get_information (_data_->_tmp33_);
#line 224 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					_data_->_tmp35_ = _data_->_tmp34_;
#line 224 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					_data_->_tmp36_ = geary_account_information_get_smtp_endpoint (_data_->_tmp35_);
#line 224 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					_data_->_tmp37_ = _data_->_tmp36_;
#line 224 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					_data_->_tmp38_ = geary_endpoint_get_is_trusted_or_never_connected (_data_->_tmp37_);
#line 224 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					_data_->_tmp39_ = _data_->_tmp38_;
#line 224 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					_data_->_tmp40_ = _data_->_tmp39_;
#line 224 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					_g_object_unref0 (_data_->_tmp37_);
#line 224 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					if (_data_->_tmp40_) {
#line 225 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
						_data_->_tmp41_ = _data_->message;
#line 225 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
						_data_->_tmp42_ = geary_smtp_outbox_folder_message_subject (_data_->_tmp41_);
#line 225 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
						_data_->_tmp43_ = _data_->_tmp42_;
#line 225 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
						_data_->_tmp44_ = _data_->row;
#line 225 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
						_data_->_tmp45_ = _data_->_tmp44_->outbox_id;
#line 225 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
						_data_->_tmp46_ = geary_email_identifier_to_string (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp45_, GEARY_TYPE_EMAIL_IDENTIFIER, GearyEmailIdentifier));
#line 225 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
						_data_->_tmp47_ = _data_->_tmp46_;
#line 225 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
						g_debug ("smtp-outbox-folder.vala:225: Outbox postman: Sending \"%s\" (ID:%s)...", _data_->_tmp43_, _data_->_tmp47_);
#line 225 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
						_g_free0 (_data_->_tmp47_);
#line 225 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
						_g_free0 (_data_->_tmp43_);
#line 227 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
						_data_->_tmp48_ = _data_->message;
#line 227 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
						_data_->_state_ = 4;
#line 227 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
						geary_smtp_outbox_folder_send_email_async (_data_->self, _data_->_tmp48_, NULL, geary_smtp_outbox_folder_do_postman_async_ready, _data_);
#line 227 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
						return FALSE;
#line 4403 "smtp-outbox-folder.c"
						_state_4:
#line 227 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
						geary_smtp_outbox_folder_send_email_finish (_data_->self, _data_->_res_, &_data_->_inner_error_);
#line 227 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
						if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
#line 4409 "smtp-outbox-folder.c"
							goto __catch200_g_error;
						}
#line 228 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
						_data_->mail_sent = TRUE;
#line 4414 "smtp-outbox-folder.c"
					} else {
#line 232 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
						_data_->_tmp49_ = _data_->self->priv->outbox_queue;
#line 232 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
						_data_->_tmp50_ = _data_->row;
#line 232 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
						geary_nonblocking_mailbox_send (_data_->_tmp49_, _data_->_tmp50_);
#line 233 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
						_data_->should_nap = TRUE;
#line 4424 "smtp-outbox-folder.c"
					}
				}
				goto __finally200;
				__catch200_g_error:
				{
#line 221 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					_data_->send_err = _data_->_inner_error_;
#line 221 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					_data_->_inner_error_ = NULL;
#line 236 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					_data_->_tmp51_ = _data_->send_err;
#line 236 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					_data_->_tmp52_ = _data_->_tmp51_->message;
#line 236 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					g_debug ("smtp-outbox-folder.vala:236: Outbox postman send error, retrying: %s", _data_->_tmp52_);
#line 238 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					_data_->should_nap = TRUE;
#line 240 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					_data_->_tmp53_ = _data_->send_err;
#line 240 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					if (g_error_matches (_data_->_tmp53_, GEARY_SMTP_ERROR, GEARY_SMTP_ERROR_AUTHENTICATION_FAILED)) {
#line 241 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
						_data_->report = TRUE;
#line 244 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
						_data_->should_nap = FALSE;
#line 4450 "smtp-outbox-folder.c"
						{
#line 249 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
							_data_->_tmp55_ = _data_->self->priv->_account;
#line 249 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
							_data_->_tmp56_ = geary_account_get_information (_data_->_tmp55_);
#line 249 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
							_data_->_tmp57_ = _data_->_tmp56_;
#line 249 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
							_data_->_state_ = 5;
#line 249 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
							geary_account_information_fetch_passwords_async (_data_->_tmp57_, GEARY_SERVICE_FLAG_SMTP, TRUE, geary_smtp_outbox_folder_do_postman_async_ready, _data_);
#line 249 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
							return FALSE;
#line 4464 "smtp-outbox-folder.c"
							_state_5:
#line 249 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
							_data_->_tmp54_ = geary_account_information_fetch_passwords_finish (_data_->_tmp57_, _data_->_res_, &_data_->_inner_error_);
#line 249 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
							if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
#line 4470 "smtp-outbox-folder.c"
								goto __catch201_g_error;
							}
#line 249 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
							if (_data_->_tmp54_) {
#line 250 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
								_data_->report = FALSE;
#line 4477 "smtp-outbox-folder.c"
							}
						}
						goto __finally201;
						__catch201_g_error:
						{
#line 248 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
							_data_->_vala1_e = _data_->_inner_error_;
#line 248 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
							_data_->_inner_error_ = NULL;
#line 252 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
							_data_->_tmp58_ = _data_->_vala1_e;
#line 252 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
							_data_->_tmp59_ = _data_->_tmp58_->message;
#line 252 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
							g_debug ("smtp-outbox-folder.vala:252: Error prompting for SMTP password: %s", _data_->_tmp59_);
#line 248 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
							_g_error_free0 (_data_->_vala1_e);
#line 4495 "smtp-outbox-folder.c"
						}
						__finally201:
#line 248 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
						if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
#line 248 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
							_g_error_free0 (_data_->send_err);
#line 248 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
							_g_error_free0 (_data_->send_err);
#line 248 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
							_g_object_unref0 (_data_->message);
#line 248 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
							_geary_smtp_outbox_folder_outbox_row_unref0 (_data_->row);
#line 248 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
							g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error_->message, g_quark_to_string (_data_->_inner_error_->domain), _data_->_inner_error_->code);
#line 248 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
							g_clear_error (&_data_->_inner_error_);
#line 248 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
							g_object_unref (_data_->_async_result);
#line 248 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
							return FALSE;
#line 4516 "smtp-outbox-folder.c"
						}
#line 255 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
						_data_->_tmp60_ = _data_->report;
#line 255 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
						if (_data_->_tmp60_) {
#line 256 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
							_data_->_tmp61_ = _data_->send_err;
#line 256 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
							g_signal_emit (_data_->self, geary_smtp_outbox_folder_signals[GEARY_SMTP_OUTBOX_FOLDER_REPORT_PROBLEM_SIGNAL], 0, GEARY_ACCOUNT_PROBLEM_SEND_EMAIL_LOGIN_FAILED, _data_->_tmp61_);
#line 4526 "smtp-outbox-folder.c"
						}
					} else {
#line 257 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
						_data_->_tmp62_ = _data_->send_err;
#line 257 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
						if (_data_->_tmp62_->domain == G_TLS_ERROR) {
#line 260 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
							_data_->_tmp63_ = _data_->self->priv->_account;
#line 260 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
							_data_->_tmp64_ = geary_account_get_information (_data_->_tmp63_);
#line 260 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
							_data_->_tmp65_ = _data_->_tmp64_;
#line 260 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
							_data_->_tmp66_ = geary_account_information_get_smtp_endpoint (_data_->_tmp65_);
#line 260 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
							_data_->_tmp67_ = _data_->_tmp66_;
#line 260 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
							_data_->_tmp68_ = geary_endpoint_to_string (_data_->_tmp67_);
#line 260 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
							_data_->_tmp69_ = _data_->_tmp68_;
#line 260 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
							g_debug ("smtp-outbox-folder.vala:260: TLS connection warnings connecting to %s," \
" user must confirm connection to continue", _data_->_tmp69_);
#line 260 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
							_g_free0 (_data_->_tmp69_);
#line 260 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
							_g_object_unref0 (_data_->_tmp67_);
#line 4553 "smtp-outbox-folder.c"
						} else {
#line 263 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
							_data_->_tmp70_ = _data_->send_err;
#line 263 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
							g_signal_emit (_data_->self, geary_smtp_outbox_folder_signals[GEARY_SMTP_OUTBOX_FOLDER_REPORT_PROBLEM_SIGNAL], 0, GEARY_ACCOUNT_PROBLEM_EMAIL_DELIVERY_FAILURE, _data_->_tmp70_);
#line 4559 "smtp-outbox-folder.c"
						}
					}
#line 221 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					_g_error_free0 (_data_->send_err);
#line 4564 "smtp-outbox-folder.c"
				}
				__finally200:
#line 221 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
#line 221 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					_g_object_unref0 (_data_->message);
#line 221 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					_geary_smtp_outbox_folder_outbox_row_unref0 (_data_->row);
#line 221 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error_->message, g_quark_to_string (_data_->_inner_error_->domain), _data_->_inner_error_->code);
#line 221 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					g_clear_error (&_data_->_inner_error_);
#line 221 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					g_object_unref (_data_->_async_result);
#line 221 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					return FALSE;
#line 4581 "smtp-outbox-folder.c"
				}
#line 267 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_tmp71_ = _data_->should_nap;
#line 267 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				if (_data_->_tmp71_) {
#line 268 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					_data_->_tmp72_ = _data_->send_retry_seconds;
#line 268 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					g_debug ("smtp-outbox-folder.vala:268: Outbox napping for %u seconds...", _data_->_tmp72_);
#line 271 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					_data_->_tmp73_ = _data_->send_retry_seconds;
#line 271 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					_data_->_state_ = 6;
#line 271 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					geary_scheduler_sleep_async (_data_->_tmp73_, geary_smtp_outbox_folder_do_postman_async_ready, _data_);
#line 271 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					return FALSE;
#line 4599 "smtp-outbox-folder.c"
					_state_6:
#line 271 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					geary_scheduler_sleep_finish (_data_->_res_);
#line 272 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					_data_->_tmp74_ = _data_->send_retry_seconds;
#line 272 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					_data_->send_retry_seconds = geary_numeric_uint_ceiling (_data_->_tmp74_ * 2, GEARY_SMTP_OUTBOX_FOLDER_MAX_SEND_RETRY_INTERVAL_SEC);
#line 4607 "smtp-outbox-folder.c"
				}
#line 276 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->send_retry_seconds = GEARY_SMTP_OUTBOX_FOLDER_MIN_SEND_RETRY_INTERVAL_SEC;
#line 280 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_tmp75_ = _data_->mail_sent;
#line 280 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				if (_data_->_tmp75_) {
#line 4615 "smtp-outbox-folder.c"
					{
#line 282 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
						_data_->_tmp76_ = _data_->row;
#line 282 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
						_data_->_tmp77_ = _data_->_tmp76_->outbox_id;
#line 282 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
						_data_->_tmp78_ = geary_email_identifier_to_string (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp77_, GEARY_TYPE_EMAIL_IDENTIFIER, GearyEmailIdentifier));
#line 282 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
						_data_->_tmp79_ = _data_->_tmp78_;
#line 282 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
						g_debug ("smtp-outbox-folder.vala:282: Outbox postman: Marking %s as sent", _data_->_tmp79_);
#line 282 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
						_g_free0 (_data_->_tmp79_);
#line 283 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
						_data_->_tmp80_ = _data_->row;
#line 283 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
						_data_->_tmp81_ = _data_->_tmp80_->outbox_id;
#line 283 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
						_data_->_state_ = 7;
#line 283 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
						geary_smtp_outbox_folder_mark_email_as_sent_async (_data_->self, _data_->_tmp81_, NULL, geary_smtp_outbox_folder_do_postman_async_ready, _data_);
#line 283 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
						return FALSE;
#line 4639 "smtp-outbox-folder.c"
						_state_7:
#line 283 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
						geary_smtp_outbox_folder_mark_email_as_sent_finish (_data_->self, _data_->_res_, &_data_->_inner_error_);
#line 283 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
						if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
#line 4645 "smtp-outbox-folder.c"
							goto __catch202_g_error;
						}
					}
					goto __finally202;
					__catch202_g_error:
					{
#line 281 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
						_data_->_vala2_e = _data_->_inner_error_;
#line 281 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
						_data_->_inner_error_ = NULL;
#line 285 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
						_data_->_tmp82_ = _data_->_vala2_e;
#line 285 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
						_data_->_tmp83_ = _data_->_tmp82_->message;
#line 285 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
						g_debug ("smtp-outbox-folder.vala:285: Outbox postman: Unable to mark row as sen" \
"t: %s", _data_->_tmp83_);
#line 281 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
						_g_error_free0 (_data_->_vala2_e);
#line 4664 "smtp-outbox-folder.c"
					}
					__finally202:
#line 281 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
#line 281 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
						_g_object_unref0 (_data_->message);
#line 281 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
						_geary_smtp_outbox_folder_outbox_row_unref0 (_data_->row);
#line 281 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error_->message, g_quark_to_string (_data_->_inner_error_->domain), _data_->_inner_error_->code);
#line 281 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
						g_clear_error (&_data_->_inner_error_);
#line 281 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
						g_object_unref (_data_->_async_result);
#line 281 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
						return FALSE;
#line 4681 "smtp-outbox-folder.c"
					}
				}
			}
#line 290 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_data_->_tmp84_ = _data_->mail_sent;
#line 290 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			if (!_data_->_tmp84_) {
#line 292 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_tmp85_ = _data_->self->priv->outbox_queue;
#line 292 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_tmp86_ = _data_->row;
#line 292 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				geary_nonblocking_mailbox_send (_data_->_tmp85_, _data_->_tmp86_);
#line 293 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_g_object_unref0 (_data_->message);
#line 293 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_geary_smtp_outbox_folder_outbox_row_unref0 (_data_->row);
#line 293 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				continue;
#line 4701 "smtp-outbox-folder.c"
			}
#line 296 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_data_->mail_saved = TRUE;
#line 297 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_data_->_tmp88_ = _data_->self->priv->_account;
#line 297 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_data_->_tmp89_ = geary_account_get_information (_data_->_tmp88_);
#line 297 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_data_->_tmp90_ = _data_->_tmp89_;
#line 297 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			if (geary_account_information_allow_save_sent_mail (_data_->_tmp90_)) {
#line 297 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_tmp91_ = _data_->self->priv->_account;
#line 297 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_tmp92_ = geary_account_get_information (_data_->_tmp91_);
#line 297 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_tmp93_ = _data_->_tmp92_;
#line 297 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_tmp94_ = geary_account_information_get_save_sent_mail (_data_->_tmp93_);
#line 297 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_tmp95_ = _data_->_tmp94_;
#line 297 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_tmp87_ = _data_->_tmp95_;
#line 4725 "smtp-outbox-folder.c"
			} else {
#line 297 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_tmp87_ = FALSE;
#line 4729 "smtp-outbox-folder.c"
			}
#line 297 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			if (_data_->_tmp87_) {
#line 298 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->mail_saved = FALSE;
#line 4735 "smtp-outbox-folder.c"
				{
#line 300 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					_data_->_tmp96_ = _data_->row;
#line 300 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					_data_->_tmp97_ = _data_->_tmp96_->outbox_id;
#line 300 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					_data_->_tmp98_ = geary_email_identifier_to_string (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp97_, GEARY_TYPE_EMAIL_IDENTIFIER, GearyEmailIdentifier));
#line 300 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					_data_->_tmp99_ = _data_->_tmp98_;
#line 300 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					g_debug ("smtp-outbox-folder.vala:300: Outbox postman: Saving %s to sent mail", _data_->_tmp99_);
#line 300 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					_g_free0 (_data_->_tmp99_);
#line 301 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					_data_->_tmp100_ = _data_->message;
#line 301 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					_data_->_state_ = 8;
#line 301 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					geary_smtp_outbox_folder_save_sent_mail_async (_data_->self, _data_->_tmp100_, NULL, geary_smtp_outbox_folder_do_postman_async_ready, _data_);
#line 301 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					return FALSE;
#line 4757 "smtp-outbox-folder.c"
					_state_8:
#line 301 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					geary_smtp_outbox_folder_save_sent_mail_finish (_data_->self, _data_->_res_, &_data_->_inner_error_);
#line 301 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
#line 4763 "smtp-outbox-folder.c"
						goto __catch203_g_error;
					}
#line 302 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					_data_->mail_saved = TRUE;
#line 4768 "smtp-outbox-folder.c"
				}
				goto __finally203;
				__catch203_g_error:
				{
#line 299 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					_data_->_vala3_e = _data_->_inner_error_;
#line 299 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					_data_->_inner_error_ = NULL;
#line 304 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					_data_->_tmp101_ = _data_->_vala3_e;
#line 304 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					_data_->_tmp102_ = _data_->_tmp101_->message;
#line 304 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					g_debug ("smtp-outbox-folder.vala:304: Outbox postman: Error saving sent mail: %" \
"s", _data_->_tmp102_);
#line 305 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					_data_->_tmp103_ = _data_->_vala3_e;
#line 305 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					g_signal_emit (_data_->self, geary_smtp_outbox_folder_signals[GEARY_SMTP_OUTBOX_FOLDER_REPORT_PROBLEM_SIGNAL], 0, GEARY_ACCOUNT_PROBLEM_SAVE_SENT_MAIL_FAILED, _data_->_tmp103_);
#line 299 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					_g_error_free0 (_data_->_vala3_e);
#line 4789 "smtp-outbox-folder.c"
				}
				__finally203:
#line 299 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
#line 299 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					_g_object_unref0 (_data_->message);
#line 299 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					_geary_smtp_outbox_folder_outbox_row_unref0 (_data_->row);
#line 299 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error_->message, g_quark_to_string (_data_->_inner_error_->domain), _data_->_inner_error_->code);
#line 299 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					g_clear_error (&_data_->_inner_error_);
#line 299 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					g_object_unref (_data_->_async_result);
#line 299 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					return FALSE;
#line 4806 "smtp-outbox-folder.c"
				}
			}
#line 309 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_data_->_tmp104_ = _data_->mail_saved;
#line 309 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			if (!_data_->_tmp104_) {
#line 311 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_tmp105_ = _data_->self->priv->outbox_queue;
#line 311 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_tmp106_ = _data_->row;
#line 311 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				geary_nonblocking_mailbox_send (_data_->_tmp105_, _data_->_tmp106_);
#line 312 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_g_object_unref0 (_data_->message);
#line 312 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_geary_smtp_outbox_folder_outbox_row_unref0 (_data_->row);
#line 312 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				continue;
#line 4825 "smtp-outbox-folder.c"
			}
			{
#line 318 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_tmp107_ = _data_->row;
#line 318 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_tmp108_ = _data_->_tmp107_->outbox_id;
#line 318 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_tmp109_ = geary_email_identifier_to_string (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp108_, GEARY_TYPE_EMAIL_IDENTIFIER, GearyEmailIdentifier));
#line 318 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_tmp110_ = _data_->_tmp109_;
#line 318 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				g_debug ("smtp-outbox-folder.vala:318: Outbox postman: Deleting row %s", _data_->_tmp110_);
#line 318 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_g_free0 (_data_->_tmp110_);
#line 319 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_tmp111_ = gee_array_list_new (GEARY_TYPE_SMTP_OUTBOX_EMAIL_IDENTIFIER, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 319 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->list = _data_->_tmp111_;
#line 320 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_tmp112_ = _data_->list;
#line 320 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_tmp113_ = _data_->row;
#line 320 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_tmp114_ = _data_->_tmp113_->outbox_id;
#line 320 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				gee_abstract_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp112_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), _data_->_tmp114_);
#line 321 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_tmp115_ = _data_->list;
#line 321 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_state_ = 9;
#line 321 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				geary_smtp_outbox_folder_internal_remove_email_async (_data_->self, G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp115_, GEE_TYPE_LIST, GeeList), NULL, geary_smtp_outbox_folder_do_postman_async_ready, _data_);
#line 321 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				return FALSE;
#line 4860 "smtp-outbox-folder.c"
				_state_9:
#line 321 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				geary_smtp_outbox_folder_internal_remove_email_finish (_data_->self, _data_->_res_, &_data_->_inner_error_);
#line 321 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
#line 321 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					_g_object_unref0 (_data_->list);
#line 4868 "smtp-outbox-folder.c"
					goto __catch204_g_error;
				}
#line 317 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_g_object_unref0 (_data_->list);
#line 4873 "smtp-outbox-folder.c"
			}
			goto __finally204;
			__catch204_g_error:
			{
#line 317 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_vala4_e = _data_->_inner_error_;
#line 317 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_inner_error_ = NULL;
#line 323 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_tmp116_ = _data_->_vala4_e;
#line 323 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_tmp117_ = _data_->_tmp116_->message;
#line 323 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				g_debug ("smtp-outbox-folder.vala:323: Outbox postman: Unable to delete row: %s", _data_->_tmp117_);
#line 317 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_g_error_free0 (_data_->_vala4_e);
#line 4890 "smtp-outbox-folder.c"
			}
			__finally204:
#line 317 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
#line 317 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_g_object_unref0 (_data_->message);
#line 317 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_geary_smtp_outbox_folder_outbox_row_unref0 (_data_->row);
#line 317 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error_->message, g_quark_to_string (_data_->_inner_error_->domain), _data_->_inner_error_->code);
#line 317 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				g_clear_error (&_data_->_inner_error_);
#line 317 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				g_object_unref (_data_->_async_result);
#line 317 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				return FALSE;
#line 4907 "smtp-outbox-folder.c"
			}
#line 182 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_g_object_unref0 (_data_->message);
#line 182 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_geary_smtp_outbox_folder_outbox_row_unref0 (_data_->row);
#line 4913 "smtp-outbox-folder.c"
		}
	}
#line 327 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_debug ("smtp-outbox-folder.vala:327: Exiting outbox postman");
#line 177 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 177 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (_data_->_state_ != 0) {
#line 177 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		while (_data_->_task_complete_ != TRUE) {
#line 177 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 4926 "smtp-outbox-folder.c"
		}
	}
#line 177 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_object_unref (_data_->_async_result);
#line 177 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return FALSE;
#line 4933 "smtp-outbox-folder.c"
}


static GearyFolderOpenState
geary_smtp_outbox_folder_real_get_open_state (GearyFolder* base)
{
	GearySmtpOutboxFolder * self;
	GearyFolderOpenState result = 0;
	GearyFolderOpenState _tmp0_ = 0;
#line 330 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, GEARY_TYPE_SMTP_OUTBOX_FOLDER, GearySmtpOutboxFolder);
#line 331 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (geary_abstract_local_folder_is_open (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_TYPE_ABSTRACT_LOCAL_FOLDER, GearyAbstractLocalFolder))) {
#line 331 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_tmp0_ = GEARY_FOLDER_OPEN_STATE_LOCAL;
#line 4949 "smtp-outbox-folder.c"
	} else {
#line 331 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_tmp0_ = GEARY_FOLDER_OPEN_STATE_CLOSED;
#line 4953 "smtp-outbox-folder.c"
	}
#line 331 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	result = _tmp0_;
#line 331 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return result;
#line 4959 "smtp-outbox-folder.c"
}


static void
geary_smtp_outbox_folder_get_email_count_async_data_free (gpointer _data)
{
	GearySmtpOutboxFolderGetEmailCountAsyncData* _data_;
	_data_ = _data;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_data_->self);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_slice_free (GearySmtpOutboxFolderGetEmailCountAsyncData, _data_);
#line 4972 "smtp-outbox-folder.c"
}


static void
geary_smtp_outbox_folder_get_email_count_async_async_ready_wrapper (GObject *source_object,
                                                                    GAsyncResult *res,
                                                                    void *user_data)
{
	GearySmtpOutboxFolderGetEmailCountAsyncData* _task_data_;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_task_data_ = g_task_get_task_data (G_TASK (res));
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (_task_data_->_callback_ != NULL) {
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_task_data_->_callback_ (source_object, res, user_data);
#line 4988 "smtp-outbox-folder.c"
	}
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_task_data_->_task_complete_ = TRUE;
#line 4992 "smtp-outbox-folder.c"
}


static void
geary_smtp_outbox_folder_get_email_count_async (GearySmtpOutboxFolder* self,
                                                GCancellable* cancellable,
                                                GAsyncReadyCallback _callback_,
                                                gpointer _user_data_)
{
	GearySmtpOutboxFolderGetEmailCountAsyncData* _data_;
	GearySmtpOutboxFolder* _tmp0_;
	GCancellable* _tmp1_;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_ = g_slice_new0 (GearySmtpOutboxFolderGetEmailCountAsyncData);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_callback_ = _callback_;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), cancellable, geary_smtp_outbox_folder_get_email_count_async_async_ready_wrapper, _user_data_);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (_callback_ == NULL) {
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_task_complete_ = TRUE;
#line 5015 "smtp-outbox-folder.c"
	}
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_task_set_task_data (_data_->_async_result, _data_, geary_smtp_outbox_folder_get_email_count_async_data_free);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->self = _tmp0_;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp1_ = _g_object_ref0 (cancellable);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_data_->cancellable);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->cancellable = _tmp1_;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	geary_smtp_outbox_folder_get_email_count_async_co (_data_);
#line 5031 "smtp-outbox-folder.c"
}


static gint
geary_smtp_outbox_folder_get_email_count_finish (GearySmtpOutboxFolder* self,
                                                 GAsyncResult* _res_,
                                                 GError** error)
{
	gint result;
	GearySmtpOutboxFolderGetEmailCountAsyncData* _data_;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (NULL == _data_) {
#line 5046 "smtp-outbox-folder.c"
		gint _tmp0_ = 0;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return _tmp0_;
#line 5050 "smtp-outbox-folder.c"
	}
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	result = _data_->result;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return result;
#line 5056 "smtp-outbox-folder.c"
}


static Block76Data*
block76_data_ref (Block76Data* _data76_)
{
#line 334 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_atomic_int_inc (&_data76_->_ref_count_);
#line 334 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return _data76_;
#line 5067 "smtp-outbox-folder.c"
}


static void
block76_data_unref (void * _userdata_)
{
	Block76Data* _data76_;
	_data76_ = (Block76Data*) _userdata_;
#line 334 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (g_atomic_int_dec_and_test (&_data76_->_ref_count_)) {
#line 5078 "smtp-outbox-folder.c"
		GearySmtpOutboxFolder* self;
#line 334 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		self = _data76_->self;
#line 334 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (_data76_->cancellable);
#line 334 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (self);
#line 334 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_slice_free (Block76Data, _data76_);
#line 5088 "smtp-outbox-folder.c"
	}
}


static GearyDbTransactionOutcome
__lambda100_ (Block76Data* _data76_,
              GearyDbConnection* cx,
              GError** error)
{
	GearySmtpOutboxFolder* self;
	GearyDbTransactionOutcome result = 0;
	gint _tmp0_ = 0;
	GError * _inner_error_ = NULL;
#line 336 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	self = _data76_->self;
#line 336 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_return_val_if_fail (GEARY_DB_IS_CONNECTION (cx), 0);
#line 337 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp0_ = geary_smtp_outbox_folder_do_get_email_count (self, cx, _data76_->cancellable, &_inner_error_);
#line 337 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 337 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_propagate_error (error, _inner_error_);
#line 337 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return 0;
#line 5114 "smtp-outbox-folder.c"
	}
#line 337 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data76_->count = _tmp0_;
#line 339 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	result = GEARY_DB_TRANSACTION_OUTCOME_DONE;
#line 339 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return result;
#line 5122 "smtp-outbox-folder.c"
}


static GearyDbTransactionOutcome
___lambda100__geary_db_transaction_method (GearyDbConnection* cx,
                                           GCancellable* cancellable,
                                           gpointer self,
                                           GError** error)
{
	GearyDbTransactionOutcome result;
	result = __lambda100_ (self, cx, error);
#line 336 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return result;
#line 5136 "smtp-outbox-folder.c"
}


static void
geary_smtp_outbox_folder_get_email_count_async_ready (GObject* source_object,
                                                      GAsyncResult* _res_,
                                                      gpointer _user_data_)
{
	GearySmtpOutboxFolderGetEmailCountAsyncData* _data_;
#line 336 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_ = _user_data_;
#line 336 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_source_object_ = source_object;
#line 336 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_res_ = _res_;
#line 336 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_task_complete_ = TRUE;
#line 336 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	geary_smtp_outbox_folder_get_email_count_async_co (_data_);
#line 5156 "smtp-outbox-folder.c"
}


static gboolean
geary_smtp_outbox_folder_get_email_count_async_co (GearySmtpOutboxFolderGetEmailCountAsyncData* _data_)
{
#line 334 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	switch (_data_->_state_) {
#line 334 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		case 0:
#line 5167 "smtp-outbox-folder.c"
		goto _state_0;
#line 334 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		case 1:
#line 5171 "smtp-outbox-folder.c"
		goto _state_1;
		default:
#line 334 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_assert_not_reached ();
#line 5176 "smtp-outbox-folder.c"
	}
	_state_0:
#line 334 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_data76_ = g_slice_new0 (Block76Data);
#line 334 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_data76_->_ref_count_ = 1;
#line 334 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_data76_->self = g_object_ref (_data_->self);
#line 334 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_data_->_data76_->cancellable);
#line 334 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_data76_->cancellable = _data_->cancellable;
#line 334 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_data76_->_async_data_ = _data_;
#line 335 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_data76_->count = 0;
#line 336 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp0_ = _data_->self->priv->db;
#line 336 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_state_ = 1;
#line 336 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	geary_db_database_exec_transaction_async (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp0_, GEARY_DB_TYPE_DATABASE, GearyDbDatabase), GEARY_DB_TRANSACTION_TYPE_RO, ___lambda100__geary_db_transaction_method, _data_->_data76_, _data_->_data76_->cancellable, geary_smtp_outbox_folder_get_email_count_async_ready, _data_);
#line 336 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return FALSE;
#line 5201 "smtp-outbox-folder.c"
	_state_1:
#line 336 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	geary_db_database_exec_transaction_finish (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp0_, GEARY_DB_TYPE_DATABASE, GearyDbDatabase), _data_->_res_, &_data_->_inner_error_);
#line 336 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
#line 336 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error_);
#line 336 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		block76_data_unref (_data_->_data76_);
#line 336 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_data76_ = NULL;
#line 336 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_object_unref (_data_->_async_result);
#line 336 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return FALSE;
#line 5217 "smtp-outbox-folder.c"
	}
#line 342 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->result = _data_->_data76_->count;
#line 342 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	block76_data_unref (_data_->_data76_);
#line 342 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_data76_ = NULL;
#line 342 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 342 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (_data_->_state_ != 0) {
#line 342 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		while (_data_->_task_complete_ != TRUE) {
#line 342 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 5233 "smtp-outbox-folder.c"
		}
	}
#line 342 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_object_unref (_data_->_async_result);
#line 342 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return FALSE;
#line 5240 "smtp-outbox-folder.c"
}


static void
geary_smtp_outbox_folder_enqueue_email_async_data_free (gpointer _data)
{
	GearySmtpOutboxFolderEnqueueEmailAsyncData* _data_;
	_data_ = _data;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_data_->result);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_data_->self);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_slice_free (GearySmtpOutboxFolderEnqueueEmailAsyncData, _data_);
#line 5255 "smtp-outbox-folder.c"
}


static void
geary_smtp_outbox_folder_enqueue_email_async_async_ready_wrapper (GObject *source_object,
                                                                  GAsyncResult *res,
                                                                  void *user_data)
{
	GearySmtpOutboxFolderEnqueueEmailAsyncData* _task_data_;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_task_data_ = g_task_get_task_data (G_TASK (res));
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (_task_data_->_callback_ != NULL) {
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_task_data_->_callback_ (source_object, res, user_data);
#line 5271 "smtp-outbox-folder.c"
	}
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_task_data_->_task_complete_ = TRUE;
#line 5275 "smtp-outbox-folder.c"
}


void
geary_smtp_outbox_folder_enqueue_email_async (GearySmtpOutboxFolder* self,
                                              GearyRFC822Message* rfc822,
                                              GCancellable* cancellable,
                                              GAsyncReadyCallback _callback_,
                                              gpointer _user_data_)
{
	GearySmtpOutboxFolderEnqueueEmailAsyncData* _data_;
	GearySmtpOutboxFolder* _tmp0_;
	GearyRFC822Message* _tmp1_;
	GCancellable* _tmp2_;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_ = g_slice_new0 (GearySmtpOutboxFolderEnqueueEmailAsyncData);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_callback_ = _callback_;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), cancellable, geary_smtp_outbox_folder_enqueue_email_async_async_ready_wrapper, _user_data_);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (_callback_ == NULL) {
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_task_complete_ = TRUE;
#line 5300 "smtp-outbox-folder.c"
	}
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_task_set_task_data (_data_->_async_result, _data_, geary_smtp_outbox_folder_enqueue_email_async_data_free);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->self = _tmp0_;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp1_ = _g_object_ref0 (rfc822);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_data_->rfc822);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->rfc822 = _tmp1_;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp2_ = _g_object_ref0 (cancellable);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_data_->cancellable);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->cancellable = _tmp2_;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	geary_smtp_outbox_folder_enqueue_email_async_co (_data_);
#line 5322 "smtp-outbox-folder.c"
}


GearySmtpOutboxEmailIdentifier*
geary_smtp_outbox_folder_enqueue_email_finish (GearySmtpOutboxFolder* self,
                                               GAsyncResult* _res_,
                                               GError** error)
{
	GearySmtpOutboxEmailIdentifier* result;
	GearySmtpOutboxFolderEnqueueEmailAsyncData* _data_;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (NULL == _data_) {
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return NULL;
#line 5339 "smtp-outbox-folder.c"
	}
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	result = _data_->result;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->result = NULL;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return result;
#line 5347 "smtp-outbox-folder.c"
}


static Block77Data*
block77_data_ref (Block77Data* _data77_)
{
#line 348 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_atomic_int_inc (&_data77_->_ref_count_);
#line 348 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return _data77_;
#line 5358 "smtp-outbox-folder.c"
}


static void
block77_data_unref (void * _userdata_)
{
	Block77Data* _data77_;
	_data77_ = (Block77Data*) _userdata_;
#line 348 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (g_atomic_int_dec_and_test (&_data77_->_ref_count_)) {
#line 5369 "smtp-outbox-folder.c"
		GearySmtpOutboxFolder* self;
#line 348 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		self = _data77_->self;
#line 348 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_geary_smtp_outbox_folder_outbox_row_unref0 (_data77_->row);
#line 348 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (_data77_->rfc822);
#line 348 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (_data77_->cancellable);
#line 348 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (self);
#line 348 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_slice_free (Block77Data, _data77_);
#line 5383 "smtp-outbox-folder.c"
	}
}


static GearyDbTransactionOutcome
__lambda101_ (Block77Data* _data77_,
              GearyDbConnection* cx,
              GError** error)
{
	GearySmtpOutboxFolder* self;
	GearyDbTransactionOutcome result = 0;
	gint64 ordering = 0LL;
	GearyDbStatement* stmt = NULL;
	GearyDbStatement* _tmp0_;
	GearyMemoryBuffer* _tmp1_ = NULL;
	GearyMemoryBuffer* _tmp2_;
	GearyDbStatement* _tmp3_;
	GearyDbStatement* _tmp4_;
	GearyDbStatement* _tmp5_;
	GearyDbStatement* _tmp6_;
	gint64 _tmp7_;
	GearyDbStatement* _tmp8_;
	GearyDbStatement* _tmp9_;
	gint64 id = 0LL;
	GearyDbStatement* _tmp10_;
	GearyDbStatement* _tmp11_ = NULL;
	GearyDbStatement* _tmp12_;
	GearyDbStatement* _tmp13_;
	GearyDbStatement* _tmp14_;
	gint64 _tmp15_;
	GearyDbStatement* _tmp16_;
	GearyDbStatement* _tmp17_;
	GearyDbResult* results = NULL;
	GearyDbStatement* _tmp18_;
	GearyDbResult* _tmp19_;
	GearyDbResult* _tmp20_;
	gboolean _tmp21_;
	gboolean _tmp22_;
	GearyMemoryBuffer* message = NULL;
	GearyDbResult* _tmp23_;
	GearyMemoryBuffer* _tmp24_;
	gint position = 0;
	gint64 _tmp25_;
	gint64 _tmp26_;
	gint _tmp27_;
	gint64 _tmp28_;
	GearyMemoryBuffer* _tmp29_;
	GearySmtpOutboxFolderRoot* _tmp30_;
	GearySmtpOutboxFolderOutboxRow* _tmp31_;
	gint _tmp32_ = 0;
	GError * _inner_error_ = NULL;
#line 352 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	self = _data77_->self;
#line 352 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_return_val_if_fail (GEARY_DB_IS_CONNECTION (cx), 0);
#line 353 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	ordering = geary_smtp_outbox_folder_do_get_next_ordering (self, cx, _data77_->cancellable, &_inner_error_);
#line 353 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 353 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_propagate_error (error, _inner_error_);
#line 353 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return 0;
#line 5447 "smtp-outbox-folder.c"
	}
#line 356 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp0_ = geary_db_connection_prepare (cx, "INSERT INTO SmtpOutboxTable (message, ordering) VALUES (?, ?)", &_inner_error_);
#line 356 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	stmt = _tmp0_;
#line 356 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 356 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_propagate_error (error, _inner_error_);
#line 356 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return 0;
#line 5459 "smtp-outbox-folder.c"
	}
#line 358 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp2_ = geary_rf_c822_message_get_network_buffer (_data77_->rfc822, FALSE, &_inner_error_);
#line 358 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp1_ = _tmp2_;
#line 358 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 358 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_propagate_error (error, _inner_error_);
#line 358 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (stmt);
#line 358 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return 0;
#line 5473 "smtp-outbox-folder.c"
	}
#line 358 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp3_ = stmt;
#line 358 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp4_ = geary_db_statement_bind_string_buffer (_tmp3_, 0, _tmp1_, &_inner_error_);
#line 358 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp5_ = _tmp4_;
#line 358 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_tmp5_);
#line 358 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 358 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_propagate_error (error, _inner_error_);
#line 358 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (_tmp1_);
#line 358 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (stmt);
#line 358 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return 0;
#line 5493 "smtp-outbox-folder.c"
	}
#line 359 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp6_ = stmt;
#line 359 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp7_ = ordering;
#line 359 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp8_ = geary_db_statement_bind_int64 (_tmp6_, 1, _tmp7_, &_inner_error_);
#line 359 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp9_ = _tmp8_;
#line 359 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_tmp9_);
#line 359 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 359 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_propagate_error (error, _inner_error_);
#line 359 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (_tmp1_);
#line 359 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (stmt);
#line 359 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return 0;
#line 5515 "smtp-outbox-folder.c"
	}
#line 361 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp10_ = stmt;
#line 361 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	id = geary_db_statement_exec_insert (_tmp10_, _data77_->cancellable, &_inner_error_);
#line 361 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 361 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_propagate_error (error, _inner_error_);
#line 361 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (_tmp1_);
#line 361 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (stmt);
#line 361 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return 0;
#line 5531 "smtp-outbox-folder.c"
	}
#line 363 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp12_ = geary_db_connection_prepare (cx, "SELECT message FROM SmtpOutboxTable WHERE id=?", &_inner_error_);
#line 363 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp11_ = _tmp12_;
#line 363 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 363 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_propagate_error (error, _inner_error_);
#line 363 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (_tmp1_);
#line 363 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (stmt);
#line 363 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return 0;
#line 5547 "smtp-outbox-folder.c"
	}
#line 363 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp13_ = _tmp11_;
#line 363 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp11_ = NULL;
#line 363 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (stmt);
#line 363 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	stmt = _tmp13_;
#line 364 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp14_ = stmt;
#line 364 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp15_ = id;
#line 364 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp16_ = geary_db_statement_bind_rowid (_tmp14_, 0, _tmp15_, &_inner_error_);
#line 364 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp17_ = _tmp16_;
#line 364 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_tmp17_);
#line 364 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 364 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_propagate_error (error, _inner_error_);
#line 364 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (_tmp11_);
#line 364 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (_tmp1_);
#line 364 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (stmt);
#line 364 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return 0;
#line 5579 "smtp-outbox-folder.c"
	}
#line 367 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp18_ = stmt;
#line 367 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp19_ = geary_db_statement_exec (_tmp18_, _data77_->cancellable, &_inner_error_);
#line 367 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	results = _tmp19_;
#line 367 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 367 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_propagate_error (error, _inner_error_);
#line 367 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (_tmp11_);
#line 367 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (_tmp1_);
#line 367 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (stmt);
#line 367 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return 0;
#line 5599 "smtp-outbox-folder.c"
	}
#line 368 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp20_ = results;
#line 368 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp21_ = geary_db_result_get_finished (_tmp20_);
#line 368 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp22_ = _tmp21_;
#line 368 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_vala_assert (!_tmp22_, "!results.finished");
#line 370 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp23_ = results;
#line 370 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp24_ = geary_db_result_string_buffer_at (_tmp23_, 0, &_inner_error_);
#line 370 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	message = _tmp24_;
#line 370 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 370 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_propagate_error (error, _inner_error_);
#line 370 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (results);
#line 370 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (_tmp11_);
#line 370 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (_tmp1_);
#line 370 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (stmt);
#line 370 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return 0;
#line 5629 "smtp-outbox-folder.c"
	}
#line 372 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp25_ = ordering;
#line 372 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	position = geary_smtp_outbox_folder_do_get_position_by_ordering (self, cx, _tmp25_, _data77_->cancellable, &_inner_error_);
#line 372 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 372 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_propagate_error (error, _inner_error_);
#line 372 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (message);
#line 372 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (results);
#line 372 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (_tmp11_);
#line 372 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (_tmp1_);
#line 372 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (stmt);
#line 372 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return 0;
#line 5651 "smtp-outbox-folder.c"
	}
#line 374 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp26_ = id;
#line 374 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp27_ = position;
#line 374 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp28_ = ordering;
#line 374 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp29_ = message;
#line 374 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp30_ = self->priv->_path;
#line 374 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp31_ = geary_smtp_outbox_folder_outbox_row_new (_tmp26_, _tmp27_, _tmp28_, FALSE, _tmp29_, _tmp30_);
#line 374 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_geary_smtp_outbox_folder_outbox_row_unref0 (_data77_->row);
#line 374 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data77_->row = _tmp31_;
#line 375 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp32_ = geary_smtp_outbox_folder_do_get_email_count (self, cx, _data77_->cancellable, &_inner_error_);
#line 375 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 375 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_propagate_error (error, _inner_error_);
#line 375 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (message);
#line 375 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (results);
#line 375 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (_tmp11_);
#line 375 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (_tmp1_);
#line 375 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (stmt);
#line 375 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return 0;
#line 5687 "smtp-outbox-folder.c"
	}
#line 375 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data77_->email_count = _tmp32_;
#line 377 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	result = GEARY_DB_TRANSACTION_OUTCOME_COMMIT;
#line 377 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (message);
#line 377 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (results);
#line 377 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_tmp11_);
#line 377 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_tmp1_);
#line 377 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (stmt);
#line 377 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return result;
#line 5705 "smtp-outbox-folder.c"
}


static GearyDbTransactionOutcome
___lambda101__geary_db_transaction_method (GearyDbConnection* cx,
                                           GCancellable* cancellable,
                                           gpointer self,
                                           GError** error)
{
	GearyDbTransactionOutcome result;
	result = __lambda101_ (self, cx, error);
#line 352 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return result;
#line 5719 "smtp-outbox-folder.c"
}


static void
geary_smtp_outbox_folder_enqueue_email_async_ready (GObject* source_object,
                                                    GAsyncResult* _res_,
                                                    gpointer _user_data_)
{
	GearySmtpOutboxFolderEnqueueEmailAsyncData* _data_;
#line 352 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_ = _user_data_;
#line 352 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_source_object_ = source_object;
#line 352 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_res_ = _res_;
#line 352 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_task_complete_ = TRUE;
#line 352 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	geary_smtp_outbox_folder_enqueue_email_async_co (_data_);
#line 5739 "smtp-outbox-folder.c"
}


static gboolean
geary_smtp_outbox_folder_enqueue_email_async_co (GearySmtpOutboxFolderEnqueueEmailAsyncData* _data_)
{
#line 348 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	switch (_data_->_state_) {
#line 348 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		case 0:
#line 5750 "smtp-outbox-folder.c"
		goto _state_0;
#line 348 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		case 1:
#line 5754 "smtp-outbox-folder.c"
		goto _state_1;
#line 348 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		case 2:
#line 5758 "smtp-outbox-folder.c"
		goto _state_2;
		default:
#line 348 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_assert_not_reached ();
#line 5763 "smtp-outbox-folder.c"
	}
	_state_0:
#line 348 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_data77_ = g_slice_new0 (Block77Data);
#line 348 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_data77_->_ref_count_ = 1;
#line 348 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_data77_->self = g_object_ref (_data_->self);
#line 348 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_data_->_data77_->rfc822);
#line 348 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_data77_->rfc822 = _data_->rfc822;
#line 348 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_data_->_data77_->cancellable);
#line 348 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_data77_->cancellable = _data_->cancellable;
#line 348 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_data77_->_async_data_ = _data_;
#line 350 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_data77_->email_count = 0;
#line 351 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_data77_->row = NULL;
#line 352 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp0_ = _data_->self->priv->db;
#line 352 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_state_ = 1;
#line 352 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	geary_db_database_exec_transaction_async (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp0_, GEARY_DB_TYPE_DATABASE, GearyDbDatabase), GEARY_DB_TRANSACTION_TYPE_WR, ___lambda101__geary_db_transaction_method, _data_->_data77_, _data_->_data77_->cancellable, geary_smtp_outbox_folder_enqueue_email_async_ready, _data_);
#line 352 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return FALSE;
#line 5794 "smtp-outbox-folder.c"
	_state_1:
#line 352 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	geary_db_database_exec_transaction_finish (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp0_, GEARY_DB_TYPE_DATABASE, GearyDbDatabase), _data_->_res_, &_data_->_inner_error_);
#line 352 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
#line 352 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error_);
#line 352 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		block77_data_unref (_data_->_data77_);
#line 352 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_data77_ = NULL;
#line 352 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_object_unref (_data_->_async_result);
#line 352 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return FALSE;
#line 5810 "smtp-outbox-folder.c"
	}
#line 381 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp1_ = _data_->_data77_->row;
#line 381 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_vala_assert (_data_->_tmp1_ != NULL, "row != null");
#line 384 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_state_ = 2;
#line 384 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	geary_smtp_outbox_folder_get_email_count_async (_data_->self, _data_->_data77_->cancellable, geary_smtp_outbox_folder_enqueue_email_async_ready, _data_);
#line 384 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return FALSE;
#line 5822 "smtp-outbox-folder.c"
	_state_2:
#line 384 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp2_ = geary_smtp_outbox_folder_get_email_count_finish (_data_->self, _data_->_res_, &_data_->_inner_error_);
#line 384 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
#line 384 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error_);
#line 384 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		block77_data_unref (_data_->_data77_);
#line 384 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_data77_ = NULL;
#line 384 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_object_unref (_data_->_async_result);
#line 384 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return FALSE;
#line 5838 "smtp-outbox-folder.c"
	}
#line 384 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp3_ = _data_->self->priv->_properties;
#line 384 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	geary_smtp_outbox_folder_properties_set_total (_data_->_tmp3_, _data_->_tmp2_);
#line 387 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp4_ = _data_->self->priv->outbox_queue;
#line 387 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp5_ = _data_->_data77_->row;
#line 387 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	geary_nonblocking_mailbox_send (_data_->_tmp4_, _data_->_tmp5_);
#line 389 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp6_ = gee_array_list_new (GEARY_TYPE_SMTP_OUTBOX_EMAIL_IDENTIFIER, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 389 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->list = G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp6_, GEE_TYPE_LIST, GeeList);
#line 390 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp7_ = _data_->list;
#line 390 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp8_ = _data_->_data77_->row;
#line 390 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp9_ = _data_->_tmp8_->outbox_id;
#line 390 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	gee_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp7_, GEE_TYPE_COLLECTION, GeeCollection), _data_->_tmp9_);
#line 392 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp10_ = _data_->list;
#line 392 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	geary_folder_notify_email_appended (G_TYPE_CHECK_INSTANCE_CAST (_data_->self, GEARY_TYPE_FOLDER, GearyFolder), G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp10_, GEE_TYPE_COLLECTION, GeeCollection));
#line 393 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp11_ = _data_->list;
#line 393 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	geary_folder_notify_email_locally_appended (G_TYPE_CHECK_INSTANCE_CAST (_data_->self, GEARY_TYPE_FOLDER, GearyFolder), G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp11_, GEE_TYPE_COLLECTION, GeeCollection));
#line 394 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp12_ = _data_->_data77_->email_count;
#line 394 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	geary_folder_notify_email_count_changed (G_TYPE_CHECK_INSTANCE_CAST (_data_->self, GEARY_TYPE_FOLDER, GearyFolder), _data_->_tmp12_, GEARY_FOLDER_COUNT_CHANGE_REASON_APPENDED);
#line 396 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp13_ = _data_->_data77_->row;
#line 396 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp14_ = _data_->_tmp13_->outbox_id;
#line 396 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp15_ = _g_object_ref0 (_data_->_tmp14_);
#line 396 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->result = _data_->_tmp15_;
#line 396 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_data_->list);
#line 396 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	block77_data_unref (_data_->_data77_);
#line 396 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_data77_ = NULL;
#line 396 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 396 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (_data_->_state_ != 0) {
#line 396 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		while (_data_->_task_complete_ != TRUE) {
#line 396 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 5896 "smtp-outbox-folder.c"
		}
	}
#line 396 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_object_unref (_data_->_async_result);
#line 396 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return FALSE;
#line 5903 "smtp-outbox-folder.c"
}


static void
geary_smtp_outbox_folder_real_create_email_async_data_free (gpointer _data)
{
	GearySmtpOutboxFolderCreateEmailAsyncData* _data_;
	_data_ = _data;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_data_->rfc822);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_data_->flags);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_date_time_unref0 (_data_->date_received);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_data_->id);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_data_->cancellable);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_data_->result);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_data_->self);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_slice_free (GearySmtpOutboxFolderCreateEmailAsyncData, _data_);
#line 5928 "smtp-outbox-folder.c"
}


static void
geary_smtp_outbox_folder_real_create_email_async_async_ready_wrapper (GObject *source_object,
                                                                      GAsyncResult *res,
                                                                      void *user_data)
{
	GearySmtpOutboxFolderCreateEmailAsyncData* _task_data_;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_task_data_ = g_task_get_task_data (G_TASK (res));
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (_task_data_->_callback_ != NULL) {
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_task_data_->_callback_ (source_object, res, user_data);
#line 5944 "smtp-outbox-folder.c"
	}
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_task_data_->_task_complete_ = TRUE;
#line 5948 "smtp-outbox-folder.c"
}


static gpointer
_g_date_time_ref0 (gpointer self)
{
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return self ? g_date_time_ref (self) : NULL;
#line 5957 "smtp-outbox-folder.c"
}


static void
geary_smtp_outbox_folder_real_create_email_async (GearySmtpOutboxFolder* self,
                                                  GearyRFC822Message* rfc822,
                                                  GearyEmailFlags* flags,
                                                  GDateTime* date_received,
                                                  GearyEmailIdentifier* id,
                                                  GCancellable* cancellable,
                                                  GAsyncReadyCallback _callback_,
                                                  gpointer _user_data_)
{
	GearySmtpOutboxFolderCreateEmailAsyncData* _data_;
	GearySmtpOutboxFolder* _tmp0_;
	GearyRFC822Message* _tmp1_;
	GearyEmailFlags* _tmp2_;
	GDateTime* _tmp3_;
	GearyEmailIdentifier* _tmp4_;
	GCancellable* _tmp5_;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_ = g_slice_new0 (GearySmtpOutboxFolderCreateEmailAsyncData);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_callback_ = _callback_;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), cancellable, geary_smtp_outbox_folder_real_create_email_async_async_ready_wrapper, _user_data_);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (_callback_ == NULL) {
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_task_complete_ = TRUE;
#line 5988 "smtp-outbox-folder.c"
	}
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_task_set_task_data (_data_->_async_result, _data_, geary_smtp_outbox_folder_real_create_email_async_data_free);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->self = _tmp0_;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp1_ = _g_object_ref0 (rfc822);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_data_->rfc822);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->rfc822 = _tmp1_;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp2_ = _g_object_ref0 (flags);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_data_->flags);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->flags = _tmp2_;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp3_ = _g_date_time_ref0 (date_received);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_date_time_unref0 (_data_->date_received);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->date_received = _tmp3_;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp4_ = _g_object_ref0 (id);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_data_->id);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->id = _tmp4_;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp5_ = _g_object_ref0 (cancellable);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_data_->cancellable);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->cancellable = _tmp5_;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	geary_smtp_outbox_folder_real_create_email_async_co (_data_);
#line 6028 "smtp-outbox-folder.c"
}


static GearyEmailIdentifier*
geary_smtp_outbox_folder_real_create_email_finish (GearySmtpOutboxFolder* self,
                                                   GAsyncResult* _res_,
                                                   GError** error)
{
	GearyEmailIdentifier* result;
	GearySmtpOutboxFolderCreateEmailAsyncData* _data_;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (NULL == _data_) {
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return NULL;
#line 6045 "smtp-outbox-folder.c"
	}
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	result = _data_->result;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->result = NULL;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return result;
#line 6053 "smtp-outbox-folder.c"
}


static void
geary_smtp_outbox_folder_create_email_async_ready (GObject* source_object,
                                                   GAsyncResult* _res_,
                                                   gpointer _user_data_)
{
	GearySmtpOutboxFolderCreateEmailAsyncData* _data_;
#line 403 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_ = _user_data_;
#line 403 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_source_object_ = source_object;
#line 403 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_res_ = _res_;
#line 403 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_task_complete_ = TRUE;
#line 403 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	geary_smtp_outbox_folder_real_create_email_async_co (_data_);
#line 6073 "smtp-outbox-folder.c"
}


static gboolean
geary_smtp_outbox_folder_real_create_email_async_co (GearySmtpOutboxFolderCreateEmailAsyncData* _data_)
{
#line 399 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	switch (_data_->_state_) {
#line 399 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		case 0:
#line 6084 "smtp-outbox-folder.c"
		goto _state_0;
#line 399 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		case 1:
#line 6088 "smtp-outbox-folder.c"
		goto _state_1;
		default:
#line 399 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_assert_not_reached ();
#line 6093 "smtp-outbox-folder.c"
	}
	_state_0:
#line 401 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	geary_abstract_local_folder_check_open (G_TYPE_CHECK_INSTANCE_CAST (_data_->self, GEARY_TYPE_ABSTRACT_LOCAL_FOLDER, GearyAbstractLocalFolder), &_data_->_inner_error_);
#line 401 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
#line 401 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error_);
#line 401 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_object_unref (_data_->_async_result);
#line 401 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return FALSE;
#line 6106 "smtp-outbox-folder.c"
	}
#line 403 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_state_ = 1;
#line 403 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	geary_smtp_outbox_folder_enqueue_email_async (_data_->self, _data_->rfc822, _data_->cancellable, geary_smtp_outbox_folder_create_email_async_ready, _data_);
#line 403 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return FALSE;
#line 6114 "smtp-outbox-folder.c"
	_state_1:
#line 403 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp1_ = geary_smtp_outbox_folder_enqueue_email_finish (_data_->self, _data_->_res_, &_data_->_inner_error_);
#line 403 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp0_ = _data_->_tmp1_;
#line 403 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
#line 403 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error_);
#line 403 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_object_unref (_data_->_async_result);
#line 403 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return FALSE;
#line 6128 "smtp-outbox-folder.c"
	}
#line 403 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp2_ = _data_->_tmp0_;
#line 403 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp0_ = NULL;
#line 403 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->result = G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp2_, GEARY_TYPE_EMAIL_IDENTIFIER, GearyEmailIdentifier);
#line 403 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_data_->_tmp0_);
#line 403 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 403 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (_data_->_state_ != 0) {
#line 403 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		while (_data_->_task_complete_ != TRUE) {
#line 403 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 6146 "smtp-outbox-folder.c"
		}
	}
#line 403 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_object_unref (_data_->_async_result);
#line 403 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return FALSE;
#line 6153 "smtp-outbox-folder.c"
}


void
geary_smtp_outbox_folder_create_email_async (GearySmtpOutboxFolder* self,
                                             GearyRFC822Message* rfc822,
                                             GearyEmailFlags* flags,
                                             GDateTime* date_received,
                                             GearyEmailIdentifier* id,
                                             GCancellable* cancellable,
                                             GAsyncReadyCallback _callback_,
                                             gpointer _user_data_)
{
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	GEARY_SMTP_OUTBOX_FOLDER_GET_CLASS (self)->create_email_async (self, rfc822, flags, date_received, id, cancellable, _callback_, _user_data_);
#line 6169 "smtp-outbox-folder.c"
}


GearyEmailIdentifier*
geary_smtp_outbox_folder_create_email_finish (GearySmtpOutboxFolder* self,
                                              GAsyncResult* _res_,
                                              GError** error)
{
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return GEARY_SMTP_OUTBOX_FOLDER_GET_CLASS (self)->create_email_finish (self, _res_, error);
#line 6180 "smtp-outbox-folder.c"
}


static void
geary_smtp_outbox_folder_real_list_email_by_id_async_data_free (gpointer _data)
{
	GearySmtpOutboxFolderListEmailByIdAsyncData* _data_;
	_data_ = _data;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_data_->_initial_id);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_data_->result);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_data_->self);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_slice_free (GearySmtpOutboxFolderListEmailByIdAsyncData, _data_);
#line 6197 "smtp-outbox-folder.c"
}


static void
geary_smtp_outbox_folder_real_list_email_by_id_async_async_ready_wrapper (GObject *source_object,
                                                                          GAsyncResult *res,
                                                                          void *user_data)
{
	GearySmtpOutboxFolderListEmailByIdAsyncData* _task_data_;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_task_data_ = g_task_get_task_data (G_TASK (res));
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (_task_data_->_callback_ != NULL) {
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_task_data_->_callback_ (source_object, res, user_data);
#line 6213 "smtp-outbox-folder.c"
	}
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_task_data_->_task_complete_ = TRUE;
#line 6217 "smtp-outbox-folder.c"
}


static void
geary_smtp_outbox_folder_real_list_email_by_id_async (GearyFolder* base,
                                                      GearyEmailIdentifier* _initial_id,
                                                      gint count,
                                                      GearyEmailField required_fields,
                                                      GearyFolderListFlags flags,
                                                      GCancellable* cancellable,
                                                      GAsyncReadyCallback _callback_,
                                                      gpointer _user_data_)
{
	GearySmtpOutboxFolder * self;
	GearySmtpOutboxFolderListEmailByIdAsyncData* _data_;
	GearySmtpOutboxFolder* _tmp0_;
	GearyEmailIdentifier* _tmp1_;
	GCancellable* _tmp2_;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, GEARY_TYPE_SMTP_OUTBOX_FOLDER, GearySmtpOutboxFolder);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_ = g_slice_new0 (GearySmtpOutboxFolderListEmailByIdAsyncData);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_callback_ = _callback_;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), cancellable, geary_smtp_outbox_folder_real_list_email_by_id_async_async_ready_wrapper, _user_data_);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (_callback_ == NULL) {
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_task_complete_ = TRUE;
#line 6248 "smtp-outbox-folder.c"
	}
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_task_set_task_data (_data_->_async_result, _data_, geary_smtp_outbox_folder_real_list_email_by_id_async_data_free);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->self = _tmp0_;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp1_ = _g_object_ref0 (_initial_id);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_data_->_initial_id);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_initial_id = _tmp1_;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->count = count;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->required_fields = required_fields;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->flags = flags;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp2_ = _g_object_ref0 (cancellable);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_data_->cancellable);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->cancellable = _tmp2_;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	geary_smtp_outbox_folder_real_list_email_by_id_async_co (_data_);
#line 6276 "smtp-outbox-folder.c"
}


static GeeList*
geary_smtp_outbox_folder_real_list_email_by_id_finish (GearyFolder* base,
                                                       GAsyncResult* _res_,
                                                       GError** error)
{
	GeeList* result;
	GearySmtpOutboxFolderListEmailByIdAsyncData* _data_;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (NULL == _data_) {
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return NULL;
#line 6293 "smtp-outbox-folder.c"
	}
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	result = _data_->result;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->result = NULL;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return result;
#line 6301 "smtp-outbox-folder.c"
}


static Block78Data*
block78_data_ref (Block78Data* _data78_)
{
#line 406 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_atomic_int_inc (&_data78_->_ref_count_);
#line 406 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return _data78_;
#line 6312 "smtp-outbox-folder.c"
}


static void
block78_data_unref (void * _userdata_)
{
	Block78Data* _data78_;
	_data78_ = (Block78Data*) _userdata_;
#line 406 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (g_atomic_int_dec_and_test (&_data78_->_ref_count_)) {
#line 6323 "smtp-outbox-folder.c"
		GearySmtpOutboxFolder* self;
#line 406 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		self = _data78_->self;
#line 406 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (_data78_->list);
#line 406 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (_data78_->initial_id);
#line 406 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (_data78_->cancellable);
#line 406 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (self);
#line 406 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_slice_free (Block78Data, _data78_);
#line 6337 "smtp-outbox-folder.c"
	}
}


static GearyDbTransactionOutcome
__lambda102_ (Block78Data* _data78_,
              GearyDbConnection* cx,
              GError** error)
{
	GearySmtpOutboxFolder* self;
	GearyDbTransactionOutcome result = 0;
	const gchar* _tmp0_ = NULL;
	gchar* dir = NULL;
	gchar* _tmp1_;
	GearyDbStatement* stmt = NULL;
	GearySmtpOutboxEmailIdentifier* _tmp2_;
	GearyDbResult* results = NULL;
	GearyDbStatement* _tmp33_;
	GearyDbResult* _tmp34_;
	GearyDbResult* _tmp35_;
	gboolean _tmp36_;
	gboolean _tmp37_;
	GeeArrayList* _tmp38_;
	gint position = 0;
	GError * _inner_error_ = NULL;
#line 421 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	self = _data78_->self;
#line 421 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_return_val_if_fail (GEARY_DB_IS_CONNECTION (cx), 0);
#line 422 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (geary_folder_list_flags_is_newest_to_oldest (_data78_->flags)) {
#line 422 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_tmp0_ = "DESC";
#line 6371 "smtp-outbox-folder.c"
	} else {
#line 422 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_tmp0_ = "ASC";
#line 6375 "smtp-outbox-folder.c"
	}
#line 422 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 422 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	dir = _tmp1_;
#line 425 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp2_ = _data78_->initial_id;
#line 425 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (_tmp2_ != NULL) {
#line 6385 "smtp-outbox-folder.c"
		GearyDbStatement* _tmp3_ = NULL;
		const gchar* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		GearyDbStatement* _tmp7_;
		GearyDbStatement* _tmp8_;
		GearyDbStatement* _tmp9_;
		gint64 _tmp10_ = 0LL;
		GearyDbStatement* _tmp17_;
		GearyDbStatement* _tmp18_;
		GearyDbStatement* _tmp19_;
		GearyDbStatement* _tmp20_;
		GearyDbStatement* _tmp21_;
		GearyDbStatement* _tmp22_;
#line 426 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_tmp4_ = dir;
#line 426 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_tmp5_ = g_strdup_printf ("\n" \
"                    SELECT id, ordering, message, sent\n" \
"                    FROM SmtpOutboxTable\n" \
"                    WHERE ordering >= ?\n" \
"                    ORDER BY ordering %s\n" \
"                    LIMIT ?\n" \
"                ", _tmp4_);
#line 426 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_tmp6_ = _tmp5_;
#line 426 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_tmp7_ = geary_db_connection_prepare (cx, _tmp6_, &_inner_error_);
#line 426 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_tmp8_ = _tmp7_;
#line 426 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_free0 (_tmp6_);
#line 426 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_tmp3_ = _tmp8_;
#line 426 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 426 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			g_propagate_error (error, _inner_error_);
#line 426 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_g_object_unref0 (stmt);
#line 426 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_g_free0 (dir);
#line 426 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			return 0;
#line 6424 "smtp-outbox-folder.c"
		}
#line 426 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_tmp9_ = _tmp3_;
#line 426 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_tmp3_ = NULL;
#line 426 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (stmt);
#line 426 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		stmt = _tmp9_;
#line 434 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		if (geary_folder_list_flags_is_including_id (_data78_->flags)) {
#line 6436 "smtp-outbox-folder.c"
			GearySmtpOutboxEmailIdentifier* _tmp11_;
			gint64 _tmp12_;
			gint64 _tmp13_;
#line 434 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp11_ = _data78_->initial_id;
#line 434 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp12_ = geary_smtp_outbox_email_identifier_get_ordering (_tmp11_);
#line 434 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp13_ = _tmp12_;
#line 434 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp10_ = _tmp13_;
#line 6448 "smtp-outbox-folder.c"
		} else {
			GearySmtpOutboxEmailIdentifier* _tmp14_;
			gint64 _tmp15_;
			gint64 _tmp16_;
#line 434 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp14_ = _data78_->initial_id;
#line 434 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp15_ = geary_smtp_outbox_email_identifier_get_ordering (_tmp14_);
#line 434 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp16_ = _tmp15_;
#line 434 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp10_ = _tmp16_ + 1;
#line 6461 "smtp-outbox-folder.c"
		}
#line 433 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_tmp17_ = stmt;
#line 433 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_tmp18_ = geary_db_statement_bind_int64 (_tmp17_, 0, _tmp10_, &_inner_error_);
#line 433 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_tmp19_ = _tmp18_;
#line 433 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (_tmp19_);
#line 433 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 433 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			g_propagate_error (error, _inner_error_);
#line 433 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_g_object_unref0 (_tmp3_);
#line 433 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_g_object_unref0 (stmt);
#line 433 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_g_free0 (dir);
#line 433 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			return 0;
#line 6483 "smtp-outbox-folder.c"
		}
#line 435 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_tmp20_ = stmt;
#line 435 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_tmp21_ = geary_db_statement_bind_int (_tmp20_, 1, _data78_->count, &_inner_error_);
#line 435 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_tmp22_ = _tmp21_;
#line 435 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (_tmp22_);
#line 435 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 435 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			g_propagate_error (error, _inner_error_);
#line 435 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_g_object_unref0 (_tmp3_);
#line 435 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_g_object_unref0 (stmt);
#line 435 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_g_free0 (dir);
#line 435 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			return 0;
#line 6505 "smtp-outbox-folder.c"
		}
#line 425 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (_tmp3_);
#line 6509 "smtp-outbox-folder.c"
	} else {
		GearyDbStatement* _tmp23_ = NULL;
		const gchar* _tmp24_;
		gchar* _tmp25_;
		gchar* _tmp26_;
		GearyDbStatement* _tmp27_;
		GearyDbStatement* _tmp28_;
		GearyDbStatement* _tmp29_;
		GearyDbStatement* _tmp30_;
		GearyDbStatement* _tmp31_;
		GearyDbStatement* _tmp32_;
#line 437 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_tmp24_ = dir;
#line 437 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_tmp25_ = g_strdup_printf ("\n" \
"                    SELECT id, ordering, message, sent\n" \
"                    FROM SmtpOutboxTable\n" \
"                    ORDER BY ordering %s\n" \
"                    LIMIT ?\n" \
"                ", _tmp24_);
#line 437 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_tmp26_ = _tmp25_;
#line 437 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_tmp27_ = geary_db_connection_prepare (cx, _tmp26_, &_inner_error_);
#line 437 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_tmp28_ = _tmp27_;
#line 437 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_free0 (_tmp26_);
#line 437 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_tmp23_ = _tmp28_;
#line 437 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 437 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			g_propagate_error (error, _inner_error_);
#line 437 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_g_object_unref0 (stmt);
#line 437 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_g_free0 (dir);
#line 437 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			return 0;
#line 6545 "smtp-outbox-folder.c"
		}
#line 437 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_tmp29_ = _tmp23_;
#line 437 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_tmp23_ = NULL;
#line 437 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (stmt);
#line 437 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		stmt = _tmp29_;
#line 443 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_tmp30_ = stmt;
#line 443 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_tmp31_ = geary_db_statement_bind_int (_tmp30_, 0, _data78_->count, &_inner_error_);
#line 443 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_tmp32_ = _tmp31_;
#line 443 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (_tmp32_);
#line 443 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 443 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			g_propagate_error (error, _inner_error_);
#line 443 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_g_object_unref0 (_tmp23_);
#line 443 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_g_object_unref0 (stmt);
#line 443 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_g_free0 (dir);
#line 443 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			return 0;
#line 6575 "smtp-outbox-folder.c"
		}
#line 425 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (_tmp23_);
#line 6579 "smtp-outbox-folder.c"
	}
#line 446 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp33_ = stmt;
#line 446 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp34_ = geary_db_statement_exec (_tmp33_, _data78_->cancellable, &_inner_error_);
#line 446 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	results = _tmp34_;
#line 446 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 446 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_propagate_error (error, _inner_error_);
#line 446 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (stmt);
#line 446 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_free0 (dir);
#line 446 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return 0;
#line 6597 "smtp-outbox-folder.c"
	}
#line 447 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp35_ = results;
#line 447 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp36_ = geary_db_result_get_finished (_tmp35_);
#line 447 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp37_ = _tmp36_;
#line 447 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (_tmp37_) {
#line 448 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		result = GEARY_DB_TRANSACTION_OUTCOME_DONE;
#line 448 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (results);
#line 448 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (stmt);
#line 448 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_free0 (dir);
#line 448 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return result;
#line 6617 "smtp-outbox-folder.c"
	}
#line 450 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp38_ = gee_array_list_new (GEARY_TYPE_EMAIL, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 450 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_data78_->list);
#line 450 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data78_->list = G_TYPE_CHECK_INSTANCE_CAST (_tmp38_, GEE_TYPE_LIST, GeeList);
#line 451 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	position = -1;
#line 6627 "smtp-outbox-folder.c"
	{
		gboolean _tmp39_ = FALSE;
#line 452 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_tmp39_ = TRUE;
#line 452 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		while (TRUE) {
#line 6634 "smtp-outbox-folder.c"
			gint64 ordering = 0LL;
			GearyDbResult* _tmp42_;
			gint _tmp43_;
			gint64 _tmp47_ = 0LL;
			GearyDbResult* _tmp48_;
			gboolean _tmp49_ = FALSE;
			GearyDbResult* _tmp50_;
			GearyMemoryBuffer* _tmp51_ = NULL;
			GearyDbResult* _tmp52_;
			GearyMemoryBuffer* _tmp53_;
			GearyEmail* _tmp54_ = NULL;
			gint _tmp55_;
			gint64 _tmp56_;
			GearySmtpOutboxFolderRoot* _tmp57_;
			GearySmtpOutboxFolderOutboxRow* _tmp58_;
			GearySmtpOutboxFolderOutboxRow* _tmp59_;
			GearyEmail* _tmp60_;
			GearyEmail* _tmp61_;
			GeeList* _tmp62_;
			gint _tmp63_ = 0;
			gint _tmp64_;
			gint _tmp65_;
#line 452 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			if (!_tmp39_) {
#line 6659 "smtp-outbox-folder.c"
				gboolean _tmp40_ = FALSE;
				GearyDbResult* _tmp41_;
#line 463 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_tmp41_ = results;
#line 463 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_tmp40_ = geary_db_result_next (_tmp41_, NULL, &_inner_error_);
#line 463 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 463 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					g_propagate_error (error, _inner_error_);
#line 463 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					_g_object_unref0 (results);
#line 463 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					_g_object_unref0 (stmt);
#line 463 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					_g_free0 (dir);
#line 463 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					return 0;
#line 6678 "smtp-outbox-folder.c"
				}
#line 463 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				if (!_tmp40_) {
#line 463 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					break;
#line 6684 "smtp-outbox-folder.c"
				}
			}
#line 452 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp39_ = FALSE;
#line 453 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp42_ = results;
#line 453 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			ordering = geary_db_result_int64_at (_tmp42_, 1, &_inner_error_);
#line 453 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 453 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				g_propagate_error (error, _inner_error_);
#line 453 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_g_object_unref0 (results);
#line 453 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_g_object_unref0 (stmt);
#line 453 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_g_free0 (dir);
#line 453 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				return 0;
#line 6705 "smtp-outbox-folder.c"
			}
#line 454 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp43_ = position;
#line 454 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			if (_tmp43_ == -1) {
#line 6711 "smtp-outbox-folder.c"
				gint _tmp44_ = 0;
				gint64 _tmp45_;
				gint _tmp46_;
#line 455 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_tmp45_ = ordering;
#line 455 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_tmp44_ = geary_smtp_outbox_folder_do_get_position_by_ordering (self, cx, _tmp45_, _data78_->cancellable, &_inner_error_);
#line 455 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 455 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					g_propagate_error (error, _inner_error_);
#line 455 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					_g_object_unref0 (results);
#line 455 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					_g_object_unref0 (stmt);
#line 455 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					_g_free0 (dir);
#line 455 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					return 0;
#line 6731 "smtp-outbox-folder.c"
				}
#line 455 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				position = _tmp44_;
#line 456 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_tmp46_ = position;
#line 456 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_vala_assert (_tmp46_ >= 1, "position >= 1");
#line 6739 "smtp-outbox-folder.c"
			}
#line 459 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp48_ = results;
#line 459 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp47_ = geary_db_result_rowid_at (_tmp48_, 0, &_inner_error_);
#line 459 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 459 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				g_propagate_error (error, _inner_error_);
#line 459 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_g_object_unref0 (results);
#line 459 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_g_object_unref0 (stmt);
#line 459 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_g_free0 (dir);
#line 459 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				return 0;
#line 6757 "smtp-outbox-folder.c"
			}
#line 460 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp50_ = results;
#line 460 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp49_ = geary_db_result_bool_at (_tmp50_, 3, &_inner_error_);
#line 460 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 460 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				g_propagate_error (error, _inner_error_);
#line 460 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_g_object_unref0 (results);
#line 460 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_g_object_unref0 (stmt);
#line 460 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_g_free0 (dir);
#line 460 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				return 0;
#line 6775 "smtp-outbox-folder.c"
			}
#line 460 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp52_ = results;
#line 460 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp53_ = geary_db_result_string_buffer_at (_tmp52_, 2, &_inner_error_);
#line 460 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp51_ = _tmp53_;
#line 460 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 460 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				g_propagate_error (error, _inner_error_);
#line 460 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_g_object_unref0 (results);
#line 460 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_g_object_unref0 (stmt);
#line 460 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_g_free0 (dir);
#line 460 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				return 0;
#line 6795 "smtp-outbox-folder.c"
			}
#line 459 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp55_ = position;
#line 459 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp56_ = ordering;
#line 459 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp57_ = self->priv->_path;
#line 459 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp58_ = geary_smtp_outbox_folder_outbox_row_new (_tmp47_, _tmp55_, _tmp56_, _tmp49_, _tmp51_, _tmp57_);
#line 459 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp59_ = _tmp58_;
#line 459 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp60_ = geary_smtp_outbox_folder_row_to_email (self, _tmp59_, &_inner_error_);
#line 459 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp61_ = _tmp60_;
#line 459 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_geary_smtp_outbox_folder_outbox_row_unref0 (_tmp59_);
#line 459 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp54_ = _tmp61_;
#line 459 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 459 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				g_propagate_error (error, _inner_error_);
#line 459 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_g_object_unref0 (_tmp51_);
#line 459 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_g_object_unref0 (results);
#line 459 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_g_object_unref0 (stmt);
#line 459 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_g_free0 (dir);
#line 459 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				return 0;
#line 6829 "smtp-outbox-folder.c"
			}
#line 459 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp62_ = _data78_->list;
#line 459 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			gee_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp62_, GEE_TYPE_COLLECTION, GeeCollection), _tmp54_);
#line 461 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			if (geary_folder_list_flags_is_newest_to_oldest (_data78_->flags)) {
#line 461 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_tmp63_ = -1;
#line 6839 "smtp-outbox-folder.c"
			} else {
#line 461 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_tmp63_ = 1;
#line 6843 "smtp-outbox-folder.c"
			}
#line 461 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp64_ = position;
#line 461 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			position = _tmp64_ + _tmp63_;
#line 462 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp65_ = position;
#line 462 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_vala_assert (_tmp65_ >= 1, "position >= 1");
#line 452 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_g_object_unref0 (_tmp54_);
#line 452 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_g_object_unref0 (_tmp51_);
#line 6857 "smtp-outbox-folder.c"
		}
	}
#line 465 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	result = GEARY_DB_TRANSACTION_OUTCOME_DONE;
#line 465 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (results);
#line 465 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (stmt);
#line 465 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_free0 (dir);
#line 465 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return result;
#line 6870 "smtp-outbox-folder.c"
}


static GearyDbTransactionOutcome
___lambda102__geary_db_transaction_method (GearyDbConnection* cx,
                                           GCancellable* cancellable,
                                           gpointer self,
                                           GError** error)
{
	GearyDbTransactionOutcome result;
	result = __lambda102_ (self, cx, error);
#line 421 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return result;
#line 6884 "smtp-outbox-folder.c"
}


static void
geary_smtp_outbox_folder_list_email_by_id_async_ready (GObject* source_object,
                                                       GAsyncResult* _res_,
                                                       gpointer _user_data_)
{
	GearySmtpOutboxFolderListEmailByIdAsyncData* _data_;
#line 421 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_ = _user_data_;
#line 421 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_source_object_ = source_object;
#line 421 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_res_ = _res_;
#line 421 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_task_complete_ = TRUE;
#line 421 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	geary_smtp_outbox_folder_real_list_email_by_id_async_co (_data_);
#line 6904 "smtp-outbox-folder.c"
}


static gboolean
geary_smtp_outbox_folder_real_list_email_by_id_async_co (GearySmtpOutboxFolderListEmailByIdAsyncData* _data_)
{
#line 406 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	switch (_data_->_state_) {
#line 406 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		case 0:
#line 6915 "smtp-outbox-folder.c"
		goto _state_0;
#line 406 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		case 1:
#line 6919 "smtp-outbox-folder.c"
		goto _state_1;
		default:
#line 406 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_assert_not_reached ();
#line 6924 "smtp-outbox-folder.c"
	}
	_state_0:
#line 406 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_data78_ = g_slice_new0 (Block78Data);
#line 406 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_data78_->_ref_count_ = 1;
#line 406 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_data78_->self = g_object_ref (_data_->self);
#line 406 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_data78_->count = _data_->count;
#line 406 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_data78_->flags = _data_->flags;
#line 406 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_data_->_data78_->cancellable);
#line 406 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_data78_->cancellable = _data_->cancellable;
#line 406 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_data78_->_async_data_ = _data_;
#line 409 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	geary_abstract_local_folder_check_open (G_TYPE_CHECK_INSTANCE_CAST (_data_->self, GEARY_TYPE_ABSTRACT_LOCAL_FOLDER, GearyAbstractLocalFolder), &_data_->_inner_error_);
#line 409 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
#line 409 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error_);
#line 409 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		block78_data_unref (_data_->_data78_);
#line 409 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_data78_ = NULL;
#line 409 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_object_unref (_data_->_async_result);
#line 409 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return FALSE;
#line 6957 "smtp-outbox-folder.c"
	}
#line 411 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_data_->_initial_id, GEARY_TYPE_SMTP_OUTBOX_EMAIL_IDENTIFIER) ? ((GearySmtpOutboxEmailIdentifier*) _data_->_initial_id) : NULL);
#line 411 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_data78_->initial_id = _data_->_tmp0_;
#line 412 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (_data_->_initial_id != NULL) {
#line 412 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_tmp2_ = _data_->_data78_->initial_id;
#line 412 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_tmp1_ = _data_->_tmp2_ == NULL;
#line 6969 "smtp-outbox-folder.c"
	} else {
#line 412 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_tmp1_ = FALSE;
#line 6973 "smtp-outbox-folder.c"
	}
#line 412 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (_data_->_tmp1_) {
#line 413 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_tmp3_ = _data_->_data78_->initial_id;
#line 413 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_tmp4_ = geary_email_identifier_to_string (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp3_, GEARY_TYPE_EMAIL_IDENTIFIER, GearyEmailIdentifier));
#line 413 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_tmp5_ = _data_->_tmp4_;
#line 413 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_tmp6_ = g_error_new (GEARY_ENGINE_ERROR, GEARY_ENGINE_ERROR_BAD_PARAMETERS, "EmailIdentifier %s not for Outbox", _data_->_tmp5_);
#line 413 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_tmp7_ = _data_->_tmp6_;
#line 413 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_free0 (_data_->_tmp5_);
#line 413 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_inner_error_ = _data_->_tmp7_;
#line 413 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error_);
#line 413 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		block78_data_unref (_data_->_data78_);
#line 413 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_data78_ = NULL;
#line 413 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_object_unref (_data_->_async_result);
#line 413 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return FALSE;
#line 7001 "smtp-outbox-folder.c"
	}
#line 417 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (_data_->_data78_->count <= 0) {
#line 418 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->result = NULL;
#line 418 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		block78_data_unref (_data_->_data78_);
#line 418 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_data78_ = NULL;
#line 418 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 418 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		if (_data_->_state_ != 0) {
#line 418 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			while (_data_->_task_complete_ != TRUE) {
#line 418 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 7019 "smtp-outbox-folder.c"
			}
		}
#line 418 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_object_unref (_data_->_async_result);
#line 418 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return FALSE;
#line 7026 "smtp-outbox-folder.c"
	}
#line 420 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_data78_->list = NULL;
#line 421 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp8_ = _data_->self->priv->db;
#line 421 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_state_ = 1;
#line 421 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	geary_db_database_exec_transaction_async (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp8_, GEARY_DB_TYPE_DATABASE, GearyDbDatabase), GEARY_DB_TRANSACTION_TYPE_RO, ___lambda102__geary_db_transaction_method, _data_->_data78_, _data_->_data78_->cancellable, geary_smtp_outbox_folder_list_email_by_id_async_ready, _data_);
#line 421 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return FALSE;
#line 7038 "smtp-outbox-folder.c"
	_state_1:
#line 421 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	geary_db_database_exec_transaction_finish (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp8_, GEARY_DB_TYPE_DATABASE, GearyDbDatabase), _data_->_res_, &_data_->_inner_error_);
#line 421 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
#line 421 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error_);
#line 421 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		block78_data_unref (_data_->_data78_);
#line 421 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_data78_ = NULL;
#line 421 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_object_unref (_data_->_async_result);
#line 421 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return FALSE;
#line 7054 "smtp-outbox-folder.c"
	}
#line 468 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp9_ = _data_->_data78_->list;
#line 468 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp10_ = _g_object_ref0 (_data_->_tmp9_);
#line 468 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->result = _data_->_tmp10_;
#line 468 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	block78_data_unref (_data_->_data78_);
#line 468 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_data78_ = NULL;
#line 468 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 468 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (_data_->_state_ != 0) {
#line 468 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		while (_data_->_task_complete_ != TRUE) {
#line 468 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 7074 "smtp-outbox-folder.c"
		}
	}
#line 468 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_object_unref (_data_->_async_result);
#line 468 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return FALSE;
#line 7081 "smtp-outbox-folder.c"
}


static void
geary_smtp_outbox_folder_real_list_email_by_sparse_id_async_data_free (gpointer _data)
{
	GearySmtpOutboxFolderListEmailBySparseIdAsyncData* _data_;
	_data_ = _data;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_data_->result);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_data_->self);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_slice_free (GearySmtpOutboxFolderListEmailBySparseIdAsyncData, _data_);
#line 7096 "smtp-outbox-folder.c"
}


static void
geary_smtp_outbox_folder_real_list_email_by_sparse_id_async_async_ready_wrapper (GObject *source_object,
                                                                                 GAsyncResult *res,
                                                                                 void *user_data)
{
	GearySmtpOutboxFolderListEmailBySparseIdAsyncData* _task_data_;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_task_data_ = g_task_get_task_data (G_TASK (res));
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (_task_data_->_callback_ != NULL) {
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_task_data_->_callback_ (source_object, res, user_data);
#line 7112 "smtp-outbox-folder.c"
	}
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_task_data_->_task_complete_ = TRUE;
#line 7116 "smtp-outbox-folder.c"
}


static void
geary_smtp_outbox_folder_real_list_email_by_sparse_id_async (GearyFolder* base,
                                                             GeeCollection* ids,
                                                             GearyEmailField required_fields,
                                                             GearyFolderListFlags flags,
                                                             GCancellable* cancellable,
                                                             GAsyncReadyCallback _callback_,
                                                             gpointer _user_data_)
{
	GearySmtpOutboxFolder * self;
	GearySmtpOutboxFolderListEmailBySparseIdAsyncData* _data_;
	GearySmtpOutboxFolder* _tmp0_;
	GeeCollection* _tmp1_;
	GCancellable* _tmp2_;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, GEARY_TYPE_SMTP_OUTBOX_FOLDER, GearySmtpOutboxFolder);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_ = g_slice_new0 (GearySmtpOutboxFolderListEmailBySparseIdAsyncData);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_callback_ = _callback_;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), cancellable, geary_smtp_outbox_folder_real_list_email_by_sparse_id_async_async_ready_wrapper, _user_data_);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (_callback_ == NULL) {
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_task_complete_ = TRUE;
#line 7146 "smtp-outbox-folder.c"
	}
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_task_set_task_data (_data_->_async_result, _data_, geary_smtp_outbox_folder_real_list_email_by_sparse_id_async_data_free);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->self = _tmp0_;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp1_ = _g_object_ref0 (ids);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_data_->ids);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->ids = _tmp1_;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->required_fields = required_fields;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->flags = flags;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp2_ = _g_object_ref0 (cancellable);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_data_->cancellable);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->cancellable = _tmp2_;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	geary_smtp_outbox_folder_real_list_email_by_sparse_id_async_co (_data_);
#line 7172 "smtp-outbox-folder.c"
}


static GeeList*
geary_smtp_outbox_folder_real_list_email_by_sparse_id_finish (GearyFolder* base,
                                                              GAsyncResult* _res_,
                                                              GError** error)
{
	GeeList* result;
	GearySmtpOutboxFolderListEmailBySparseIdAsyncData* _data_;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (NULL == _data_) {
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return NULL;
#line 7189 "smtp-outbox-folder.c"
	}
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	result = _data_->result;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->result = NULL;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return result;
#line 7197 "smtp-outbox-folder.c"
}


static Block79Data*
block79_data_ref (Block79Data* _data79_)
{
#line 471 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_atomic_int_inc (&_data79_->_ref_count_);
#line 471 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return _data79_;
#line 7208 "smtp-outbox-folder.c"
}


static void
block79_data_unref (void * _userdata_)
{
	Block79Data* _data79_;
	_data79_ = (Block79Data*) _userdata_;
#line 471 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (g_atomic_int_dec_and_test (&_data79_->_ref_count_)) {
#line 7219 "smtp-outbox-folder.c"
		GearySmtpOutboxFolder* self;
#line 471 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		self = _data79_->self;
#line 471 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (_data79_->list);
#line 471 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (_data79_->ids);
#line 471 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (_data79_->cancellable);
#line 471 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (self);
#line 471 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_slice_free (Block79Data, _data79_);
#line 7233 "smtp-outbox-folder.c"
	}
}


static GearyDbTransactionOutcome
__lambda103_ (Block79Data* _data79_,
              GearyDbConnection* cx,
              GError** error)
{
	GearySmtpOutboxFolder* self;
	GearyDbTransactionOutcome result = 0;
	GError * _inner_error_ = NULL;
#line 477 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	self = _data79_->self;
#line 477 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_return_val_if_fail (GEARY_DB_IS_CONNECTION (cx), 0);
#line 7250 "smtp-outbox-folder.c"
	{
		GeeIterator* _id_it = NULL;
		GeeIterator* _tmp0_;
#line 478 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_tmp0_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_data79_->ids, GEE_TYPE_ITERABLE, GeeIterable));
#line 478 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_id_it = _tmp0_;
#line 478 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		while (TRUE) {
#line 7260 "smtp-outbox-folder.c"
			GeeIterator* _tmp1_;
			GearyEmailIdentifier* id = NULL;
			GeeIterator* _tmp2_;
			gpointer _tmp3_;
			GearySmtpOutboxEmailIdentifier* outbox_id = NULL;
			GearyEmailIdentifier* _tmp4_;
			GearySmtpOutboxEmailIdentifier* _tmp5_;
			GearySmtpOutboxEmailIdentifier* _tmp6_;
			GearySmtpOutboxFolderOutboxRow* row = NULL;
			GearySmtpOutboxEmailIdentifier* _tmp12_;
			gint64 _tmp13_;
			gint64 _tmp14_;
			GearySmtpOutboxFolderOutboxRow* _tmp15_;
			GearySmtpOutboxFolderOutboxRow* _tmp16_;
			GearyEmail* _tmp17_ = NULL;
			GearySmtpOutboxFolderOutboxRow* _tmp18_;
			GearyEmail* _tmp19_;
			GeeList* _tmp20_;
#line 478 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp1_ = _id_it;
#line 478 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			if (!gee_iterator_next (_tmp1_)) {
#line 478 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				break;
#line 7285 "smtp-outbox-folder.c"
			}
#line 478 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp2_ = _id_it;
#line 478 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp3_ = gee_iterator_get (_tmp2_);
#line 478 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			id = (GearyEmailIdentifier*) _tmp3_;
#line 479 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp4_ = id;
#line 479 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp5_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp4_, GEARY_TYPE_SMTP_OUTBOX_EMAIL_IDENTIFIER) ? ((GearySmtpOutboxEmailIdentifier*) _tmp4_) : NULL);
#line 479 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			outbox_id = _tmp5_;
#line 480 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp6_ = outbox_id;
#line 480 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			if (_tmp6_ == NULL) {
#line 7303 "smtp-outbox-folder.c"
				GearyEmailIdentifier* _tmp7_;
				gchar* _tmp8_;
				gchar* _tmp9_;
				GError* _tmp10_;
				GError* _tmp11_;
#line 481 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_tmp7_ = id;
#line 481 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_tmp8_ = geary_email_identifier_to_string (_tmp7_);
#line 481 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_tmp9_ = _tmp8_;
#line 481 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_tmp10_ = g_error_new (GEARY_ENGINE_ERROR, GEARY_ENGINE_ERROR_BAD_PARAMETERS, "%s is not outbox EmailIdentifier", _tmp9_);
#line 481 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_tmp11_ = _tmp10_;
#line 481 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_g_free0 (_tmp9_);
#line 481 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_inner_error_ = _tmp11_;
#line 481 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				g_propagate_error (error, _inner_error_);
#line 481 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_g_object_unref0 (outbox_id);
#line 481 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_g_object_unref0 (id);
#line 481 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_g_object_unref0 (_id_it);
#line 481 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				return 0;
#line 7333 "smtp-outbox-folder.c"
			}
#line 483 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp12_ = outbox_id;
#line 483 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp13_ = geary_smtp_outbox_email_identifier_get_ordering (_tmp12_);
#line 483 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp14_ = _tmp13_;
#line 483 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp15_ = geary_smtp_outbox_folder_do_fetch_row_by_ordering (self, cx, _tmp14_, _data79_->cancellable, &_inner_error_);
#line 483 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			row = _tmp15_;
#line 483 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 483 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				g_propagate_error (error, _inner_error_);
#line 483 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_g_object_unref0 (outbox_id);
#line 483 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_g_object_unref0 (id);
#line 483 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_g_object_unref0 (_id_it);
#line 483 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				return 0;
#line 7357 "smtp-outbox-folder.c"
			}
#line 484 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp16_ = row;
#line 484 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			if (_tmp16_ == NULL) {
#line 485 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_geary_smtp_outbox_folder_outbox_row_unref0 (row);
#line 485 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_g_object_unref0 (outbox_id);
#line 485 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_g_object_unref0 (id);
#line 485 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				continue;
#line 7371 "smtp-outbox-folder.c"
			}
#line 487 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp18_ = row;
#line 487 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp19_ = geary_smtp_outbox_folder_row_to_email (self, _tmp18_, &_inner_error_);
#line 487 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp17_ = _tmp19_;
#line 487 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 487 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				g_propagate_error (error, _inner_error_);
#line 487 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_geary_smtp_outbox_folder_outbox_row_unref0 (row);
#line 487 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_g_object_unref0 (outbox_id);
#line 487 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_g_object_unref0 (id);
#line 487 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_g_object_unref0 (_id_it);
#line 487 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				return 0;
#line 7393 "smtp-outbox-folder.c"
			}
#line 487 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp20_ = _data79_->list;
#line 487 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			gee_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp20_, GEE_TYPE_COLLECTION, GeeCollection), _tmp17_);
#line 478 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_g_object_unref0 (_tmp17_);
#line 478 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_geary_smtp_outbox_folder_outbox_row_unref0 (row);
#line 478 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_g_object_unref0 (outbox_id);
#line 478 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_g_object_unref0 (id);
#line 7407 "smtp-outbox-folder.c"
		}
#line 478 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (_id_it);
#line 7411 "smtp-outbox-folder.c"
	}
#line 490 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	result = GEARY_DB_TRANSACTION_OUTCOME_DONE;
#line 490 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return result;
#line 7417 "smtp-outbox-folder.c"
}


static GearyDbTransactionOutcome
___lambda103__geary_db_transaction_method (GearyDbConnection* cx,
                                           GCancellable* cancellable,
                                           gpointer self,
                                           GError** error)
{
	GearyDbTransactionOutcome result;
	result = __lambda103_ (self, cx, error);
#line 477 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return result;
#line 7431 "smtp-outbox-folder.c"
}


static void
geary_smtp_outbox_folder_list_email_by_sparse_id_async_ready (GObject* source_object,
                                                              GAsyncResult* _res_,
                                                              gpointer _user_data_)
{
	GearySmtpOutboxFolderListEmailBySparseIdAsyncData* _data_;
#line 477 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_ = _user_data_;
#line 477 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_source_object_ = source_object;
#line 477 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_res_ = _res_;
#line 477 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_task_complete_ = TRUE;
#line 477 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	geary_smtp_outbox_folder_real_list_email_by_sparse_id_async_co (_data_);
#line 7451 "smtp-outbox-folder.c"
}


static gboolean
geary_smtp_outbox_folder_real_list_email_by_sparse_id_async_co (GearySmtpOutboxFolderListEmailBySparseIdAsyncData* _data_)
{
#line 471 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	switch (_data_->_state_) {
#line 471 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		case 0:
#line 7462 "smtp-outbox-folder.c"
		goto _state_0;
#line 471 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		case 1:
#line 7466 "smtp-outbox-folder.c"
		goto _state_1;
		default:
#line 471 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_assert_not_reached ();
#line 7471 "smtp-outbox-folder.c"
	}
	_state_0:
#line 471 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_data79_ = g_slice_new0 (Block79Data);
#line 471 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_data79_->_ref_count_ = 1;
#line 471 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_data79_->self = g_object_ref (_data_->self);
#line 471 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_data_->_data79_->ids);
#line 471 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_data79_->ids = _data_->ids;
#line 471 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_data_->_data79_->cancellable);
#line 471 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_data79_->cancellable = _data_->cancellable;
#line 471 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_data79_->_async_data_ = _data_;
#line 474 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	geary_abstract_local_folder_check_open (G_TYPE_CHECK_INSTANCE_CAST (_data_->self, GEARY_TYPE_ABSTRACT_LOCAL_FOLDER, GearyAbstractLocalFolder), &_data_->_inner_error_);
#line 474 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
#line 474 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error_);
#line 474 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		block79_data_unref (_data_->_data79_);
#line 474 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_data79_ = NULL;
#line 474 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_object_unref (_data_->_async_result);
#line 474 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return FALSE;
#line 7504 "smtp-outbox-folder.c"
	}
#line 476 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp0_ = gee_array_list_new (GEARY_TYPE_EMAIL, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 476 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_data79_->list = G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp0_, GEE_TYPE_LIST, GeeList);
#line 477 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp1_ = _data_->self->priv->db;
#line 477 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_state_ = 1;
#line 477 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	geary_db_database_exec_transaction_async (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp1_, GEARY_DB_TYPE_DATABASE, GearyDbDatabase), GEARY_DB_TRANSACTION_TYPE_RO, ___lambda103__geary_db_transaction_method, _data_->_data79_, _data_->_data79_->cancellable, geary_smtp_outbox_folder_list_email_by_sparse_id_async_ready, _data_);
#line 477 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return FALSE;
#line 7518 "smtp-outbox-folder.c"
	_state_1:
#line 477 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	geary_db_database_exec_transaction_finish (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp1_, GEARY_DB_TYPE_DATABASE, GearyDbDatabase), _data_->_res_, &_data_->_inner_error_);
#line 477 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
#line 477 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error_);
#line 477 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		block79_data_unref (_data_->_data79_);
#line 477 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_data79_ = NULL;
#line 477 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_object_unref (_data_->_async_result);
#line 477 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return FALSE;
#line 7534 "smtp-outbox-folder.c"
	}
#line 493 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp3_ = _data_->_data79_->list;
#line 493 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp4_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp3_, GEE_TYPE_COLLECTION, GeeCollection));
#line 493 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp5_ = _data_->_tmp4_;
#line 493 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (_data_->_tmp5_ > 0) {
#line 493 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_tmp6_ = _data_->_data79_->list;
#line 493 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_tmp2_ = _data_->_tmp6_;
#line 7548 "smtp-outbox-folder.c"
	} else {
#line 493 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_tmp2_ = NULL;
#line 7552 "smtp-outbox-folder.c"
	}
#line 493 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp7_ = _g_object_ref0 (_data_->_tmp2_);
#line 493 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->result = _data_->_tmp7_;
#line 493 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	block79_data_unref (_data_->_data79_);
#line 493 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_data79_ = NULL;
#line 493 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 493 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (_data_->_state_ != 0) {
#line 493 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		while (_data_->_task_complete_ != TRUE) {
#line 493 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 7570 "smtp-outbox-folder.c"
		}
	}
#line 493 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_object_unref (_data_->_async_result);
#line 493 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return FALSE;
#line 7577 "smtp-outbox-folder.c"
}


static void
geary_smtp_outbox_folder_real_list_local_email_fields_async_data_free (gpointer _data)
{
	GearySmtpOutboxFolderListLocalEmailFieldsAsyncData* _data_;
	_data_ = _data;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_data_->result);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_data_->self);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_slice_free (GearySmtpOutboxFolderListLocalEmailFieldsAsyncData, _data_);
#line 7592 "smtp-outbox-folder.c"
}


static void
geary_smtp_outbox_folder_real_list_local_email_fields_async_async_ready_wrapper (GObject *source_object,
                                                                                 GAsyncResult *res,
                                                                                 void *user_data)
{
	GearySmtpOutboxFolderListLocalEmailFieldsAsyncData* _task_data_;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_task_data_ = g_task_get_task_data (G_TASK (res));
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (_task_data_->_callback_ != NULL) {
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_task_data_->_callback_ (source_object, res, user_data);
#line 7608 "smtp-outbox-folder.c"
	}
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_task_data_->_task_complete_ = TRUE;
#line 7612 "smtp-outbox-folder.c"
}


static void
geary_smtp_outbox_folder_real_list_local_email_fields_async (GearyFolder* base,
                                                             GeeCollection* ids,
                                                             GCancellable* cancellable,
                                                             GAsyncReadyCallback _callback_,
                                                             gpointer _user_data_)
{
	GearySmtpOutboxFolder * self;
	GearySmtpOutboxFolderListLocalEmailFieldsAsyncData* _data_;
	GearySmtpOutboxFolder* _tmp0_;
	GeeCollection* _tmp1_;
	GCancellable* _tmp2_;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, GEARY_TYPE_SMTP_OUTBOX_FOLDER, GearySmtpOutboxFolder);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_ = g_slice_new0 (GearySmtpOutboxFolderListLocalEmailFieldsAsyncData);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_callback_ = _callback_;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), cancellable, geary_smtp_outbox_folder_real_list_local_email_fields_async_async_ready_wrapper, _user_data_);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (_callback_ == NULL) {
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_task_complete_ = TRUE;
#line 7640 "smtp-outbox-folder.c"
	}
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_task_set_task_data (_data_->_async_result, _data_, geary_smtp_outbox_folder_real_list_local_email_fields_async_data_free);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->self = _tmp0_;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp1_ = _g_object_ref0 (ids);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_data_->ids);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->ids = _tmp1_;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp2_ = _g_object_ref0 (cancellable);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_data_->cancellable);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->cancellable = _tmp2_;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	geary_smtp_outbox_folder_real_list_local_email_fields_async_co (_data_);
#line 7662 "smtp-outbox-folder.c"
}


static GeeMap*
geary_smtp_outbox_folder_real_list_local_email_fields_finish (GearyFolder* base,
                                                              GAsyncResult* _res_,
                                                              GError** error)
{
	GeeMap* result;
	GearySmtpOutboxFolderListLocalEmailFieldsAsyncData* _data_;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (NULL == _data_) {
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return NULL;
#line 7679 "smtp-outbox-folder.c"
	}
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	result = _data_->result;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->result = NULL;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return result;
#line 7687 "smtp-outbox-folder.c"
}


static Block80Data*
block80_data_ref (Block80Data* _data80_)
{
#line 496 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_atomic_int_inc (&_data80_->_ref_count_);
#line 496 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return _data80_;
#line 7698 "smtp-outbox-folder.c"
}


static void
block80_data_unref (void * _userdata_)
{
	Block80Data* _data80_;
	_data80_ = (Block80Data*) _userdata_;
#line 496 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (g_atomic_int_dec_and_test (&_data80_->_ref_count_)) {
#line 7709 "smtp-outbox-folder.c"
		GearySmtpOutboxFolder* self;
#line 496 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		self = _data80_->self;
#line 496 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (_data80_->map);
#line 496 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (_data80_->ids);
#line 496 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (_data80_->cancellable);
#line 496 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (self);
#line 496 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_slice_free (Block80Data, _data80_);
#line 7723 "smtp-outbox-folder.c"
	}
}


static GearyDbTransactionOutcome
__lambda104_ (Block80Data* _data80_,
              GearyDbConnection* cx,
              GError** error)
{
	GearySmtpOutboxFolder* self;
	GearyDbTransactionOutcome result = 0;
	GearyDbStatement* stmt = NULL;
	GearyDbStatement* _tmp0_;
	GError * _inner_error_ = NULL;
#line 503 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	self = _data80_->self;
#line 503 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_return_val_if_fail (GEARY_DB_IS_CONNECTION (cx), 0);
#line 504 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp0_ = geary_db_connection_prepare (cx, "SELECT id FROM SmtpOutboxTable WHERE ordering=?", &_inner_error_);
#line 504 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	stmt = _tmp0_;
#line 504 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 504 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_propagate_error (error, _inner_error_);
#line 504 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return 0;
#line 7752 "smtp-outbox-folder.c"
	}
	{
		GeeIterator* _id_it = NULL;
		GeeIterator* _tmp1_;
#line 506 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_tmp1_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_data80_->ids, GEE_TYPE_ITERABLE, GeeIterable));
#line 506 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_id_it = _tmp1_;
#line 506 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		while (TRUE) {
#line 7763 "smtp-outbox-folder.c"
			GeeIterator* _tmp2_;
			GearyEmailIdentifier* id = NULL;
			GeeIterator* _tmp3_;
			gpointer _tmp4_;
			GearySmtpOutboxEmailIdentifier* outbox_id = NULL;
			GearyEmailIdentifier* _tmp5_;
			GearySmtpOutboxEmailIdentifier* _tmp6_;
			GearySmtpOutboxEmailIdentifier* _tmp7_;
			GearyDbStatement* _tmp13_;
			GearyDbStatement* _tmp14_;
			GearyDbStatement* _tmp15_;
			GearyDbStatement* _tmp16_;
			GearySmtpOutboxEmailIdentifier* _tmp17_;
			gint64 _tmp18_;
			gint64 _tmp19_;
			GearyDbStatement* _tmp20_;
			GearyDbStatement* _tmp21_;
			GearyDbResult* results = NULL;
			GearyDbStatement* _tmp22_;
			GearyDbResult* _tmp23_;
			GearyDbResult* _tmp24_;
			gboolean _tmp25_;
			gboolean _tmp26_;
#line 506 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp2_ = _id_it;
#line 506 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			if (!gee_iterator_next (_tmp2_)) {
#line 506 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				break;
#line 7793 "smtp-outbox-folder.c"
			}
#line 506 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp3_ = _id_it;
#line 506 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp4_ = gee_iterator_get (_tmp3_);
#line 506 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			id = (GearyEmailIdentifier*) _tmp4_;
#line 507 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp5_ = id;
#line 507 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp6_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp5_, GEARY_TYPE_SMTP_OUTBOX_EMAIL_IDENTIFIER) ? ((GearySmtpOutboxEmailIdentifier*) _tmp5_) : NULL);
#line 507 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			outbox_id = _tmp6_;
#line 508 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp7_ = outbox_id;
#line 508 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			if (_tmp7_ == NULL) {
#line 7811 "smtp-outbox-folder.c"
				GearyEmailIdentifier* _tmp8_;
				gchar* _tmp9_;
				gchar* _tmp10_;
				GError* _tmp11_;
				GError* _tmp12_;
#line 509 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_tmp8_ = id;
#line 509 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_tmp9_ = geary_email_identifier_to_string (_tmp8_);
#line 509 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_tmp10_ = _tmp9_;
#line 509 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_tmp11_ = g_error_new (GEARY_ENGINE_ERROR, GEARY_ENGINE_ERROR_BAD_PARAMETERS, "%s is not outbox EmailIdentifier", _tmp10_);
#line 509 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_tmp12_ = _tmp11_;
#line 509 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_g_free0 (_tmp10_);
#line 509 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_inner_error_ = _tmp12_;
#line 509 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				g_propagate_error (error, _inner_error_);
#line 509 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_g_object_unref0 (outbox_id);
#line 509 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_g_object_unref0 (id);
#line 509 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_g_object_unref0 (_id_it);
#line 509 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_g_object_unref0 (stmt);
#line 509 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				return 0;
#line 7843 "smtp-outbox-folder.c"
			}
#line 511 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp13_ = stmt;
#line 511 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp14_ = geary_db_statement_reset (_tmp13_, GEARY_DB_RESET_SCOPE_CLEAR_BINDINGS, &_inner_error_);
#line 511 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp15_ = _tmp14_;
#line 511 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_g_object_unref0 (_tmp15_);
#line 511 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 511 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				g_propagate_error (error, _inner_error_);
#line 511 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_g_object_unref0 (outbox_id);
#line 511 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_g_object_unref0 (id);
#line 511 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_g_object_unref0 (_id_it);
#line 511 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_g_object_unref0 (stmt);
#line 511 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				return 0;
#line 7867 "smtp-outbox-folder.c"
			}
#line 512 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp16_ = stmt;
#line 512 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp17_ = outbox_id;
#line 512 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp18_ = geary_smtp_outbox_email_identifier_get_ordering (_tmp17_);
#line 512 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp19_ = _tmp18_;
#line 512 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp20_ = geary_db_statement_bind_int64 (_tmp16_, 0, _tmp19_, &_inner_error_);
#line 512 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp21_ = _tmp20_;
#line 512 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_g_object_unref0 (_tmp21_);
#line 512 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 512 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				g_propagate_error (error, _inner_error_);
#line 512 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_g_object_unref0 (outbox_id);
#line 512 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_g_object_unref0 (id);
#line 512 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_g_object_unref0 (_id_it);
#line 512 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_g_object_unref0 (stmt);
#line 512 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				return 0;
#line 7897 "smtp-outbox-folder.c"
			}
#line 515 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp22_ = stmt;
#line 515 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp23_ = geary_db_statement_exec (_tmp22_, _data80_->cancellable, &_inner_error_);
#line 515 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			results = _tmp23_;
#line 515 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 515 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				g_propagate_error (error, _inner_error_);
#line 515 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_g_object_unref0 (outbox_id);
#line 515 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_g_object_unref0 (id);
#line 515 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_g_object_unref0 (_id_it);
#line 515 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_g_object_unref0 (stmt);
#line 515 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				return 0;
#line 7919 "smtp-outbox-folder.c"
			}
#line 516 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp24_ = results;
#line 516 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp25_ = geary_db_result_get_finished (_tmp24_);
#line 516 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp26_ = _tmp25_;
#line 516 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			if (!_tmp26_) {
#line 7929 "smtp-outbox-folder.c"
				GeeMap* _tmp27_;
				GearySmtpOutboxEmailIdentifier* _tmp28_;
#line 517 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_tmp27_ = _data80_->map;
#line 517 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_tmp28_ = outbox_id;
#line 517 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				gee_map_set (_tmp27_, G_TYPE_CHECK_INSTANCE_CAST (_tmp28_, GEARY_TYPE_EMAIL_IDENTIFIER, GearyEmailIdentifier), (gpointer) ((gintptr) GEARY_EMAIL_FIELD_ALL));
#line 7938 "smtp-outbox-folder.c"
			}
#line 506 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_g_object_unref0 (results);
#line 506 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_g_object_unref0 (outbox_id);
#line 506 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_g_object_unref0 (id);
#line 7946 "smtp-outbox-folder.c"
		}
#line 506 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (_id_it);
#line 7950 "smtp-outbox-folder.c"
	}
#line 520 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	result = GEARY_DB_TRANSACTION_OUTCOME_DONE;
#line 520 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (stmt);
#line 520 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return result;
#line 7958 "smtp-outbox-folder.c"
}


static GearyDbTransactionOutcome
___lambda104__geary_db_transaction_method (GearyDbConnection* cx,
                                           GCancellable* cancellable,
                                           gpointer self,
                                           GError** error)
{
	GearyDbTransactionOutcome result;
	result = __lambda104_ (self, cx, error);
#line 503 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return result;
#line 7972 "smtp-outbox-folder.c"
}


static void
geary_smtp_outbox_folder_list_local_email_fields_async_ready (GObject* source_object,
                                                              GAsyncResult* _res_,
                                                              gpointer _user_data_)
{
	GearySmtpOutboxFolderListLocalEmailFieldsAsyncData* _data_;
#line 503 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_ = _user_data_;
#line 503 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_source_object_ = source_object;
#line 503 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_res_ = _res_;
#line 503 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_task_complete_ = TRUE;
#line 503 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	geary_smtp_outbox_folder_real_list_local_email_fields_async_co (_data_);
#line 7992 "smtp-outbox-folder.c"
}


static gboolean
geary_smtp_outbox_folder_real_list_local_email_fields_async_co (GearySmtpOutboxFolderListLocalEmailFieldsAsyncData* _data_)
{
#line 496 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	switch (_data_->_state_) {
#line 496 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		case 0:
#line 8003 "smtp-outbox-folder.c"
		goto _state_0;
#line 496 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		case 1:
#line 8007 "smtp-outbox-folder.c"
		goto _state_1;
		default:
#line 496 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_assert_not_reached ();
#line 8012 "smtp-outbox-folder.c"
	}
	_state_0:
#line 496 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_data80_ = g_slice_new0 (Block80Data);
#line 496 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_data80_->_ref_count_ = 1;
#line 496 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_data80_->self = g_object_ref (_data_->self);
#line 496 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_data_->_data80_->ids);
#line 496 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_data80_->ids = _data_->ids;
#line 496 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_data_->_data80_->cancellable);
#line 496 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_data80_->cancellable = _data_->cancellable;
#line 496 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_data80_->_async_data_ = _data_;
#line 499 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	geary_abstract_local_folder_check_open (G_TYPE_CHECK_INSTANCE_CAST (_data_->self, GEARY_TYPE_ABSTRACT_LOCAL_FOLDER, GearyAbstractLocalFolder), &_data_->_inner_error_);
#line 499 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
#line 499 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error_);
#line 499 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		block80_data_unref (_data_->_data80_);
#line 499 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_data80_ = NULL;
#line 499 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_object_unref (_data_->_async_result);
#line 499 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return FALSE;
#line 8045 "smtp-outbox-folder.c"
	}
#line 501 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp0_ = gee_hash_map_new (GEARY_TYPE_EMAIL_IDENTIFIER, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, GEARY_EMAIL_TYPE_FIELD, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 501 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_data80_->map = G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp0_, GEE_TYPE_MAP, GeeMap);
#line 503 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp1_ = _data_->self->priv->db;
#line 503 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_state_ = 1;
#line 503 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	geary_db_database_exec_transaction_async (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp1_, GEARY_DB_TYPE_DATABASE, GearyDbDatabase), GEARY_DB_TRANSACTION_TYPE_RO, ___lambda104__geary_db_transaction_method, _data_->_data80_, _data_->_data80_->cancellable, geary_smtp_outbox_folder_list_local_email_fields_async_ready, _data_);
#line 503 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return FALSE;
#line 8059 "smtp-outbox-folder.c"
	_state_1:
#line 503 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	geary_db_database_exec_transaction_finish (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp1_, GEARY_DB_TYPE_DATABASE, GearyDbDatabase), _data_->_res_, &_data_->_inner_error_);
#line 503 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
#line 503 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error_);
#line 503 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		block80_data_unref (_data_->_data80_);
#line 503 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_data80_ = NULL;
#line 503 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_object_unref (_data_->_async_result);
#line 503 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return FALSE;
#line 8075 "smtp-outbox-folder.c"
	}
#line 523 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp3_ = _data_->_data80_->map;
#line 523 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp4_ = gee_map_get_size (_data_->_tmp3_);
#line 523 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp5_ = _data_->_tmp4_;
#line 523 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (_data_->_tmp5_ > 0) {
#line 523 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_tmp6_ = _data_->_data80_->map;
#line 523 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_tmp2_ = _data_->_tmp6_;
#line 8089 "smtp-outbox-folder.c"
	} else {
#line 523 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_tmp2_ = NULL;
#line 8093 "smtp-outbox-folder.c"
	}
#line 523 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp7_ = _g_object_ref0 (_data_->_tmp2_);
#line 523 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->result = _data_->_tmp7_;
#line 523 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	block80_data_unref (_data_->_data80_);
#line 523 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_data80_ = NULL;
#line 523 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 523 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (_data_->_state_ != 0) {
#line 523 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		while (_data_->_task_complete_ != TRUE) {
#line 523 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 8111 "smtp-outbox-folder.c"
		}
	}
#line 523 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_object_unref (_data_->_async_result);
#line 523 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return FALSE;
#line 8118 "smtp-outbox-folder.c"
}


static void
geary_smtp_outbox_folder_real_fetch_email_async_data_free (gpointer _data)
{
	GearySmtpOutboxFolderFetchEmailAsyncData* _data_;
	_data_ = _data;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_data_->id);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_data_->result);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_data_->self);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_slice_free (GearySmtpOutboxFolderFetchEmailAsyncData, _data_);
#line 8135 "smtp-outbox-folder.c"
}


static void
geary_smtp_outbox_folder_real_fetch_email_async_async_ready_wrapper (GObject *source_object,
                                                                     GAsyncResult *res,
                                                                     void *user_data)
{
	GearySmtpOutboxFolderFetchEmailAsyncData* _task_data_;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_task_data_ = g_task_get_task_data (G_TASK (res));
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (_task_data_->_callback_ != NULL) {
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_task_data_->_callback_ (source_object, res, user_data);
#line 8151 "smtp-outbox-folder.c"
	}
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_task_data_->_task_complete_ = TRUE;
#line 8155 "smtp-outbox-folder.c"
}


static void
geary_smtp_outbox_folder_real_fetch_email_async (GearyFolder* base,
                                                 GearyEmailIdentifier* id,
                                                 GearyEmailField required_fields,
                                                 GearyFolderListFlags flags,
                                                 GCancellable* cancellable,
                                                 GAsyncReadyCallback _callback_,
                                                 gpointer _user_data_)
{
	GearySmtpOutboxFolder * self;
	GearySmtpOutboxFolderFetchEmailAsyncData* _data_;
	GearySmtpOutboxFolder* _tmp0_;
	GearyEmailIdentifier* _tmp1_;
	GCancellable* _tmp2_;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, GEARY_TYPE_SMTP_OUTBOX_FOLDER, GearySmtpOutboxFolder);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_ = g_slice_new0 (GearySmtpOutboxFolderFetchEmailAsyncData);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_callback_ = _callback_;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), cancellable, geary_smtp_outbox_folder_real_fetch_email_async_async_ready_wrapper, _user_data_);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (_callback_ == NULL) {
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_task_complete_ = TRUE;
#line 8185 "smtp-outbox-folder.c"
	}
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_task_set_task_data (_data_->_async_result, _data_, geary_smtp_outbox_folder_real_fetch_email_async_data_free);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->self = _tmp0_;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp1_ = _g_object_ref0 (id);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_data_->id);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->id = _tmp1_;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->required_fields = required_fields;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->flags = flags;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp2_ = _g_object_ref0 (cancellable);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_data_->cancellable);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->cancellable = _tmp2_;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	geary_smtp_outbox_folder_real_fetch_email_async_co (_data_);
#line 8211 "smtp-outbox-folder.c"
}


static GearyEmail*
geary_smtp_outbox_folder_real_fetch_email_finish (GearyFolder* base,
                                                  GAsyncResult* _res_,
                                                  GError** error)
{
	GearyEmail* result;
	GearySmtpOutboxFolderFetchEmailAsyncData* _data_;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (NULL == _data_) {
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return NULL;
#line 8228 "smtp-outbox-folder.c"
	}
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	result = _data_->result;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->result = NULL;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return result;
#line 8236 "smtp-outbox-folder.c"
}


static Block81Data*
block81_data_ref (Block81Data* _data81_)
{
#line 526 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_atomic_int_inc (&_data81_->_ref_count_);
#line 526 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return _data81_;
#line 8247 "smtp-outbox-folder.c"
}


static void
block81_data_unref (void * _userdata_)
{
	Block81Data* _data81_;
	_data81_ = (Block81Data*) _userdata_;
#line 526 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (g_atomic_int_dec_and_test (&_data81_->_ref_count_)) {
#line 8258 "smtp-outbox-folder.c"
		GearySmtpOutboxFolder* self;
#line 526 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		self = _data81_->self;
#line 526 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_geary_smtp_outbox_folder_outbox_row_unref0 (_data81_->row);
#line 526 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (_data81_->outbox_id);
#line 526 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (_data81_->cancellable);
#line 526 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (self);
#line 526 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_slice_free (Block81Data, _data81_);
#line 8272 "smtp-outbox-folder.c"
	}
}


static GearyDbTransactionOutcome
__lambda105_ (Block81Data* _data81_,
              GearyDbConnection* cx,
              GError** error)
{
	GearySmtpOutboxFolder* self;
	GearyDbTransactionOutcome result = 0;
	GearySmtpOutboxFolderOutboxRow* _tmp0_ = NULL;
	GearySmtpOutboxEmailIdentifier* _tmp1_;
	gint64 _tmp2_;
	gint64 _tmp3_;
	GearySmtpOutboxFolderOutboxRow* _tmp4_;
	GearySmtpOutboxFolderOutboxRow* _tmp5_;
	GError * _inner_error_ = NULL;
#line 536 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	self = _data81_->self;
#line 536 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_return_val_if_fail (GEARY_DB_IS_CONNECTION (cx), 0);
#line 537 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp1_ = _data81_->outbox_id;
#line 537 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp2_ = geary_smtp_outbox_email_identifier_get_ordering (_tmp1_);
#line 537 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp3_ = _tmp2_;
#line 537 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp4_ = geary_smtp_outbox_folder_do_fetch_row_by_ordering (self, cx, _tmp3_, _data81_->cancellable, &_inner_error_);
#line 537 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp0_ = _tmp4_;
#line 537 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 537 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_propagate_error (error, _inner_error_);
#line 537 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return 0;
#line 8311 "smtp-outbox-folder.c"
	}
#line 537 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp5_ = _tmp0_;
#line 537 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp0_ = NULL;
#line 537 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_geary_smtp_outbox_folder_outbox_row_unref0 (_data81_->row);
#line 537 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data81_->row = _tmp5_;
#line 539 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	result = GEARY_DB_TRANSACTION_OUTCOME_DONE;
#line 539 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_geary_smtp_outbox_folder_outbox_row_unref0 (_tmp0_);
#line 539 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return result;
#line 8327 "smtp-outbox-folder.c"
}


static GearyDbTransactionOutcome
___lambda105__geary_db_transaction_method (GearyDbConnection* cx,
                                           GCancellable* cancellable,
                                           gpointer self,
                                           GError** error)
{
	GearyDbTransactionOutcome result;
	result = __lambda105_ (self, cx, error);
#line 536 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return result;
#line 8341 "smtp-outbox-folder.c"
}


static void
geary_smtp_outbox_folder_fetch_email_async_ready (GObject* source_object,
                                                  GAsyncResult* _res_,
                                                  gpointer _user_data_)
{
	GearySmtpOutboxFolderFetchEmailAsyncData* _data_;
#line 536 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_ = _user_data_;
#line 536 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_source_object_ = source_object;
#line 536 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_res_ = _res_;
#line 536 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_task_complete_ = TRUE;
#line 536 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	geary_smtp_outbox_folder_real_fetch_email_async_co (_data_);
#line 8361 "smtp-outbox-folder.c"
}


static gboolean
geary_smtp_outbox_folder_real_fetch_email_async_co (GearySmtpOutboxFolderFetchEmailAsyncData* _data_)
{
#line 526 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	switch (_data_->_state_) {
#line 526 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		case 0:
#line 8372 "smtp-outbox-folder.c"
		goto _state_0;
#line 526 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		case 1:
#line 8376 "smtp-outbox-folder.c"
		goto _state_1;
		default:
#line 526 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_assert_not_reached ();
#line 8381 "smtp-outbox-folder.c"
	}
	_state_0:
#line 526 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_data81_ = g_slice_new0 (Block81Data);
#line 526 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_data81_->_ref_count_ = 1;
#line 526 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_data81_->self = g_object_ref (_data_->self);
#line 526 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_data_->_data81_->cancellable);
#line 526 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_data81_->cancellable = _data_->cancellable;
#line 526 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_data81_->_async_data_ = _data_;
#line 529 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	geary_abstract_local_folder_check_open (G_TYPE_CHECK_INSTANCE_CAST (_data_->self, GEARY_TYPE_ABSTRACT_LOCAL_FOLDER, GearyAbstractLocalFolder), &_data_->_inner_error_);
#line 529 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
#line 529 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error_);
#line 529 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		block81_data_unref (_data_->_data81_);
#line 529 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_data81_ = NULL;
#line 529 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_object_unref (_data_->_async_result);
#line 529 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return FALSE;
#line 8410 "smtp-outbox-folder.c"
	}
#line 531 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_data_->id, GEARY_TYPE_SMTP_OUTBOX_EMAIL_IDENTIFIER) ? ((GearySmtpOutboxEmailIdentifier*) _data_->id) : NULL);
#line 531 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_data81_->outbox_id = _data_->_tmp0_;
#line 532 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp1_ = _data_->_data81_->outbox_id;
#line 532 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (_data_->_tmp1_ == NULL) {
#line 533 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_tmp2_ = geary_email_identifier_to_string (_data_->id);
#line 533 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_tmp3_ = _data_->_tmp2_;
#line 533 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_tmp4_ = g_error_new (GEARY_ENGINE_ERROR, GEARY_ENGINE_ERROR_BAD_PARAMETERS, "%s is not outbox EmailIdentifier", _data_->_tmp3_);
#line 533 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_tmp5_ = _data_->_tmp4_;
#line 533 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_free0 (_data_->_tmp3_);
#line 533 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_inner_error_ = _data_->_tmp5_;
#line 533 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error_);
#line 533 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		block81_data_unref (_data_->_data81_);
#line 533 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_data81_ = NULL;
#line 533 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_object_unref (_data_->_async_result);
#line 533 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return FALSE;
#line 8442 "smtp-outbox-folder.c"
	}
#line 535 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_data81_->row = NULL;
#line 536 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp6_ = _data_->self->priv->db;
#line 536 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_state_ = 1;
#line 536 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	geary_db_database_exec_transaction_async (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp6_, GEARY_DB_TYPE_DATABASE, GearyDbDatabase), GEARY_DB_TRANSACTION_TYPE_RO, ___lambda105__geary_db_transaction_method, _data_->_data81_, _data_->_data81_->cancellable, geary_smtp_outbox_folder_fetch_email_async_ready, _data_);
#line 536 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return FALSE;
#line 8454 "smtp-outbox-folder.c"
	_state_1:
#line 536 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	geary_db_database_exec_transaction_finish (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp6_, GEARY_DB_TYPE_DATABASE, GearyDbDatabase), _data_->_res_, &_data_->_inner_error_);
#line 536 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
#line 536 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error_);
#line 536 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		block81_data_unref (_data_->_data81_);
#line 536 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_data81_ = NULL;
#line 536 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_object_unref (_data_->_async_result);
#line 536 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return FALSE;
#line 8470 "smtp-outbox-folder.c"
	}
#line 542 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp7_ = _data_->_data81_->row;
#line 542 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (_data_->_tmp7_ == NULL) {
#line 543 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_tmp8_ = geary_email_identifier_to_string (_data_->id);
#line 543 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_tmp9_ = _data_->_tmp8_;
#line 543 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_tmp10_ = g_error_new (GEARY_ENGINE_ERROR, GEARY_ENGINE_ERROR_NOT_FOUND, "No message with ID %s in outbox", _data_->_tmp9_);
#line 543 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_tmp11_ = _data_->_tmp10_;
#line 543 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_free0 (_data_->_tmp9_);
#line 543 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_inner_error_ = _data_->_tmp11_;
#line 543 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error_);
#line 543 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		block81_data_unref (_data_->_data81_);
#line 543 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_data81_ = NULL;
#line 543 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_object_unref (_data_->_async_result);
#line 543 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return FALSE;
#line 8498 "smtp-outbox-folder.c"
	}
#line 545 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp13_ = _data_->_data81_->row;
#line 545 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp14_ = geary_smtp_outbox_folder_row_to_email (_data_->self, _data_->_tmp13_, &_data_->_inner_error_);
#line 545 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp12_ = _data_->_tmp14_;
#line 545 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
#line 545 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error_);
#line 545 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		block81_data_unref (_data_->_data81_);
#line 545 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_data81_ = NULL;
#line 545 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_object_unref (_data_->_async_result);
#line 545 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return FALSE;
#line 8518 "smtp-outbox-folder.c"
	}
#line 545 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp15_ = _data_->_tmp12_;
#line 545 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp12_ = NULL;
#line 545 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->result = _data_->_tmp15_;
#line 545 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_data_->_tmp12_);
#line 545 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	block81_data_unref (_data_->_data81_);
#line 545 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_data81_ = NULL;
#line 545 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 545 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (_data_->_state_ != 0) {
#line 545 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		while (_data_->_task_complete_ != TRUE) {
#line 545 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 8540 "smtp-outbox-folder.c"
		}
	}
#line 545 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_object_unref (_data_->_async_result);
#line 545 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return FALSE;
#line 8547 "smtp-outbox-folder.c"
}


static void
geary_smtp_outbox_folder_mark_email_as_sent_async_data_free (gpointer _data)
{
	GearySmtpOutboxFolderMarkEmailAsSentAsyncData* _data_;
	_data_ = _data;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_data_->self);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_slice_free (GearySmtpOutboxFolderMarkEmailAsSentAsyncData, _data_);
#line 8560 "smtp-outbox-folder.c"
}


static void
geary_smtp_outbox_folder_mark_email_as_sent_async_async_ready_wrapper (GObject *source_object,
                                                                       GAsyncResult *res,
                                                                       void *user_data)
{
	GearySmtpOutboxFolderMarkEmailAsSentAsyncData* _task_data_;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_task_data_ = g_task_get_task_data (G_TASK (res));
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (_task_data_->_callback_ != NULL) {
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_task_data_->_callback_ (source_object, res, user_data);
#line 8576 "smtp-outbox-folder.c"
	}
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_task_data_->_task_complete_ = TRUE;
#line 8580 "smtp-outbox-folder.c"
}


static void
geary_smtp_outbox_folder_mark_email_as_sent_async (GearySmtpOutboxFolder* self,
                                                   GearySmtpOutboxEmailIdentifier* outbox_id,
                                                   GCancellable* cancellable,
                                                   GAsyncReadyCallback _callback_,
                                                   gpointer _user_data_)
{
	GearySmtpOutboxFolderMarkEmailAsSentAsyncData* _data_;
	GearySmtpOutboxFolder* _tmp0_;
	GearySmtpOutboxEmailIdentifier* _tmp1_;
	GCancellable* _tmp2_;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_ = g_slice_new0 (GearySmtpOutboxFolderMarkEmailAsSentAsyncData);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_callback_ = _callback_;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), cancellable, geary_smtp_outbox_folder_mark_email_as_sent_async_async_ready_wrapper, _user_data_);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (_callback_ == NULL) {
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_task_complete_ = TRUE;
#line 8605 "smtp-outbox-folder.c"
	}
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_task_set_task_data (_data_->_async_result, _data_, geary_smtp_outbox_folder_mark_email_as_sent_async_data_free);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->self = _tmp0_;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp1_ = _g_object_ref0 (outbox_id);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_data_->outbox_id);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->outbox_id = _tmp1_;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp2_ = _g_object_ref0 (cancellable);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_data_->cancellable);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->cancellable = _tmp2_;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	geary_smtp_outbox_folder_mark_email_as_sent_async_co (_data_);
#line 8627 "smtp-outbox-folder.c"
}


static void
geary_smtp_outbox_folder_mark_email_as_sent_finish (GearySmtpOutboxFolder* self,
                                                    GAsyncResult* _res_,
                                                    GError** error)
{
	GearySmtpOutboxFolderMarkEmailAsSentAsyncData* _data_;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (NULL == _data_) {
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return;
#line 8643 "smtp-outbox-folder.c"
	}
}


static Block82Data*
block82_data_ref (Block82Data* _data82_)
{
#line 548 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_atomic_int_inc (&_data82_->_ref_count_);
#line 548 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return _data82_;
#line 8655 "smtp-outbox-folder.c"
}


static void
block82_data_unref (void * _userdata_)
{
	Block82Data* _data82_;
	_data82_ = (Block82Data*) _userdata_;
#line 548 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (g_atomic_int_dec_and_test (&_data82_->_ref_count_)) {
#line 8666 "smtp-outbox-folder.c"
		GearySmtpOutboxFolder* self;
#line 548 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		self = _data82_->self;
#line 548 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (_data82_->outbox_id);
#line 548 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (_data82_->cancellable);
#line 548 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (self);
#line 548 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_slice_free (Block82Data, _data82_);
#line 8678 "smtp-outbox-folder.c"
	}
}


static GearyDbTransactionOutcome
__lambda96_ (Block82Data* _data82_,
             GearyDbConnection* cx,
             GError** error)
{
	GearySmtpOutboxFolder* self;
	GearyDbTransactionOutcome result = 0;
	GError * _inner_error_ = NULL;
#line 550 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	self = _data82_->self;
#line 550 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_return_val_if_fail (GEARY_DB_IS_CONNECTION (cx), 0);
#line 551 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	geary_smtp_outbox_folder_do_mark_email_as_sent (self, cx, _data82_->outbox_id, _data82_->cancellable, &_inner_error_);
#line 551 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 551 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_propagate_error (error, _inner_error_);
#line 551 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return 0;
#line 8703 "smtp-outbox-folder.c"
	}
#line 553 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	result = GEARY_DB_TRANSACTION_OUTCOME_COMMIT;
#line 553 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return result;
#line 8709 "smtp-outbox-folder.c"
}


static GearyDbTransactionOutcome
___lambda96__geary_db_transaction_method (GearyDbConnection* cx,
                                          GCancellable* cancellable,
                                          gpointer self,
                                          GError** error)
{
	GearyDbTransactionOutcome result;
	result = __lambda96_ (self, cx, error);
#line 550 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return result;
#line 8723 "smtp-outbox-folder.c"
}


static void
geary_smtp_outbox_folder_mark_email_as_sent_async_ready (GObject* source_object,
                                                         GAsyncResult* _res_,
                                                         gpointer _user_data_)
{
	GearySmtpOutboxFolderMarkEmailAsSentAsyncData* _data_;
#line 550 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_ = _user_data_;
#line 550 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_source_object_ = source_object;
#line 550 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_res_ = _res_;
#line 550 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_task_complete_ = TRUE;
#line 550 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	geary_smtp_outbox_folder_mark_email_as_sent_async_co (_data_);
#line 8743 "smtp-outbox-folder.c"
}


static gboolean
geary_smtp_outbox_folder_mark_email_as_sent_async_co (GearySmtpOutboxFolderMarkEmailAsSentAsyncData* _data_)
{
#line 548 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	switch (_data_->_state_) {
#line 548 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		case 0:
#line 8754 "smtp-outbox-folder.c"
		goto _state_0;
#line 548 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		case 1:
#line 8758 "smtp-outbox-folder.c"
		goto _state_1;
		default:
#line 548 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_assert_not_reached ();
#line 8763 "smtp-outbox-folder.c"
	}
	_state_0:
#line 548 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_data82_ = g_slice_new0 (Block82Data);
#line 548 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_data82_->_ref_count_ = 1;
#line 548 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_data82_->self = g_object_ref (_data_->self);
#line 548 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_data_->_data82_->outbox_id);
#line 548 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_data82_->outbox_id = _data_->outbox_id;
#line 548 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_data_->_data82_->cancellable);
#line 548 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_data82_->cancellable = _data_->cancellable;
#line 548 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_data82_->_async_data_ = _data_;
#line 550 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp0_ = _data_->self->priv->db;
#line 550 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_state_ = 1;
#line 550 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	geary_db_database_exec_transaction_async (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp0_, GEARY_DB_TYPE_DATABASE, GearyDbDatabase), GEARY_DB_TRANSACTION_TYPE_WR, ___lambda96__geary_db_transaction_method, _data_->_data82_, _data_->_data82_->cancellable, geary_smtp_outbox_folder_mark_email_as_sent_async_ready, _data_);
#line 550 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return FALSE;
#line 8790 "smtp-outbox-folder.c"
	_state_1:
#line 550 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	geary_db_database_exec_transaction_finish (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp0_, GEARY_DB_TYPE_DATABASE, GearyDbDatabase), _data_->_res_, &_data_->_inner_error_);
#line 550 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
#line 550 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error_);
#line 550 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		block82_data_unref (_data_->_data82_);
#line 550 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_data82_ = NULL;
#line 550 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_object_unref (_data_->_async_result);
#line 550 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return FALSE;
#line 8806 "smtp-outbox-folder.c"
	}
#line 556 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp1_ = geary_email_flags_new ();
#line 556 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->flags = _data_->_tmp1_;
#line 557 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp2_ = _data_->flags;
#line 557 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp3_ = geary_email_flags_get_OUTBOX_SENT ();
#line 557 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp4_ = _data_->_tmp3_;
#line 557 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp5_ = _data_->_tmp4_;
#line 557 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	geary_named_flags_add (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp2_, GEARY_TYPE_NAMED_FLAGS, GearyNamedFlags), _data_->_tmp5_);
#line 557 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_data_->_tmp5_);
#line 559 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp6_ = gee_hash_map_new (GEARY_TYPE_EMAIL_IDENTIFIER, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, GEARY_TYPE_EMAIL_FLAGS, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 559 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->changed_map = _data_->_tmp6_;
#line 561 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp7_ = _data_->changed_map;
#line 561 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp8_ = _data_->flags;
#line 561 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	gee_abstract_map_set (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp7_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), G_TYPE_CHECK_INSTANCE_CAST (_data_->_data82_->outbox_id, GEARY_TYPE_EMAIL_IDENTIFIER, GearyEmailIdentifier), _data_->_tmp8_);
#line 562 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp9_ = _data_->changed_map;
#line 562 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	geary_folder_notify_email_flags_changed (G_TYPE_CHECK_INSTANCE_CAST (_data_->self, GEARY_TYPE_FOLDER, GearyFolder), G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp9_, GEE_TYPE_MAP, GeeMap));
#line 548 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_data_->changed_map);
#line 548 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_data_->flags);
#line 548 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	block82_data_unref (_data_->_data82_);
#line 548 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_data82_ = NULL;
#line 548 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 548 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (_data_->_state_ != 0) {
#line 548 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		while (_data_->_task_complete_ != TRUE) {
#line 548 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 8854 "smtp-outbox-folder.c"
		}
	}
#line 548 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_object_unref (_data_->_async_result);
#line 548 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return FALSE;
#line 8861 "smtp-outbox-folder.c"
}


static void
geary_smtp_outbox_folder_real_remove_email_async_data_free (gpointer _data)
{
	GearySmtpOutboxFolderRemoveEmailAsyncData* _data_;
	_data_ = _data;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_data_->email_ids);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_data_->cancellable);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_data_->self);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_slice_free (GearySmtpOutboxFolderRemoveEmailAsyncData, _data_);
#line 8878 "smtp-outbox-folder.c"
}


static void
geary_smtp_outbox_folder_real_remove_email_async_async_ready_wrapper (GObject *source_object,
                                                                      GAsyncResult *res,
                                                                      void *user_data)
{
	GearySmtpOutboxFolderRemoveEmailAsyncData* _task_data_;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_task_data_ = g_task_get_task_data (G_TASK (res));
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (_task_data_->_callback_ != NULL) {
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_task_data_->_callback_ (source_object, res, user_data);
#line 8894 "smtp-outbox-folder.c"
	}
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_task_data_->_task_complete_ = TRUE;
#line 8898 "smtp-outbox-folder.c"
}


static void
geary_smtp_outbox_folder_real_remove_email_async (GearySmtpOutboxFolder* self,
                                                  GeeList* email_ids,
                                                  GCancellable* cancellable,
                                                  GAsyncReadyCallback _callback_,
                                                  gpointer _user_data_)
{
	GearySmtpOutboxFolderRemoveEmailAsyncData* _data_;
	GearySmtpOutboxFolder* _tmp0_;
	GeeList* _tmp1_;
	GCancellable* _tmp2_;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_ = g_slice_new0 (GearySmtpOutboxFolderRemoveEmailAsyncData);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_callback_ = _callback_;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), cancellable, geary_smtp_outbox_folder_real_remove_email_async_async_ready_wrapper, _user_data_);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (_callback_ == NULL) {
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_task_complete_ = TRUE;
#line 8923 "smtp-outbox-folder.c"
	}
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_task_set_task_data (_data_->_async_result, _data_, geary_smtp_outbox_folder_real_remove_email_async_data_free);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->self = _tmp0_;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp1_ = _g_object_ref0 (email_ids);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_data_->email_ids);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->email_ids = _tmp1_;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp2_ = _g_object_ref0 (cancellable);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_data_->cancellable);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->cancellable = _tmp2_;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	geary_smtp_outbox_folder_real_remove_email_async_co (_data_);
#line 8945 "smtp-outbox-folder.c"
}


static void
geary_smtp_outbox_folder_real_remove_email_finish (GearySmtpOutboxFolder* self,
                                                   GAsyncResult* _res_,
                                                   GError** error)
{
	GearySmtpOutboxFolderRemoveEmailAsyncData* _data_;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (NULL == _data_) {
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return;
#line 8961 "smtp-outbox-folder.c"
	}
}


static void
geary_smtp_outbox_folder_remove_email_async_ready (GObject* source_object,
                                                   GAsyncResult* _res_,
                                                   gpointer _user_data_)
{
	GearySmtpOutboxFolderRemoveEmailAsyncData* _data_;
#line 569 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_ = _user_data_;
#line 569 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_source_object_ = source_object;
#line 569 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_res_ = _res_;
#line 569 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_task_complete_ = TRUE;
#line 569 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	geary_smtp_outbox_folder_real_remove_email_async_co (_data_);
#line 8982 "smtp-outbox-folder.c"
}


static gboolean
geary_smtp_outbox_folder_real_remove_email_async_co (GearySmtpOutboxFolderRemoveEmailAsyncData* _data_)
{
#line 565 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	switch (_data_->_state_) {
#line 565 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		case 0:
#line 8993 "smtp-outbox-folder.c"
		goto _state_0;
#line 565 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		case 1:
#line 8997 "smtp-outbox-folder.c"
		goto _state_1;
		default:
#line 565 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_assert_not_reached ();
#line 9002 "smtp-outbox-folder.c"
	}
	_state_0:
#line 567 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	geary_abstract_local_folder_check_open (G_TYPE_CHECK_INSTANCE_CAST (_data_->self, GEARY_TYPE_ABSTRACT_LOCAL_FOLDER, GearyAbstractLocalFolder), &_data_->_inner_error_);
#line 567 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
#line 567 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error_);
#line 567 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_object_unref (_data_->_async_result);
#line 567 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return FALSE;
#line 9015 "smtp-outbox-folder.c"
	}
#line 569 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_state_ = 1;
#line 569 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	geary_smtp_outbox_folder_internal_remove_email_async (_data_->self, _data_->email_ids, _data_->cancellable, geary_smtp_outbox_folder_remove_email_async_ready, _data_);
#line 569 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return FALSE;
#line 9023 "smtp-outbox-folder.c"
	_state_1:
#line 569 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	geary_smtp_outbox_folder_internal_remove_email_finish (_data_->self, _data_->_res_, &_data_->_inner_error_);
#line 569 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
#line 569 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error_);
#line 569 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_object_unref (_data_->_async_result);
#line 569 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return FALSE;
#line 9035 "smtp-outbox-folder.c"
	}
#line 565 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 565 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (_data_->_state_ != 0) {
#line 565 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		while (_data_->_task_complete_ != TRUE) {
#line 565 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 9045 "smtp-outbox-folder.c"
		}
	}
#line 565 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_object_unref (_data_->_async_result);
#line 565 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return FALSE;
#line 9052 "smtp-outbox-folder.c"
}


void
geary_smtp_outbox_folder_remove_email_async (GearySmtpOutboxFolder* self,
                                             GeeList* email_ids,
                                             GCancellable* cancellable,
                                             GAsyncReadyCallback _callback_,
                                             gpointer _user_data_)
{
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	GEARY_SMTP_OUTBOX_FOLDER_GET_CLASS (self)->remove_email_async (self, email_ids, cancellable, _callback_, _user_data_);
#line 9065 "smtp-outbox-folder.c"
}


void
geary_smtp_outbox_folder_remove_email_finish (GearySmtpOutboxFolder* self,
                                              GAsyncResult* _res_,
                                              GError** error)
{
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	GEARY_SMTP_OUTBOX_FOLDER_GET_CLASS (self)->remove_email_finish (self, _res_, error);
#line 9076 "smtp-outbox-folder.c"
}


static void
geary_smtp_outbox_folder_internal_remove_email_async_data_free (gpointer _data)
{
	GearySmtpOutboxFolderInternalRemoveEmailAsyncData* _data_;
	_data_ = _data;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_data_->self);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_slice_free (GearySmtpOutboxFolderInternalRemoveEmailAsyncData, _data_);
#line 9089 "smtp-outbox-folder.c"
}


static void
geary_smtp_outbox_folder_internal_remove_email_async_async_ready_wrapper (GObject *source_object,
                                                                          GAsyncResult *res,
                                                                          void *user_data)
{
	GearySmtpOutboxFolderInternalRemoveEmailAsyncData* _task_data_;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_task_data_ = g_task_get_task_data (G_TASK (res));
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (_task_data_->_callback_ != NULL) {
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_task_data_->_callback_ (source_object, res, user_data);
#line 9105 "smtp-outbox-folder.c"
	}
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_task_data_->_task_complete_ = TRUE;
#line 9109 "smtp-outbox-folder.c"
}


static void
geary_smtp_outbox_folder_internal_remove_email_async (GearySmtpOutboxFolder* self,
                                                      GeeList* email_ids,
                                                      GCancellable* cancellable,
                                                      GAsyncReadyCallback _callback_,
                                                      gpointer _user_data_)
{
	GearySmtpOutboxFolderInternalRemoveEmailAsyncData* _data_;
	GearySmtpOutboxFolder* _tmp0_;
	GeeList* _tmp1_;
	GCancellable* _tmp2_;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_ = g_slice_new0 (GearySmtpOutboxFolderInternalRemoveEmailAsyncData);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_callback_ = _callback_;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), cancellable, geary_smtp_outbox_folder_internal_remove_email_async_async_ready_wrapper, _user_data_);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (_callback_ == NULL) {
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_task_complete_ = TRUE;
#line 9134 "smtp-outbox-folder.c"
	}
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_task_set_task_data (_data_->_async_result, _data_, geary_smtp_outbox_folder_internal_remove_email_async_data_free);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->self = _tmp0_;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp1_ = _g_object_ref0 (email_ids);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_data_->email_ids);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->email_ids = _tmp1_;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp2_ = _g_object_ref0 (cancellable);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_data_->cancellable);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->cancellable = _tmp2_;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	geary_smtp_outbox_folder_internal_remove_email_async_co (_data_);
#line 9156 "smtp-outbox-folder.c"
}


static gboolean
geary_smtp_outbox_folder_internal_remove_email_finish (GearySmtpOutboxFolder* self,
                                                       GAsyncResult* _res_,
                                                       GError** error)
{
	gboolean result;
	GearySmtpOutboxFolderInternalRemoveEmailAsyncData* _data_;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (NULL == _data_) {
#line 9171 "smtp-outbox-folder.c"
		gboolean _tmp0_ = FALSE;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return _tmp0_;
#line 9175 "smtp-outbox-folder.c"
	}
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	result = _data_->result;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return result;
#line 9181 "smtp-outbox-folder.c"
}


static Block83Data*
block83_data_ref (Block83Data* _data83_)
{
#line 573 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_atomic_int_inc (&_data83_->_ref_count_);
#line 573 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return _data83_;
#line 9192 "smtp-outbox-folder.c"
}


static void
block83_data_unref (void * _userdata_)
{
	Block83Data* _data83_;
	_data83_ = (Block83Data*) _userdata_;
#line 573 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (g_atomic_int_dec_and_test (&_data83_->_ref_count_)) {
#line 9203 "smtp-outbox-folder.c"
		GearySmtpOutboxFolder* self;
#line 573 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		self = _data83_->self;
#line 573 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (_data83_->removed);
#line 573 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (_data83_->email_ids);
#line 573 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (_data83_->cancellable);
#line 573 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (self);
#line 573 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_slice_free (Block83Data, _data83_);
#line 9217 "smtp-outbox-folder.c"
	}
}


static GearyDbTransactionOutcome
__lambda97_ (Block83Data* _data83_,
             GearyDbConnection* cx,
             GError** error)
{
	GearySmtpOutboxFolder* self;
	GearyDbTransactionOutcome result = 0;
	gint _tmp16_ = 0;
	GError * _inner_error_ = NULL;
#line 577 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	self = _data83_->self;
#line 577 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_return_val_if_fail (GEARY_DB_IS_CONNECTION (cx), 0);
#line 9235 "smtp-outbox-folder.c"
	{
		GeeList* _id_list = NULL;
		GeeList* _tmp0_;
		gint _id_size = 0;
		GeeList* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
		gint _id_index = 0;
#line 578 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_tmp0_ = _g_object_ref0 (_data83_->email_ids);
#line 578 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_id_list = _tmp0_;
#line 578 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_tmp1_ = _id_list;
#line 578 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_tmp2_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, GEE_TYPE_COLLECTION, GeeCollection));
#line 578 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_tmp3_ = _tmp2_;
#line 578 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_id_size = _tmp3_;
#line 578 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_id_index = -1;
#line 578 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		while (TRUE) {
#line 9260 "smtp-outbox-folder.c"
			gint _tmp4_;
			gint _tmp5_;
			gint _tmp6_;
			GearyEmailIdentifier* id = NULL;
			GeeList* _tmp7_;
			gint _tmp8_;
			gpointer _tmp9_;
			GearySmtpOutboxEmailIdentifier* outbox_id = NULL;
			GearyEmailIdentifier* _tmp10_;
			GearySmtpOutboxEmailIdentifier* _tmp11_;
			GearySmtpOutboxEmailIdentifier* _tmp12_;
			gboolean _tmp13_ = FALSE;
			GearySmtpOutboxEmailIdentifier* _tmp14_;
#line 578 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp4_ = _id_index;
#line 578 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_id_index = _tmp4_ + 1;
#line 578 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp5_ = _id_index;
#line 578 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp6_ = _id_size;
#line 578 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			if (!(_tmp5_ < _tmp6_)) {
#line 578 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				break;
#line 9286 "smtp-outbox-folder.c"
			}
#line 578 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp7_ = _id_list;
#line 578 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp8_ = _id_index;
#line 578 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp9_ = gee_list_get (_tmp7_, _tmp8_);
#line 578 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			id = (GearyEmailIdentifier*) _tmp9_;
#line 581 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp10_ = id;
#line 581 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp11_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp10_, GEARY_TYPE_SMTP_OUTBOX_EMAIL_IDENTIFIER) ? ((GearySmtpOutboxEmailIdentifier*) _tmp10_) : NULL);
#line 581 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			outbox_id = _tmp11_;
#line 582 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp12_ = outbox_id;
#line 582 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			if (_tmp12_ == NULL) {
#line 583 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_g_object_unref0 (outbox_id);
#line 583 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_g_object_unref0 (id);
#line 583 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				continue;
#line 9312 "smtp-outbox-folder.c"
			}
#line 588 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			geary_smtp_outbox_folder_do_get_next_ordering (self, cx, _data83_->cancellable, &_inner_error_);
#line 588 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 588 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				g_propagate_error (error, _inner_error_);
#line 588 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_g_object_unref0 (outbox_id);
#line 588 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_g_object_unref0 (id);
#line 588 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_g_object_unref0 (_id_list);
#line 588 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				return 0;
#line 9328 "smtp-outbox-folder.c"
			}
#line 590 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp14_ = outbox_id;
#line 590 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp13_ = geary_smtp_outbox_folder_do_remove_email (self, cx, _tmp14_, _data83_->cancellable, &_inner_error_);
#line 590 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 590 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				g_propagate_error (error, _inner_error_);
#line 590 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_g_object_unref0 (outbox_id);
#line 590 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_g_object_unref0 (id);
#line 590 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_g_object_unref0 (_id_list);
#line 590 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				return 0;
#line 9346 "smtp-outbox-folder.c"
			}
#line 590 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			if (_tmp13_) {
#line 9350 "smtp-outbox-folder.c"
				GearySmtpOutboxEmailIdentifier* _tmp15_;
#line 591 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_tmp15_ = outbox_id;
#line 591 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				gee_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_data83_->removed, GEE_TYPE_COLLECTION, GeeCollection), G_TYPE_CHECK_INSTANCE_CAST (_tmp15_, GEARY_TYPE_EMAIL_IDENTIFIER, GearyEmailIdentifier));
#line 9356 "smtp-outbox-folder.c"
			}
#line 578 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_g_object_unref0 (outbox_id);
#line 578 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_g_object_unref0 (id);
#line 9362 "smtp-outbox-folder.c"
		}
#line 578 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (_id_list);
#line 9366 "smtp-outbox-folder.c"
	}
#line 594 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp16_ = geary_smtp_outbox_folder_do_get_email_count (self, cx, _data83_->cancellable, &_inner_error_);
#line 594 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 594 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_propagate_error (error, _inner_error_);
#line 594 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return 0;
#line 9376 "smtp-outbox-folder.c"
	}
#line 594 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data83_->final_count = _tmp16_;
#line 596 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	result = GEARY_DB_TRANSACTION_OUTCOME_COMMIT;
#line 596 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return result;
#line 9384 "smtp-outbox-folder.c"
}


static GearyDbTransactionOutcome
___lambda97__geary_db_transaction_method (GearyDbConnection* cx,
                                          GCancellable* cancellable,
                                          gpointer self,
                                          GError** error)
{
	GearyDbTransactionOutcome result;
	result = __lambda97_ (self, cx, error);
#line 577 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return result;
#line 9398 "smtp-outbox-folder.c"
}


static void
geary_smtp_outbox_folder_internal_remove_email_async_ready (GObject* source_object,
                                                            GAsyncResult* _res_,
                                                            gpointer _user_data_)
{
	GearySmtpOutboxFolderInternalRemoveEmailAsyncData* _data_;
#line 577 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_ = _user_data_;
#line 577 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_source_object_ = source_object;
#line 577 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_res_ = _res_;
#line 577 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_task_complete_ = TRUE;
#line 577 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	geary_smtp_outbox_folder_internal_remove_email_async_co (_data_);
#line 9418 "smtp-outbox-folder.c"
}


static gboolean
geary_smtp_outbox_folder_internal_remove_email_async_co (GearySmtpOutboxFolderInternalRemoveEmailAsyncData* _data_)
{
#line 573 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	switch (_data_->_state_) {
#line 573 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		case 0:
#line 9429 "smtp-outbox-folder.c"
		goto _state_0;
#line 573 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		case 1:
#line 9433 "smtp-outbox-folder.c"
		goto _state_1;
		default:
#line 573 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_assert_not_reached ();
#line 9438 "smtp-outbox-folder.c"
	}
	_state_0:
#line 573 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_data83_ = g_slice_new0 (Block83Data);
#line 573 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_data83_->_ref_count_ = 1;
#line 573 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_data83_->self = g_object_ref (_data_->self);
#line 573 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_data_->_data83_->email_ids);
#line 573 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_data83_->email_ids = _data_->email_ids;
#line 573 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_data_->_data83_->cancellable);
#line 573 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_data83_->cancellable = _data_->cancellable;
#line 573 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_data83_->_async_data_ = _data_;
#line 575 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp0_ = gee_array_list_new (GEARY_TYPE_EMAIL_IDENTIFIER, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 575 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_data83_->removed = G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp0_, GEE_TYPE_LIST, GeeList);
#line 576 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_data83_->final_count = 0;
#line 577 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp1_ = _data_->self->priv->db;
#line 577 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_state_ = 1;
#line 577 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	geary_db_database_exec_transaction_async (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp1_, GEARY_DB_TYPE_DATABASE, GearyDbDatabase), GEARY_DB_TRANSACTION_TYPE_WR, ___lambda97__geary_db_transaction_method, _data_->_data83_, _data_->_data83_->cancellable, geary_smtp_outbox_folder_internal_remove_email_async_ready, _data_);
#line 577 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return FALSE;
#line 9471 "smtp-outbox-folder.c"
	_state_1:
#line 577 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	geary_db_database_exec_transaction_finish (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp1_, GEARY_DB_TYPE_DATABASE, GearyDbDatabase), _data_->_res_, &_data_->_inner_error_);
#line 577 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
#line 577 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error_);
#line 577 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		block83_data_unref (_data_->_data83_);
#line 577 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_data83_ = NULL;
#line 577 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_object_unref (_data_->_async_result);
#line 577 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return FALSE;
#line 9487 "smtp-outbox-folder.c"
	}
#line 599 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp2_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_data_->_data83_->removed, GEE_TYPE_COLLECTION, GeeCollection));
#line 599 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp3_ = _data_->_tmp2_;
#line 599 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (_data_->_tmp3_ == 0) {
#line 600 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->result = FALSE;
#line 600 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		block83_data_unref (_data_->_data83_);
#line 600 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_data83_ = NULL;
#line 600 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 600 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		if (_data_->_state_ != 0) {
#line 600 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			while (_data_->_task_complete_ != TRUE) {
#line 600 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 9509 "smtp-outbox-folder.c"
			}
		}
#line 600 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_object_unref (_data_->_async_result);
#line 600 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return FALSE;
#line 9516 "smtp-outbox-folder.c"
	}
#line 602 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp4_ = _data_->self->priv->_properties;
#line 602 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	geary_smtp_outbox_folder_properties_set_total (_data_->_tmp4_, _data_->_data83_->final_count);
#line 604 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	geary_folder_notify_email_removed (G_TYPE_CHECK_INSTANCE_CAST (_data_->self, GEARY_TYPE_FOLDER, GearyFolder), G_TYPE_CHECK_INSTANCE_CAST (_data_->_data83_->removed, GEE_TYPE_COLLECTION, GeeCollection));
#line 605 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	geary_folder_notify_email_count_changed (G_TYPE_CHECK_INSTANCE_CAST (_data_->self, GEARY_TYPE_FOLDER, GearyFolder), _data_->_data83_->final_count, GEARY_FOLDER_COUNT_CHANGE_REASON_REMOVED);
#line 607 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->result = TRUE;
#line 607 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	block83_data_unref (_data_->_data83_);
#line 607 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_data83_ = NULL;
#line 607 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 607 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (_data_->_state_ != 0) {
#line 607 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		while (_data_->_task_complete_ != TRUE) {
#line 607 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 9540 "smtp-outbox-folder.c"
		}
	}
#line 607 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_object_unref (_data_->_async_result);
#line 607 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return FALSE;
#line 9547 "smtp-outbox-folder.c"
}


static void
geary_smtp_outbox_folder_real_remove_single_email_async_data_free (gpointer _data)
{
	GearySmtpOutboxFolderRemoveSingleEmailAsyncData* _data_;
	_data_ = _data;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_data_->id);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_data_->cancellable);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_data_->self);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_slice_free (GearySmtpOutboxFolderRemoveSingleEmailAsyncData, _data_);
#line 9564 "smtp-outbox-folder.c"
}


static void
geary_smtp_outbox_folder_real_remove_single_email_async_async_ready_wrapper (GObject *source_object,
                                                                             GAsyncResult *res,
                                                                             void *user_data)
{
	GearySmtpOutboxFolderRemoveSingleEmailAsyncData* _task_data_;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_task_data_ = g_task_get_task_data (G_TASK (res));
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (_task_data_->_callback_ != NULL) {
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_task_data_->_callback_ (source_object, res, user_data);
#line 9580 "smtp-outbox-folder.c"
	}
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_task_data_->_task_complete_ = TRUE;
#line 9584 "smtp-outbox-folder.c"
}


static void
geary_smtp_outbox_folder_real_remove_single_email_async (GearySmtpOutboxFolder* self,
                                                         GearyEmailIdentifier* id,
                                                         GCancellable* cancellable,
                                                         GAsyncReadyCallback _callback_,
                                                         gpointer _user_data_)
{
	GearySmtpOutboxFolderRemoveSingleEmailAsyncData* _data_;
	GearySmtpOutboxFolder* _tmp0_;
	GearyEmailIdentifier* _tmp1_;
	GCancellable* _tmp2_;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_ = g_slice_new0 (GearySmtpOutboxFolderRemoveSingleEmailAsyncData);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_callback_ = _callback_;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), cancellable, geary_smtp_outbox_folder_real_remove_single_email_async_async_ready_wrapper, _user_data_);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (_callback_ == NULL) {
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_task_complete_ = TRUE;
#line 9609 "smtp-outbox-folder.c"
	}
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_task_set_task_data (_data_->_async_result, _data_, geary_smtp_outbox_folder_real_remove_single_email_async_data_free);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->self = _tmp0_;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp1_ = _g_object_ref0 (id);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_data_->id);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->id = _tmp1_;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp2_ = _g_object_ref0 (cancellable);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_data_->cancellable);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->cancellable = _tmp2_;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	geary_smtp_outbox_folder_real_remove_single_email_async_co (_data_);
#line 9631 "smtp-outbox-folder.c"
}


static void
geary_smtp_outbox_folder_real_remove_single_email_finish (GearySmtpOutboxFolder* self,
                                                          GAsyncResult* _res_,
                                                          GError** error)
{
	GearySmtpOutboxFolderRemoveSingleEmailAsyncData* _data_;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (NULL == _data_) {
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return;
#line 9647 "smtp-outbox-folder.c"
	}
}


static void
geary_smtp_outbox_folder_remove_single_email_async_ready (GObject* source_object,
                                                          GAsyncResult* _res_,
                                                          gpointer _user_data_)
{
	GearySmtpOutboxFolderRemoveSingleEmailAsyncData* _data_;
#line 615 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_ = _user_data_;
#line 615 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_source_object_ = source_object;
#line 615 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_res_ = _res_;
#line 615 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_task_complete_ = TRUE;
#line 615 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	geary_smtp_outbox_folder_real_remove_single_email_async_co (_data_);
#line 9668 "smtp-outbox-folder.c"
}


static gboolean
geary_smtp_outbox_folder_real_remove_single_email_async_co (GearySmtpOutboxFolderRemoveSingleEmailAsyncData* _data_)
{
#line 610 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	switch (_data_->_state_) {
#line 610 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		case 0:
#line 9679 "smtp-outbox-folder.c"
		goto _state_0;
#line 610 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		case 1:
#line 9683 "smtp-outbox-folder.c"
		goto _state_1;
		default:
#line 610 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_assert_not_reached ();
#line 9688 "smtp-outbox-folder.c"
	}
	_state_0:
#line 612 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp0_ = gee_array_list_new (GEARY_TYPE_EMAIL_IDENTIFIER, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 612 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->list = G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp0_, GEE_TYPE_LIST, GeeList);
#line 613 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	gee_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_data_->list, GEE_TYPE_COLLECTION, GeeCollection), _data_->id);
#line 615 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_state_ = 1;
#line 615 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	geary_smtp_outbox_folder_remove_email_async (_data_->self, _data_->list, _data_->cancellable, geary_smtp_outbox_folder_remove_single_email_async_ready, _data_);
#line 615 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return FALSE;
#line 9703 "smtp-outbox-folder.c"
	_state_1:
#line 615 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	geary_smtp_outbox_folder_remove_email_finish (_data_->self, _data_->_res_, &_data_->_inner_error_);
#line 615 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
#line 615 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error_);
#line 615 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (_data_->list);
#line 615 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_object_unref (_data_->_async_result);
#line 615 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return FALSE;
#line 9717 "smtp-outbox-folder.c"
	}
#line 610 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_data_->list);
#line 610 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 610 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (_data_->_state_ != 0) {
#line 610 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		while (_data_->_task_complete_ != TRUE) {
#line 610 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 9729 "smtp-outbox-folder.c"
		}
	}
#line 610 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_object_unref (_data_->_async_result);
#line 610 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return FALSE;
#line 9736 "smtp-outbox-folder.c"
}


void
geary_smtp_outbox_folder_remove_single_email_async (GearySmtpOutboxFolder* self,
                                                    GearyEmailIdentifier* id,
                                                    GCancellable* cancellable,
                                                    GAsyncReadyCallback _callback_,
                                                    gpointer _user_data_)
{
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	GEARY_SMTP_OUTBOX_FOLDER_GET_CLASS (self)->remove_single_email_async (self, id, cancellable, _callback_, _user_data_);
#line 9749 "smtp-outbox-folder.c"
}


void
geary_smtp_outbox_folder_remove_single_email_finish (GearySmtpOutboxFolder* self,
                                                     GAsyncResult* _res_,
                                                     GError** error)
{
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	GEARY_SMTP_OUTBOX_FOLDER_GET_CLASS (self)->remove_single_email_finish (self, _res_, error);
#line 9760 "smtp-outbox-folder.c"
}


static GearyEmail*
geary_smtp_outbox_folder_row_to_email (GearySmtpOutboxFolder* self,
                                       GearySmtpOutboxFolderOutboxRow* row,
                                       GError** error)
{
	GearyEmail* result = NULL;
	GearyRFC822Message* message = NULL;
	GearyMemoryBuffer* _tmp0_;
	GearyRFC822Message* _tmp1_;
	GearyEmail* email = NULL;
	GearyRFC822Message* _tmp2_;
	GearySmtpOutboxEmailIdentifier* _tmp3_;
	GearyEmail* _tmp4_;
	GearyEmail* _tmp5_;
	GDateTime* _tmp6_;
	GDateTime* _tmp7_;
	GearySmtpOutboxEmailProperties* _tmp8_;
	GearySmtpOutboxEmailProperties* _tmp9_;
	GearyEmailFlags* flags = NULL;
	GearyEmailFlags* _tmp10_;
	gboolean _tmp11_;
	GearyEmail* _tmp16_;
	GearyEmailFlags* _tmp17_;
	GError * _inner_error_ = NULL;
#line 619 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_return_val_if_fail (GEARY_IS_SMTP_OUTBOX_FOLDER (self), NULL);
#line 619 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_return_val_if_fail (GEARY_SMTP_OUTBOX_FOLDER_IS_OUTBOX_ROW (row), NULL);
#line 620 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp0_ = row->message;
#line 620 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp1_ = geary_rf_c822_message_new_from_buffer (_tmp0_, &_inner_error_);
#line 620 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	message = _tmp1_;
#line 620 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 620 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_propagate_error (error, _inner_error_);
#line 620 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return NULL;
#line 9804 "smtp-outbox-folder.c"
	}
#line 622 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp2_ = message;
#line 622 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp3_ = row->outbox_id;
#line 622 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp4_ = geary_rf_c822_message_get_email (_tmp2_, G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, GEARY_TYPE_EMAIL_IDENTIFIER, GearyEmailIdentifier), &_inner_error_);
#line 622 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	email = _tmp4_;
#line 622 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 622 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_propagate_error (error, _inner_error_);
#line 622 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (message);
#line 622 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return NULL;
#line 9822 "smtp-outbox-folder.c"
	}
#line 624 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp5_ = email;
#line 624 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp6_ = g_date_time_new_now_local ();
#line 624 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp7_ = _tmp6_;
#line 624 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp8_ = geary_smtp_outbox_email_properties_new (_tmp7_, (glong) -1);
#line 624 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp9_ = _tmp8_;
#line 624 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	geary_email_set_email_properties (_tmp5_, G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, GEARY_TYPE_EMAIL_PROPERTIES, GearyEmailProperties));
#line 624 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_tmp9_);
#line 624 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_date_time_unref0 (_tmp7_);
#line 625 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp10_ = geary_email_flags_new ();
#line 625 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	flags = _tmp10_;
#line 626 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp11_ = row->sent;
#line 626 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (_tmp11_) {
#line 9848 "smtp-outbox-folder.c"
		GearyEmailFlags* _tmp12_;
		GearyNamedFlag* _tmp13_;
		GearyNamedFlag* _tmp14_;
		GearyNamedFlag* _tmp15_;
#line 627 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_tmp12_ = flags;
#line 627 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_tmp13_ = geary_email_flags_get_OUTBOX_SENT ();
#line 627 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_tmp14_ = _tmp13_;
#line 627 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_tmp15_ = _tmp14_;
#line 627 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		geary_named_flags_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp12_, GEARY_TYPE_NAMED_FLAGS, GearyNamedFlags), _tmp15_);
#line 627 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (_tmp15_);
#line 9865 "smtp-outbox-folder.c"
	}
#line 628 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp16_ = email;
#line 628 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp17_ = flags;
#line 628 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	geary_email_set_flags (_tmp16_, _tmp17_);
#line 630 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	result = email;
#line 630 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (flags);
#line 630 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (message);
#line 630 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return result;
#line 9881 "smtp-outbox-folder.c"
}


static void
geary_smtp_outbox_folder_send_email_async_data_free (gpointer _data)
{
	GearySmtpOutboxFolderSendEmailAsyncData* _data_;
	_data_ = _data;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_data_->rfc822);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_data_->cancellable);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_data_->self);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_slice_free (GearySmtpOutboxFolderSendEmailAsyncData, _data_);
#line 9898 "smtp-outbox-folder.c"
}


static void
geary_smtp_outbox_folder_send_email_async_async_ready_wrapper (GObject *source_object,
                                                               GAsyncResult *res,
                                                               void *user_data)
{
	GearySmtpOutboxFolderSendEmailAsyncData* _task_data_;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_task_data_ = g_task_get_task_data (G_TASK (res));
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (_task_data_->_callback_ != NULL) {
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_task_data_->_callback_ (source_object, res, user_data);
#line 9914 "smtp-outbox-folder.c"
	}
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_task_data_->_task_complete_ = TRUE;
#line 9918 "smtp-outbox-folder.c"
}


static void
geary_smtp_outbox_folder_send_email_async (GearySmtpOutboxFolder* self,
                                           GearyRFC822Message* rfc822,
                                           GCancellable* cancellable,
                                           GAsyncReadyCallback _callback_,
                                           gpointer _user_data_)
{
	GearySmtpOutboxFolderSendEmailAsyncData* _data_;
	GearySmtpOutboxFolder* _tmp0_;
	GearyRFC822Message* _tmp1_;
	GCancellable* _tmp2_;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_ = g_slice_new0 (GearySmtpOutboxFolderSendEmailAsyncData);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_callback_ = _callback_;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), cancellable, geary_smtp_outbox_folder_send_email_async_async_ready_wrapper, _user_data_);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (_callback_ == NULL) {
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_task_complete_ = TRUE;
#line 9943 "smtp-outbox-folder.c"
	}
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_task_set_task_data (_data_->_async_result, _data_, geary_smtp_outbox_folder_send_email_async_data_free);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->self = _tmp0_;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp1_ = _g_object_ref0 (rfc822);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_data_->rfc822);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->rfc822 = _tmp1_;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp2_ = _g_object_ref0 (cancellable);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_data_->cancellable);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->cancellable = _tmp2_;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	geary_smtp_outbox_folder_send_email_async_co (_data_);
#line 9965 "smtp-outbox-folder.c"
}


static void
geary_smtp_outbox_folder_send_email_finish (GearySmtpOutboxFolder* self,
                                            GAsyncResult* _res_,
                                            GError** error)
{
	GearySmtpOutboxFolderSendEmailAsyncData* _data_;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (NULL == _data_) {
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return;
#line 9981 "smtp-outbox-folder.c"
	}
}


static void
geary_smtp_outbox_folder_send_email_async_ready (GObject* source_object,
                                                 GAsyncResult* _res_,
                                                 gpointer _user_data_)
{
	GearySmtpOutboxFolderSendEmailAsyncData* _data_;
#line 639 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_ = _user_data_;
#line 639 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_source_object_ = source_object;
#line 639 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_res_ = _res_;
#line 639 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_task_complete_ = TRUE;
#line 639 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	geary_smtp_outbox_folder_send_email_async_co (_data_);
#line 10002 "smtp-outbox-folder.c"
}


static gpointer
_g_error_copy0 (gpointer self)
{
#line 642 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return self ? g_error_copy (self) : NULL;
#line 10011 "smtp-outbox-folder.c"
}


static gboolean
geary_smtp_outbox_folder_send_email_async_co (GearySmtpOutboxFolderSendEmailAsyncData* _data_)
{
#line 633 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	switch (_data_->_state_) {
#line 633 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		case 0:
#line 10022 "smtp-outbox-folder.c"
		goto _state_0;
#line 633 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		case 1:
#line 10026 "smtp-outbox-folder.c"
		goto _state_1;
#line 633 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		case 2:
#line 10030 "smtp-outbox-folder.c"
		goto _state_2;
#line 633 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		case 3:
#line 10034 "smtp-outbox-folder.c"
		goto _state_3;
		default:
#line 633 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_assert_not_reached ();
#line 10039 "smtp-outbox-folder.c"
	}
	_state_0:
#line 635 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp0_ = _data_->self->priv->sending_monitor;
#line 635 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	geary_progress_monitor_notify_start (_data_->_tmp0_);
#line 637 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->smtp_err = NULL;
#line 10048 "smtp-outbox-folder.c"
	{
#line 639 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_tmp1_ = _data_->self->priv->smtp;
#line 639 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_tmp2_ = _data_->self->priv->_account;
#line 639 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_tmp3_ = geary_account_get_information (_data_->_tmp2_);
#line 639 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_tmp4_ = _data_->_tmp3_;
#line 639 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_tmp5_ = geary_account_information_get_smtp_credentials (_data_->_tmp4_);
#line 639 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_tmp6_ = _data_->_tmp5_;
#line 639 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_state_ = 1;
#line 639 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		geary_smtp_client_session_login_async (_data_->_tmp1_, _data_->_tmp6_, _data_->cancellable, geary_smtp_outbox_folder_send_email_async_ready, _data_);
#line 639 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return FALSE;
#line 10068 "smtp-outbox-folder.c"
		_state_1:
#line 639 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_tmp7_ = geary_smtp_client_session_login_finish (_data_->_tmp1_, _data_->_res_, &_data_->_inner_error_);
#line 639 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_tmp8_ = _data_->_tmp7_;
#line 639 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_geary_smtp_response_unref0 (_data_->_tmp8_);
#line 639 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
#line 10078 "smtp-outbox-folder.c"
			goto __catch205_g_error;
		}
	}
	goto __finally205;
	__catch205_g_error:
	{
#line 638 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->login_err = _data_->_inner_error_;
#line 638 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_inner_error_ = NULL;
#line 641 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_tmp9_ = _data_->login_err;
#line 641 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_tmp10_ = _data_->_tmp9_->message;
#line 641 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_debug ("smtp-outbox-folder.vala:641: SMTP login error: %s", _data_->_tmp10_);
#line 642 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_tmp11_ = _data_->login_err;
#line 642 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_tmp12_ = _g_error_copy0 (_data_->_tmp11_);
#line 642 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_error_free0 (_data_->smtp_err);
#line 642 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->smtp_err = _data_->_tmp12_;
#line 638 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_error_free0 (_data_->login_err);
#line 10105 "smtp-outbox-folder.c"
	}
	__finally205:
#line 638 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
#line 638 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error_);
#line 638 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_error_free0 (_data_->smtp_err);
#line 638 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_object_unref (_data_->_async_result);
#line 638 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return FALSE;
#line 10118 "smtp-outbox-folder.c"
	}
#line 645 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp13_ = _data_->smtp_err;
#line 645 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (_data_->_tmp13_ == NULL) {
#line 10124 "smtp-outbox-folder.c"
		{
#line 647 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_data_->_tmp14_ = _data_->self->priv->smtp;
#line 647 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_data_->_tmp15_ = _data_->self->priv->_account;
#line 647 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_data_->_tmp16_ = geary_account_get_information (_data_->_tmp15_);
#line 647 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_data_->_tmp17_ = _data_->_tmp16_;
#line 647 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_data_->_tmp18_ = geary_account_information_get_primary_mailbox (_data_->_tmp17_);
#line 647 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_data_->_tmp19_ = _data_->_tmp18_;
#line 647 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_data_->_state_ = 2;
#line 647 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			geary_smtp_client_session_send_email_async (_data_->_tmp14_, _data_->_tmp19_, _data_->rfc822, _data_->cancellable, geary_smtp_outbox_folder_send_email_async_ready, _data_);
#line 647 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			return FALSE;
#line 10144 "smtp-outbox-folder.c"
			_state_2:
#line 647 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			geary_smtp_client_session_send_email_finish (_data_->_tmp14_, _data_->_res_, &_data_->_inner_error_);
#line 647 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
#line 10150 "smtp-outbox-folder.c"
				goto __catch206_g_error;
			}
		}
		goto __finally206;
		__catch206_g_error:
		{
#line 646 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_data_->send_err = _data_->_inner_error_;
#line 646 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_data_->_inner_error_ = NULL;
#line 650 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_data_->_tmp20_ = _data_->send_err;
#line 650 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_data_->_tmp21_ = _data_->_tmp20_->message;
#line 650 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			g_debug ("smtp-outbox-folder.vala:650: SMTP send mail error: %s", _data_->_tmp21_);
#line 651 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_data_->_tmp22_ = _data_->send_err;
#line 651 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_data_->_tmp23_ = _g_error_copy0 (_data_->_tmp22_);
#line 651 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_g_error_free0 (_data_->smtp_err);
#line 651 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_data_->smtp_err = _data_->_tmp23_;
#line 646 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_g_error_free0 (_data_->send_err);
#line 10177 "smtp-outbox-folder.c"
		}
		__finally206:
#line 646 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
#line 646 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			g_task_return_error (_data_->_async_result, _data_->_inner_error_);
#line 646 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_g_error_free0 (_data_->smtp_err);
#line 646 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			g_object_unref (_data_->_async_result);
#line 646 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			return FALSE;
#line 10190 "smtp-outbox-folder.c"
		}
	}
	{
#line 657 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_tmp24_ = _data_->self->priv->smtp;
#line 657 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_state_ = 3;
#line 657 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		geary_smtp_client_session_logout_async (_data_->_tmp24_, FALSE, _data_->cancellable, geary_smtp_outbox_folder_send_email_async_ready, _data_);
#line 657 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return FALSE;
#line 10202 "smtp-outbox-folder.c"
		_state_3:
#line 657 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_tmp25_ = geary_smtp_client_session_logout_finish (_data_->_tmp24_, _data_->_res_, &_data_->_inner_error_);
#line 657 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_tmp26_ = _data_->_tmp25_;
#line 657 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_geary_smtp_response_unref0 (_data_->_tmp26_);
#line 657 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
#line 10212 "smtp-outbox-folder.c"
			goto __catch207_g_error;
		}
	}
	goto __finally207;
	__catch207_g_error:
	{
#line 656 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->err = _data_->_inner_error_;
#line 656 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_inner_error_ = NULL;
#line 659 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_tmp27_ = _data_->self->priv->smtp;
#line 659 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_tmp28_ = geary_smtp_client_session_to_string (_data_->_tmp27_);
#line 659 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_tmp29_ = _data_->_tmp28_;
#line 659 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_tmp30_ = _data_->err;
#line 659 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_tmp31_ = _data_->_tmp30_->message;
#line 659 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_debug ("smtp-outbox-folder.vala:659: Unable to disconnect from SMTP server %s:" \
" %s", _data_->_tmp29_, _data_->_tmp31_);
#line 659 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_free0 (_data_->_tmp29_);
#line 656 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_error_free0 (_data_->err);
#line 10239 "smtp-outbox-folder.c"
	}
	__finally207:
#line 656 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
#line 656 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error_);
#line 656 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_error_free0 (_data_->smtp_err);
#line 656 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_object_unref (_data_->_async_result);
#line 656 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return FALSE;
#line 10252 "smtp-outbox-folder.c"
	}
#line 662 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp32_ = _data_->self->priv->sending_monitor;
#line 662 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	geary_progress_monitor_notify_finish (_data_->_tmp32_);
#line 664 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp33_ = _data_->smtp_err;
#line 664 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (_data_->_tmp33_ != NULL) {
#line 665 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_tmp34_ = _data_->smtp_err;
#line 665 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_tmp35_ = _g_error_copy0 (_data_->_tmp34_);
#line 665 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_inner_error_ = _data_->_tmp35_;
#line 665 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error_);
#line 665 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_error_free0 (_data_->smtp_err);
#line 665 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_object_unref (_data_->_async_result);
#line 665 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return FALSE;
#line 10276 "smtp-outbox-folder.c"
	}
#line 667 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_signal_emit (_data_->self, geary_smtp_outbox_folder_signals[GEARY_SMTP_OUTBOX_FOLDER_EMAIL_SENT_SIGNAL], 0, _data_->rfc822);
#line 633 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_error_free0 (_data_->smtp_err);
#line 633 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 633 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (_data_->_state_ != 0) {
#line 633 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		while (_data_->_task_complete_ != TRUE) {
#line 633 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 10290 "smtp-outbox-folder.c"
		}
	}
#line 633 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_object_unref (_data_->_async_result);
#line 633 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return FALSE;
#line 10297 "smtp-outbox-folder.c"
}


static void
geary_smtp_outbox_folder_save_sent_mail_async_data_free (gpointer _data)
{
	GearySmtpOutboxFolderSaveSentMailAsyncData* _data_;
	_data_ = _data;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_data_->rfc822);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_data_->cancellable);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_data_->self);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_slice_free (GearySmtpOutboxFolderSaveSentMailAsyncData, _data_);
#line 10314 "smtp-outbox-folder.c"
}


static void
geary_smtp_outbox_folder_save_sent_mail_async_async_ready_wrapper (GObject *source_object,
                                                                   GAsyncResult *res,
                                                                   void *user_data)
{
	GearySmtpOutboxFolderSaveSentMailAsyncData* _task_data_;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_task_data_ = g_task_get_task_data (G_TASK (res));
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (_task_data_->_callback_ != NULL) {
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_task_data_->_callback_ (source_object, res, user_data);
#line 10330 "smtp-outbox-folder.c"
	}
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_task_data_->_task_complete_ = TRUE;
#line 10334 "smtp-outbox-folder.c"
}


static void
geary_smtp_outbox_folder_save_sent_mail_async (GearySmtpOutboxFolder* self,
                                               GearyRFC822Message* rfc822,
                                               GCancellable* cancellable,
                                               GAsyncReadyCallback _callback_,
                                               gpointer _user_data_)
{
	GearySmtpOutboxFolderSaveSentMailAsyncData* _data_;
	GearySmtpOutboxFolder* _tmp0_;
	GearyRFC822Message* _tmp1_;
	GCancellable* _tmp2_;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_ = g_slice_new0 (GearySmtpOutboxFolderSaveSentMailAsyncData);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_callback_ = _callback_;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), cancellable, geary_smtp_outbox_folder_save_sent_mail_async_async_ready_wrapper, _user_data_);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (_callback_ == NULL) {
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_task_complete_ = TRUE;
#line 10359 "smtp-outbox-folder.c"
	}
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_task_set_task_data (_data_->_async_result, _data_, geary_smtp_outbox_folder_save_sent_mail_async_data_free);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->self = _tmp0_;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp1_ = _g_object_ref0 (rfc822);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_data_->rfc822);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->rfc822 = _tmp1_;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp2_ = _g_object_ref0 (cancellable);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_data_->cancellable);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->cancellable = _tmp2_;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	geary_smtp_outbox_folder_save_sent_mail_async_co (_data_);
#line 10381 "smtp-outbox-folder.c"
}


static void
geary_smtp_outbox_folder_save_sent_mail_finish (GearySmtpOutboxFolder* self,
                                                GAsyncResult* _res_,
                                                GError** error)
{
	GearySmtpOutboxFolderSaveSentMailAsyncData* _data_;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (NULL == _data_) {
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return;
#line 10397 "smtp-outbox-folder.c"
	}
}


static void
geary_smtp_outbox_folder_save_sent_mail_async_ready (GObject* source_object,
                                                     GAsyncResult* _res_,
                                                     gpointer _user_data_)
{
	GearySmtpOutboxFolderSaveSentMailAsyncData* _data_;
#line 672 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_ = _user_data_;
#line 672 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_source_object_ = source_object;
#line 672 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_res_ = _res_;
#line 672 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_task_complete_ = TRUE;
#line 672 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	geary_smtp_outbox_folder_save_sent_mail_async_co (_data_);
#line 10418 "smtp-outbox-folder.c"
}


static gboolean
geary_smtp_outbox_folder_save_sent_mail_async_co (GearySmtpOutboxFolderSaveSentMailAsyncData* _data_)
{
#line 670 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	switch (_data_->_state_) {
#line 670 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		case 0:
#line 10429 "smtp-outbox-folder.c"
		goto _state_0;
#line 670 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		case 1:
#line 10433 "smtp-outbox-folder.c"
		goto _state_1;
#line 670 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		case 2:
#line 10437 "smtp-outbox-folder.c"
		goto _state_2;
#line 670 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		case 3:
#line 10441 "smtp-outbox-folder.c"
		goto _state_3;
#line 670 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		case 4:
#line 10445 "smtp-outbox-folder.c"
		goto _state_4;
#line 670 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		case 5:
#line 10449 "smtp-outbox-folder.c"
		goto _state_5;
		default:
#line 670 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_assert_not_reached ();
#line 10454 "smtp-outbox-folder.c"
	}
	_state_0:
#line 672 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp1_ = _data_->self->priv->_account;
#line 672 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_state_ = 1;
#line 672 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	geary_account_get_required_special_folder_async (_data_->_tmp1_, GEARY_SPECIAL_FOLDER_TYPE_SENT, _data_->cancellable, geary_smtp_outbox_folder_save_sent_mail_async_ready, _data_);
#line 672 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return FALSE;
#line 10465 "smtp-outbox-folder.c"
	_state_1:
#line 672 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp2_ = geary_account_get_required_special_folder_finish (_data_->_tmp1_, _data_->_res_, &_data_->_inner_error_);
#line 672 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp0_ = _data_->_tmp2_;
#line 672 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
#line 672 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error_);
#line 672 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_object_unref (_data_->_async_result);
#line 672 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return FALSE;
#line 10479 "smtp-outbox-folder.c"
	}
#line 672 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp3_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_data_->_tmp0_, GEARY_FOLDER_SUPPORT_TYPE_CREATE) ? ((GearyFolderSupportCreate*) _data_->_tmp0_) : NULL);
#line 672 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->create = _data_->_tmp3_;
#line 674 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp4_ = _data_->create;
#line 674 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (_data_->_tmp4_ == NULL) {
#line 675 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_tmp5_ = g_error_new_literal (GEARY_ENGINE_ERROR, GEARY_ENGINE_ERROR_NOT_FOUND, "Save sent mail enabled, but no writable sent mail folder");
#line 675 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_inner_error_ = _data_->_tmp5_;
#line 675 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error_);
#line 675 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (_data_->create);
#line 675 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (_data_->_tmp0_);
#line 675 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_object_unref (_data_->_async_result);
#line 675 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return FALSE;
#line 10503 "smtp-outbox-folder.c"
	}
#line 677 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->open = FALSE;
#line 10507 "smtp-outbox-folder.c"
	{
#line 679 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_tmp6_ = _data_->create;
#line 679 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_state_ = 2;
#line 679 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		geary_folder_open_async (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp6_, GEARY_TYPE_FOLDER, GearyFolder), GEARY_FOLDER_OPEN_FLAGS_FAST_OPEN, _data_->cancellable, geary_smtp_outbox_folder_save_sent_mail_async_ready, _data_);
#line 679 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return FALSE;
#line 10517 "smtp-outbox-folder.c"
		_state_2:
#line 679 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		geary_folder_open_finish (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp6_, GEARY_TYPE_FOLDER, GearyFolder), _data_->_res_, &_data_->_inner_error_);
#line 679 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
#line 10523 "smtp-outbox-folder.c"
			goto __catch208_g_error;
		}
#line 680 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->open = TRUE;
#line 682 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_tmp7_ = _data_->create;
#line 682 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_state_ = 3;
#line 682 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		geary_folder_support_create_create_email_async (_data_->_tmp7_, _data_->rfc822, NULL, NULL, NULL, _data_->cancellable, geary_smtp_outbox_folder_save_sent_mail_async_ready, _data_);
#line 682 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return FALSE;
#line 10536 "smtp-outbox-folder.c"
		_state_3:
#line 682 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_tmp8_ = geary_folder_support_create_create_email_finish (_data_->_tmp7_, _data_->_res_, &_data_->_inner_error_);
#line 682 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_tmp9_ = _data_->_tmp8_;
#line 682 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (_data_->_tmp9_);
#line 682 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
#line 10546 "smtp-outbox-folder.c"
			goto __catch208_g_error;
		}
#line 684 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_tmp10_ = _data_->create;
#line 684 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_state_ = 4;
#line 684 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		geary_folder_close_async (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp10_, GEARY_TYPE_FOLDER, GearyFolder), _data_->cancellable, geary_smtp_outbox_folder_save_sent_mail_async_ready, _data_);
#line 684 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return FALSE;
#line 10557 "smtp-outbox-folder.c"
		_state_4:
#line 684 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		geary_folder_close_finish (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp10_, GEARY_TYPE_FOLDER, GearyFolder), _data_->_res_, &_data_->_inner_error_);
#line 684 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
#line 10563 "smtp-outbox-folder.c"
			goto __catch208_g_error;
		}
#line 685 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->open = FALSE;
#line 10568 "smtp-outbox-folder.c"
	}
	goto __finally208;
	__catch208_g_error:
	{
#line 678 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->e = _data_->_inner_error_;
#line 678 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_inner_error_ = NULL;
#line 687 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_tmp11_ = _data_->open;
#line 687 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		if (_data_->_tmp11_) {
#line 10581 "smtp-outbox-folder.c"
			{
#line 689 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_tmp12_ = _data_->create;
#line 689 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_state_ = 5;
#line 689 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				geary_folder_close_async (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp12_, GEARY_TYPE_FOLDER, GearyFolder), _data_->cancellable, geary_smtp_outbox_folder_save_sent_mail_async_ready, _data_);
#line 689 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				return FALSE;
#line 10591 "smtp-outbox-folder.c"
				_state_5:
#line 689 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				geary_folder_close_finish (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp12_, GEARY_TYPE_FOLDER, GearyFolder), _data_->_res_, &_data_->_inner_error_);
#line 689 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
#line 10597 "smtp-outbox-folder.c"
					goto __catch209_g_error;
				}
#line 690 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->open = FALSE;
#line 10602 "smtp-outbox-folder.c"
			}
			goto __finally209;
			__catch209_g_error:
			{
#line 688 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_vala1_e = _data_->_inner_error_;
#line 688 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_inner_error_ = NULL;
#line 692 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_tmp13_ = _data_->create;
#line 692 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_tmp14_ = geary_folder_to_string (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp13_, GEARY_TYPE_FOLDER, GearyFolder));
#line 692 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_tmp15_ = _data_->_tmp14_;
#line 692 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_tmp16_ = _data_->_vala1_e;
#line 692 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_tmp17_ = _data_->_tmp16_->message;
#line 692 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				g_debug ("smtp-outbox-folder.vala:692: Error closing folder %s: %s", _data_->_tmp15_, _data_->_tmp17_);
#line 692 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_g_free0 (_data_->_tmp15_);
#line 688 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_g_error_free0 (_data_->_vala1_e);
#line 10627 "smtp-outbox-folder.c"
			}
			__finally209:
#line 688 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
#line 688 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_g_error_free0 (_data_->e);
#line 688 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_g_error_free0 (_data_->e);
#line 688 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_g_object_unref0 (_data_->create);
#line 688 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_g_object_unref0 (_data_->_tmp0_);
#line 688 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error_->message, g_quark_to_string (_data_->_inner_error_->domain), _data_->_inner_error_->code);
#line 688 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				g_clear_error (&_data_->_inner_error_);
#line 688 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				g_object_unref (_data_->_async_result);
#line 688 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				return FALSE;
#line 10648 "smtp-outbox-folder.c"
			}
		}
#line 695 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_tmp18_ = _data_->e;
#line 695 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_tmp19_ = _g_error_copy0 (_data_->_tmp18_);
#line 695 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_inner_error_ = _data_->_tmp19_;
#line 695 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_error_free0 (_data_->e);
#line 10659 "smtp-outbox-folder.c"
		goto __finally208;
	}
	__finally208:
#line 678 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
#line 678 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error_);
#line 678 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (_data_->create);
#line 678 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (_data_->_tmp0_);
#line 678 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_object_unref (_data_->_async_result);
#line 678 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return FALSE;
#line 10675 "smtp-outbox-folder.c"
	}
#line 670 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_data_->create);
#line 670 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_data_->_tmp0_);
#line 670 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 670 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (_data_->_state_ != 0) {
#line 670 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		while (_data_->_task_complete_ != TRUE) {
#line 670 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 10689 "smtp-outbox-folder.c"
		}
	}
#line 670 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_object_unref (_data_->_async_result);
#line 670 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return FALSE;
#line 10696 "smtp-outbox-folder.c"
}


static void
geary_smtp_outbox_folder_is_unsent_async_data_free (gpointer _data)
{
	GearySmtpOutboxFolderIsUnsentAsyncData* _data_;
	_data_ = _data;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_data_->self);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_slice_free (GearySmtpOutboxFolderIsUnsentAsyncData, _data_);
#line 10709 "smtp-outbox-folder.c"
}


static void
geary_smtp_outbox_folder_is_unsent_async_async_ready_wrapper (GObject *source_object,
                                                              GAsyncResult *res,
                                                              void *user_data)
{
	GearySmtpOutboxFolderIsUnsentAsyncData* _task_data_;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_task_data_ = g_task_get_task_data (G_TASK (res));
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (_task_data_->_callback_ != NULL) {
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_task_data_->_callback_ (source_object, res, user_data);
#line 10725 "smtp-outbox-folder.c"
	}
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_task_data_->_task_complete_ = TRUE;
#line 10729 "smtp-outbox-folder.c"
}


static void
geary_smtp_outbox_folder_is_unsent_async (GearySmtpOutboxFolder* self,
                                          gint64 ordering,
                                          GCancellable* cancellable,
                                          GAsyncReadyCallback _callback_,
                                          gpointer _user_data_)
{
	GearySmtpOutboxFolderIsUnsentAsyncData* _data_;
	GearySmtpOutboxFolder* _tmp0_;
	GCancellable* _tmp1_;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_ = g_slice_new0 (GearySmtpOutboxFolderIsUnsentAsyncData);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_callback_ = _callback_;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), cancellable, geary_smtp_outbox_folder_is_unsent_async_async_ready_wrapper, _user_data_);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (_callback_ == NULL) {
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_task_complete_ = TRUE;
#line 10753 "smtp-outbox-folder.c"
	}
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_task_set_task_data (_data_->_async_result, _data_, geary_smtp_outbox_folder_is_unsent_async_data_free);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->self = _tmp0_;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->ordering = ordering;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp1_ = _g_object_ref0 (cancellable);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_data_->cancellable);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->cancellable = _tmp1_;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	geary_smtp_outbox_folder_is_unsent_async_co (_data_);
#line 10771 "smtp-outbox-folder.c"
}


static gboolean
geary_smtp_outbox_folder_is_unsent_finish (GearySmtpOutboxFolder* self,
                                           GAsyncResult* _res_,
                                           GError** error)
{
	gboolean result;
	GearySmtpOutboxFolderIsUnsentAsyncData* _data_;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (NULL == _data_) {
#line 10786 "smtp-outbox-folder.c"
		gboolean _tmp0_ = FALSE;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return _tmp0_;
#line 10790 "smtp-outbox-folder.c"
	}
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	result = _data_->result;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return result;
#line 10796 "smtp-outbox-folder.c"
}


static Block84Data*
block84_data_ref (Block84Data* _data84_)
{
#line 699 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_atomic_int_inc (&_data84_->_ref_count_);
#line 699 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return _data84_;
#line 10807 "smtp-outbox-folder.c"
}


static void
block84_data_unref (void * _userdata_)
{
	Block84Data* _data84_;
	_data84_ = (Block84Data*) _userdata_;
#line 699 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (g_atomic_int_dec_and_test (&_data84_->_ref_count_)) {
#line 10818 "smtp-outbox-folder.c"
		GearySmtpOutboxFolder* self;
#line 699 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		self = _data84_->self;
#line 699 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (_data84_->cancellable);
#line 699 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (self);
#line 699 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_slice_free (Block84Data, _data84_);
#line 10828 "smtp-outbox-folder.c"
	}
}


static GearyDbTransactionOutcome
__lambda95_ (Block84Data* _data84_,
             GearyDbConnection* cx,
             GError** error)
{
	GearySmtpOutboxFolder* self;
	GearyDbTransactionOutcome result = 0;
	GearyDbStatement* stmt = NULL;
	GearyDbStatement* _tmp0_;
	GearyDbStatement* _tmp1_;
	GearyDbStatement* _tmp2_;
	GearyDbStatement* _tmp3_;
	GearyDbResult* _tmp4_ = NULL;
	GearyDbStatement* _tmp5_;
	GearyDbResult* _tmp6_;
	gboolean _tmp7_;
	gboolean _tmp8_;
	GError * _inner_error_ = NULL;
#line 701 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	self = _data84_->self;
#line 701 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_return_val_if_fail (GEARY_DB_IS_CONNECTION (cx), 0);
#line 702 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp0_ = geary_db_connection_prepare (cx, "SELECT 1 FROM SmtpOutboxTable WHERE ordering=? AND sent = 0", &_inner_error_);
#line 702 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	stmt = _tmp0_;
#line 702 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 702 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_propagate_error (error, _inner_error_);
#line 702 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return 0;
#line 10865 "smtp-outbox-folder.c"
	}
#line 704 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp1_ = stmt;
#line 704 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp2_ = geary_db_statement_bind_int64 (_tmp1_, 0, _data84_->ordering, &_inner_error_);
#line 704 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp3_ = _tmp2_;
#line 704 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_tmp3_);
#line 704 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 704 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_propagate_error (error, _inner_error_);
#line 704 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (stmt);
#line 704 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return 0;
#line 10883 "smtp-outbox-folder.c"
	}
#line 706 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp5_ = stmt;
#line 706 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp6_ = geary_db_statement_exec (_tmp5_, _data84_->cancellable, &_inner_error_);
#line 706 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp4_ = _tmp6_;
#line 706 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 706 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_propagate_error (error, _inner_error_);
#line 706 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (stmt);
#line 706 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return 0;
#line 10899 "smtp-outbox-folder.c"
	}
#line 706 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp7_ = geary_db_result_get_finished (_tmp4_);
#line 706 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp8_ = _tmp7_;
#line 706 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data84_->exists = !_tmp8_;
#line 708 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	result = GEARY_DB_TRANSACTION_OUTCOME_DONE;
#line 708 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_tmp4_);
#line 708 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (stmt);
#line 708 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return result;
#line 10915 "smtp-outbox-folder.c"
}


static GearyDbTransactionOutcome
___lambda95__geary_db_transaction_method (GearyDbConnection* cx,
                                          GCancellable* cancellable,
                                          gpointer self,
                                          GError** error)
{
	GearyDbTransactionOutcome result;
	result = __lambda95_ (self, cx, error);
#line 701 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return result;
#line 10929 "smtp-outbox-folder.c"
}


static void
geary_smtp_outbox_folder_is_unsent_async_ready (GObject* source_object,
                                                GAsyncResult* _res_,
                                                gpointer _user_data_)
{
	GearySmtpOutboxFolderIsUnsentAsyncData* _data_;
#line 701 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_ = _user_data_;
#line 701 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_source_object_ = source_object;
#line 701 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_res_ = _res_;
#line 701 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_task_complete_ = TRUE;
#line 701 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	geary_smtp_outbox_folder_is_unsent_async_co (_data_);
#line 10949 "smtp-outbox-folder.c"
}


static gboolean
geary_smtp_outbox_folder_is_unsent_async_co (GearySmtpOutboxFolderIsUnsentAsyncData* _data_)
{
#line 699 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	switch (_data_->_state_) {
#line 699 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		case 0:
#line 10960 "smtp-outbox-folder.c"
		goto _state_0;
#line 699 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		case 1:
#line 10964 "smtp-outbox-folder.c"
		goto _state_1;
		default:
#line 699 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_assert_not_reached ();
#line 10969 "smtp-outbox-folder.c"
	}
	_state_0:
#line 699 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_data84_ = g_slice_new0 (Block84Data);
#line 699 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_data84_->_ref_count_ = 1;
#line 699 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_data84_->self = g_object_ref (_data_->self);
#line 699 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_data84_->ordering = _data_->ordering;
#line 699 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_data_->_data84_->cancellable);
#line 699 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_data84_->cancellable = _data_->cancellable;
#line 699 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_data84_->_async_data_ = _data_;
#line 700 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_data84_->exists = FALSE;
#line 701 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp0_ = _data_->self->priv->db;
#line 701 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_state_ = 1;
#line 701 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	geary_db_database_exec_transaction_async (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp0_, GEARY_DB_TYPE_DATABASE, GearyDbDatabase), GEARY_DB_TRANSACTION_TYPE_RO, ___lambda95__geary_db_transaction_method, _data_->_data84_, _data_->_data84_->cancellable, geary_smtp_outbox_folder_is_unsent_async_ready, _data_);
#line 701 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return FALSE;
#line 10996 "smtp-outbox-folder.c"
	_state_1:
#line 701 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	geary_db_database_exec_transaction_finish (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp0_, GEARY_DB_TYPE_DATABASE, GearyDbDatabase), _data_->_res_, &_data_->_inner_error_);
#line 701 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
#line 701 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error_);
#line 701 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		block84_data_unref (_data_->_data84_);
#line 701 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_data84_ = NULL;
#line 701 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_object_unref (_data_->_async_result);
#line 701 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return FALSE;
#line 11012 "smtp-outbox-folder.c"
	}
#line 711 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->result = _data_->_data84_->exists;
#line 711 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	block84_data_unref (_data_->_data84_);
#line 711 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_data84_ = NULL;
#line 711 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 711 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (_data_->_state_ != 0) {
#line 711 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		while (_data_->_task_complete_ != TRUE) {
#line 711 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 11028 "smtp-outbox-folder.c"
		}
	}
#line 711 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_object_unref (_data_->_async_result);
#line 711 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return FALSE;
#line 11035 "smtp-outbox-folder.c"
}


static gint64
geary_smtp_outbox_folder_do_get_next_ordering (GearySmtpOutboxFolder* self,
                                               GearyDbConnection* cx,
                                               GCancellable* cancellable,
                                               GError** error)
{
	gint64 result = 0LL;
	GError * _inner_error_ = NULL;
#line 718 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_return_val_if_fail (GEARY_IS_SMTP_OUTBOX_FOLDER (self), 0LL);
#line 718 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_return_val_if_fail (GEARY_DB_IS_CONNECTION (cx), 0LL);
#line 718 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_return_val_if_fail ((cancellable == NULL) || G_IS_CANCELLABLE (cancellable), 0LL);
#line 11053 "smtp-outbox-folder.c"
	{
		gint64 _tmp0_;
		gint64 _tmp14_ = 0LL;
#line 719 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_tmp0_ = self->priv->next_ordering;
#line 719 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_rec_mutex_lock (&self->priv->__lock_next_ordering);
#line 11061 "smtp-outbox-folder.c"
		{
			gint64 _tmp1_;
			gint64 _tmp11_;
#line 720 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp1_ = self->priv->next_ordering;
#line 720 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			if (_tmp1_ == ((gint64) 0)) {
#line 11069 "smtp-outbox-folder.c"
				GearyDbStatement* stmt = NULL;
				GearyDbStatement* _tmp2_;
				GearyDbResult* _result_ = NULL;
				GearyDbStatement* _tmp3_;
				GearyDbResult* _tmp4_;
				GearyDbResult* _tmp5_;
				gboolean _tmp6_;
				gboolean _tmp7_;
				gint64 _tmp10_;
#line 721 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_tmp2_ = geary_db_connection_prepare (cx, "SELECT COALESCE(MAX(ordering), 0) + 1 FROM SmtpOutboxTable", &_inner_error_);
#line 721 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				stmt = _tmp2_;
#line 721 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 11085 "smtp-outbox-folder.c"
					goto __finally210;
				}
#line 723 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_tmp3_ = stmt;
#line 723 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_tmp4_ = geary_db_statement_exec (_tmp3_, cancellable, &_inner_error_);
#line 723 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_result_ = _tmp4_;
#line 723 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 723 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					_g_object_unref0 (stmt);
#line 11098 "smtp-outbox-folder.c"
					goto __finally210;
				}
#line 724 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_tmp5_ = _result_;
#line 724 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_tmp6_ = geary_db_result_get_finished (_tmp5_);
#line 724 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_tmp7_ = _tmp6_;
#line 724 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				if (!_tmp7_) {
#line 11109 "smtp-outbox-folder.c"
					gint64 _tmp8_ = 0LL;
					GearyDbResult* _tmp9_;
#line 725 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					_tmp9_ = _result_;
#line 725 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					_tmp8_ = geary_db_result_int64_at (_tmp9_, 0, &_inner_error_);
#line 725 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 725 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
						_g_object_unref0 (_result_);
#line 725 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
						_g_object_unref0 (stmt);
#line 11122 "smtp-outbox-folder.c"
						goto __finally210;
					}
#line 725 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					self->priv->next_ordering = _tmp8_;
#line 11127 "smtp-outbox-folder.c"
				}
#line 727 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_tmp10_ = self->priv->next_ordering;
#line 727 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_vala_assert (_tmp10_ > ((gint64) 0), "next_ordering > 0");
#line 720 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_g_object_unref0 (_result_);
#line 720 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_g_object_unref0 (stmt);
#line 11137 "smtp-outbox-folder.c"
			}
#line 730 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp11_ = self->priv->next_ordering;
#line 730 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			self->priv->next_ordering = _tmp11_ + 1;
#line 730 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			result = _tmp11_;
#line 11145 "smtp-outbox-folder.c"
			{
				gint64 _tmp12_;
#line 719 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_tmp12_ = self->priv->next_ordering;
#line 719 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				g_rec_mutex_unlock (&self->priv->__lock_next_ordering);
#line 11152 "smtp-outbox-folder.c"
			}
#line 730 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			return result;
#line 11156 "smtp-outbox-folder.c"
		}
		__finally210:
		{
			gint64 _tmp13_;
#line 719 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp13_ = self->priv->next_ordering;
#line 719 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			g_rec_mutex_unlock (&self->priv->__lock_next_ordering);
#line 11165 "smtp-outbox-folder.c"
		}
#line 719 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_propagate_error (error, _inner_error_);
#line 719 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return _tmp14_;
#line 11171 "smtp-outbox-folder.c"
	}
}


static gint
geary_smtp_outbox_folder_do_get_email_count (GearySmtpOutboxFolder* self,
                                             GearyDbConnection* cx,
                                             GCancellable* cancellable,
                                             GError** error)
{
	gint result = 0;
	GearyDbStatement* stmt = NULL;
	GearyDbStatement* _tmp0_;
	GearyDbResult* results = NULL;
	GearyDbStatement* _tmp2_;
	GearyDbResult* _tmp3_;
	gint _tmp5_ = 0;
	GearyDbResult* _tmp6_;
	gboolean _tmp7_;
	gboolean _tmp8_;
	GError * _inner_error_ = NULL;
#line 734 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_return_val_if_fail (GEARY_IS_SMTP_OUTBOX_FOLDER (self), 0);
#line 734 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_return_val_if_fail (GEARY_DB_IS_CONNECTION (cx), 0);
#line 734 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_return_val_if_fail ((cancellable == NULL) || G_IS_CANCELLABLE (cancellable), 0);
#line 735 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp0_ = geary_db_connection_prepare (cx, "SELECT COUNT(*) FROM SmtpOutboxTable", &_inner_error_);
#line 735 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	stmt = _tmp0_;
#line 735 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 11205 "smtp-outbox-folder.c"
		gint _tmp1_ = 0;
#line 735 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_propagate_error (error, _inner_error_);
#line 735 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return _tmp1_;
#line 11211 "smtp-outbox-folder.c"
	}
#line 737 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp2_ = stmt;
#line 737 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp3_ = geary_db_statement_exec (_tmp2_, cancellable, &_inner_error_);
#line 737 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	results = _tmp3_;
#line 737 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 11221 "smtp-outbox-folder.c"
		gint _tmp4_ = 0;
#line 737 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_propagate_error (error, _inner_error_);
#line 737 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (stmt);
#line 737 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return _tmp4_;
#line 11229 "smtp-outbox-folder.c"
	}
#line 739 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp6_ = results;
#line 739 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp7_ = geary_db_result_get_finished (_tmp6_);
#line 739 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp8_ = _tmp7_;
#line 739 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (!_tmp8_) {
#line 11239 "smtp-outbox-folder.c"
		GearyDbResult* _tmp9_;
#line 739 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_tmp9_ = results;
#line 739 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_tmp5_ = geary_db_result_int_at (_tmp9_, 0, &_inner_error_);
#line 739 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 11247 "smtp-outbox-folder.c"
			gint _tmp10_ = 0;
#line 739 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			g_propagate_error (error, _inner_error_);
#line 739 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_g_object_unref0 (results);
#line 739 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_g_object_unref0 (stmt);
#line 739 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			return _tmp10_;
#line 11257 "smtp-outbox-folder.c"
		}
	} else {
#line 739 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_tmp5_ = 0;
#line 11262 "smtp-outbox-folder.c"
	}
#line 739 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	result = _tmp5_;
#line 739 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (results);
#line 739 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (stmt);
#line 739 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return result;
#line 11272 "smtp-outbox-folder.c"
}


static gint
geary_smtp_outbox_folder_do_get_position_by_ordering (GearySmtpOutboxFolder* self,
                                                      GearyDbConnection* cx,
                                                      gint64 ordering,
                                                      GCancellable* cancellable,
                                                      GError** error)
{
	gint result = 0;
	GearyDbStatement* stmt = NULL;
	GearyDbStatement* _tmp0_;
	GearyDbStatement* _tmp2_;
	GearyDbStatement* _tmp3_;
	GearyDbStatement* _tmp4_;
	GearyDbResult* results = NULL;
	GearyDbStatement* _tmp6_;
	GearyDbResult* _tmp7_;
	GearyDbResult* _tmp9_;
	gboolean _tmp10_;
	gboolean _tmp11_;
	gint64 _tmp12_ = 0LL;
	GearyDbResult* _tmp13_;
	gint _tmp15_ = 0;
	GearyDbResult* _tmp16_;
	GError * _inner_error_ = NULL;
#line 742 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_return_val_if_fail (GEARY_IS_SMTP_OUTBOX_FOLDER (self), 0);
#line 742 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_return_val_if_fail (GEARY_DB_IS_CONNECTION (cx), 0);
#line 742 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_return_val_if_fail ((cancellable == NULL) || G_IS_CANCELLABLE (cancellable), 0);
#line 744 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp0_ = geary_db_connection_prepare (cx, "SELECT COUNT(*), MAX(ordering) FROM SmtpOutboxTable WHERE ordering <= " \
"? ORDER BY ordering ASC", &_inner_error_);
#line 744 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	stmt = _tmp0_;
#line 744 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 11312 "smtp-outbox-folder.c"
		gint _tmp1_ = 0;
#line 744 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_propagate_error (error, _inner_error_);
#line 744 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return _tmp1_;
#line 11318 "smtp-outbox-folder.c"
	}
#line 746 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp2_ = stmt;
#line 746 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp3_ = geary_db_statement_bind_int64 (_tmp2_, 0, ordering, &_inner_error_);
#line 746 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp4_ = _tmp3_;
#line 746 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_tmp4_);
#line 746 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 11330 "smtp-outbox-folder.c"
		gint _tmp5_ = 0;
#line 746 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_propagate_error (error, _inner_error_);
#line 746 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (stmt);
#line 746 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return _tmp5_;
#line 11338 "smtp-outbox-folder.c"
	}
#line 748 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp6_ = stmt;
#line 748 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp7_ = geary_db_statement_exec (_tmp6_, cancellable, &_inner_error_);
#line 748 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	results = _tmp7_;
#line 748 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 11348 "smtp-outbox-folder.c"
		gint _tmp8_ = 0;
#line 748 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_propagate_error (error, _inner_error_);
#line 748 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (stmt);
#line 748 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return _tmp8_;
#line 11356 "smtp-outbox-folder.c"
	}
#line 749 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp9_ = results;
#line 749 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp10_ = geary_db_result_get_finished (_tmp9_);
#line 749 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp11_ = _tmp10_;
#line 749 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (_tmp11_) {
#line 750 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		result = -1;
#line 750 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (results);
#line 750 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (stmt);
#line 750 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return result;
#line 11374 "smtp-outbox-folder.c"
	}
#line 753 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp13_ = results;
#line 753 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp12_ = geary_db_result_int64_at (_tmp13_, 1, &_inner_error_);
#line 753 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 11382 "smtp-outbox-folder.c"
		gint _tmp14_ = 0;
#line 753 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_propagate_error (error, _inner_error_);
#line 753 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (results);
#line 753 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (stmt);
#line 753 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return _tmp14_;
#line 11392 "smtp-outbox-folder.c"
	}
#line 753 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (_tmp12_ != ordering) {
#line 754 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		result = -1;
#line 754 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (results);
#line 754 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (stmt);
#line 754 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return result;
#line 11404 "smtp-outbox-folder.c"
	}
#line 756 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp16_ = results;
#line 756 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp15_ = geary_db_result_int_at (_tmp16_, 0, &_inner_error_);
#line 756 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 11412 "smtp-outbox-folder.c"
		gint _tmp17_ = 0;
#line 756 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_propagate_error (error, _inner_error_);
#line 756 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (results);
#line 756 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (stmt);
#line 756 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return _tmp17_;
#line 11422 "smtp-outbox-folder.c"
	}
#line 756 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	result = _tmp15_ + 1;
#line 756 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (results);
#line 756 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (stmt);
#line 756 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return result;
#line 11432 "smtp-outbox-folder.c"
}


static GearySmtpOutboxFolderOutboxRow*
geary_smtp_outbox_folder_do_fetch_row_by_ordering (GearySmtpOutboxFolder* self,
                                                   GearyDbConnection* cx,
                                                   gint64 ordering,
                                                   GCancellable* cancellable,
                                                   GError** error)
{
	GearySmtpOutboxFolderOutboxRow* result = NULL;
	GearyDbStatement* stmt = NULL;
	GearyDbStatement* _tmp0_;
	GearyDbStatement* _tmp1_;
	GearyDbStatement* _tmp2_;
	GearyDbStatement* _tmp3_;
	GearyDbResult* results = NULL;
	GearyDbStatement* _tmp4_;
	GearyDbResult* _tmp5_;
	GearyDbResult* _tmp6_;
	gboolean _tmp7_;
	gboolean _tmp8_;
	gint position = 0;
	gint _tmp9_;
	gint64 _tmp10_ = 0LL;
	GearyDbResult* _tmp11_;
	gboolean _tmp12_ = FALSE;
	GearyDbResult* _tmp13_;
	GearyMemoryBuffer* _tmp14_ = NULL;
	GearyDbResult* _tmp15_;
	GearyMemoryBuffer* _tmp16_;
	gint _tmp17_;
	GearySmtpOutboxFolderRoot* _tmp18_;
	GearySmtpOutboxFolderOutboxRow* _tmp19_;
	GError * _inner_error_ = NULL;
#line 759 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_return_val_if_fail (GEARY_IS_SMTP_OUTBOX_FOLDER (self), NULL);
#line 759 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_return_val_if_fail (GEARY_DB_IS_CONNECTION (cx), NULL);
#line 759 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_return_val_if_fail ((cancellable == NULL) || G_IS_CANCELLABLE (cancellable), NULL);
#line 761 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp0_ = geary_db_connection_prepare (cx, "\n" \
"            SELECT id, message, sent\n" \
"            FROM SmtpOutboxTable\n" \
"            WHERE ordering=?\n" \
"        ", &_inner_error_);
#line 761 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	stmt = _tmp0_;
#line 761 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 761 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_propagate_error (error, _inner_error_);
#line 761 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return NULL;
#line 11484 "smtp-outbox-folder.c"
	}
#line 766 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp1_ = stmt;
#line 766 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp2_ = geary_db_statement_bind_int64 (_tmp1_, 0, ordering, &_inner_error_);
#line 766 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp3_ = _tmp2_;
#line 766 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_tmp3_);
#line 766 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 766 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_propagate_error (error, _inner_error_);
#line 766 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (stmt);
#line 766 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return NULL;
#line 11502 "smtp-outbox-folder.c"
	}
#line 768 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp4_ = stmt;
#line 768 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp5_ = geary_db_statement_exec (_tmp4_, cancellable, &_inner_error_);
#line 768 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	results = _tmp5_;
#line 768 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 768 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_propagate_error (error, _inner_error_);
#line 768 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (stmt);
#line 768 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return NULL;
#line 11518 "smtp-outbox-folder.c"
	}
#line 769 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp6_ = results;
#line 769 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp7_ = geary_db_result_get_finished (_tmp6_);
#line 769 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp8_ = _tmp7_;
#line 769 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (_tmp8_) {
#line 770 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		result = NULL;
#line 770 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (results);
#line 770 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (stmt);
#line 770 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return result;
#line 11536 "smtp-outbox-folder.c"
	}
#line 772 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	position = geary_smtp_outbox_folder_do_get_position_by_ordering (self, cx, ordering, cancellable, &_inner_error_);
#line 772 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 772 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_propagate_error (error, _inner_error_);
#line 772 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (results);
#line 772 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (stmt);
#line 772 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return NULL;
#line 11550 "smtp-outbox-folder.c"
	}
#line 773 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp9_ = position;
#line 773 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (_tmp9_ < 1) {
#line 774 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		result = NULL;
#line 774 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (results);
#line 774 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (stmt);
#line 774 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return result;
#line 11564 "smtp-outbox-folder.c"
	}
#line 776 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp11_ = results;
#line 776 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp10_ = geary_db_result_rowid_at (_tmp11_, 0, &_inner_error_);
#line 776 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 776 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_propagate_error (error, _inner_error_);
#line 776 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (results);
#line 776 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (stmt);
#line 776 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return NULL;
#line 11580 "smtp-outbox-folder.c"
	}
#line 776 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp13_ = results;
#line 776 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp12_ = geary_db_result_bool_at (_tmp13_, 2, &_inner_error_);
#line 776 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 776 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_propagate_error (error, _inner_error_);
#line 776 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (results);
#line 776 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (stmt);
#line 776 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return NULL;
#line 11596 "smtp-outbox-folder.c"
	}
#line 777 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp15_ = results;
#line 777 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp16_ = geary_db_result_string_buffer_at (_tmp15_, 1, &_inner_error_);
#line 777 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp14_ = _tmp16_;
#line 777 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 777 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_propagate_error (error, _inner_error_);
#line 777 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (results);
#line 777 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (stmt);
#line 777 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return NULL;
#line 11614 "smtp-outbox-folder.c"
	}
#line 776 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp17_ = position;
#line 776 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp18_ = self->priv->_path;
#line 776 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp19_ = geary_smtp_outbox_folder_outbox_row_new (_tmp10_, _tmp17_, ordering, _tmp12_, _tmp14_, _tmp18_);
#line 776 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	result = _tmp19_;
#line 776 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_tmp14_);
#line 776 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (results);
#line 776 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (stmt);
#line 776 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return result;
#line 11632 "smtp-outbox-folder.c"
}


static void
geary_smtp_outbox_folder_do_mark_email_as_sent (GearySmtpOutboxFolder* self,
                                                GearyDbConnection* cx,
                                                GearySmtpOutboxEmailIdentifier* id,
                                                GCancellable* cancellable,
                                                GError** error)
{
	GearyDbStatement* stmt = NULL;
	GearyDbStatement* _tmp0_;
	GearyDbStatement* _tmp1_;
	gint64 _tmp2_;
	gint64 _tmp3_;
	GearyDbStatement* _tmp4_;
	GearyDbStatement* _tmp5_;
	GearyDbStatement* _tmp6_;
	GearyDbResult* _tmp7_;
	GearyDbResult* _tmp8_;
	GError * _inner_error_ = NULL;
#line 780 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_return_if_fail (GEARY_IS_SMTP_OUTBOX_FOLDER (self));
#line 780 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_return_if_fail (GEARY_DB_IS_CONNECTION (cx));
#line 780 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_return_if_fail (GEARY_IS_SMTP_OUTBOX_EMAIL_IDENTIFIER (id));
#line 780 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_return_if_fail ((cancellable == NULL) || G_IS_CANCELLABLE (cancellable));
#line 782 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp0_ = geary_db_connection_prepare (cx, "UPDATE SmtpOutboxTable SET sent = 1 WHERE ordering = ?", &_inner_error_);
#line 782 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	stmt = _tmp0_;
#line 782 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 782 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_propagate_error (error, _inner_error_);
#line 782 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return;
#line 11672 "smtp-outbox-folder.c"
	}
#line 783 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp1_ = stmt;
#line 783 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp2_ = geary_smtp_outbox_email_identifier_get_ordering (id);
#line 783 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp3_ = _tmp2_;
#line 783 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp4_ = geary_db_statement_bind_int64 (_tmp1_, 0, _tmp3_, &_inner_error_);
#line 783 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp5_ = _tmp4_;
#line 783 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_tmp5_);
#line 783 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 783 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_propagate_error (error, _inner_error_);
#line 783 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (stmt);
#line 783 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return;
#line 11694 "smtp-outbox-folder.c"
	}
#line 785 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp6_ = stmt;
#line 785 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp7_ = geary_db_statement_exec (_tmp6_, cancellable, &_inner_error_);
#line 785 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp8_ = _tmp7_;
#line 785 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_tmp8_);
#line 785 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 785 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_propagate_error (error, _inner_error_);
#line 785 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (stmt);
#line 785 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return;
#line 11712 "smtp-outbox-folder.c"
	}
#line 780 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (stmt);
#line 11716 "smtp-outbox-folder.c"
}


static gboolean
geary_smtp_outbox_folder_do_remove_email (GearySmtpOutboxFolder* self,
                                          GearyDbConnection* cx,
                                          GearySmtpOutboxEmailIdentifier* id,
                                          GCancellable* cancellable,
                                          GError** error)
{
	gboolean result = FALSE;
	GearyDbStatement* stmt = NULL;
	GearyDbStatement* _tmp0_;
	GearyDbStatement* _tmp2_;
	gint64 _tmp3_;
	gint64 _tmp4_;
	GearyDbStatement* _tmp5_;
	GearyDbStatement* _tmp6_;
	gint _tmp8_ = 0;
	GearyDbStatement* _tmp9_;
	GError * _inner_error_ = NULL;
#line 788 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_return_val_if_fail (GEARY_IS_SMTP_OUTBOX_FOLDER (self), FALSE);
#line 788 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_return_val_if_fail (GEARY_DB_IS_CONNECTION (cx), FALSE);
#line 788 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_return_val_if_fail (GEARY_IS_SMTP_OUTBOX_EMAIL_IDENTIFIER (id), FALSE);
#line 788 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_return_val_if_fail ((cancellable == NULL) || G_IS_CANCELLABLE (cancellable), FALSE);
#line 790 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp0_ = geary_db_connection_prepare (cx, "DELETE FROM SmtpOutboxTable WHERE ordering=?", &_inner_error_);
#line 790 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	stmt = _tmp0_;
#line 790 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 11752 "smtp-outbox-folder.c"
		gboolean _tmp1_ = FALSE;
#line 790 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_propagate_error (error, _inner_error_);
#line 790 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return _tmp1_;
#line 11758 "smtp-outbox-folder.c"
	}
#line 791 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp2_ = stmt;
#line 791 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp3_ = geary_smtp_outbox_email_identifier_get_ordering (id);
#line 791 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp4_ = _tmp3_;
#line 791 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp5_ = geary_db_statement_bind_int64 (_tmp2_, 0, _tmp4_, &_inner_error_);
#line 791 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp6_ = _tmp5_;
#line 791 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_tmp6_);
#line 791 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 11774 "smtp-outbox-folder.c"
		gboolean _tmp7_ = FALSE;
#line 791 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_propagate_error (error, _inner_error_);
#line 791 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (stmt);
#line 791 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return _tmp7_;
#line 11782 "smtp-outbox-folder.c"
	}
#line 793 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp9_ = stmt;
#line 793 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp8_ = geary_db_statement_exec_get_modified (_tmp9_, cancellable, &_inner_error_);
#line 793 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 11790 "smtp-outbox-folder.c"
		gboolean _tmp10_ = FALSE;
#line 793 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_propagate_error (error, _inner_error_);
#line 793 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (stmt);
#line 793 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return _tmp10_;
#line 11798 "smtp-outbox-folder.c"
	}
#line 793 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	result = _tmp8_ > 0;
#line 793 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (stmt);
#line 793 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return result;
#line 11806 "smtp-outbox-folder.c"
}


static GearyAccount*
geary_smtp_outbox_folder_real_get_account (GearyFolder* base)
{
	GearyAccount* result;
	GearySmtpOutboxFolder* self;
	GearyAccount* _tmp0_;
#line 38 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, GEARY_TYPE_SMTP_OUTBOX_FOLDER, GearySmtpOutboxFolder);
#line 38 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp0_ = self->priv->_account;
#line 38 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	result = _tmp0_;
#line 38 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return result;
#line 11824 "smtp-outbox-folder.c"
}


static GearyFolderProperties*
geary_smtp_outbox_folder_real_get_properties (GearyFolder* base)
{
	GearyFolderProperties* result;
	GearySmtpOutboxFolder* self;
	GearySmtpOutboxFolderProperties* _tmp0_;
#line 40 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, GEARY_TYPE_SMTP_OUTBOX_FOLDER, GearySmtpOutboxFolder);
#line 40 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp0_ = self->priv->_properties;
#line 40 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	result = G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEARY_TYPE_FOLDER_PROPERTIES, GearyFolderProperties);
#line 40 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return result;
#line 11842 "smtp-outbox-folder.c"
}


static GearyFolderPath*
geary_smtp_outbox_folder_real_get_path (GearyFolder* base)
{
	GearyFolderPath* result;
	GearySmtpOutboxFolder* self;
	GearySmtpOutboxFolderRoot* _tmp0_;
#line 44 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, GEARY_TYPE_SMTP_OUTBOX_FOLDER, GearySmtpOutboxFolder);
#line 45 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp0_ = self->priv->_path;
#line 45 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	result = G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEARY_TYPE_FOLDER_PATH, GearyFolderPath);
#line 45 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return result;
#line 11860 "smtp-outbox-folder.c"
}


static GearySpecialFolderType
geary_smtp_outbox_folder_real_get_special_folder_type (GearyFolder* base)
{
	GearySpecialFolderType result;
	GearySmtpOutboxFolder* self;
#line 50 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, GEARY_TYPE_SMTP_OUTBOX_FOLDER, GearySmtpOutboxFolder);
#line 51 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	result = GEARY_SPECIAL_FOLDER_TYPE_OUTBOX;
#line 51 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return result;
#line 11875 "smtp-outbox-folder.c"
}


static void
g_cclosure_user_marshal_VOID__ENUM_POINTER (GClosure * closure,
                                            GValue * return_value,
                                            guint n_param_values,
                                            const GValue * param_values,
                                            gpointer invocation_hint,
                                            gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__ENUM_POINTER) (gpointer data1, gint arg_1, gpointer arg_2, gpointer data2);
	register GMarshalFunc_VOID__ENUM_POINTER callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_return_if_fail (n_param_values == 3);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		data1 = closure->data;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		data2 = param_values->data[0].v_pointer;
#line 11901 "smtp-outbox-folder.c"
	} else {
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		data1 = param_values->data[0].v_pointer;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		data2 = closure->data;
#line 11907 "smtp-outbox-folder.c"
	}
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	callback = (GMarshalFunc_VOID__ENUM_POINTER) (marshal_data ? marshal_data : cc->callback);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	callback (data1, g_value_get_enum (param_values + 1), g_value_get_pointer (param_values + 2), data2);
#line 11913 "smtp-outbox-folder.c"
}


static GearySmtpOutboxFolderOutboxRow*
geary_smtp_outbox_folder_outbox_row_construct (GType object_type,
                                               gint64 id,
                                               gint position,
                                               gint64 ordering,
                                               gboolean sent,
                                               GearyMemoryBuffer* message,
                                               GearySmtpOutboxFolderRoot* root)
{
	GearySmtpOutboxFolderOutboxRow* self = NULL;
	GearyMemoryBuffer* _tmp0_;
	GearySmtpOutboxEmailIdentifier* _tmp1_;
#line 24 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_return_val_if_fail ((message == NULL) || GEARY_MEMORY_IS_BUFFER (message), NULL);
#line 24 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_return_val_if_fail (GEARY_IS_SMTP_OUTBOX_FOLDER_ROOT (root), NULL);
#line 24 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	self = (GearySmtpOutboxFolderOutboxRow*) g_type_create_instance (object_type);
#line 26 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_vala_assert (position >= 1, "position >= 1");
#line 28 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	self->id = id;
#line 29 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	self->position = position;
#line 30 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	self->ordering = ordering;
#line 31 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp0_ = _g_object_ref0 (message);
#line 31 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (self->message);
#line 31 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	self->message = _tmp0_;
#line 32 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	self->sent = sent;
#line 34 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp1_ = geary_smtp_outbox_email_identifier_new (id, ordering);
#line 34 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (self->outbox_id);
#line 34 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	self->outbox_id = _tmp1_;
#line 24 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return self;
#line 11959 "smtp-outbox-folder.c"
}


static GearySmtpOutboxFolderOutboxRow*
geary_smtp_outbox_folder_outbox_row_new (gint64 id,
                                         gint position,
                                         gint64 ordering,
                                         gboolean sent,
                                         GearyMemoryBuffer* message,
                                         GearySmtpOutboxFolderRoot* root)
{
#line 24 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return geary_smtp_outbox_folder_outbox_row_construct (GEARY_SMTP_OUTBOX_FOLDER_TYPE_OUTBOX_ROW, id, position, ordering, sent, message, root);
#line 11973 "smtp-outbox-folder.c"
}


static void
geary_smtp_outbox_folder_value_outbox_row_init (GValue* value)
{
#line 16 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	value->data[0].v_pointer = NULL;
#line 11982 "smtp-outbox-folder.c"
}


static void
geary_smtp_outbox_folder_value_outbox_row_free_value (GValue* value)
{
#line 16 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (value->data[0].v_pointer) {
#line 16 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		geary_smtp_outbox_folder_outbox_row_unref (value->data[0].v_pointer);
#line 11993 "smtp-outbox-folder.c"
	}
}


static void
geary_smtp_outbox_folder_value_outbox_row_copy_value (const GValue* src_value,
                                                      GValue* dest_value)
{
#line 16 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (src_value->data[0].v_pointer) {
#line 16 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		dest_value->data[0].v_pointer = geary_smtp_outbox_folder_outbox_row_ref (src_value->data[0].v_pointer);
#line 12006 "smtp-outbox-folder.c"
	} else {
#line 16 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		dest_value->data[0].v_pointer = NULL;
#line 12010 "smtp-outbox-folder.c"
	}
}


static gpointer
geary_smtp_outbox_folder_value_outbox_row_peek_pointer (const GValue* value)
{
#line 16 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return value->data[0].v_pointer;
#line 12020 "smtp-outbox-folder.c"
}


static gchar*
geary_smtp_outbox_folder_value_outbox_row_collect_value (GValue* value,
                                                         guint n_collect_values,
                                                         GTypeCValue* collect_values,
                                                         guint collect_flags)
{
#line 16 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (collect_values[0].v_pointer) {
#line 12032 "smtp-outbox-folder.c"
		GearySmtpOutboxFolderOutboxRow * object;
		object = collect_values[0].v_pointer;
#line 16 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		if (object->parent_instance.g_class == NULL) {
#line 16 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 12039 "smtp-outbox-folder.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 16 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 12043 "smtp-outbox-folder.c"
		}
#line 16 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		value->data[0].v_pointer = geary_smtp_outbox_folder_outbox_row_ref (object);
#line 12047 "smtp-outbox-folder.c"
	} else {
#line 16 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		value->data[0].v_pointer = NULL;
#line 12051 "smtp-outbox-folder.c"
	}
#line 16 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return NULL;
#line 12055 "smtp-outbox-folder.c"
}


static gchar*
geary_smtp_outbox_folder_value_outbox_row_lcopy_value (const GValue* value,
                                                       guint n_collect_values,
                                                       GTypeCValue* collect_values,
                                                       guint collect_flags)
{
	GearySmtpOutboxFolderOutboxRow ** object_p;
	object_p = collect_values[0].v_pointer;
#line 16 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (!object_p) {
#line 16 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 12071 "smtp-outbox-folder.c"
	}
#line 16 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (!value->data[0].v_pointer) {
#line 16 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		*object_p = NULL;
#line 12077 "smtp-outbox-folder.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 16 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		*object_p = value->data[0].v_pointer;
#line 12081 "smtp-outbox-folder.c"
	} else {
#line 16 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		*object_p = geary_smtp_outbox_folder_outbox_row_ref (value->data[0].v_pointer);
#line 12085 "smtp-outbox-folder.c"
	}
#line 16 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return NULL;
#line 12089 "smtp-outbox-folder.c"
}


static GParamSpec*
geary_smtp_outbox_folder_param_spec_outbox_row (const gchar* name,
                                                const gchar* nick,
                                                const gchar* blurb,
                                                GType object_type,
                                                GParamFlags flags)
{
	GearySmtpOutboxFolderParamSpecOutboxRow* spec;
#line 16 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_return_val_if_fail (g_type_is_a (object_type, GEARY_SMTP_OUTBOX_FOLDER_TYPE_OUTBOX_ROW), NULL);
#line 16 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 16 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 16 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return G_PARAM_SPEC (spec);
#line 12109 "smtp-outbox-folder.c"
}


static gpointer
geary_smtp_outbox_folder_value_get_outbox_row (const GValue* value)
{
#line 16 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, GEARY_SMTP_OUTBOX_FOLDER_TYPE_OUTBOX_ROW), NULL);
#line 16 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return value->data[0].v_pointer;
#line 12120 "smtp-outbox-folder.c"
}


static void
geary_smtp_outbox_folder_value_set_outbox_row (GValue* value,
                                               gpointer v_object)
{
	GearySmtpOutboxFolderOutboxRow * old;
#line 16 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, GEARY_SMTP_OUTBOX_FOLDER_TYPE_OUTBOX_ROW));
#line 16 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	old = value->data[0].v_pointer;
#line 16 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (v_object) {
#line 16 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, GEARY_SMTP_OUTBOX_FOLDER_TYPE_OUTBOX_ROW));
#line 16 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 16 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		value->data[0].v_pointer = v_object;
#line 16 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		geary_smtp_outbox_folder_outbox_row_ref (value->data[0].v_pointer);
#line 12143 "smtp-outbox-folder.c"
	} else {
#line 16 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		value->data[0].v_pointer = NULL;
#line 12147 "smtp-outbox-folder.c"
	}
#line 16 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (old) {
#line 16 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		geary_smtp_outbox_folder_outbox_row_unref (old);
#line 12153 "smtp-outbox-folder.c"
	}
}


static void
geary_smtp_outbox_folder_value_take_outbox_row (GValue* value,
                                                gpointer v_object)
{
	GearySmtpOutboxFolderOutboxRow * old;
#line 16 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, GEARY_SMTP_OUTBOX_FOLDER_TYPE_OUTBOX_ROW));
#line 16 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	old = value->data[0].v_pointer;
#line 16 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (v_object) {
#line 16 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, GEARY_SMTP_OUTBOX_FOLDER_TYPE_OUTBOX_ROW));
#line 16 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 16 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		value->data[0].v_pointer = v_object;
#line 12175 "smtp-outbox-folder.c"
	} else {
#line 16 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		value->data[0].v_pointer = NULL;
#line 12179 "smtp-outbox-folder.c"
	}
#line 16 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (old) {
#line 16 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		geary_smtp_outbox_folder_outbox_row_unref (old);
#line 12185 "smtp-outbox-folder.c"
	}
}


static void
geary_smtp_outbox_folder_outbox_row_class_init (GearySmtpOutboxFolderOutboxRowClass * klass)
{
#line 16 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	geary_smtp_outbox_folder_outbox_row_parent_class = g_type_class_peek_parent (klass);
#line 16 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	((GearySmtpOutboxFolderOutboxRowClass *) klass)->finalize = geary_smtp_outbox_folder_outbox_row_finalize;
#line 12197 "smtp-outbox-folder.c"
}


static void
geary_smtp_outbox_folder_outbox_row_instance_init (GearySmtpOutboxFolderOutboxRow * self)
{
#line 16 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	self->ref_count = 1;
#line 12206 "smtp-outbox-folder.c"
}


static void
geary_smtp_outbox_folder_outbox_row_finalize (GearySmtpOutboxFolderOutboxRow * obj)
{
	GearySmtpOutboxFolderOutboxRow * self;
#line 16 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GEARY_SMTP_OUTBOX_FOLDER_TYPE_OUTBOX_ROW, GearySmtpOutboxFolderOutboxRow);
#line 16 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_signal_handlers_destroy (self);
#line 21 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (self->message);
#line 22 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (self->outbox_id);
#line 12222 "smtp-outbox-folder.c"
}


static GType
geary_smtp_outbox_folder_outbox_row_get_type (void)
{
	static volatile gsize geary_smtp_outbox_folder_outbox_row_type_id__volatile = 0;
	if (g_once_init_enter (&geary_smtp_outbox_folder_outbox_row_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { geary_smtp_outbox_folder_value_outbox_row_init, geary_smtp_outbox_folder_value_outbox_row_free_value, geary_smtp_outbox_folder_value_outbox_row_copy_value, geary_smtp_outbox_folder_value_outbox_row_peek_pointer, "p", geary_smtp_outbox_folder_value_outbox_row_collect_value, "p", geary_smtp_outbox_folder_value_outbox_row_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (GearySmtpOutboxFolderOutboxRowClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) geary_smtp_outbox_folder_outbox_row_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GearySmtpOutboxFolderOutboxRow), 0, (GInstanceInitFunc) geary_smtp_outbox_folder_outbox_row_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType geary_smtp_outbox_folder_outbox_row_type_id;
		geary_smtp_outbox_folder_outbox_row_type_id = g_type_register_fundamental (g_type_fundamental_next (), "GearySmtpOutboxFolderOutboxRow", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&geary_smtp_outbox_folder_outbox_row_type_id__volatile, geary_smtp_outbox_folder_outbox_row_type_id);
	}
	return geary_smtp_outbox_folder_outbox_row_type_id__volatile;
}


static gpointer
geary_smtp_outbox_folder_outbox_row_ref (gpointer instance)
{
	GearySmtpOutboxFolderOutboxRow * self;
	self = instance;
#line 16 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_atomic_int_inc (&self->ref_count);
#line 16 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return instance;
#line 12251 "smtp-outbox-folder.c"
}


static void
geary_smtp_outbox_folder_outbox_row_unref (gpointer instance)
{
	GearySmtpOutboxFolderOutboxRow * self;
	self = instance;
#line 16 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 16 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		GEARY_SMTP_OUTBOX_FOLDER_OUTBOX_ROW_GET_CLASS (self)->finalize (self);
#line 16 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 12266 "smtp-outbox-folder.c"
	}
}


static void
geary_smtp_outbox_folder_class_init (GearySmtpOutboxFolderClass * klass)
{
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	geary_smtp_outbox_folder_parent_class = g_type_class_peek_parent (klass);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_type_class_add_private (klass, sizeof (GearySmtpOutboxFolderPrivate));
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	((GearyFolderClass *) klass)->find_boundaries_async = (void (*) (GearyFolder *, GeeCollection*, GCancellable*, GAsyncReadyCallback, gpointer)) geary_smtp_outbox_folder_real_find_boundaries_async;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	((GearyFolderClass *) klass)->find_boundaries_finish = (void (*) (GearyFolder *, GAsyncResult*, GearyEmailIdentifier* *, GearyEmailIdentifier* *, GError**)) geary_smtp_outbox_folder_real_find_boundaries_finish;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	((GearyFolderClass *) klass)->get_open_state = (GearyFolderOpenState (*) (GearyFolder *)) geary_smtp_outbox_folder_real_get_open_state;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	((GearySmtpOutboxFolderClass *) klass)->create_email_async = (void (*) (GearySmtpOutboxFolder *, GearyRFC822Message*, GearyEmailFlags*, GDateTime*, GearyEmailIdentifier*, GCancellable*, GAsyncReadyCallback, gpointer)) geary_smtp_outbox_folder_real_create_email_async;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	((GearySmtpOutboxFolderClass *) klass)->create_email_finish = (GearyEmailIdentifier* (*) (GearySmtpOutboxFolder *, GAsyncResult*, GError**)) geary_smtp_outbox_folder_real_create_email_finish;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	((GearyFolderClass *) klass)->list_email_by_id_async = (void (*) (GearyFolder *, GearyEmailIdentifier*, gint, GearyEmailField, GearyFolderListFlags, GCancellable*, GAsyncReadyCallback, gpointer)) geary_smtp_outbox_folder_real_list_email_by_id_async;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	((GearyFolderClass *) klass)->list_email_by_id_finish = (GeeList* (*) (GearyFolder *, GAsyncResult*, GError**)) geary_smtp_outbox_folder_real_list_email_by_id_finish;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	((GearyFolderClass *) klass)->list_email_by_sparse_id_async = (void (*) (GearyFolder *, GeeCollection*, GearyEmailField, GearyFolderListFlags, GCancellable*, GAsyncReadyCallback, gpointer)) geary_smtp_outbox_folder_real_list_email_by_sparse_id_async;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	((GearyFolderClass *) klass)->list_email_by_sparse_id_finish = (GeeList* (*) (GearyFolder *, GAsyncResult*, GError**)) geary_smtp_outbox_folder_real_list_email_by_sparse_id_finish;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	((GearyFolderClass *) klass)->list_local_email_fields_async = (void (*) (GearyFolder *, GeeCollection*, GCancellable*, GAsyncReadyCallback, gpointer)) geary_smtp_outbox_folder_real_list_local_email_fields_async;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	((GearyFolderClass *) klass)->list_local_email_fields_finish = (GeeMap* (*) (GearyFolder *, GAsyncResult*, GError**)) geary_smtp_outbox_folder_real_list_local_email_fields_finish;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	((GearyFolderClass *) klass)->fetch_email_async = (void (*) (GearyFolder *, GearyEmailIdentifier*, GearyEmailField, GearyFolderListFlags, GCancellable*, GAsyncReadyCallback, gpointer)) geary_smtp_outbox_folder_real_fetch_email_async;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	((GearyFolderClass *) klass)->fetch_email_finish = (GearyEmail* (*) (GearyFolder *, GAsyncResult*, GError**)) geary_smtp_outbox_folder_real_fetch_email_finish;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	((GearySmtpOutboxFolderClass *) klass)->remove_email_async = (void (*) (GearySmtpOutboxFolder *, GeeList*, GCancellable*, GAsyncReadyCallback, gpointer)) geary_smtp_outbox_folder_real_remove_email_async;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	((GearySmtpOutboxFolderClass *) klass)->remove_email_finish = (void (*) (GearySmtpOutboxFolder *, GAsyncResult*, GError**)) geary_smtp_outbox_folder_real_remove_email_finish;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	((GearySmtpOutboxFolderClass *) klass)->remove_single_email_async = (void (*) (GearySmtpOutboxFolder *, GearyEmailIdentifier*, GCancellable*, GAsyncReadyCallback, gpointer)) geary_smtp_outbox_folder_real_remove_single_email_async;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	((GearySmtpOutboxFolderClass *) klass)->remove_single_email_finish = (void (*) (GearySmtpOutboxFolder *, GAsyncResult*, GError**)) geary_smtp_outbox_folder_real_remove_single_email_finish;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	GEARY_FOLDER_CLASS (klass)->get_account = geary_smtp_outbox_folder_real_get_account;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	GEARY_FOLDER_CLASS (klass)->get_properties = geary_smtp_outbox_folder_real_get_properties;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	GEARY_FOLDER_CLASS (klass)->get_path = geary_smtp_outbox_folder_real_get_path;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	GEARY_FOLDER_CLASS (klass)->get_special_folder_type = geary_smtp_outbox_folder_real_get_special_folder_type;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_geary_smtp_outbox_folder_get_property;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	G_OBJECT_CLASS (klass)->finalize = geary_smtp_outbox_folder_finalize;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEARY_SMTP_OUTBOX_FOLDER_ACCOUNT_PROPERTY, geary_smtp_outbox_folder_properties[GEARY_SMTP_OUTBOX_FOLDER_ACCOUNT_PROPERTY] = g_param_spec_object ("account", "account", "account", GEARY_TYPE_ACCOUNT, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEARY_SMTP_OUTBOX_FOLDER_PROPERTIES_PROPERTY, geary_smtp_outbox_folder_properties[GEARY_SMTP_OUTBOX_FOLDER_PROPERTIES_PROPERTY] = g_param_spec_object ("properties", "properties", "properties", GEARY_TYPE_FOLDER_PROPERTIES, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEARY_SMTP_OUTBOX_FOLDER_PATH_PROPERTY, geary_smtp_outbox_folder_properties[GEARY_SMTP_OUTBOX_FOLDER_PATH_PROPERTY] = g_param_spec_object ("path", "path", "path", GEARY_TYPE_FOLDER_PATH, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEARY_SMTP_OUTBOX_FOLDER_SPECIAL_FOLDER_TYPE_PROPERTY, geary_smtp_outbox_folder_properties[GEARY_SMTP_OUTBOX_FOLDER_SPECIAL_FOLDER_TYPE_PROPERTY] = g_param_spec_enum ("special-folder-type", "special-folder-type", "special-folder-type", GEARY_TYPE_SPECIAL_FOLDER_TYPE, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	geary_smtp_outbox_folder_signals[GEARY_SMTP_OUTBOX_FOLDER_REPORT_PROBLEM_SIGNAL] = g_signal_new ("report-problem", GEARY_TYPE_SMTP_OUTBOX_FOLDER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__ENUM_POINTER, G_TYPE_NONE, 2, GEARY_ACCOUNT_TYPE_PROBLEM, G_TYPE_POINTER);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	geary_smtp_outbox_folder_signals[GEARY_SMTP_OUTBOX_FOLDER_EMAIL_SENT_SIGNAL] = g_signal_new ("email-sent", GEARY_TYPE_SMTP_OUTBOX_FOLDER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, GEARY_RF_C822_TYPE_MESSAGE);
#line 12336 "smtp-outbox-folder.c"
}


static void
geary_smtp_outbox_folder_geary_folder_support_remove_interface_init (GearyFolderSupportRemoveIface * iface)
{
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	geary_smtp_outbox_folder_geary_folder_support_remove_parent_iface = g_type_interface_peek_parent (iface);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	iface->remove_email_async = (void (*) (GearyFolderSupportRemove *, GeeList*, GCancellable*, GAsyncReadyCallback, gpointer)) geary_smtp_outbox_folder_remove_email_async;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	iface->remove_email_finish = (void (*) (GearyFolderSupportRemove *, GAsyncResult*, GError**)) geary_smtp_outbox_folder_remove_email_finish;
#line 12349 "smtp-outbox-folder.c"
}


static void
geary_smtp_outbox_folder_geary_folder_support_create_interface_init (GearyFolderSupportCreateIface * iface)
{
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	geary_smtp_outbox_folder_geary_folder_support_create_parent_iface = g_type_interface_peek_parent (iface);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	iface->create_email_async = (void (*) (GearyFolderSupportCreate *, GearyRFC822Message*, GearyEmailFlags*, GDateTime*, GearyEmailIdentifier*, GCancellable*, GAsyncReadyCallback, gpointer)) geary_smtp_outbox_folder_create_email_async;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	iface->create_email_finish = (GearyEmailIdentifier* (*) (GearyFolderSupportCreate *, GAsyncResult*, GError**)) geary_smtp_outbox_folder_create_email_finish;
#line 12362 "smtp-outbox-folder.c"
}


static void
geary_smtp_outbox_folder_instance_init (GearySmtpOutboxFolder * self)
{
	GearySmtpOutboxFolderRoot* _tmp0_;
	GearyNonblockingMailbox* _tmp1_;
	GearySmtpOutboxFolderProperties* _tmp2_;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	self->priv = GEARY_SMTP_OUTBOX_FOLDER_GET_PRIVATE (self);
#line 42 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp0_ = geary_smtp_outbox_folder_root_new ();
#line 42 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	self->priv->_path = _tmp0_;
#line 63 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp1_ = geary_nonblocking_mailbox_new (GEARY_SMTP_OUTBOX_FOLDER_TYPE_OUTBOX_ROW, (GBoxedCopyFunc) geary_smtp_outbox_folder_outbox_row_ref, (GDestroyNotify) geary_smtp_outbox_folder_outbox_row_unref, NULL, NULL, NULL);
#line 63 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	self->priv->outbox_queue = _tmp1_;
#line 64 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp2_ = geary_smtp_outbox_folder_properties_new (0, 0);
#line 64 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	self->priv->_properties = _tmp2_;
#line 65 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_rec_mutex_init (&self->priv->__lock_next_ordering);
#line 65 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	self->priv->next_ordering = (gint64) 0;
#line 12390 "smtp-outbox-folder.c"
}


static void
geary_smtp_outbox_folder_finalize (GObject * obj)
{
	GearySmtpOutboxFolder * self;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GEARY_TYPE_SMTP_OUTBOX_FOLDER, GearySmtpOutboxFolder);
#line 42 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (self->priv->_path);
#line 59 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (self->priv->db);
#line 61 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (self->priv->sending_monitor);
#line 62 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_geary_smtp_client_session_unref0 (self->priv->smtp);
#line 63 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (self->priv->outbox_queue);
#line 64 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (self->priv->_properties);
#line 65 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_rec_mutex_clear (&self->priv->__lock_next_ordering);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	G_OBJECT_CLASS (geary_smtp_outbox_folder_parent_class)->finalize (obj);
#line 12416 "smtp-outbox-folder.c"
}


GType
geary_smtp_outbox_folder_get_type (void)
{
	static volatile gsize geary_smtp_outbox_folder_type_id__volatile = 0;
	if (g_once_init_enter (&geary_smtp_outbox_folder_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (GearySmtpOutboxFolderClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) geary_smtp_outbox_folder_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GearySmtpOutboxFolder), 0, (GInstanceInitFunc) geary_smtp_outbox_folder_instance_init, NULL };
		static const GInterfaceInfo geary_folder_support_remove_info = { (GInterfaceInitFunc) geary_smtp_outbox_folder_geary_folder_support_remove_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
		static const GInterfaceInfo geary_folder_support_create_info = { (GInterfaceInitFunc) geary_smtp_outbox_folder_geary_folder_support_create_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
		GType geary_smtp_outbox_folder_type_id;
		geary_smtp_outbox_folder_type_id = g_type_register_static (GEARY_TYPE_ABSTRACT_LOCAL_FOLDER, "GearySmtpOutboxFolder", &g_define_type_info, 0);
		g_type_add_interface_static (geary_smtp_outbox_folder_type_id, GEARY_FOLDER_SUPPORT_TYPE_REMOVE, &geary_folder_support_remove_info);
		g_type_add_interface_static (geary_smtp_outbox_folder_type_id, GEARY_FOLDER_SUPPORT_TYPE_CREATE, &geary_folder_support_create_info);
		g_once_init_leave (&geary_smtp_outbox_folder_type_id__volatile, geary_smtp_outbox_folder_type_id);
	}
	return geary_smtp_outbox_folder_type_id__volatile;
}


static void
_vala_geary_smtp_outbox_folder_get_property (GObject * object,
                                             guint property_id,
                                             GValue * value,
                                             GParamSpec * pspec)
{
	GearySmtpOutboxFolder * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GEARY_TYPE_SMTP_OUTBOX_FOLDER, GearySmtpOutboxFolder);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	switch (property_id) {
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		case GEARY_SMTP_OUTBOX_FOLDER_ACCOUNT_PROPERTY:
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_value_set_object (value, geary_folder_get_account (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_TYPE_FOLDER, GearyFolder)));
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		break;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		case GEARY_SMTP_OUTBOX_FOLDER_PROPERTIES_PROPERTY:
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_value_set_object (value, geary_folder_get_properties (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_TYPE_FOLDER, GearyFolder)));
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		break;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		case GEARY_SMTP_OUTBOX_FOLDER_PATH_PROPERTY:
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_value_set_object (value, geary_folder_get_path (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_TYPE_FOLDER, GearyFolder)));
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		break;
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		case GEARY_SMTP_OUTBOX_FOLDER_SPECIAL_FOLDER_TYPE_PROPERTY:
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_value_set_enum (value, geary_folder_get_special_folder_type (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_TYPE_FOLDER, GearyFolder)));
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		break;
#line 12472 "smtp-outbox-folder.c"
		default:
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 14 "/builddir/build/BUILD/geary-0.12.1/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		break;
#line 12478 "smtp-outbox-folder.c"
	}
}



